/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2011, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   core_yyscan_t yyscanner);


#line 220 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    FCONST = 259,
    SCONST = 260,
    BCONST = 261,
    XCONST = 262,
    Op = 263,
    ICONST = 264,
    PARAM = 265,
    TYPECAST = 266,
    DOT_DOT = 267,
    COLON_EQUALS = 268,
    ABORT_P = 269,
    ABSOLUTE_P = 270,
    ACCESS = 271,
    ACTION = 272,
    ADD_P = 273,
    ADMIN = 274,
    AFTER = 275,
    AGGREGATE = 276,
    ALL = 277,
    ALSO = 278,
    ALTER = 279,
    ALWAYS = 280,
    ANALYSE = 281,
    ANALYZE = 282,
    AND = 283,
    ANY = 284,
    ARRAY = 285,
    AS = 286,
    ASC = 287,
    ASSERTION = 288,
    ASSIGNMENT = 289,
    ASYMMETRIC = 290,
    AT = 291,
    ATTRIBUTE = 292,
    AUTHORIZATION = 293,
    BACKWARD = 294,
    BEFORE = 295,
    BEGIN_P = 296,
    BETWEEN = 297,
    BIGINT = 298,
    BINARY = 299,
    BIT = 300,
    BOOLEAN_P = 301,
    BOTH = 302,
    BY = 303,
    CACHE = 304,
    CALLED = 305,
    CASCADE = 306,
    CASCADED = 307,
    CASE = 308,
    CAST = 309,
    CATALOG_P = 310,
    CHAIN = 311,
    CHAR_P = 312,
    CHARACTER = 313,
    CHARACTERISTICS = 314,
    CHECK = 315,
    CHECKPOINT = 316,
    CLASS = 317,
    CLOSE = 318,
    CLUSTER = 319,
    COALESCE = 320,
    COLLATE = 321,
    COLLATION = 322,
    COLUMN = 323,
    COMMENT = 324,
    COMMENTS = 325,
    COMMIT = 326,
    COMMITTED = 327,
    CONCURRENTLY = 328,
    CONFIGURATION = 329,
    CONNECTION = 330,
    CONSTRAINT = 331,
    CONSTRAINTS = 332,
    CONTENT_P = 333,
    CONTINUE_P = 334,
    CONVERSION_P = 335,
    COPY = 336,
    COST = 337,
    CREATE = 338,
    CROSS = 339,
    CSV = 340,
    CURRENT_P = 341,
    CURRENT_CATALOG = 342,
    CURRENT_DATE = 343,
    CURRENT_ROLE = 344,
    CURRENT_SCHEMA = 345,
    CURRENT_TIME = 346,
    CURRENT_TIMESTAMP = 347,
    CURRENT_USER = 348,
    CURSOR = 349,
    CYCLE = 350,
    DATA_P = 351,
    DATABASE = 352,
    DAY_P = 353,
    DEALLOCATE = 354,
    DEC = 355,
    DECIMAL_P = 356,
    DECLARE = 357,
    DEFAULT = 358,
    DEFAULTS = 359,
    DEFERRABLE = 360,
    DEFERRED = 361,
    DEFINER = 362,
    DELETE_P = 363,
    DELIMITER = 364,
    DELIMITERS = 365,
    DESC = 366,
    DICTIONARY = 367,
    DISABLE_P = 368,
    DISCARD = 369,
    DISTINCT = 370,
    DO = 371,
    DOCUMENT_P = 372,
    DOMAIN_P = 373,
    DOUBLE_P = 374,
    DROP = 375,
    EACH = 376,
    ELSE = 377,
    ENABLE_P = 378,
    ENCODING = 379,
    ENCRYPTED = 380,
    END_P = 381,
    ENUM_P = 382,
    ESCAPE = 383,
    EXCEPT = 384,
    EXCLUDE = 385,
    EXCLUDING = 386,
    EXCLUSIVE = 387,
    EXECUTE = 388,
    EXISTS = 389,
    EXPLAIN = 390,
    EXTENSION = 391,
    EXTERNAL = 392,
    EXTRACT = 393,
    FALSE_P = 394,
    FAMILY = 395,
    FETCH = 396,
    FIRST_P = 397,
    FLOAT_P = 398,
    FOLLOWING = 399,
    FOR = 400,
    FORCE = 401,
    FOREIGN = 402,
    FORWARD = 403,
    FREEZE = 404,
    FROM = 405,
    FULL = 406,
    FUNCTION = 407,
    FUNCTIONS = 408,
    GLOBAL = 409,
    GRANT = 410,
    GRANTED = 411,
    GREATEST = 412,
    GROUP_P = 413,
    HANDLER = 414,
    HAVING = 415,
    HEADER_P = 416,
    HOLD = 417,
    HOUR_P = 418,
    IDENTITY_P = 419,
    IF_P = 420,
    ILIKE = 421,
    IMMEDIATE = 422,
    IMMUTABLE = 423,
    IMPLICIT_P = 424,
    IN_P = 425,
    INCLUDING = 426,
    INCREMENT = 427,
    INDEX = 428,
    INDEXES = 429,
    INHERIT = 430,
    INHERITS = 431,
    INITIALLY = 432,
    INLINE_P = 433,
    INNER_P = 434,
    INOUT = 435,
    INPUT_P = 436,
    INSENSITIVE = 437,
    INSERT = 438,
    INSTEAD = 439,
    INT_P = 440,
    INTEGER = 441,
    INTERSECT = 442,
    INTERVAL = 443,
    INTO = 444,
    INVOKER = 445,
    IS = 446,
    ISNULL = 447,
    ISOLATION = 448,
    JOIN = 449,
    KEY = 450,
    LABEL = 451,
    LANGUAGE = 452,
    LARGE_P = 453,
    LAST_P = 454,
    LC_COLLATE_P = 455,
    LC_CTYPE_P = 456,
    LEADING = 457,
    LEAST = 458,
    LEFT = 459,
    LEVEL = 460,
    LIKE = 461,
    LIMIT = 462,
    LISTEN = 463,
    LOAD = 464,
    LOCAL = 465,
    LOCALTIME = 466,
    LOCALTIMESTAMP = 467,
    LOCATION = 468,
    LOCK_P = 469,
    MAPPING = 470,
    MATCH = 471,
    MAXVALUE = 472,
    MINUTE_P = 473,
    MINVALUE = 474,
    MODE = 475,
    MONTH_P = 476,
    MOVE = 477,
    NAME_P = 478,
    NAMES = 479,
    NATIONAL = 480,
    NATURAL = 481,
    NCHAR = 482,
    NEXT = 483,
    NO = 484,
    NONE = 485,
    NOT = 486,
    NOTHING = 487,
    NOTIFY = 488,
    NOTNULL = 489,
    NOWAIT = 490,
    NULL_P = 491,
    NULLIF = 492,
    NULLS_P = 493,
    NUMERIC = 494,
    OBJECT_P = 495,
    OF = 496,
    OFF = 497,
    OFFSET = 498,
    OIDS = 499,
    ON = 500,
    ONLY = 501,
    OPERATOR = 502,
    OPTION = 503,
    OPTIONS = 504,
    OR = 505,
    ORDER = 506,
    OUT_P = 507,
    OUTER_P = 508,
    OVER = 509,
    OVERLAPS = 510,
    OVERLAY = 511,
    OWNED = 512,
    OWNER = 513,
    PARSER = 514,
    PARTIAL = 515,
    PARTITION = 516,
    PASSING = 517,
    PASSWORD = 518,
    PLACING = 519,
    PLANS = 520,
    POSITION = 521,
    PRECEDING = 522,
    PRECISION = 523,
    PRESERVE = 524,
    PREPARE = 525,
    PREPARED = 526,
    PRIMARY = 527,
    PRIOR = 528,
    PRIVILEGES = 529,
    PROCEDURAL = 530,
    PROCEDURE = 531,
    QUOTE = 532,
    RANGE = 533,
    READ = 534,
    REAL = 535,
    REASSIGN = 536,
    RECHECK = 537,
    RECURSIVE = 538,
    REF = 539,
    REFERENCES = 540,
    REINDEX = 541,
    RELATIVE_P = 542,
    RELEASE = 543,
    RENAME = 544,
    REPEATABLE = 545,
    REPLACE = 546,
    REPLICA = 547,
    RESET = 548,
    RESTART = 549,
    RESTRICT = 550,
    RETURNING = 551,
    RETURNS = 552,
    REVOKE = 553,
    RIGHT = 554,
    ROLE = 555,
    ROLLBACK = 556,
    ROW = 557,
    ROWS = 558,
    RULE = 559,
    SAVEPOINT = 560,
    SCHEMA = 561,
    SCROLL = 562,
    SEARCH = 563,
    SECOND_P = 564,
    SECURITY = 565,
    SELECT = 566,
    SEQUENCE = 567,
    SEQUENCES = 568,
    SERIALIZABLE = 569,
    SERVER = 570,
    SESSION = 571,
    SESSION_USER = 572,
    SET = 573,
    SETOF = 574,
    SHARE = 575,
    SHOW = 576,
    SIMILAR = 577,
    SIMPLE = 578,
    SMALLINT = 579,
    SOME = 580,
    STABLE = 581,
    STANDALONE_P = 582,
    START = 583,
    STATEMENT = 584,
    STATISTICS = 585,
    STDIN = 586,
    STDOUT = 587,
    STORAGE = 588,
    STRICT_P = 589,
    STRIP_P = 590,
    SUBSTRING = 591,
    SYMMETRIC = 592,
    SYSID = 593,
    SYSTEM_P = 594,
    TABLE = 595,
    TABLES = 596,
    TABLESPACE = 597,
    TEMP = 598,
    TEMPLATE = 599,
    TEMPORARY = 600,
    TEXT_P = 601,
    THEN = 602,
    TIME = 603,
    TIMESTAMP = 604,
    TO = 605,
    TRAILING = 606,
    TRANSACTION = 607,
    TREAT = 608,
    TRIGGER = 609,
    TRIM = 610,
    TRUE_P = 611,
    TRUNCATE = 612,
    TRUSTED = 613,
    TYPE_P = 614,
    UNBOUNDED = 615,
    UNCOMMITTED = 616,
    UNENCRYPTED = 617,
    UNION = 618,
    UNIQUE = 619,
    UNKNOWN = 620,
    UNLISTEN = 621,
    UNLOGGED = 622,
    UNTIL = 623,
    UPDATE = 624,
    USER = 625,
    USING = 626,
    VACUUM = 627,
    VALID = 628,
    VALIDATE = 629,
    VALIDATOR = 630,
    VALUE_P = 631,
    VALUES = 632,
    VARCHAR = 633,
    VARIADIC = 634,
    VARYING = 635,
    VERBOSE = 636,
    VERSION_P = 637,
    VIEW = 638,
    VOLATILE = 639,
    WHEN = 640,
    WHERE = 641,
    WHITESPACE_P = 642,
    WINDOW = 643,
    WITH = 644,
    WITHOUT = 645,
    WORK = 646,
    WRAPPER = 647,
    WRITE = 648,
    XML_P = 649,
    XMLATTRIBUTES = 650,
    XMLCONCAT = 651,
    XMLELEMENT = 652,
    XMLEXISTS = 653,
    XMLFOREST = 654,
    XMLPARSE = 655,
    XMLPI = 656,
    XMLROOT = 657,
    XMLSERIALIZE = 658,
    YEAR_P = 659,
    YES_P = 660,
    ZONE = 661,
    NULLS_FIRST = 662,
    NULLS_LAST = 663,
    WITH_TIME = 664,
    POSTFIXOP = 665,
    UMINUS = 666
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 158 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;

#line 709 "gram.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 737 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  693
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   69680

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  429
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  546
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2218
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  4179

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   666

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   418,     2,     2,
     423,   424,   416,   414,   427,   415,   425,   417,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   428,   426,
     411,   410,   412,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   421,     2,   422,   419,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   413,   420
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   654,   654,   661,   668,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   789,   799,   810,   811,   820,
     821,   825,   826,   830,   835,   839,   844,   849,   853,   857,
     862,   866,   920,   922,   926,   930,   934,   938,   952,   970,
     981,   982,   986,  1004,  1016,  1037,  1044,  1063,  1070,  1087,
    1105,  1116,  1117,  1129,  1136,  1153,  1165,  1177,  1178,  1182,
    1183,  1191,  1192,  1193,  1194,  1195,  1196,  1210,  1216,  1222,
    1231,  1239,  1247,  1254,  1261,  1269,  1280,  1288,  1296,  1304,
    1312,  1323,  1331,  1339,  1346,  1356,  1357,  1364,  1365,  1368,
    1370,  1374,  1375,  1376,  1377,  1381,  1382,  1383,  1389,  1401,
    1405,  1409,  1424,  1447,  1448,  1449,  1453,  1454,  1455,  1459,
    1460,  1464,  1471,  1478,  1485,  1492,  1502,  1503,  1508,  1514,
    1520,  1526,  1532,  1542,  1552,  1553,  1557,  1558,  1566,  1581,
    1587,  1593,  1599,  1617,  1625,  1633,  1641,  1652,  1653,  1658,
    1666,  1674,  1683,  1691,  1699,  1708,  1717,  1726,  1735,  1745,
    1758,  1772,  1780,  1788,  1798,  1808,  1815,  1822,  1830,  1838,
    1846,  1854,  1862,  1869,  1876,  1884,  1891,  1898,  1906,  1914,
    1922,  1930,  1938,  1946,  1956,  1963,  1971,  1979,  1987,  1994,
    2004,  2005,  2009,  2010,  2011,  2015,  2023,  2027,  2028,  2032,
    2035,  2036,  2040,  2041,  2046,  2050,  2054,  2059,  2074,  2087,
    2088,  2093,  2102,  2112,  2122,  2147,  2153,  2180,  2202,  2216,
    2217,  2226,  2227,  2228,  2231,  2232,  2237,  2238,  2242,  2246,
    2250,  2254,  2258,  2262,  2266,  2270,  2274,  2278,  2282,  2286,
    2295,  2299,  2303,  2307,  2311,  2315,  2319,  2320,  2325,  2329,
    2336,  2343,  2344,  2345,  2346,  2347,  2351,  2355,  2363,  2374,
    2389,  2405,  2421,  2446,  2447,  2448,  2449,  2450,  2451,  2452,
    2453,  2457,  2458,  2462,  2463,  2467,  2471,  2478,  2482,  2489,
    2490,  2491,  2495,  2496,  2499,  2518,  2538,  2539,  2543,  2551,
    2552,  2553,  2584,  2591,  2598,  2609,  2620,  2629,  2638,  2671,
    2678,  2685,  2692,  2711,  2721,  2722,  2723,  2727,  2728,  2729,
    2730,  2731,  2732,  2741,  2749,  2753,  2765,  2780,  2794,  2809,
    2823,  2841,  2863,  2864,  2868,  2869,  2872,  2878,  2882,  2890,
    2895,  2901,  2902,  2906,  2911,  2918,  2919,  2929,  2931,  2933,
    2935,  2938,  2941,  2944,  2948,  2949,  2950,  2951,  2952,  2955,
    2956,  2961,  2962,  2963,  2964,  2967,  2968,  2969,  2970,  2973,
    2974,  2977,  2978,  2981,  2991,  3016,  3028,  3029,  3033,  3034,
    3038,  3058,  3059,  3060,  3073,  3085,  3094,  3095,  3098,  3099,
    3102,  3106,  3110,  3114,  3118,  3122,  3126,  3130,  3134,  3138,
    3142,  3146,  3152,  3153,  3157,  3158,  3163,  3166,  3167,  3179,
    3191,  3206,  3207,  3215,  3216,  3220,  3221,  3225,  3226,  3230,
    3231,  3235,  3243,  3254,  3255,  3265,  3275,  3276,  3289,  3296,
    3313,  3321,  3332,  3335,  3339,  3343,  3347,  3359,  3369,  3372,
    3376,  3389,  3399,  3409,  3418,  3427,  3436,  3446,  3455,  3465,
    3475,  3485,  3494,  3503,  3512,  3521,  3530,  3539,  3548,  3557,
    3566,  3575,  3584,  3602,  3613,  3614,  3615,  3616,  3620,  3621,
    3625,  3626,  3636,  3644,  3661,  3669,  3681,  3682,  3686,  3690,
    3698,  3702,  3706,  3713,  3717,  3722,  3727,  3734,  3741,  3746,
    3756,  3770,  3771,  3776,  3777,  3781,  3782,  3792,  3800,  3817,
    3826,  3834,  3851,  3866,  3884,  3885,  3889,  3893,  3900,  3911,
    3928,  3940,  3941,  3942,  3952,  3960,  3977,  3996,  4016,  4041,
    4042,  4043,  4047,  4049,  4071,  4073,  4075,  4077,  4079,  4084,
    4089,  4099,  4100,  4104,  4105,  4109,  4110,  4114,  4115,  4116,
    4120,  4126,  4127,  4128,  4132,  4133,  4138,  4139,  4166,  4167,
    4168,  4169,  4170,  4175,  4185,  4207,  4227,  4250,  4260,  4271,
    4281,  4291,  4302,  4311,  4318,  4327,  4336,  4345,  4354,  4363,
    4374,  4377,  4378,  4381,  4385,  4392,  4393,  4394,  4395,  4396,
    4399,  4400,  4403,  4406,  4407,  4415,  4422,  4423,  4426,  4428,
    4439,  4448,  4457,  4481,  4496,  4497,  4501,  4511,  4522,  4531,
    4541,  4550,  4551,  4554,  4555,  4558,  4559,  4560,  4563,  4577,
    4582,  4592,  4601,  4613,  4614,  4618,  4626,  4638,  4647,  4659,
    4668,  4689,  4699,  4717,  4726,  4738,  4739,  4740,  4741,  4742,
    4743,  4744,  4745,  4746,  4747,  4748,  4749,  4750,  4751,  4752,
    4756,  4757,  4760,  4761,  4764,  4766,  4779,  4790,  4791,  4792,
    4818,  4827,  4836,  4845,  4854,  4863,  4872,  4882,  4891,  4900,
    4909,  4918,  4927,  4936,  4944,  4952,  4960,  4971,  4972,  4973,
    4974,  4975,  4976,  4977,  4978,  4979,  4980,  4981,  4982,  4983,
    4984,  4985,  4986,  4987,  4991,  4992,  5006,  5017,  5028,  5039,
    5050,  5063,  5064,  5068,  5069,  5070,  5071,  5072,  5073,  5074,
    5075,  5078,  5079,  5089,  5095,  5103,  5111,  5119,  5127,  5135,
    5143,  5151,  5159,  5167,  5175,  5183,  5191,  5199,  5207,  5215,
    5223,  5233,  5234,  5237,  5238,  5248,  5264,  5278,  5304,  5306,
    5308,  5310,  5317,  5326,  5327,  5330,  5337,  5344,  5351,  5365,
    5373,  5381,  5389,  5397,  5405,  5413,  5421,  5429,  5437,  5445,
    5453,  5461,  5469,  5481,  5482,  5485,  5495,  5509,  5510,  5514,
    5515,  5520,  5536,  5549,  5559,  5571,  5572,  5575,  5576,  5586,
    5596,  5597,  5601,  5605,  5609,  5620,  5633,  5647,  5664,  5665,
    5666,  5678,  5698,  5699,  5703,  5704,  5708,  5709,  5713,  5714,
    5717,  5718,  5726,  5737,  5748,  5761,  5762,  5765,  5766,  5767,
    5770,  5771,  5772,  5775,  5776,  5777,  5793,  5805,  5818,  5833,
    5834,  5837,  5838,  5842,  5843,  5851,  5852,  5856,  5857,  5872,
    5881,  5890,  5899,  5908,  5920,  5921,  5922,  5923,  5924,  5930,
    5934,  5949,  5950,  5956,  5966,  5970,  5975,  5985,  5986,  5993,
    5997,  6001,  6005,  6009,  6013,  6017,  6021,  6025,  6029,  6033,
    6037,  6041,  6049,  6053,  6057,  6061,  6067,  6068,  6075,  6076,
    6079,  6091,  6095,  6110,  6121,  6122,  6127,  6128,  6143,  6153,
    6166,  6176,  6189,  6199,  6212,  6220,  6222,  6224,  6229,  6231,
    6244,  6253,  6254,  6258,  6262,  6274,  6285,  6296,  6309,  6310,
    6311,  6315,  6326,  6327,  6341,  6349,  6359,  6372,  6373,  6376,
    6377,  6387,  6396,  6404,  6412,  6420,  6429,  6437,  6445,  6454,
    6463,  6471,  6480,  6489,  6498,  6507,  6516,  6526,  6536,  6545,
    6553,  6561,  6569,  6578,  6587,  6595,  6603,  6611,  6619,  6627,
    6640,  6641,  6644,  6645,  6655,  6664,  6672,  6680,  6688,  6696,
    6705,  6714,  6723,  6732,  6740,  6748,  6756,  6764,  6772,  6780,
    6788,  6796,  6812,  6821,  6829,  6837,  6845,  6853,  6862,  6870,
    6878,  6887,  6896,  6905,  6913,  6921,  6929,  6937,  6945,  6953,
    6970,  6987,  6988,  6989,  6994,  7000,  7009,  7010,  7011,  7012,
    7013,  7017,  7018,  7021,  7022,  7023,  7024,  7028,  7029,  7030,
    7035,  7045,  7066,  7076,  7077,  7080,  7089,  7095,  7114,  7121,
    7128,  7135,  7142,  7149,  7156,  7164,  7172,  7180,  7188,  7196,
    7203,  7210,  7219,  7220,  7221,  7225,  7228,  7231,  7234,  7237,
    7244,  7246,  7248,  7253,  7255,  7267,  7278,  7292,  7298,  7304,
    7310,  7320,  7336,  7346,  7347,  7351,  7355,  7359,  7363,  7367,
    7371,  7375,  7379,  7383,  7387,  7391,  7395,  7399,  7403,  7407,
    7411,  7421,  7422,  7433,  7440,  7451,  7462,  7463,  7467,  7481,
    7488,  7505,  7518,  7527,  7535,  7543,  7552,  7563,  7564,  7575,
    7585,  7595,  7605,  7615,  7625,  7633,  7654,  7677,  7685,  7694,
    7705,  7706,  7718,  7732,  7746,  7758,  7770,  7787,  7788,  7792,
    7793,  7794,  7795,  7799,  7811,  7826,  7827,  7831,  7832,  7835,
    7836,  7839,  7840,  7844,  7845,  7858,  7865,  7875,  7882,  7892,
    7893,  7894,  7895,  7896,  7897,  7898,  7902,  7906,  7913,  7920,
    7921,  7925,  7926,  7927,  7937,  7947,  7948,  7952,  7953,  7954,
    7955,  7965,  7973,  7990,  7991,  8001,  8007,  8013,  8019,  8035,
    8045,  8051,  8057,  8066,  8068,  8073,  8084,  8085,  8096,  8110,
    8111,  8122,  8133,  8134,  8137,  8138,  8139,  8140,  8141,  8142,
    8143,  8144,  8147,  8148,  8159,  8177,  8178,  8182,  8183,  8187,
    8195,  8223,  8234,  8235,  8245,  8256,  8259,  8260,  8261,  8262,
    8263,  8266,  8267,  8268,  8316,  8317,  8321,  8322,  8336,  8337,
    8344,  8352,  8360,  8368,  8376,  8384,  8395,  8396,  8423,  8438,
    8439,  8458,  8462,  8466,  8481,  8488,  8498,  8499,  8502,  8514,
    8515,  8519,  8529,  8537,  8542,  8547,  8552,  8557,  8562,  8567,
    8572,  8577,  8584,  8585,  8588,  8589,  8590,  8597,  8598,  8599,
    8600,  8604,  8605,  8609,  8613,  8614,  8617,  8626,  8639,  8640,
    8641,  8642,  8646,  8647,  8651,  8653,  8663,  8668,  8671,  8676,
    8677,  8685,  8695,  8696,  8697,  8705,  8709,  8710,  8713,  8714,
    8719,  8720,  8724,  8725,  8729,  8730,  8734,  8735,  8739,  8740,
    8744,  8752,  8763,  8764,  8769,  8775,  8793,  8794,  8798,  8799,
    8809,  8813,  8818,  8825,  8833,  8840,  8850,  8860,  8888,  8895,
    8899,  8925,  8929,  8941,  8954,  8968,  8979,  8994,  9000,  9005,
    9011,  9018,  9019,  9020,  9021,  9025,  9026,  9038,  9039,  9044,
    9051,  9058,  9065,  9076,  9077,  9090,  9094,  9101,  9111,  9116,
    9117,  9122,  9123,  9131,  9136,  9137,  9141,  9145,  9151,  9180,
    9185,  9192,  9197,  9203,  9208,  9217,  9219,  9222,  9226,  9227,
    9228,  9229,  9230,  9231,  9236,  9266,  9267,  9268,  9269,  9280,
    9286,  9294,  9295,  9301,  9306,  9311,  9316,  9321,  9326,  9331,
    9336,  9342,  9348,  9354,  9361,  9383,  9392,  9396,  9404,  9408,
    9416,  9428,  9449,  9453,  9459,  9463,  9476,  9495,  9518,  9520,
    9522,  9524,  9526,  9528,  9533,  9534,  9538,  9539,  9546,  9555,
    9563,  9572,  9583,  9591,  9592,  9593,  9597,  9599,  9601,  9603,
    9605,  9607,  9609,  9614,  9619,  9625,  9633,  9638,  9645,  9652,
    9656,  9660,  9690,  9691,  9693,  9701,  9723,  9725,  9727,  9729,
    9731,  9733,  9735,  9737,  9739,  9741,  9743,  9746,  9748,  9750,
    9753,  9755,  9757,  9760,  9762,  9775,  9777,  9790,  9792,  9805,
    9807,  9821,  9834,  9847,  9860,  9883,  9890,  9897,  9904,  9911,
    9934,  9941,  9948,  9955,  9962,  9969,  9976,  9980,  9988,  9992,
   10002, 10009, 10016, 10029, 10042, 10061, 10082, 10092, 10099, 10115,
   10120, 10138, 10140, 10142, 10144, 10146, 10148, 10150, 10152, 10154,
   10156, 10158, 10160, 10162, 10164, 10166, 10168, 10170, 10174, 10179,
   10183, 10187, 10192, 10209, 10210, 10211, 10226, 10238, 10240, 10242,
   10252, 10275, 10285, 10295, 10303, 10321, 10334, 10347, 10360, 10373,
   10386, 10403, 10416, 10439, 10460, 10470, 10483, 10500, 10513, 10523,
   10536, 10546, 10559, 10572, 10585, 10598, 10611, 10624, 10637, 10639,
   10652, 10670, 10684, 10700, 10722, 10738, 10751, 10764, 10777, 10781,
   10788, 10796, 10804, 10808, 10812, 10816, 10820, 10824, 10839, 10843,
   10852, 10856, 10860, 10865, 10879, 10881, 10885, 10887, 10889, 10892,
   10895, 10898, 10899, 10902, 10910, 10920, 10921, 10924, 10925, 10926,
   10931, 10935, 10939, 10943, 10954, 10955, 10959, 10960, 10965, 10973,
   10975, 10989, 10992, 11019, 11020, 11023, 11024, 11035, 11053, 11060,
   11069, 11086, 11131, 11139, 11147, 11155, 11163, 11184, 11185, 11186,
   11189, 11190, 11191, 11194, 11195, 11198, 11199, 11200, 11201, 11202,
   11203, 11204, 11205, 11206, 11209, 11211, 11216, 11218, 11223, 11225,
   11227, 11229, 11231, 11233, 11245, 11249, 11256, 11260, 11266, 11270,
   11281, 11282, 11285, 11289, 11293, 11299, 11300, 11305, 11309, 11316,
   11317, 11318, 11319, 11320, 11321, 11322, 11323, 11333, 11337, 11344,
   11351, 11352, 11368, 11372, 11377, 11381, 11396, 11401, 11405, 11408,
   11411, 11412, 11413, 11416, 11423, 11433, 11447, 11448, 11452, 11463,
   11464, 11467, 11468, 11471, 11475, 11482, 11486, 11490, 11497, 11507,
   11508, 11512, 11513, 11516, 11517, 11528, 11529, 11538, 11539, 11547,
   11558, 11559, 11562, 11578, 11586, 11594, 11616, 11617, 11628, 11632,
   11659, 11661, 11666, 11669, 11672, 11674, 11676, 11678, 11688, 11690,
   11701, 11705, 11709, 11713, 11717, 11726, 11733, 11758, 11762, 11768,
   11785, 11789, 11793, 11799, 11800, 11801, 11803, 11805, 11809, 11810,
   11811, 11827, 11828, 11829, 11834, 11835, 11836, 11841, 11842, 11843,
   11844, 11850, 11851, 11852, 11853, 11854, 11874, 11875, 11876, 11877,
   11878, 11879, 11880, 11881, 11882, 11883, 11884, 11885, 11886, 11887,
   11888, 11889, 11890, 11891, 11892, 11893, 11894, 11895, 11896, 11897,
   11898, 11899, 11900, 11901, 11902, 11903, 11904, 11905, 11906, 11907,
   11908, 11909, 11910, 11911, 11912, 11913, 11914, 11915, 11916, 11917,
   11918, 11919, 11920, 11921, 11922, 11923, 11924, 11925, 11926, 11927,
   11928, 11929, 11930, 11931, 11932, 11933, 11934, 11935, 11936, 11937,
   11938, 11939, 11940, 11941, 11942, 11943, 11944, 11945, 11946, 11947,
   11948, 11949, 11950, 11951, 11952, 11953, 11954, 11955, 11956, 11957,
   11958, 11959, 11960, 11961, 11962, 11963, 11964, 11965, 11966, 11967,
   11968, 11969, 11970, 11971, 11972, 11973, 11974, 11975, 11976, 11977,
   11978, 11979, 11980, 11981, 11982, 11983, 11984, 11985, 11986, 11987,
   11988, 11989, 11990, 11991, 11992, 11993, 11994, 11995, 11996, 11997,
   11998, 11999, 12000, 12001, 12002, 12003, 12004, 12005, 12006, 12007,
   12008, 12009, 12010, 12011, 12012, 12013, 12014, 12015, 12016, 12017,
   12018, 12019, 12020, 12021, 12022, 12023, 12024, 12025, 12026, 12027,
   12028, 12029, 12030, 12031, 12032, 12033, 12034, 12035, 12036, 12037,
   12038, 12039, 12040, 12041, 12042, 12043, 12044, 12045, 12046, 12047,
   12048, 12049, 12050, 12051, 12052, 12053, 12054, 12055, 12056, 12057,
   12058, 12059, 12060, 12061, 12062, 12063, 12064, 12065, 12066, 12067,
   12068, 12069, 12070, 12071, 12072, 12073, 12074, 12075, 12076, 12077,
   12078, 12079, 12080, 12081, 12082, 12083, 12084, 12085, 12086, 12087,
   12088, 12089, 12090, 12091, 12092, 12093, 12094, 12095, 12096, 12097,
   12098, 12099, 12100, 12101, 12102, 12103, 12104, 12105, 12106, 12107,
   12108, 12109, 12110, 12111, 12112, 12113, 12114, 12115, 12116, 12117,
   12118, 12119, 12120, 12121, 12135, 12136, 12137, 12138, 12139, 12140,
   12141, 12142, 12143, 12144, 12145, 12146, 12147, 12148, 12149, 12150,
   12151, 12152, 12153, 12154, 12155, 12156, 12157, 12158, 12159, 12160,
   12161, 12162, 12163, 12164, 12165, 12166, 12167, 12168, 12169, 12170,
   12171, 12172, 12173, 12174, 12175, 12176, 12177, 12178, 12179, 12180,
   12181, 12195, 12196, 12197, 12198, 12199, 12200, 12201, 12202, 12203,
   12204, 12205, 12206, 12207, 12208, 12209, 12210, 12211, 12212, 12213,
   12214, 12215, 12216, 12226, 12227, 12228, 12229, 12230, 12231, 12232,
   12233, 12234, 12235, 12236, 12237, 12238, 12239, 12240, 12241, 12242,
   12243, 12244, 12245, 12246, 12247, 12248, 12249, 12250, 12251, 12252,
   12253, 12254, 12255, 12256, 12257, 12258, 12259, 12260, 12261, 12262,
   12263, 12264, 12265, 12266, 12267, 12268, 12269, 12270, 12271, 12272,
   12273, 12274, 12275, 12276, 12277, 12278, 12279, 12280, 12281, 12282,
   12283, 12284, 12285, 12286, 12287, 12288, 12289, 12290, 12291, 12292,
   12293, 12294, 12295, 12296, 12297, 12298, 12299, 12300, 12301
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED",
  "CONCURRENTLY", "CONFIGURATION", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE",
  "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP",
  "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P",
  "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS",
  "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P", "DELIMITER",
  "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT",
  "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE",
  "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN",
  "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL",
  "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "OUT_P", "OUTER_P", "OVER",
  "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE", "RANGE",
  "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF", "REFERENCES",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT", "TRIGGER", "TRIM",
  "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "UNBOUNDED", "UNCOMMITTED",
  "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED",
  "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID", "VALIDATE",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS",
  "XMLFOREST", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P",
  "YES_P", "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'",
  "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "AlterCompositeTypeStmt", "alter_type_cmds",
  "alter_type_cmd", "ClosePortalStmt", "CopyStmt", "copy_from",
  "copy_file_name", "copy_options", "copy_opt_list", "copy_opt_item",
  "opt_binary", "opt_oids", "copy_delimiter", "opt_using",
  "copy_generic_opt_list", "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "OptCreateAs", "CreateAsList",
  "CreateAsElement", "opt_with_data", "CreateSeqStmt", "AlterSeqStmt",
  "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly",
  "NumericOnly_list", "CreatePLangStmt", "opt_trusted", "handler_name",
  "opt_inline_handler", "validator_clause", "opt_validator",
  "DropPLangStmt", "opt_procedural", "CreateTableSpaceStmt",
  "OptTableSpaceOwner", "DropTableSpaceStmt", "CreateExtensionStmt",
  "create_extension_opt_list", "create_extension_opt_item",
  "AlterExtensionStmt", "alter_extension_opt_list",
  "alter_extension_opt_item", "AlterExtensionContentsStmt",
  "CreateFdwStmt", "fdw_option", "fdw_options", "opt_fdw_options",
  "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "OptForeignTableElementList", "ForeignTableElementList",
  "ForeignTableElement", "AlterForeignTableStmt", "CreateUserMappingStmt",
  "auth_ident", "DropUserMappingStmt", "AlterUserMappingStmt",
  "CreateTrigStmt", "TriggerActionTime", "TriggerEvents",
  "TriggerOneEvent", "TriggerForSpec", "TriggerForOptEach",
  "TriggerForType", "TriggerWhen", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opclass_purpose", "opt_recheck", "CreateOpFamilyStmt",
  "AlterOpFamilyStmt", "opclass_drop_list", "opclass_drop",
  "DropOpClassStmt", "DropOpFamilyStmt", "DropOwnedStmt",
  "ReassignOwnedStmt", "DropStmt", "drop_type", "any_name_list",
  "any_name", "attrs", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_type", "comment_text", "SecLabelStmt", "opt_provider",
  "security_label_type", "security_label", "FetchStmt", "fetch_args",
  "from_in", "opt_from_in", "GrantStmt", "RevokeStmt", "privileges",
  "privilege_list", "privilege", "privilege_target", "grantee_list",
  "grantee", "opt_grant_grant_option", "function_with_argtypes_list",
  "function_with_argtypes", "GrantRoleStmt", "RevokeRoleStmt",
  "opt_grant_admin_option", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique", "opt_concurrently",
  "opt_index_name", "access_method_clause", "index_params", "index_elem",
  "opt_collate", "opt_class", "opt_asc_desc", "opt_nulls_order",
  "CreateFunctionStmt", "opt_or_replace", "func_args", "func_args_list",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "locked_rels_list", "values_clause", "from_clause", "from_list",
  "table_ref", "joined_table", "alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_expr", "xml_root_version", "opt_xml_root_standalone",
  "xml_attributes", "xml_attribute_list", "xml_attribute_el",
  "document_or_content", "xml_whitespace_option", "xmlexists_argument",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "role_list", "SignedIconst", "ColId",
  "type_function_name", "NonReservedWord", "ColLabel",
  "unreserved_keyword", "col_name_keyword", "type_func_name_keyword",
  "reserved_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
      61,    60,    62,   665,    43,    45,    42,    47,    37,    94,
     666,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -3755

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-3755)))

#define YYTABLE_NINF -2126

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2126)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    4212,    13,  6951, -3755, -3755,    13, -3755, 49555,   476,   679,
      75,   128,  8492, 49959, 56019,   180,   272, 10019,    13, 56019,
     932, 37031, 47131, 56019,  1104,   853, 37031, 56019, 56423,   962,
     850, 56827, 50363, 45919,  1012, 56019,  1132,   948, 57231, 50767,
    1009, 51171,   853, 34223,   188,   960, 57635,  1045,  1418,  1109,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755,   476, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755,   169, -3755,   918,   211,  1142,   765,  1123, -3755,
   -3755, -3755, 41475, 56019, 56019, 56019,  1328, 56019, 56019,   173,
   41475, 41879, 56019,  1366, 30911, -3755, 41879, 56019, 56019, 56019,
   51171, 56019,  1351, 56019, 56019, 42283, 56019,  1486,  1148, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, 56019,  8169,  1104, -3755, -3755, 56019,  1375, 41475,
   56019,  1315, 56019,  1391, 56019, -3755, 56019, 58039,   697,   470,
   41879,  1372, 31328,  1464, 41879, 56019, 56019, 56019, -3755, -3755,
    1459, 56019, 56019, -3755, -3755, 42687,  1298,  1701,  1600,   608,
   -3755, 51575, -3755, -3755, -3755, -3755, -3755, -3755, -3755, 40263,
     272, -3755, -3755, 43091, 56019,  1624, -3755, -3755, 58443, -3755,
   -3755,   732, 43495, 43899, -3755, 31745,  1755, 44303, 58847, -3755,
   -3755, 59251, -3755, 59655,  1508, 60059, -3755, 44707, -3755,  1633,
   60463, -3755,  1414,   967,    94, 27624, -3755,   476, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755,   307,  1378,   184,   163,
     246, -3755, -3755,   165,   168,   175,   307,  1846,  1846, -3755,
   56019, -3755, -3755,  1378,    26,  1463,  1463,  1463,  1652,    14,
   -3755,  1463, -3755, -3755, -3755, -3755, 51171, -3755,  1485,  1104,
    1495,  1842, 56019, -3755, 56019, -3755, 56019, 56019, -3755, -3755,
    1884,  1521,  1744,  1525, -3755,  1685,  1708,  1731,    91,  1104,
    1653, -3755,  1801, -3755,  1768, 18866,  1104, 51979, 60867,   192,
   40263,  1104, 52383,  1601,  1148,  1769, -3755,   614, -3755,  1992,
    1654,  1853,  1525,  1148, 28854, -3755,  1659,   -45, 51171, -3755,
   -3755, -3755,   282,  1935, 19287, -3755, 56019,  1661, -3755,  1700,
    1670,  1697,  1142, -3755,  4212, 56019,  1068,  1068,  2081,  1068,
    1319,  1370, -3755,  1578, -3755,  1986,  1949, 51171,   960,   199,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755,  1719,   -45, -3755,   213, -3755,  1212,  1726,  1310,
    1034, -3755, -3755,   842,  1829,   158,    -1,  1779, 51171,  2480,
    1761, -3755,   620, -3755, -3755, -3755, -3755,  4248,   276, -3755,
   56019, 56019, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755,  1790, -3755, -3755,  1751,   980,  1469, 11144,   958,  4738,
    1231,   773,  1952,   201,  2110,  1312,  5419, 56019, -3755,  2051,
    2161,    60, -3755,   250, -3755,  1907,  2034,   859, 41475,  1857,
   -3755, -3755, 56019, -3755, -3755, -3755, -3755,   753, 41475, -3755,
    2044, 32162, -3755, 56019, -3755, -3755, -3755, -3755, -3755,  1977,
   56019, -3755, -3755,  2108, 56019, -3755,  1463,   237,  1893,  2247,
   68095,    78, 56019,  1939,  2301,  2109,  1939,  1954, 61271, -3755,
   -3755,  1939, -3755, -3755, 56019, 56019,  1918,  1313,  1939,  2320,
    2321,  2002,  2105,   807,  1141,   140,  2219,  1939, 56019, 61675,
   56019, 56019,  2292, 41475, 56019, -3755,  2092, -3755, -3755,  1382,
   -3755, -3755, -3755, -3755,  2236,  1719,   802,  2238,  1950,  2240,
   -3755,  1983, -3755,  2242,  1761,  2246, -3755,  1955, 62079, 62483,
    2250,  1790, 41879,  2251,  1955,  2252,  2136,  2256,   802,  2258,
   -3755,   942,  2259,  2149,  2261,  1439,  1955, 40667,  2265,   207,
   -3755, 20971, -3755,  2060, -3755,   960, -3755,  1308, -3755, 36627,
   -3755,    94,  1378, -3755, 56019,  1378, 56019,  1378, 56019,  1378,
   56019,  1378, 56019, 56019, 56019,  1378, -3755, -3755, -3755, 56019,
    1978, 56019, 56019, -3755, -3755, -3755, 47535, 41879, 47939, -3755,
   -3755,   304,  1104, -3755, -3755, 68095,  2372, 41879,  2260,  2260,
    2260, -3755, -3755, -3755,  2199, 56019,  2263,  2264, 47535, 41879,
   -3755, 62887, 40263,  2165,  1988, -3755, -3755, -3755, -3755, -3755,
    1340,  2408,   181,  2420, 20971,  2005,   156,   156,  2006, -3755,
   -3755, -3755,   218,  2007,  2008, -3755,   219,   219,  2166,  2010,
    2012, -3755,   231,  2013,  2432,  2433,   242,  2018,  2023,  2024,
    1651,   156, 20971, -3755,  2025,   219,  2026,  2027,  2028,  2447,
    2030, -3755,  2449,  2032,   157,   265,  2037,  2038, -3755,  2010,
   -3755,   204,  2039,  2040,  2041,  2043,  2045,  2046,  2047,  2048,
   20971, 20971, -3755, 18024,   -45,  1104, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755,   120, -3755,   243,  4851, -3755, -3755,  2202,
   20971, -3755, -3755,    82, -3755,   252, -3755, -3755, -3755,   -45,
   -3755, -3755,  1005,  2049, -3755,  1591, -3755, -3755, -3755, -3755,
   -3755, -3755, 39051,  2436, -3755,   847,   250,  1425,  2386, 35819,
   36223, -3755, -3755,  2273, -3755, 56019, -3755, -3755, 20971, 33819,
   -3755,   -45,   197, -3755, -3755, -3755,  1505, -3755, -3755, -3755,
     476, -3755, 10993, -3755,  1511,  1661, 56019, 56019,  2451, -3755,
   -3755, -3755,  1700, -3755, -3755,  1142,  1142, 20971,  1142,   741,
    1268, 19708, 20971,  2335,  2241,   648,   178,  2341, -3755,  1319,
    1370, 51171, 56019, 63291,  2169, -3755, 35031,  1368,   -45,  2150,
    2154,  2193, 37839,  2080,  2157,  2158,  2204,  2162,  2168, 63695,
   -3755, -3755, -3755, -3755,  1227,   860,   217,  2171,   914, -3755,
    2205, -3755, -3755, -3755,  3216, 56019,  5457,  2270,   276,  2206,
   -3755,  2173,  2174,  2283,   276,   220, 64099, -3755, -3755, -3755,
   -3755, -3755,  1423, 16817, -3755,  2175,  2159, 45111,  2459,  2287,
      37,  1409,   160, 56019,  2353,  2294, 56019,  2113,  2187,  2189,
    2120,  1191,  2470,  2121, -3755, -3755, -3755,  1832,  2291, -3755,
    2179,  2180, 67309,   590, 32579,  2455,  2203, -3755,  1111,  2207,
    2217,   276, -3755,  2506,   276,   276,  1267,  2520,  2221,   328,
    1357,  1939,  2121,  1181, -3755,  2222,   248, -3755,  2326,   132,
    1397,  2121,  2226,  2227,  2120,  2120, 56019, 56019, 56019, 56019,
   56019,   198,  2532,  2542,  2230,   166,  2278,  2163, -3755, 39455,
    2235, 60867, -3755, -3755,  2239,  1428,  2121,  1471,  1337, -3755,
   -3755, -3755,  1148, -3755, 56019, -3755, 56019,  1719, 68095,  2343,
    2194, -3755,  1761,   276, 56019, 56019,  1790,   716,   995,  2346,
   56019,  2402,  2208, -3755, -3755,  1939, -3755, 35425,  1918, -3755,
    2172, -3755, -3755,  2214, -3755,  2214,  2214,  2178,  2178,  2182,
   -3755, -3755, -3755,  1651,  2214,  2178, -3755, 68881, -3755,  1331,
    1341, -3755,  2565,  2568, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755,   647,  1449, -3755, 56019, 37839, -3755,  2592,
   -3755, -3755, 68095,  2484, -3755, 56019,  2383,  2196, -3755,  2518,
    2254, -3755,  2244, -3755, 41879,   224,  1104,  2248, 56019,  2409,
   56019, 56019, 56019, 56019, -3755, -3755,  2388,   639,    83, -3755,
   39455, -3755,  1181,  2400,  2601,    32,  1463,  2490, -3755, 56019,
    2213,  2606,  2441, -3755,  1456, -3755,  2332, -3755, 41475,   802,
   -3755, -3755, -3755, -3755, 68095, 56019, 64503, 41475,   802, 41879,
   41879,  2507,  2269,  2508,  2272, 32579,   802,   235, 41879, 56019,
   56019, 56019, -3755, 56019, -3755, -3755, -3755, -3755, 56019, 56019,
   41879, 39455,  2510,  2511,   802, 56019, 56019, -3755, 10993,  1524,
   56019,    94, 39859, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, 56019, -3755, 56019, -3755, 56019, -3755, 56019, -3755, 56019,
   -3755, -3755, -3755, 56019, -3755, 56019,  1564, -3755, -3755,  1565,
     137, 56019,   171, 41475, 56019,  2407, 56019, 56019, 56019, 56019,
    2299,  2049,   -21, -3755,   512, 51171,  2415, -3755, -3755,  1569,
    1045,   511, -3755, -3755, -3755, -3755, -3755, -3755, 47939, 47131,
    2501,    66, 56019, -3755, -3755,  1596, 20971,   -45, 18445, -3755,
   -3755, -3755,  2229, 10993,  2268, 20971, -3755, -3755, 20971,  1846,
    1846, 20971, -3755, -3755, -3755, -3755,   804,  1846, -3755, 20971,
   20971,  1846,  1846,  2214,  2214, -3755,  3505, 20971, -3755, 32579,
   20971, 23497, 15582, 20971,  2308,  2253,  1846, -3755,  1846, -3755,
   20971, 17603, -3755, 20971,  2435, 24333, 20971,  1425,  2437, 20971,
    1425,  2650,  2650,  2564,  4869,  2245,   -45, -3755,  2345,  1846,
   -3755,  1846,   135, -3755,   186, 68095, 20971, 37839,  2319,   225,
   56019, 20971,  2262,  1176, -3755, 20971,  1000, -3755,  2271, 20971,
    2323, 20971, 20971, 20971, 20971, 20971, 20971, 20971, 20971, 20971,
   -3755, 25153,   232,    57,  1461, 52787, 18866,  2519, 15160, -3755,
     193, -3755, -3755, -3755, 56019,  2436, -3755, -3755,  2322, -3755,
   -3755, -3755, -3755, -3755,   259, -3755, -3755, -3755, -3755, -3755,
   -3755,  2257, -3755, -3755, -3755, -3755,  2257, -3755,  2267,  2311,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755,  2517,  2528,   802, 56019,   282,
   48343, -3755, 19287, -3755,  1571, -3755,  2274, -3755,  2496, -3755,
    2275, -3755,  8048,  2496, -3755, -3755,   270,  2425,  2457,  2457,
   -3755,  2279, 10993, -3755,  1669, 10993,  1738, -3755, -3755, -3755,
   -3755, -3755, -3755,  1015, -3755,  2335,   178,  2328,   678, 56019,
   -3755, 29264,  2276,  1584,  2351,  2358,  2414, 41879, 56019, 56019,
   -3755, 37839, 41879, 56019, 56019, 41879, 56019, 56019, -3755,  2638,
     651, 47131,  2418, 46323, -3755, -3755,  2312, 56019,  2360,  2539,
    2541,   463, -3755, -3755, 56019, -3755,  2504, 41879, 20971,  2505,
   56019, 56019,  2387, 41475,  2324, 56019, 56019, 56019,   798, 41475,
   32996, 56019, 56019, 56019, 56019,  2434, 56019, 56019,  2546,   747,
     162,  1710,  2121,  2512, -3755,   222, 41879, 56019,  2499, -3755,
   -3755, -3755, 53191, -3755, -3755, -3755,  2497, -3755, -3755, 68881,
   -3755, -3755,  1588, -3755, 68488, 66119, -3755, -3755,   396, 41879,
   41879, 56019,   823, -3755, -3755, 68095, -3755, 56019, 56019, 56019,
   48747, 64907, 65311,   898,  1255, 56019, 49151, -3755, 56019, -3755,
   -3755, 38243, 41879, 56019, 37839, -3755, 56019,  2509,   233, -3755,
   56019,  5472, -3755,  2404, 56019, 56019,  2325,  1618,  2405,  2444,
   -3755, 56019, 41879,   176, -3755, 41879, 56019, -3755, -3755,   276,
   -3755, -3755, -3755, -3755, -3755, 56019, 56019,   276, 56019,   276,
    1146, -3755, 41879, -3755, -3755, -3755, 56019, 56019, 56019, 41879,
   56019, -3755, -3755,   840,    34,   523,  1379,  2467, 56019,  1104,
   56019, 65715, 41879, 56019, 56019, 56019,  1059, -3755, -3755,  2442,
   -3755, 41879,   176, 56019, 56019,  2410,  2411,   258,  2485, -3755,
   -3755, -3755, -3755, -3755, -3755,  2572,  2728, 56019, -3755,  2574,
    2575,  2396,  2397,  2579,   267, 56019, 56019, 56019, 56019, 56019,
   56019,  2581,   267,  2535,   125,  2357,  2366,  1638, -3755, -3755,
   20971,  2751, 68095,  2361,  2363,  2439,  2443,  2446, -3755,  2362,
    2450,  1846, -3755, -3755,  1478, -3755, -3755,  1666, -3755,  2376,
     639,  1256, -3755, 56019,   116,   774,  2657, 16406,  2477,  2495,
    2652, 56019, 56019,  2495, -3755,  2177, 47131, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755,  2654, -3755,  1104,  1918,
    1918,  1918,  1918, -3755, -3755, -3755, -3755,  2558,  1602, -3755,
    2379, 56019,  2489,  2495, -3755,  1181,  2671,   822, 56019, 45515,
    1635,  2777,  1104,  2571, -3755, 17210,  3117,  2573, 40263,  2647,
    2648,  2668, -3755,  1719, -3755,  2786, -3755,  2688,   802,  1761,
   -3755,  1955, -3755, 56019, 56019, 56019, 56019,  1790, -3755, -3755,
    1955,  2578,   802,   802, -3755,  2580,   802,  1955,  2513,  2679,
   40263, -3755,   207, -3755, -3755, 20971,  2403, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755,  1671, -3755, 56019, -3755,  2659,
    2662,  2666,  2417,  2445, 56019,  2419, -3755,  2417,   276,  2417,
    2049,  2049,  2417, 41071,  2808,  2689,   711, -3755,   764,    59,
    2627, -3755, -3755, -3755, -3755, 68095, -3755, -3755, -3755, -3755,
   -3755, 56019,   106,  2603,  2422, 41071,  2802,   802, -3755, 41475,
   -3755, -3755,  2514, 41475,  2611, -3755, -3755, -3755, -3755, -3755,
    2656, 56019,  1686, -3755, -3755,  1465, -3755,  1467, 20971, 20971,
     350, -3755,  9813,  1691,  2453,  2454,  1692, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755,  2456,  2706, -3755,  2458,  1693,  1698,
    2460,  2461, -3755, -3755,  1877,  2462, 10245,  2463, 23497, 23497,
     725, -3755, -3755, 23497,  2465, -3755,  1716,  8736,  2431,  2466,
    2464, -3755,  2468,  2469,  9825, 20129, 20971, 20129, 20129,  9559,
    2431,  2471,  1722, 37839,  2597, 10543,  1734, -3755, 20971, 37839,
    4428, 20971, -3755, 20971, 56019,  2472,  2473, -3755, -3755,  3505,
   -3755,  2475, -3755, 23497, 23497, -3755,  2498, 18024, -3755, -3755,
    2710, -3755, -3755,  1118, -3755,  2438, -3755, -3755,  4226,   363,
   20971,  2262, 20971,  2516, 32579,  6230, 20971,  3014,  6500,  6500,
     333,   333,   238,   238,   238,   366,  1461, -3755, -3755, -3755,
    2440,  2030, 20971, -3755,  1481,  1621, 56019,  3419,  3469,  3825,
   -3755, -3755, -3755, 26394,  2481, 20971, 20971, 20971,  2476,  2615,
    2858, 10993,   981, -3755,  2860, -3755,  1148,  1846,   135, 36627,
   -3755, -3755, 20971, -3755, -3755, -3755,  1700, -3755, -3755, -3755,
   -3755, -3755, 56019,  1045, 20971, -3755, -3755,   460,  1723, 20971,
    1669, -3755, -3755, 56019,  2415,  2415, 20971, -3755, -3755, -3755,
   -3755, -3755, 26394,  2488,  2524, 28444,  2587, -3755, -3755, 56019,
     133, -3755, -3755, -3755,  2492, -3755, -3755, -3755, 41879, 56019,
   56019, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755,  2684, -3755, 41879, 41879,  2630, 56019,  2646,  2658, 20971,
     941, 56019,  2482,  2483,   873,  2731, 56019, -3755,   802, -3755,
   -3755, 10993, -3755, -3755, -3755, 40263, -3755,  1719, 68095, -3755,
   -3755, -3755,  2515, 56019, -3755, 56019, 56019,  1790, -3755, -3755,
   -3755, -3755,  1004, -3755, -3755, 56019, 56019,   610,  2560, 56019,
   -3755,   686,  2326, 56019, 56019, 56019,  2730, -3755, -3755, -3755,
   -3755,  2685, -3755, -3755,  1449, -3755, 66119, 68488, -3755, 68488,
   -3755,  1449,  1438, -3755,  1955, -3755, -3755,   899, -3755, -3755,
   -3755, -3755, -3755,  2788,   802,  2789,   802, 56019, 56019, 56019,
   56019, -3755, -3755, -3755, -3755, -3755, 37839, 37839, 37839,  1740,
   -3755, -3755,  1104, -3755, -3755, -3755,  1741, -3755,   504, -3755,
   -3755, -3755, -3755, -3755, -3755, 41879,  1448, -3755,   806, 68095,
   -3755, 67702, 41879, 56019, -3755, -3755, -3755,  2713,  2661, -3755,
     758,  2663, 41879,  2557, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755,  2582, -3755, -3755, -3755,  2714,
    2716,  2718,  2584,  2585,  2622,  2586,  2588,  2633, -3755,  2590,
    2635,  2593,  2636,  2594,   802, 68095,  1645,  2628,  2811,   802,
   -3755,  2600, -3755, -3755,  2916, -3755, 56019, -3755, -3755, -3755,
   41879, 56019, -3755, -3755, -3755,   267, 68095,  2763,   267,   267,
   56019, 56019,   267, -3755, -3755, -3755,  2764,  2767,  2768,  2769,
    2770,  2771,   267, -3755, -3755, -3755, -3755,   237, 37839, -3755,
    1946, 30494, -3755,  2961,  5138,  2544,  2363,  2543,  1846,   161,
    1153,   110,  2660,  1846,  2745,  2548, -3755, -3755, 37839, 30494,
    1648,  2761,  2563,  2563,  2563,  2563,  2563,  2563,  2563, -3755,
    2302,  1939, 40263, 56019, 40263, -3755,   774,  2721, 56019, -3755,
   -3755,  1742, -3755, 56019, 41879,   671, 41879,  1846, -3755, -3755,
    2625, -3755,  1463,   224,  2696,  1322,  2894, -3755, -3755, -3755,
   -3755, -3755, 56019, 56019,   639,  1104,  2567,  2583, -3755, 56019,
   56019, 56019,  2609,  2577, 56019,  2589,  2596, -3755, -3755, -3755,
   -3755,  1746, -3755, 68095,    44,  2758,  2760,  1045,  2667, 56019,
   -3755,  1753,    79, -3755,  1104, 40263, 66512, -3755,  1660, -3755,
   -3755,   680,  2848, -3755, -3755,  1045,   802, 68095, 56019, -3755,
     802,  2640,   802,  2641,   802,   802, 56019, -3755, -3755, 56019,
   -3755, 56019, 39455,   802, -3755, 10993, 56019, -3755, -3755,  2703,
    2715,  2722, 56019,  2417, 41475, -3755,  2602, 41879,   631, -3755,
   -3755,  2776, -3755, -3755, -3755, -3755, -3755,  2884,  2887, -3755,
   -3755, -3755, 41879, 47535,   275, 41879, -3755,  1719, -3755,  1761,
     276, 56019,  2839, -3755, -3755, -3755,  2610,  1754,  9283, 20971,
   -3755,  2906, 68095, -3755, -3755, -3755, -3755, -3755, 20971, -3755,
   -3755, -3755, -3755, -3755, 20971, -3755, 20971,  2885, -3755,  3026,
    3026, 68095, 23497,  1401,  2026, 23497, 23497, 23497, 23497, 23497,
   23497, 23497, 23497, 23497, 25574,   382, -3755, -3755, 20971, 20971,
    2895,  2885, -3755, -3755,  1279,  1279, 68095,  2617,  2431,  2618,
    2619, 20971, -3755, -3755,  1762, 24743,  2629, 37839, -3755, 20971,
    8952,  1774,  2669, 10803,   -45,  5337, -3755,  2981,  1104, 20971,
     976,  1814, 20971,  1778, 20971,  2902, -3755, -3755, -3755,  2632,
   -3755, -3755, 68095, 20971, 23497, 23497,  4417, -3755,  4918, 20971,
    2637,  6984, 18024, -3755,   853,   853,   853,   853, -3755, 56019,
   56019, 56019, 25984, 53595,  2642,  1640, -3755, 53595, 53999, -3755,
    2634,   -45, 20971,  2901,   603,   603,  2643,  2615, 29674, -3755,
   20971,   790, 20550,  2644,   250,  2649, -3755, -3755,  7735, -3755,
   -3755,  2651, -3755,  2639, -3755,  1723, -3755, -3755, -3755,  5450,
    2814,  2049, -3755, -3755, -3755,  2642, 21392,  2587, -3755,  1780,
   -3755, -3755, 18866, -3755, -3755,  1782, 29264,  2488, 19287,   -45,
   -3755, -3755, -3755,  2563,  1955,  1955,   138,  2417,  2919,   138,
    5763, -3755, -3755, 26804, 56019, 56019, -3755, 56019,  1784,   991,
   -3755, -3755, -3755,  3039, 56019, -3755,  2700,  2708, -3755, 56019,
   56019, 56019, 56019, -3755, -3755,  1726, -3755, -3755, 41879, -3755,
   -3755, -3755, -3755,  2724, -3755, -3755,  2896,  1492, -3755, -3755,
   -3755,  2723,  2302,   209,  2120,   662, -3755,  2725, 56019, -3755,
   56019, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   38243, -3755, -3755, -3755, 37839, 30494, 37839, -3755,  2733,  2735,
    2775,   707,   170,  2736,  2737,  2783,  2670,  2672,  2680, -3755,
   -3755,   307,  1104, -3755, -3755,  1104,  1955,  1104, 56019,  2945,
     599,  1522, 41879, 56019, 56019, 41879, 56019, 56019, 56019, 56019,
   56019, 56019, 56019, -3755,  3025,  1104,  1104,  2996,  2734, 56019,
   -3755, 56019,  2326, -3755, -3755, -3755,  2681,   267, -3755, -3755,
    2904,  2912, -3755,   267,   267,   267,   267,   267,   267, -3755,
     155,  1788, -3755, 27214, -3755, -3755,  2301,  1104,  2301,  1358,
   -3755,  2301, -3755,  2301, -3755,  2639,  1846,  1832, -3755, -3755,
   -3755, -3755, -3755, -3755,  2366, -3755, -3755,  1846,  1770,  2686,
   -3755,  2687, -3755, -3755, -3755, -3755, -3755, -3755,  2682, -3755,
     135, -3755, -3755, 56019,  2563, -3755,   353,   326,   343,  1233,
   54403, 54807, 55211,  2690, 56019, 56019, 23497, -3755,  1130,   206,
   -3755,  2915, 56019,  2726, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755,  2691, -3755,  2196, -3755, 56019,  2721,  1955, 41879, 41879,
    1955, -3755, 68095,  3076,   967, 61675,  2719,  2693,  2971, -3755,
    2694,  2695, -3755, -3755, 56019,  2721,   505,  1414,   720, -3755,
   46727,  1635, -3755,  2941, 45515, -3755, 56019, -3755, -3755, -3755,
    3050,  2781,  2738,  1104,  2360, -3755, 66119, 20971, 20971, -3755,
    2697, -3755,  2702,  4073, -3755,  1918, -3755, -3755, -3755, -3755,
   -3755, -3755,  2778, 56019, -3755, -3755,  2705,   802, -3755, 56019,
   -3755, 56019, -3755, -3755,   802,   802, -3755,  2815, -3755, -3755,
   56019, 56019, 56019,  2417, -3755,   276, -3755,  2977, 41071, -3755,
   -3755, -3755, -3755,    66,  2983, -3755, -3755,  2944,  2946,  2947,
    2948,   761, -3755, -3755, 20971, 10993, -3755,  2712, 10993,  5964,
   10993,  2895, -3755,  2300,  2990, -3755,  1083,  2720,  2300,  1260,
    1260,   338,   338,   196,   196,   196,  3026,   382, 10993, 10993,
   -3755, -3755, -3755, -3755,  2717, -3755, -3755, -3755,  2431, -3755,
   21813,  2861,  3098, -3755, -3755, -3755,  2762,  2765,  2729, -3755,
   20971, 22234,  2727, 68881, -3755, -3755,   135,  1276, 23497, 23497,
    1662, -3755,  1229, 20971, 68095,  1811,  1662,  2078,  2192, 20971,
   20971,  7380,   385, 20971,  6181, 56019, 56019, 56019, 56019, -3755,
   -3755, -3755, 15995,  1640,  2732, 56019, -3755,  2739, 26394,  2956,
    2905, -3755, 26394,  2905,  1284,  2905,  2966, -3755, 30084, -3755,
    2742, 15160,  1381, 10993,  3113,  3006, 20971,  2744, -3755,  2747,
    2615, -3755, 66905, -3755, -3755, 10993, -3755, -3755, 20971, -3755,
    2615,  1104, -3755, -3755, 32579, -3755, -3755, -3755,  2931, 10993,
   -3755,  1045, 56019,   -45,  2746,  2766, 56019, -3755,  2587, -3755,
     307, -3755, -3755, -3755,  2827, 47131,  3028, -3755, 20971,  1812,
   -3755,  2790,  3115,   294,  1813,  1817,   991, -3755,  2726, -3755,
    1152,   296, -3755, 68095, -3755, 56019, 56019, -3755, -3755, -3755,
   -3755,  2080, -3755, 56019, -3755,  2823, -3755,  2949, -3755, -3755,
    2950,   307, 56019, -3755, 68095,   802,   802, -3755, -3755, -3755,
    2773, 41879, 56019, 56019,  1846,  1846, 68095,  2774, -3755,  1846,
    1846,  2780, -3755, 41879, 56019, 56019, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, 56019, 56019, 56019, 56019,  3053, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   56019, -3755, -3755, -3755, 68095,   802,   802, -3755,  2997, -3755,
     267,   267, -3755, -3755, -3755, -3755, -3755, -3755, -3755,  1939,
    3080, -3755, 37839, -3755, 38647, -3755, -3755, -3755,  1104, -3755,
    1104,  2955, 34627,  1104,  1104,   991,  2772,   191,  3040, -3755,
   -3755, -3755, -3755,  3043,   307, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   20971, -3755,  1336,  2300, -3755, -3755, -3755, -3755,  2726,  1463,
    2824,   116, 37839,  2881, -3755, -3755,  1955,  1955,  2832,  1045,
     529, 56019,  3077,  2819, -3755,  1104, -3755, -3755, 56019, 45515,
   -3755, -3755,  3112,  1819, -3755, -3755, -3755,  2820,  2760,  1294,
    2787,  1635, -3755, -3755,   793, 56019, -3755,  1122, -3755,  3061,
    2793, -3755, 10993, 10993,  1104, 69274,  1660, -3755, 56019,  3034,
     802, -3755,   802,   802, -3755, -3755, 56019,  2417,  2417,  2417,
   -3755,  2965, -3755,   802, 41071,   761,   761,   761,   761, -3755,
   -3755, -3755, 10993, -3755, -3755, -3755, 23497,  3067, -3755,  2795,
   68095, -3755,  2798,  1821,  1823, 24333,  2942, -3755, -3755, -3755,
    6537,  2852, 10993,  2911,  2805,  2818, -3755,  1030,  1030,  1229,
    1825, -3755, 23497, 23497,  1662,  1662, 20971,  1662, -3755, -3755,
   -3755, -3755, -3755, 53595,  2809, 56019,  1640, 26394, -3755, -3755,
    1100, -3755, 26394,  3045, -3755, 26394, 56019,  2821, 56019,  1031,
   20971, 20971,  2855,  2615,  2615, -3755,  2985, -3755,  2825, -3755,
     135,  2826, 56019, -3755, -3755,   960, -3755, -3755, -3755, 41071,
    3002, 41071,   991,  7111,  2726, 26804, 33413, 56019, 55615, 55615,
    2967,  2726,  2824, -3755, -3755, -3755, -3755,  2829, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755,  3025, -3755, -3755, 30494,
   -3755, -3755, -3755, 28034, 32579, -3755,   707,  2828,  2833,   170,
   -3755, -3755, -3755,  1110,   979,  2866,  2417,  3114, -3755,  3025,
   -3755, -3755,   267, -3755, -3755,  2357,  1104, -3755, -3755,  1827,
   -3755, -3755, -3755, 56019, -3755,  2693, -3755, -3755, -3755, 41475,
    3226,  3226, 56019, -3755, -3755,  7177,  3022, -3755,  2824,  3044,
    3091, -3755,  1835, -3755, 56019, 56019,  2738, 45515,  2721, -3755,
     876,  2842,  3133, -3755,  2577,  2843, -3755, -3755, 46727,  3019,
    2781,   956,   956, 56019,  2760,  2968, -3755,  2969, -3755,  3209,
    3029,  3213, 56019, 26804, -3755, 68488, -3755,  1836, -3755, -3755,
    2481, 56019,    85, -3755, -3755, -3755, -3755, -3755, -3755,   275,
   -3755, -3755, -3755, -3755,   595, 23497, 68095,  1837, 20971, -3755,
   20971, -3755,  3228, -3755, -3755, -3755,   640, -3755, -3755, -3755,
    1030,  1030,  1662, -3755, 56019,  1841, -3755, 20971,  2851, -3755,
   -3755, 26394,  1100,  1843, 56019,  1848, 68095,  2615,  2431, 10993,
   56019, -3755, -3755, -3755,  3230,  3030,  2615, -3755, -3755, -3755,
   -3755,   631,   138,   275,  3115,  2824, -3755,  2856, -3755, -3755,
   56019, -3755,  1144,  1144, 56019,  2824, -3755, -3755,  2909, -3755,
   68095,  1761,    87, -3755, 68095, 68095, -3755, 56019, 56019, 56019,
   56019, 56019,   802, -3755, -3755, -3755, -3755, 38647,  2693,  3226,
     268, -3755, -3755, -3755,  1376, -3755, -3755,   955,  3037,  2951,
   -3755, 37839,  2721,  3144, -3755, -3755, -3755, -3755, -3755, 20971,
    3010,  1635,  2941, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755,  1849,  2781, -3755, -3755,  3041, -3755,
    3042, -3755,  1850, -3755, -3755,  4073, 69274,  3172, -3755,  2920,
   56019, -3755, -3755, -3755,   595,  1873, -3755,  1874,  1882,  3007,
    2918, -3755,  1888, -3755, 10993, 56019, -3755, -3755, -3755,  1896,
   -3755,  2870, -3755,  3267, 20971,  1309, -3755, -3755,  3149, -3755,
   55615,  2914, 32579, -3755,  1723,  1723,  1463, -3755,   991, 20971,
   -3755,  1897, -3755,   122,  3020,  3156,  1902,  1903,  2876,  2917,
    2876, -3755,  2417, -3755, -3755, -3755, -3755, -3755,  3183, -3755,
   -3755, -3755,   339, -3755,  3062,  3063, 56019, -3755, -3755, 56019,
    3278,  7598, 41475,  2760,  1635,  2302, -3755, -3755, -3755, -3755,
    2921, 26804,  1660, -3755,   769, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755,  1921, -3755, 56019,  2888,  2431, 22655, 22655,
    2889, 41071,  1144,  2892, -3755,  2893, -3755, -3755,  3044,   991,
   10993, 41475,  3264, -3755, -3755, -3755,  3020, -3755, -3755, 56019,
    3017,   757,   757,  3208, -3755,  2952, -3755, -3755, -3755,   707,
   -3755,  2897,  2781,  2760,  2120,  2781, -3755, -3755, -3755, -3755,
    1674, -3755, -3755, -3755, 23918,  3021,   783,  9067, -3755, -3755,
   -3755, -3755,   275,  1723, 20971,   991, -3755,  3037,  1761, 56019,
   -3755, -3755,  2819, -3755,  3307, -3755,   200, -3755, -3755,  2774,
   37435, -3755,  2781, -3755,  2481, -3755,  1551, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755,  3297, -3755, -3755, -3755, -3755, -3755,
   -3755, -3755,  7708, -3755, -3755, -3755,  3193, -3755, -3755, -3755,
   -3755,  1927, -3755, -3755, -3755, -3755, -3755, -3755,  1573, -3755,
   -3755,  1630,  1697, 23076, -3755,   991,  3051, -3755, 37435, -3755,
    1551, -3755, 41475, -3755, -3755,  2907, 37435,  1933, -3755
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1290,  1094,   504,  1176,  1175,  1094,   228,     0,  1178,     0,
    1094,   331,   890,     0,     0,     0,     0,   504,  1094,     0,
    1290,     0,     0,     0,     0,  1303,     0,     0,     0,     0,
       0,     0,     0,     0,  1094,     0,     0,  1310,     0,     0,
       0,     0,  1303,     0,  1180,     0,     0,     0,     0,     2,
       4,    56,    57,    23,    22,    28,    27,    79,    80,    46,
      16,    70,    51,   112,   111,   113,    34,    30,    64,    20,
      21,    31,    35,    53,    36,    52,    19,    50,    74,    54,
      77,    41,    10,    11,    42,    68,    12,    43,    69,    13,
      44,    14,    58,    81,    26,    55,    78,    37,    66,    62,
       9,    47,    48,    49,    71,    72,    73,    95,    76,   107,
      33,   104,    85,    86,   101,    87,   102,     7,    88,    45,
      15,    98,    97,    99,    65,    38,    67,    96,   100,    17,
      18,   103,    75,    93,    90,   108,   106,   114,    91,    59,
       5,     6,    82,    40,     8,    25,    24,    39,    32,   110,
      29,  1178,    84,    94,    83,    60,    89,    63,    92,   109,
      61,   105,  1277,  1264,  1312,  1276,  1289,     0,  1279,  1093,
    1092,  1078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1104,  1811,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,   306,  1834,
    1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  2074,
    2075,  2076,  2077,  1844,  1845,  1846,  1847,  1848,  1849,  1850,
    2078,  2079,  1851,  1852,  1853,  1854,  1855,  2080,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  2081,
    2082,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  2083,  1901,  1902,  1903,  2084,
    1904,  1905,  2085,  1906,  1907,  1908,  1909,  1910,  1911,  1912,
    2086,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  2087,  1929,  1930,
    1931,  1932,  2088,  2089,  2090,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  2091,  1942,  1943,  1944,  1945,  1946,
    1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,
    1957,  2092,  2093,  1958,  1959,  2094,  1960,  1961,  1962,  2095,
    1963,  2096,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  2097,
    2098,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  2099,
    1979,  2100,  1982,  1980,  1981,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  2101,  1990,  1991,  1992,  1993,  1994,  1995,  1996,
    1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,
    2007,  2102,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2103,  2022,  2023,  2024,
    2104,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2105,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,
    2106,  2107,  2043,  2108,  2044,  2109,  2045,  2046,  2047,  2048,
    2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,
    2059,  2060,  2110,  2111,  2061,  2062,  2063,  2064,  2065,  2066,
    2067,  2068,  2069,  2070,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2071,  2072,  2073,   305,  1255,  1782,  1812,
    1813,  1177,  1158,   504,     0,  1081,   330,     0,     0,     0,
       0,     0,     0,     0,     0,   681,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   158,     0,     0,   354,   353,
       0,     0,     0,   862,   359,     0,     0,     0,     0,   492,
    1217,  1980,  1215,  1256,   229,   232,   230,   231,  1804,     0,
     960,   961,   963,     0,     0,   973,   712,   713,     0,   711,
     715,     0,     0,     0,   708,     0,     0,     0,     0,   714,
     706,     0,   705,     0,     0,     0,   710,     0,   707,     0,
       0,  1082,  1214,   360,  1290,     0,  1194,  1178,  1185,  1195,
    1190,  1192,  1191,  1193,  1189,  1803,  1827,   804,   804,   804,
     804,   801,   802,   804,   804,   804,  1995,     0,     0,   783,
       0,   785,  1808,   804,   809,   413,   413,   413,     0,   808,
     813,   413,  1075,  1111,  1787,  1302,     0,   784,  1074,  2043,
    1206,     0,     0,   977,     0,   978,     0,  2010,  1086,   215,
    2020,  2106,  2043,   211,   185,  1831,     0,     0,   808,     0,
    1083,  1084,   772,  1309,  1307,     0,  1849,  1863,  1945,   208,
    2006,  2011,  2020,  2106,  2043,  2070,   167,     0,   222,  2020,
    2106,  2043,   218,  1104,     0,  1280,  1389,  1778,     0,  1077,
    1076,  1179,     0,  1182,     0,  1354,  1992,  1284,  1286,  1184,
    1277,     0,     0,     1,  1290,  1173,  1306,  1306,     0,  1306,
       0,  1269,  1277,  1272,  1276,     0,     0,     0,     0,  1811,
    2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,
    2141,  2142,     0,     0,  1788,  1812,  1816,     0,   722,     0,
     118,  1783,   851,     0,     0,     0,  1782,     0,     0,     0,
       0,  1817,     0,  1805,  1818,  1819,  1820,     0,     0,  1683,
    1853,  1904,  1693,  1691,  1692,  1685,  1686,  1687,  1688,  1689,
    1690,     0,   958,  1684,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,  1948,   118,     0,     0,  1098,     0,
       0,     0,  1100,  1103,  1079,  1161,     0,  1778,     0,     0,
     756,   747,     0,   757,   748,   753,   759,     0,     0,   750,
       0,     0,   760,     0,   749,   751,   762,   752,   758,     0,
       0,   754,   755,     0,     0,  1090,   413,     0,     0,     0,
       0,     0,     0,   118,  1148,  1918,   118,     0,     0,   358,
     357,   118,   356,   355,  1853,  1904,     0,   889,   118,     0,
     160,   572,   507,     0,     0,   641,  1948,   118,     0,     0,
       0,     0,   865,     0,     0,   491,   504,  1218,  1216,     0,
     964,   210,   209,   962,  1918,     0,   284,     0,     0,  1918,
    1139,     0,   709,  1918,     0,  1918,  1806,   153,  1853,  1904,
    1918,     0,     0,  1918,   145,  1918,     0,  1918,   284,  1918,
     508,     0,  1918,     0,  1918,  1948,   147,     0,  1918,   284,
     720,     0,  1211,     0,  1187,  2110,  1200,     0,  1196,  1203,
    1199,  1290,   804,   803,     0,   804,     0,   804,     0,   804,
       0,   804,     0,     0,     0,   804,  1809,  1810,   786,     0,
     810,     0,     0,   817,   816,   815,     0,     0,     0,   818,
    1393,  1233,     0,  1072,  1089,     0,     0,     0,   980,   980,
     980,  1085,   214,   212,     0,     0,     0,     0,     0,     0,
    1091,     0,     0,     0,     0,  1791,  1793,  1794,  1694,  1761,
       0,  2075,  2076,  2077,  1752,     0,  2078,  2079,  2080,  1606,
    1593,  1602,  1607,  1594,  1596,  1603,  2081,  2082,  1889,  2083,
    2084,  1801,  2085,  2086,  2088,  2089,  2090,  2091,  1598,  1600,
    2092,  2093,     0,  1802,  2095,  2096,  1968,  2098,  2099,  2101,
    2102,  1604,  2104,  2105,  2106,  2107,  2108,  2109,  1800,     0,
    1605,  2111,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,
       0,     0,  1775,     0,  1579,     0,  1425,  1426,  1448,  1449,
    1427,  1454,  1455,  1467,  1428,     0,  1774,  1492,  1578,  1584,
       0,  1577,  1573,  1292,  1770,     0,  1574,  1790,  1792,  1753,
     178,   224,     0,   225,  1776,  2020,   168,   207,   180,   206,
     181,   179,     0,  1851,   169,     0,   176,     0,     0,     0,
       0,   221,   219,     0,  1080,     0,  1391,  1390,     0,     0,
    1759,  1779,   729,  1171,  1172,  1170,     0,  1167,  1169,  1181,
    1178,  1766,  1765,  1767,     0,  1285,     0,     0,     0,  1267,
    1266,     3,  1184,  1304,  1305,     0,     0,     0,     0,     0,
       0,     0,     0,  1347,  1320,  1321,  1323,  1344,  1348,     0,
    1273,     0,     0,  1395,     0,  1355,     0,     0,  1789,     0,
       0,     0,     0,   723,     0,     0,     0,     0,     0,     0,
     117,  1137,   217,  1135,     0,     0,     0,     0,     0,  1142,
       0,   151,   152,   519,   504,     0,     0,     0,     0,     0,
     922,     0,     0,     0,     0,     0,     0,   923,   921,   924,
     931,   944,   947,     0,   841,     0,     0,     0,  1011,     0,
       0,  1011,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   234,   237,   279,   484,     0,     0,   486,
       0,     0,     0,     0,     0,     0,     0,   122,     0,     0,
       0,     0,   471,   483,     0,     0,     0,     0,     0,   480,
       0,   118,   235,   465,   468,     0,     0,   581,   580,  1011,
       0,   233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   298,   299,     0,
       0,     0,   122,   144,     0,     0,   236,     0,     0,  1099,
    1096,  1097,     0,  1102,     0,  1157,     0,     0,     0,     0,
       0,   761,     0,     0,  1853,  1904,     0,     0,     0,     0,
       0,     0,   333,   312,   313,   118,   311,     0,     0,   638,
       0,  1814,  1436,  1465,  1443,  1465,  1465,  1432,  1432,  1445,
    1433,  1434,  1472,     0,  1465,  1432,  1437,     0,  1435,  1475,
    1475,  1460,     0,  1417,  1418,  1419,  1420,  1446,  1447,  1421,
    1452,  1453,  1422,  1489,  1432,  1815,     0,     0,   648,     0,
    1114,  1147,     0,     0,   513,     0,  1918,     0,   120,   682,
       0,   639,     0,   120,     0,   156,     0,   576,     0,     0,
       0,     0,     0,     0,   600,   599,     0,     0,     0,   640,
       0,   120,   467,  1918,     0,   457,   413,     0,   864,   867,
       0,     0,     0,  1259,  1261,  1260,     0,  1258,     0,   284,
     282,   283,   636,   972,     0,     0,     0,     0,   284,     0,
       0,  1918,     0,  1918,     0,     0,   284,   284,     0,     0,
       0,     0,   577,     0,   719,   717,   716,   718,     0,     0,
       0,     0,     0,  1918,   284,     0,     0,   704,  1704,     0,
       0,  1290,     0,   196,   197,   195,  1201,   198,  1202,  1198,
    1186,     0,   794,     0,   798,     0,   789,     0,   795,     0,
     790,   787,   788,     0,   793,     0,     0,   414,   416,     0,
       0,  1874,     0,  1909,  1937,  1938,  2011,  2016,     0,  2038,
       0,   819,   846,   814,     0,     0,  1243,  1073,  1710,     0,
    1290,     0,   979,   976,   975,   974,   213,   186,     0,     0,
       0,   848,  2010,  1088,   771,   504,     0,  1575,     0,  1582,
    1583,  1464,  1451,  1751,     0,     0,  1459,  1458,     0,     0,
       0,     0,  1441,  1440,  1439,  1581,  1718,     0,  1438,     0,
       0,     0,     0,  1465,  1465,  1463,  1512,     0,  1442,     0,
       0,  1731,     0,  1737,     0,     0,     0,  1471,     0,  1469,
       0,     0,  1548,     0,     0,     0,     0,     0,     0,     0,
       0,  1496,  1497,  1579,  1704,     0,  1580,  1797,     0,     0,
    1457,     0,  1489,  1773,  1694,     0,     0,     0,     0,  1764,
       0,  1702,     0,     0,  1526,  1700,     0,  1528,     0,     0,
       0,  1693,  1691,  1692,  1685,  1686,  1687,  1688,  1689,  1690,
    1698,  1509,     0,     0,  1508,     0,     0,  1357,     0,  1795,
    1754,   226,   227,   223,     0,     0,   183,   182,     0,   200,
     204,   205,   175,   203,     0,   199,  1646,  1645,   184,   174,
     172,   170,   187,   189,   190,   173,   171,   220,     0,     0,
    1821,  2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,
    2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,
    2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,  2201,
    2202,  2203,  2204,  2205,  2206,  2207,  2208,  2209,  2210,  2211,
    2212,  2213,  2214,  2215,  2216,  2217,  2218,  1756,  1755,  1785,
    1822,  1823,  1824,  1825,  1760,     0,     0,   284,  1165,     0,
    1162,  1769,     0,  1287,     0,  1780,     0,  1174,  1283,  1282,
    1313,  1314,   882,  1281,  1338,  1339,  1334,     0,  1353,  1353,
    1330,  1324,  1329,  1327,     0,  1331,  1492,  1346,  1271,  1318,
    1319,  1322,  1270,     0,  1349,  1347,  1323,  1230,     0,     0,
    1396,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     724,     0,     0,     0,     0,     0,     0,  2038,   216,  1133,
       0,     0,     0,     0,   850,   849,     0,     0,   869,     0,
       0,     0,  1145,   404,     0,   281,     0,     0,     0,     0,
       0,     0,   517,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   551,
    1011,     0,   589,     0,   929,     0,     0,     0,     0,   930,
     927,   928,  2011,   946,   945,   943,   904,   906,   905,     0,
     908,   892,     0,   893,     0,     0,   903,   911,   909,     0,
       0,     0,  1897,   239,   251,     0,  1010,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   271,     0,   274,
     273,     0,     0,     0,     0,   278,     0,     0,     0,   277,
       0,     0,   485,     0,     0,     0,     0,     0,     0,     0,
     959,     0,     0,   139,   142,     0,     0,   470,   482,     0,
     474,   475,   472,   476,   477,     0,     0,     0,     0,     0,
       0,   469,     0,   574,   573,   579,     0,     0,     0,     0,
       0,  1003,  1002,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   591,   592,     0,
     593,     0,   143,     0,     0,     0,     0,     0,     0,   194,
    1095,  1101,  1160,  1786,  1159,     0,     0,     0,   763,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   317,  1814,     0,   663,   637,
       0,  1417,     0,  1413,  1409,  1478,  1479,  1480,  1477,  1490,
    1476,     0,  1423,  1481,  1432,  1429,   649,     0,   651,   654,
       0,  1112,   377,     0,   510,   551,     0,     0,     0,   149,
       0,     0,     0,   116,   160,   360,     0,   159,   161,   163,
     164,   165,   162,   166,   571,   575,     0,   506,     0,     0,
       0,     0,     0,   601,   605,   604,   608,   606,     0,   602,
       0,  1405,     0,   138,   464,   466,     0,     0,     0,   362,
     444,     0,     0,     0,   866,     0,     0,     0,     0,     0,
       0,     0,  1257,     0,   950,     0,  1140,  1918,   284,     0,
     948,   154,  1807,     0,     0,     0,     0,     0,   952,   701,
     146,     0,   284,   284,   509,     0,   284,   148,     0,     0,
       0,   501,   284,   721,  1213,     0,   457,  1188,  1197,   791,
     800,   799,   797,   796,   792,     0,   811,     0,   412,     0,
       0,     0,   825,     0,     0,   824,   839,   826,     0,   828,
     821,   820,   829,     0,     0,   848,     0,  1240,     0,  1238,
       0,  1394,  1242,  1231,  1205,     0,  1204,  1208,  1210,  1209,
    1207,     0,     0,     0,   808,     0,     0,   284,  1087,     0,
     773,   778,     0,     0,     0,   775,   776,   777,   779,   780,
       0,     0,     0,  1762,  1714,     0,  1715,     0,     0,     0,
    1750,  1746,     0,     0,     0,     0,     0,  1719,  1722,  1723,
    1724,  1721,  1725,  1720,     0,     0,  1726,     0,     0,     0,
       0,     0,  1462,  1461,     0,     0,     0,     0,     0,     0,
       0,  1551,  1584,     0,     0,  1678,     0,  1704,  1736,     0,
       0,  1473,     0,     0,     0,     0,     0,     0,     0,  1704,
    1742,     0,     0,     0,     0,  1644,     0,  1641,     0,     0,
       0,     0,  1761,     0,     0,     0,     0,  1798,  1493,  1510,
    1772,     0,  1763,     0,     0,  1494,  1517,     0,  1743,  1544,
       0,  1549,  1532,     0,  1525,     0,  1530,  1534,  1513,  1764,
    1703,     0,  1701,     0,     0,  1511,     0,  1506,  1504,  1505,
    1498,  1499,  1500,  1501,  1502,  1503,  1507,  1682,  1680,  1681,
       0,     0,     0,  1529,  1911,  1945,     0,  1303,  1303,  1303,
    1291,  1301,  1771,     0,  1400,     0,     0,     0,     0,  1661,
       0,  1708,     0,  1706,  1788,  1777,     0,     0,  1489,     0,
    1392,  1757,     0,   727,   728,   726,  1184,  1168,  1164,  1163,
    1768,  1183,     0,  1290,     0,   880,   881,     0,   885,     0,
       0,  1332,  1345,     0,  1243,  1243,     0,  1336,  1337,  1328,
    1275,  1274,     0,  1403,     0,     0,  1227,  1220,  1397,     0,
    1357,  1245,  1247,  1248,     0,  1761,   661,   660,     0,     0,
       0,  1033,   982,  1015,   725,  1034,   983,  1016,  1035,   984,
    1134,     0,  1136,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   626,   284,  1143,
    1036,   280,  1144,  1017,  1018,     0,   518,     0,     0,   523,
     524,   525,     0,     0,   526,  1853,  1904,     0,   531,   537,
     541,   532,     0,   542,   538,     0,     0,     0,     0,     0,
     548,   555,     0,     0,     0,     0,     0,   925,   926,  1037,
     985,     0,  1019,   907,  1432,   891,     0,     0,   902,     0,
     901,  1432,  1432,   986,   150,   240,   377,  1013,   257,   270,
     265,   266,   264,  1918,   284,  1918,   284,     0,     0,     0,
       0,   267,   262,   263,   259,   272,  1830,  1890,  2021,     0,
     561,   563,     0,   568,   275,   994,     0,   292,   295,   276,
     255,   258,   256,   252,   238,     0,     0,  1784,     0,     0,
     954,     0,     0,     0,   141,   999,   131,     0,     0,   127,
       0,     0,     0,     0,   121,  1043,   990,   473,   478,   992,
     481,  1028,   479,  1049,   991,     0,  1023,  1045,  1001,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1149,     0,
       0,     0,     0,     0,   284,     0,   670,  1013,  1918,   284,
    1044,     0,  1008,  1031,     0,   300,     0,  1000,   993,  1029,
       0,     0,   192,   191,   193,     0,     0,     0,     0,     0,
       0,     0,     0,   765,   736,   764,     0,     0,     0,     0,
       0,     0,     0,   730,   332,   309,   310,     0,     0,   308,
     314,     0,   662,     0,     0,  1414,  1410,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1430,   650,     0,     0,
       0,     0,  1132,  1132,  1132,  1132,  1132,  1132,  1132,  1113,
    1141,   118,     0,     0,     0,   512,   550,   557,     0,   585,
     588,     0,   586,     0,     0,     0,     0,     0,   132,   119,
       0,   690,   413,   155,     0,     0,     0,   505,   647,   645,
     644,   646,     0,     0,     0,   667,     0,  1404,  1406,     0,
       0,     0,   463,   364,     0,     0,   361,   365,   369,   370,
     371,     0,   458,   460,     0,     0,   448,     0,     0,     0,
     896,     0,   914,   897,     0,     0,     0,   934,   939,   935,
     917,     0,   489,  1262,  1263,     0,   284,     0,     0,   552,
     284,     0,   284,     0,   284,   284,     0,  1070,   578,     0,
     633,     0,     0,   284,   703,  1705,     0,   812,   415,     0,
       0,     0,     0,   823,     0,   487,   827,     0,   838,   833,
     835,     0,   842,  1241,  1234,  1236,  1235,     0,     0,  1232,
    1711,   702,     0,     0,   284,     0,   843,     0,   774,     0,
       0,     0,     0,  1308,  1712,  1713,     0,     0,     0,     0,
    1747,     0,     0,  1619,  1595,  1597,  1431,  1609,     0,  1444,
    1620,  1621,  1599,  1601,     0,  1695,     0,     0,  1610,  1553,
    1554,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1566,  1565,  1611,  1677,     0,     0,
    1734,  1735,  1612,  1474,  1475,  1475,     0,     0,  1741,     0,
       0,     0,  1617,  1622,     0,     0,     0,     0,  1628,     0,
    1649,     0,     0,     0,  1576,  1705,  1466,  1467,     0,     0,
       0,     0,     0,     0,     0,     0,  1550,  1533,  1527,     0,
    1531,  1535,     0,     0,     0,     0,  1519,  1545,  1515,     0,
       0,  1521,     0,  1546,  1303,  1303,  1303,  1303,  1300,     0,
       0,     0,     0,  1367,  1356,  1358,  1369,  1360,  1362,  1398,
       0,  1778,     0,  1341,  1312,  1312,     0,  1661,     0,  1585,
       0,  1661,     0,     0,   177,     0,   201,   188,     0,  1166,
    1781,     0,  1315,     0,  1696,   885,   883,   884,  1317,     0,
       0,  1352,  1351,  1350,  1325,  1229,     0,  1227,  1222,     0,
    1223,  1761,     0,  1219,  1252,     0,     0,  1403,     0,  1251,
    1032,   981,  1014,  1132,   853,   854,     0,   852,     0,     0,
       0,   403,   868,     0,     0,     0,   626,     0,     0,   407,
    1146,   520,   521,     0,     0,   539,     0,     0,   528,     0,
       0,     0,     0,   527,   544,   493,   545,   547,     0,   546,
     549,   554,   995,     0,  1030,   919,     0,  1432,   894,   899,
     900,     0,   374,     0,     0,     0,   241,     0,     0,   254,
       0,   249,   268,   260,   269,   261,   565,   566,   564,   560,
       0,   567,   569,   289,     0,     0,     0,  1039,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1040,
    1020,     0,     0,   124,   123,     0,   130,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   301,   286,     0,     0,     0,     0,     0,
     303,     0,     0,  1038,   987,   731,     0,     0,   732,   740,
       0,     0,   733,     0,     0,     0,     0,     0,     0,   742,
     335,     0,   338,   345,   318,   322,  1148,     0,  1148,     0,
     323,  1148,   319,  1148,   316,  1968,  1685,  1686,   658,   665,
     655,   657,   659,   656,     0,   664,   626,     0,     0,     0,
    1415,     0,  1483,  1484,  1485,  1486,  1487,  1488,     0,  1482,
    1489,   652,   653,     0,  1132,  1131,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   389,     0,     0,
     383,     0,     0,   939,   376,   379,   380,   513,   516,   514,
     515,     0,   543,     0,   584,     0,   557,   134,     0,     0,
     135,   133,     0,     0,   360,     0,     0,   607,   610,   603,
       0,   666,   668,   642,     0,   557,     0,  1214,     0,   454,
       0,   444,   396,   440,     0,   456,     0,   442,   441,   443,
       0,   450,  1110,     0,   869,   895,     0,     0,     0,   932,
     936,   933,     0,     0,   910,     0,   918,   888,  1065,  1066,
    1063,  1064,     0,     0,  1254,   951,     0,   284,   949,     0,
     697,     0,   699,   953,   284,   284,   594,     0,   502,   460,
       0,     0,     0,   822,   840,     0,   836,     0,     0,   805,
     845,  1239,  1237,   848,     0,   806,   847,     0,     0,     0,
       0,     0,  1716,  1450,     0,  1749,  1745,     0,  1717,     0,
    1729,  1728,  1552,  1730,     0,  1571,     0,     0,  1563,  1561,
    1562,  1555,  1556,  1557,  1558,  1559,  1560,  1564,  1739,  1738,
    1732,  1733,  1470,  1468,     0,  1614,  1615,  1616,  1740,  1623,
       0,  1844,  1650,  1627,  1643,  1642,     0,     0,     0,  1630,
       0,     0,  1639,     0,  1679,  1456,  1489,  1495,     0,     0,
    1518,  1744,  1536,     0,     0,     0,  1514,     0,     0,     0,
       0,  1523,  1695,     0,     0,     0,     0,     0,     0,  1294,
    1293,  1299,  1277,     0,  1369,     0,  1368,  1380,     0,     0,
    1386,  1384,     0,  1386,     0,  1386,     0,  1361,     0,  1363,
    1380,     0,  1779,  1399,     0,  1343,     0,     0,  1311,     0,
    1661,  1592,  1664,  1659,  1660,  1709,  1586,  1796,     0,  1707,
    1661,     0,  1758,  1288,     0,  1316,  1333,  1326,  1870,  1401,
    1228,     0,     0,  1225,  1226,     0,     0,  1246,  1227,  1249,
       0,   859,   860,   858,     0,     0,     0,   626,     0,     0,
     421,     0,   876,   876,     0,     0,   409,   453,   939,   629,
       0,     0,   627,     0,   540,     0,     0,   536,   534,   533,
     535,   494,  1048,     0,   920,     0,   912,     0,   246,  1012,
       0,     0,     0,   245,     0,   284,   284,   562,   293,   294,
     297,     0,     0,     0,     0,     0,     0,   691,   674,     0,
       0,   692,   693,     0,     0,     0,   956,   957,   955,   128,
     125,   126,   129,   996,     0,     0,     0,     0,     0,  1047,
    1007,  1027,  1046,  1005,  1025,  1004,  1024,  1006,  1026,   998,
       0,  1408,   672,   671,     0,   284,   284,   596,     0,   734,
       0,     0,   735,   746,   744,   743,   745,   737,   336,   118,
       0,   315,     0,   343,     0,   341,   340,   342,     0,   329,
       0,     0,     0,     0,     0,   635,     0,     0,     0,  1411,
    1416,  1491,  1424,   625,     0,  1123,  1122,  1121,  1125,  1124,
    1127,  1126,  1118,  1117,  1130,  1129,  1116,  1115,  1120,  1119,
       0,   381,     0,   387,   391,   392,   390,   382,   939,   413,
     452,   511,     0,     0,   587,   582,   137,   136,     0,     0,
       0,     0,   612,   616,   643,     0,  1407,   590,     0,   362,
    1212,   461,     0,     0,   367,   372,   373,     0,   448,   393,
       0,   444,   366,   459,     0,     0,   455,     0,  1105,     0,
       0,   898,   915,   916,     0,     0,   939,   938,     0,   496,
     284,   553,   284,   284,  1071,   634,     0,   832,   831,   830,
     488,     0,   834,   284,     0,     0,     0,     0,     0,   782,
     766,   781,  1748,  1608,  1618,  1727,     0,     0,  1572,     0,
       0,  1613,  2112,     0,     0,     0,     0,  1647,  1648,  1629,
       0,  1959,  1634,     0,     0,     0,  1799,  1542,  1540,  1537,
       0,  1538,     0,     0,  1520,  1516,     0,  1522,  1547,  1298,
    1297,  1296,  1295,  1371,  1378,     0,  1359,     0,  1385,  1381,
       0,  1382,     0,     0,  1383,     0,     0,  1378,     0,     0,
       0,     0,  1655,  1661,  1661,  1587,  1666,  1663,     0,  1589,
    1489,     0,     0,  1221,  1224,     0,  1253,  1244,  1138,     0,
       0,     0,   405,     0,   939,     0,     0,     0,   879,   879,
       0,   939,   452,   631,   630,   628,   632,     0,   529,   530,
     997,   913,   242,   243,   244,   247,   286,   253,   248,     0,
    1041,   988,  1021,     0,     0,   680,     0,     0,     0,     0,
    1042,   989,  1022,     0,     0,     0,  1154,     0,   285,   286,
     302,  1009,     0,   738,   739,   317,     0,   339,   348,     0,
     346,   320,   325,     0,   327,   326,   321,   324,  1412,     0,
     970,   970,     0,   626,  1128,     0,     0,   378,   452,   420,
       0,   384,     0,   558,     0,     0,  1110,   362,   557,   611,
       0,     0,     0,   669,   364,     0,   462,   363,     0,     0,
     450,     0,     0,     0,   448,     0,   445,     0,   449,     0,
       0,     0,     0,     0,   937,     0,   941,     0,   909,   886,
    1400,     0,   500,   971,   698,   700,   595,   837,   844,   284,
     767,   768,   769,   770,  1567,     0,     0,     0,     0,  1624,
       0,  1625,  1652,  1651,  1631,  1635,     0,  1632,  1633,  1539,
    1543,  1541,  1524,  1370,     0,     0,  1372,     0,     0,  1374,
    1376,     0,     0,     0,     0,     0,  1782,  1661,  1340,  1342,
       0,  1278,  1590,  1591,     0,  1312,  1661,   202,  1697,  1402,
    1250,   838,     0,   284,   876,   452,   422,  1968,   423,   875,
       0,   877,   882,   882,     0,   452,   626,   522,   288,   296,
       0,     0,   687,   675,     0,     0,   694,     0,     0,     0,
       0,     0,   284,   741,   307,   334,   344,     0,   328,   970,
       0,   967,   966,   624,     0,   386,   385,     0,   431,     0,
     556,     0,   557,   684,  1106,   570,   613,   614,   609,     0,
       0,   444,   440,   368,   377,   351,   402,   401,   398,   397,
     399,   400,   395,   394,     0,   450,   446,   447,     0,  1107,
       0,  1156,     0,   870,   940,     0,     0,     0,   495,     0,
       0,   499,   490,   807,  1568,     0,  1569,     0,     0,     0,
    1637,  1636,     0,  1379,  1388,     0,  1375,  1373,  1364,     0,
    1366,  1654,  1656,     0,     0,  1669,  1588,   855,     0,   856,
     879,   426,     0,   878,   885,   885,   413,   626,   406,     0,
     250,     0,   678,     0,   689,   687,     0,     0,  1150,     0,
    1151,  1152,  1155,   304,   347,   965,   969,   968,     0,   417,
     418,   419,     0,   388,   427,   428,     0,   559,   583,     0,
       0,     0,     0,   448,   444,   375,   439,   349,  1108,  1109,
     291,     0,   939,   942,  1069,   498,   497,  1570,  1640,  1626,
    1653,  1638,  1377,     0,  1365,     0,     0,  1665,     0,     0,
       0,     0,   882,     0,   626,     0,   873,   872,   420,   408,
     287,     0,     0,   685,   688,   676,   689,   696,   695,     0,
       0,     0,     0,     0,   429,     0,   430,   451,   683,     0,
     615,     0,   450,   448,     0,   450,   871,   887,  1068,  1067,
    1290,  1387,  1657,  1658,  2074,  1870,  2048,     0,  1667,  1670,
    1668,  1662,   284,   885,     0,   410,   424,   431,     0,     0,
     677,  1153,   616,   436,     0,   435,     0,   433,   432,   673,
     619,   352,   450,   290,  1400,  1051,  1290,  1050,  1052,  1060,
    1057,  1059,  1058,  1056,     0,  1674,  1673,  1672,  1676,  1675,
     857,   874,     0,   626,   679,   686,     0,   434,   438,   437,
     621,     0,   617,   620,   622,   623,   350,   861,     0,  1061,
    1055,  1277,  1264,     0,   425,   411,     0,   597,     0,  1053,
    1290,  1671,     0,   618,  1054,     0,   619,     0,   598
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3755, -3755, -3755,  2645, -3755,  -717,   330,  2056,  -522, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
    2591, -3755, -3755, -3755,  1305, -3755, -3755,   129,  1504,  2243,
    1013, -3755,  -901, -3755, -3755,  -510,   139,  -580, -3755, -3755,
   -3755, -3755, -3755, -3755, -3755,  -490,  1440,   878,  -517, -3343,
   -3755, -1176, -3755, -3755,   344, -3755, -3755,  1394, -3755, -3755,
   -3755,   750,  -394, -3755, -3755, -3755, -3755, -3755, -3755, -3755,
    -138, -3755, -3755,  -552, -1277,    47,  -202,  -426, -3755, -3755,
     185,  -424, -1133, -3755, -2384, -3755,  -167, -3755, -3755, -3755,
    -425, -1121,   968,  -592,  -900,  1242,  -687, -3755,  -312, -3755,
    -729,  -636,  -633,  -688,  -535, -3024, -3394, -3551, -2425,   996,
     141, -3755, -3755, -3755,   223, -3755, -1276, -3755, -3755,  2003,
   -1115, -3755,  -508, -3755, -3755, -3755, -2347, -3755, -3755, -3755,
   -3755,    73, -3755, -3755, -3755, -3755,   264, -3755, -3755, -3755,
   -3755, -3755, -3755, -2150,  1377,  1383, -3755, -3755, -3001, -3755,
    -740, -3755,   403, -2373,   919, -3755, -3755, -3755,  2033, -3755,
   -3755, -3755, -3755,   266, -3755,   262, -3755, -3755, -1293, -3755,
   -3755, -1273, -3755,  1392,   749, -3755, -3755, -3755,  -711,  -772,
    -763, -3755, -2823, -3755, -3755, -3755, -3755, -3755,  -814, -3755,
     799, -2495,  -766, -3755, -3755,   813, -3755, -3755, -3755, -3755,
    -671,  -307,  2052, -3755,  -583,  -653, -3755, -3755, -3755,  -304,
   -3755, -3755, -3755, -3755, -3755, -3755, -1404,    43, -1271, -3755,
   -3755, -3755, -3755, -1901, -3755, -3755, -3755, -1636, -3755,  3390,
    1895,  1210, -1268, -3755,   -19,    53,  2486,  -916, -2084,   205,
    -423, -3755, -1436, -3755, -3755, -3755, -2027, -3755, -3755, -3755,
   -3755, -2814, -1266, -3755, -3755, -3755,   263, -3755, -3003, -3236,
   -3476, -3046, -2797, -3755, -3755,  -867, -3755, -3755, -3755, -1099,
    1585, -1143, -3755, -1729,   271, -3053,  -600, -2608, -3755, -2950,
    -507, -3755, -3755, -3755, -3755, -3755, -3755, -3755,  -883,  -512,
   -3755, -3755,  2891, -3755, -3441, -3755, -3755, -3755, -3755,  1232,
   -3755, -1048,   895, -3755, -3755, -3755, -3755, -3755,  -646,  -724,
   -3755, -3755, -3755,   144, -3755, -3755, -3755, -3755,  1830,  -750,
    -604,  2779, -1265,  -313, -3755, -3755, -3755, -3755, -2426, -3755,
   -3755, -3755, -3755, -3755, -3755, -3755, -1278, -3755, -3755, -3755,
   -3755, -3755, -3755, -3755,  1727,  1728,    71,   -31, -3755, -3755,
   -1015, -3755,  -467, -3755,  2015, -3755, -3755, -3755, -3755,  1126,
     145,   303, -3755,     3, -3755, -3755,   102, -2759,     4, -3755,
   -3755, -3755, -3755,  -127,     5, -3755,   549, -3755, -3755, -2247,
   -3755,   146,    49, -3755, -3755,     1,     0,   -41,   -39,   -34,
       2,  2782,  2350, -3755, -3755, -3755,   -16,  1374, -3755,  -680,
    -155, -3755,  1133,  -549,  1705,  2337,  2339, -3755,  1128, -3755,
   -3755,  1136, -3755, -3755, -3755,  -543,  1715, -3755,  2349,  1733,
   -3755,  1127,  1131, -2710,   628, -2725,   174, -1221,  -350,    54,
    2816,  2354, -3755, -3619,   580, -3755, -3374, -1837,  -463,  1509,
   -1282, -3755, -3755,  -930,  6043, -3755, -3755, -3755,  8354, 10542,
   -3755, -3755, 10767, 10986, -3755,  -828,   672, 11307,  3744,  -955,
   -1507,  -618, 10026, -2014,  -370, -2219, -3755, -3755, -3755,  -311,
     687,   507, -3755, -3755, -3755, -3755,  -536, -2232,  -538, -3755,
   -3755, -3755,  -539, -3754,   189, -3755,  -165, -3755, 10915,  1175,
   -3755,  -805, -2184, -2173,  -928, -1412, -3755, -3755, -3755, -3755,
   -3755, -3755, -3755, -1152, -2644,  -302,  1243, -3755, -3755,  1335,
   -3755, -3755, -3755, -1046,  -697, -2106,  1248, -1628, -3755,  -678,
     606,  1913,  -641,   491, -1056,  8480,  -440, -1841,  -997, -1215,
   -3755,  -159, -3755,    25,    -9,  -146,  -484,     7,  3192,  8135,
    -537, -1042,  6102,  8671,  9923, -2480
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    48,    49,    50,    51,  1161,  2019,  1903,  2638,  2639,
      52,    53,  1228,    54,    55,    56,    57,    58,    59,    60,
    1174,    61,    62,   849,  1365,  2027,    63,  1788,   667,  1631,
    1632,  1960,  1633,  1622,  1078,  1447,  1162,  1190,    65,    66,
    1072,  1613,    67,    68,    69,  1213,  1214,  1169,  1402,  3461,
    3990,  1889,  4085,  2486,  2487,    70,  1267,  1268,    71,    72,
    2587,  1305,  2589,  2590,  3074,   507,  1984,  3479,  3480,  3061,
    3062,  3486,  3739,  3740,    73,  1362,  2665,  3161,  2666,  3553,
    2667,  3554,  2668,  3555,  2620,  3124,  3125,  3126,  2669,  3559,
    3932,  2670,  1803,   943,  1466,  1467,  3908,  3379,  3380,  4054,
    4013,  4014,  4015,  4117,  3561,  2676,  3171,  3566,  3761,  2397,
     586,  1384,  2060,  2671,  2672,  3159,    75,    76,  2054,  1243,
    1244,  1909,  3078,  2726,    77,   866,  2954,  3802,  3951,  3952,
      78,   197,    79,  1369,    80,    81,  2014,  2625,    82,  1812,
    2406,    83,    84,  2430,  2431,  2432,    85,    86,  3132,  3762,
    1215,  2479,  2480,  2481,  2482,  2991,    87,  1367,  1248,  2036,
      88,    89,    90,  2018,  2631,  2632,    91,    92,  1949,    93,
      94,    95,  1377,  2048,  2049,  3543,  3770,  3918,  3772,  4151,
    4152,  3753,  2939,  3392,    96,    97,    98,    99,  1348,  2007,
    2008,  3079,  1147,  1309,  1987,  1988,  3150,  3151,   100,   101,
    3427,  3428,   537,  4020,  3994,  4065,   102,   103,  3431,  3432,
     104,   105,   106,   107,   108,   580,   909,   910,  1153,   109,
    1727,   110,   824,  2574,   111,   973,  2171,  3600,   112,   609,
     923,   924,   113,   114,   618,  2154,   620,  1480,  2728,  2729,
    3219,  2125,   749,   115,   116,  2135,  2157,   117,  1164,  1794,
    1795,  3374,   118,   538,  1389,  2063,  2392,  3942,  3381,  3688,
    3872,  2338,  2898,   119,   539,  1194,  1852,  2066,  2681,  2682,
    1854,  2310,  3183,  1856,  2683,  2688,  2689,  2690,  3179,  3187,
    3796,  3797,   120,  1192,  1845,   121,   122,   123,  1223,   771,
     124,   550,   551,   125,  3901,   126,   878,   127,   636,  1493,
     128,  1867,  2977,   129,   130,   131,  4127,  4158,  4159,  4160,
    3192,  4090,   132,  4129,   953,   134,   135,   136,   171,   792,
     793,   794,   137,  3568,   138,   139,  2011,  2619,  3106,   140,
     141,  1789,  2382,   142,   143,   144,  1352,   145,   146,   147,
     148,  1285,   149,  1106,  1107,   150,   151,   502,   683,  1110,
    1118,   152,   588,   917,   918,   919,  1449,   153,   956,  2146,
     589,   912,   155,   590,  2356,  2909,  2910,  2913,   591,  2353,
     158,  1486,  2140,  2143,   592,  2360,  2361,  2362,  2363,  2364,
    2915,   593,   611,   869,  2071,   594,  1044,   163,   164,   165,
     692,   687,   688,   167,  1607,  2300,   626,  1125,   655,   700,
    3338,  1740,  1741,  1761,  1762,  1134,  1135,  1751,  1753,  2340,
    1754,  2349,  1746,  3335,  3662,  1757,  1758,  1137,  1138,  2344,
     168,  2304,  2864,  2865,  2866,  3316,  3326,  3649,  3839,  2867,
     951,  1144,  2868,  2873,  2907,  2656,  2657,  2658,  1857,  1994,
    1333,  1045,  1334,  2005,  1046,  1528,  1336,  1047,  1048,  1049,
    1339,  1050,  1051,  1052,  1053,  1512,  1570,  1054,  1055,  1547,
    2002,  2003,  1438,  2210,  1057,  1058,  3282,  3624,  3613,  2236,
    2237,  1628,  3278,  2816,  3851,  3971,  3972,  3346,  3343,  3666,
    3855,  4050,  4098,  4099,  1059,  2290,  1600,   773,  1060,  3081,
    1602,  2230,  2312,  2313,  1773,  1510,  2177,  2194,  2195,  2207,
    2777,  2214,  2219,  2800,  2801,  2231,  2259,  1061,  2180,  2181,
    2761,  1514,  1062,  1100,  1101,  1507,  2254,  1113,  1114,   685,
    1063,  1064,  1481,   676,  3835,   497,   740,  2496,  1718,   796,
     623,  1065,  1066,  1067,  1068,   886,   887,  1219,   498,   734,
     753,  2483,   499,   500,   736,  1723
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     162,   161,   166,   156,   157,   159,   691,   552,  1416,   701,
     846,   508,   872,   732,   647,   624,  1073,  1408,  1446,   772,
     162,   750,   166,  1139,   944,   945,   678,  1489,   613,   949,
    1145,  2102,  1361,   613,  1885,   752,  1148,  2126,  1247,   870,
     775,  1379,  1469,  1283,  1802,  1991,   612,   690,   920,   785,
    1855,   612,  1500,   891,  2498,  1724,   496,  1719,  1227,   536,
    1086,  1734,  1308,   543,  1863,  2247,  1522,  1523,  1272,  1962,
    1549,  2744,  2972,  2004,   833,   619,  1864,  2879,  1931,  1932,
    3186,  2583,  2959,   894,  2869,  1538,   648,  2052,  2028,  2029,
     579,   587,  2030,   906,  1853,   675,  2176,  2031,  3355,  2032,
    2033,  2544,  1724,  2986,  2330,  2988,  1439,  1737,  2732,  1399,
    1719,  3083,  2914,  3386,  3102,  3376,  1350,   914,   880,  1354,
     695,  2874,  2875,   872,  1358,  2448,  2450,   703,  1921,  3083,
    3576,  1363,   704,  2869,  2876,  3535,  2824,  3558,  2098,    64,
    1381,    74,  3327,  3329,   133,   154,   160,  3689,  3360,  1191,
    1080,  1133,  3313,  1872,  3547,  1780,  3260,  1136,  1516,  1517,
    1163, -1465, -1475, -1905,  3780, -1939,   702,   666, -1958, -1265,
     595,  1378,   506,  3530,  2064, -1983,  1171,   583,  1568,  2506,
    2641,  3947,  3177,  1535, -1841,  1873, -1465,  3107,  3108,  3109,
    3110,  3111,  3112,   595,  2779,  2780,    14,   548, -1789,  2795,
    1866,  1927,   544,  1943, -1814,  1273,   925,  2781, -1683, -1460,
    2050, -1268, -1814,  3873, -1465, -1683,   737,   739, -1815,  1261,
     743,   744,  2156, -2125, -1432,  1262, -1815,    19,  1346,  3925,
    1866, -2125,  3993,  1995,  1302,  1938, -1445,   783,  1565,  2830,
    2831,   969,   548,  2702,   779,  2704, -1908, -1472,   548,  1575,
    1218,  2507, -1265,   548,  2287,   595,  2742,   548,  1400,  2919,
    2252,  2288, -1460,  3495,   548,  -337,  2622,  2123,   929,   747,
   -1475,  1605,   548,  2058,  1578,  2585,  1725,   548,  1172,   595,
    1216,  2960,  3843,  2303,  3845,   595,  1400,  1242,  3167,  1251,
    2119,  3371,  2535,  1804, -1268,  1077,  1276,  2491,  1996,  1296,
     940,  2508,  4006,  4148,  1580,  2009,  1280,  2025,     3,     4,
    3902,  3526,  1805,   601,  3949,   601,   595,  -722,   601,  1129,
    1805,  1263,  3429,  2536, -1265,   601,  1400,  1840,  3095,  2437,
    2562,   548,  -118,   602,   601,   602,  1283,  -118,   602,   681,
    4134,  1869, -1957,  3749,  1575,   602,   504,  1566,   548,  2781,
     828,  2509,  2537,  1997,   602,   788,  1998,   772,   548,  2291,
    3687,  2737,   595,  3878,   947,   169, -1268,  1332,  2134,  1578,
     872,  3750,  1610,  4062,   841,  1549,  1098,  1575,   848,  2026,
    1099,  1422,   872,  2414,  4027,  1131,  3892,  1522,  1523,   857,
    3935,  1870,  1437,  2781,   875,  1538,   601,  1434,  2252,  1580,
     772,  3695,  1578,   884,   170,    37,  1410, -1699,  1417,  4171,
    1841,  1448,  2438,  1973, -1699,  2122,   602,  3430,  2127,  1999,
    2129,  1132,  2623,  2132,  1152,  1969, -1432,   169,  2738,  3508,
    4063,  1103,  1580,  1104,    41,   872,  4149,  4007,  3692,  2510,
    3407,   948,  3527,   789,  1999,   545,  3510,  4071,  1806,   941,
    2120,  3372,  1874,  1281,  1450,  2059,  3505,  1347,  4005,  1264,
    3950,  2173,  1504,  1482,  1875, -1265,   170,  1884,   759,   549,
    3969,    45,  2759,  1491,  1484,  2586,  2960,  2492,  2121,  3373,
    2292,   790,  1926,    46,  1923,  1501,  2124,  1516,  1517,  3178,
    1265,  1726,  1488,  1410,  1989,   825,  1535,  3370,  2624, -1432,
    3419,  1347,  1401,  2573,  4052,  4157,  2051, -1268,  1925,  1606,
    1222, -1683,  2433,   748,  1876,  3083,  1944,    47,   948,  1266,
    1724,  1965,  1917,   546,  1919,   547,  3478,  1173,  2136,   791,
    1401,  4121,  1961,   948,  4124,  2250,  1511,  3784,  2511,  2000,
     871,   552, -1957,  1569,   691,   872,  2512,  1544,  1140,  2513,
    2932,    47,   872,   872,  3682,   831,   921,  2289, -1265,   834,
    2916,  1511,  2253,  1347,  1724,  2115,  1545,  1991,  1303,  1304,
    1401,  4156,  1617,  2783,  1939,   855,   823,  1623,  3758, -1465,
    1546,  1634,  1634,  3090,   162,   690,   166,  2452,  1985, -1905,
    1765, -1939,  1844, -1265, -1958, -1265,  1766,  3605,   607,   608,
   -1268, -1983, -1957,   922, -1465,   927,  2781,   931,  3646,  3677,
   -1841,   682,  3650,   935,  1098,  2793, -1789, -1957,  1099,  2563,
     954,   612, -1814,   612,  1485,   612,  3799, -1460,  3980,  4082,
     913,   612,   936,   937,  1436, -1268, -1815, -1268,  1171,  1287,
     970, -2125,  1521,  2869,  2137,  3341,   772,  1070,  1904,  1292,
    1079,   871,  1081,   703,  1527,  1544,   916,  1599,   704,   938,
     607,   608,  1410,  1105,  3045, -1472,  1571,  3048,  3049,  3696,
    1834,  3052, -1908,   757,  1545,  1608,  1839,  1282,  3504,   777,
     950,  3059,  2317,  1488,   607,   608,  1832,   786,  1548,  4122,
     607,  1217,   702,  2339,   162,   161,   166,   156,   157,   159,
    2844,  2172,  3218,  2175,  1390,  2202,  2203,  2893,  4072,  3349,
   -1699,  2447,  1900,  2183,  3382,  1098,  2186,  1160,  2969,  1099,
    2970,   607,   608,  1907,  2198,  2199,  1910,  1911,  2455,  3050,
    3051,  1485,   950,   978,  3865,  2179,  2781,  2216,  2218,  1719,
    1172,  3875,  -118,  -118,  3445,  1995,  3548,  2044,  2232,  1596,
    1597,  1598,  1599,  1108,  2790,  2791,  2792,  2793,  3409,  1897,
     863,  1143,  1756,   548,  1088,  1808,   548,  3915,  3243,  2956,
    2058,  3248,  3249,  3250,  3251,  3252,  3253,  3254,  3255,  3256,
    3257,  2354,  2434,   612,  2374,  1970, -2126,  1076,  3188,  1129,
    3943,  1084,  4088,   837,  2061,   548,  2788,  2789,  2790,  2791,
    2792,  2793,  1176,  1220,  1221,  3363, -1432,  2187,  4113,   548,
    1996,  2886,  2539,   839,  2138,   840,  3551, -1432,  1306,  1521,
   -1432,  1152,  2045, -1432,  3001,  1966,  3984,  3985,   881,  3138,
    3297,  3298,  2139,    64,  2395,    74,  2130,  2131,   133,   154,
     160,  2540,  2488,  2733,  1488,  2426,  3579,  1256,  1898,  1290,
    1619,  1216,   548,  1400,   698,  1131,   595,   501,  2529,  3424,
    1165,  2151,  3080,  3189,  2530,  1997,  1566,  1301,  1998,  3960,
     762,   763,   764,   705,   765,   766,   767,   768,   769,   770,
    3080,  1370,  2074,  1744,  2630,  1257,  2396,  1359,  1360,  2012,
    3446,  2080,  4032,  3410,  2412,  2782,  2735,  4023,   871,  2088,
    2089,  3785,  2188,  2087,  1387,   920,  2426,  1974,  1899,  1195,
     871,  4018,   864,  3786,  2995,  2427,  2783,  2101,  3833,  1371,
    1796,   162,  1855,   166,   503,  2081,  3002,  4136,  3549,  2996,
    3904,  1412,  1414,  2426,  2090,  -550,  1797,  3836,  1410,  1392,
    1921,  2075,  3840,  1487,   612,  3842,  2097,   632,   706,  3552,
    1620,  2383,  3767,  4089,  3425,  2661,  1999,  3184,     3,     4,
    2531,  1975,  1166,   871,  1089,  2076,   865,  2189,  3186,  1745,
     653,  3139,  2784,  1452,  2107,  1454,  2427,  1456,  3926,  1458,
    1509,  1460,  1461,  1462,   978,  2957,  4114,  2781,  1464,    37,
    1798,  3190,  3411,   795,  3013,  3412,  2046,  3599,   826,  1525,
    4083,  1796,   691,  2427,  3288,  2428,  4103,  1799,  2047,  2788,
    2789,  2790,  2791,  2792,  2793,   583,  1424,  1808,    41,  2973,
    3217,  2384,  2190,   633,  1090,  2191,  3927,  2205,  4086,  1552,
    3336,  2734,  1258,  3928,    14,  1322,  1567,   838,   978,   965,
    3426,  2781,  2269,  1563,  2878,  3961,  1572,   696,  3978,  3191,
    4137,  2000,  4115,  3988,  1425,    45,  1609,  1621,  3218,   772,
    3929,  2429,  3787,   654,  3003,    19,  1372,    46,  2723,  1976,
    2001,  1798,   882,   871,  2606,  4116,  1625,  2554,  2949,  1730,
     871,   871,  4087,  1262,  2736,  1884,  1738,  1739,  1799,  1743,
    1123,   704,   704,  1291,   704,  3004,  3389,  1401,  2532,  2869,
    1167,  2355,  3523,  2869, -1786,   697,  4009,  1977,  3665,   548,
     612,  1611,  2248,  2192,   612,   612,  2950,  1259,  3669,  3676,
    2538,   519,  2429,  1950,  3005,   702,   702,   960,   702,  2533,
    3930,  3966,  1800,    37,   707,  2785,  2786,  2787,  2413,  2788,
    2789,  2790,  2791,  2792,  2793,  1809,  3469,  3659,  1074,  2429,
    1225,  1373,  3472,  3473,  3474,  3475,  3476,  3477,  2534,  3763,
    1168,  1374,    41,  3349,  4059,  1096,  2270,  2783,  3390,   698,
    2271,  2211,  1612,  2967,  3789,  3668,  2335,   521,  3916,  1263,
    2452,  1375,  3790,  1124,  3319,  2234,  1122,  4056,  4057,   634,
     635,  2814,  2974,   625,  2391,  1143,  3593,  2821,  3607,    45,
    3608,  1426,  2467,   612,  2705,  3917,  2272,  1207,  2193,   612,
    2325,    46,  2700,  1800,  3879,  4010,  1245,  2975,  2024,   631,
    1810,  2783,  3391,  2784,  1801,  2648,  2649,  2650,  2651,  3083,
    1231,  4105,   698,  2835,  1950,  2836,  3524,  1924,   548,  2073,
    1575,  1912,   937,    37,  2395,    47,  -869,  1828,  2079,  1880,
     772,  3320,  2468,   788,  1978,  2336,   612,  2837,  3693,   612,
     612,   607,  1217,  2951,  2082,  1578,  3080,  3876,   978,  1226,
    3888,  2781,    41,  -140,  3627,  3628,  1232,  2784,  4011,  3321,
    1098,   699,   698,   649,  1099,  1950,  1427,  1575,  3214,  3931,
    3369,  2260,  1157,  2261,  3322,  1580,  2935,  3525,  -140,  1933,
    1934,  1935,  1936,  1855,  3323,  1801,  4141,  2696,  2417,    45,
     528,  2889,   529,   584,   750,  2262,  3092,  3546,   612,  3694,
    4165,    46,  2273,  1158,  3609,  1376,  3324,    32,   652,  1357,
    2927,  2611,  3791,  3906,   534,  1748,  3512,  1971,  1972,  1979,
    1246,   789,  1580,  1981,  3232,  3837,  2379,  2968,  2952,  1382,
    1385,  1386,  1159,  1233,  2838,   585,    37,  2034,  3582,  2839,
    3583,   673,  1912,  1913,   169,  1914,  2028,  2029,  3889,  1160,
    2030,  3093,  1790,  2757,   772,  2031,  2454,  2032,  2033,   790,
    2612,  2514,  1791,   684,  1749,    41,  2785,  2786,  2787,  2006,
    2788,  2789,  2790,  2791,  2792,  2793,  3113,  1792,  1234,  3325,
    1235,  2517,  2456,   170,    32,  2881,  2332,  2263,  2882,  2520,
    1920,  2522,  2264,  2039,  2040,  2041,  2042,  2265,   693,  3207,
   -2126,  2808,    45,  1160,  3186,  3781,  1393,   791,  2869,  1271,
    2514,  3852,  3853,  2869,    46,  3320,  2869,  1074,  1237,  3116,
    3981,   162,  1878,   166,  2788,  2789,  2790,  2791,  2792,  2793,
    3987,  2783,  2833,    37,  3948,  3847,  2613,  2614,  2882,  1074,
    1129,  2504,  1999,  3321,  1130,  3782,  3382,   519,    47,  2615,
    1149,  3838,  1575,  1177,  2840,  1239,  1394,  1866,  3652,  2103,
    2153,  3389,    41,  2841,  1913,  1871,  1914,  1565,  3323,  1252,
     162,  2150,   166,  2147,  2148,  2149,  2938,  1578,  3168,  3887,
    2109,  1150,  2110,  1626,  2111,  1178,  2112,  2784,  2113,  1241,
    3809, -1311,  2114,   916,  2616, -1311,  3244,  2196,  3245,    45,
    1253,  4008,  2606,   521,  1254,  1793,  1131,  1580,   601,  2597,
    1151,   872,  2266,  1886,  2948,   694,   643,  2332,  4017,  2141,
    4025,  2267,  1627,   672,  2184,  2185,  3063,  1747,   602,  1255,
     708,  2152,  2197,  3390,  3698,  3699,  2200,  2201,  2692,  2469,
    1179,  2699,  1132,   872,  1395,    47,  2009,  3756,  1154,  3733,
    3734,  2222,  3120,  2223,  3382,  2707,  2708, -1311,  2170,  2710,
    1887,  1888,  2258,  3325,  1431,  2714,  1638,  4048,  1748,  3491,
    2713,  1180,  3814,  3502,  2245,  3861,  2246,  3863,  2617,  1155,
    2618,  1270,   742,  4036,  1432,    32,   758,  3391,  3121,  2470,
     858,  1396,  4049, -1311,  1884,  2318,  1957,  2159,  3830,  3831,
    2725,  3122,  2869,  2255,  3976,  3241,  1774,  1958,  1156,  1082,
    1271,  2371,  3246,  1768,   858,  3492,  2375,  1749,   859,  2378,
    2746,  2942,  3247,  1594,  1595,  1596,  1597,  1598,  1599,  3261,
    1615,  1959,  1583,  1584,  2407,   772,   528,  1775,   529,   781,
     750,  2400,  3145,  1918,  2160,  3035,  3213,  3447,  2541,  1544,
    1574, -2126, -2126,  1575,  2788,  2789,  2790,  2791,  2792,  2793,
     534,   860,  2740,   787,  3401,  3036,  1776,  3448,  1545,  1397,
    2439,  2684,  2961,  2023,  1877,  1587,  -360,  2542,  1578,  1886,
    3123,  1160,  2901,  1928,  1579,   860,  2998,   696,  1533,  1534,
    1177,  2053,  2884,  2453,  2161,   842,    32,   843,  1843, -1312,
    1183,  1544,  3387, -1312,  3319,   827,  1184,  1229,  1580,  1955,
    2212,  1544,  1441,  1185,  1954,  1442,  2484,  2999,   830,  1886,
    1545,  1271,  1178,  2162,  2212,   832,  1887,  1888,  2163,  1187,
    1545,  1937,  3147,  2341,  1546,   847,  2505,  1188,  1230,  2515,
    1956,  1508,  2850,    47,  1548,   697,  3000,   853,   162,  2357,
    1886,   612,  2385,   862,  2388,  3274,  2523,  1964,  2173,  3626,
    1884,   861,   872,  2527,    27, -1312,  1887,  1888,  3488,   877,
    3490,  3320,  2293,  3493,  2164,  3494,  2550,  1179,  3408,  3413,
    1108,  3954,  1098,   892, -1789,  2557,  1099,  1189,   926,   928,
     930,  1634,  3382,   932,   933,   934,   901,  1887,  1888,  3321,
    1884, -1312,   978,   939,  2854,  2781,  2855,  3224,  1180,   698,
     907,  3893,  1582,  1081,  3322,   198,  1892,   911,  2211,  2211,
     505,   595,  3289,  2211,  3323,  2069,  2070,  2653,   581,  3262,
    3263,  1884,  2654,  1583,  1584,   595,  2971,  2685,  2409,  2410,
    2411,  1521,    37,  1781,   650,  2419,  3324,  2421,   872,  2423,
    2424,   185,  1521,  2173,  1152,  1594,  1595,  1596,  1597,  1598,
    1599,  2940,  3228,  2211,  2211,  1574,   942,  2754,  1575,  2755,
     957,    41,  2105,  3103,  2756,  2941,  1587,   946,  2654,  2924,
    2925,  1521,  2165,  1781,  3127,  1576,  4125,    27,  2166,  1588,
    3405,  2092,   952,  1578,  3295,  1521,   610,  1781,   955,  1579,
    2096,   610,   962,  2807,  3913,  2809,  2810,   963,    45,  1728,
    2546,  2106,  1729,   966,   612,  1731,  2167,   964,  1732,  3325,
      46,   699,   612,  1580,   612,  2943,   972,  2979,  2104,  2981,
     965,  2105,  2488,    32,  3420,  2168,   967,  1183,  2518,  3810,
    3811,  3812,  3813,  1184,  2856,  2575,  2857,  4102,  1074,  1074,
    1185,  2347,  2348,  2575,    47, -1062,   968, -1062,  1271,  2169,
    3080,  3227,  3094,  3096,  3097,    37,  1187,  2730,  2116,  2118,
    3064,  2117,  2117,  2144,  1188,  2331,  2145,  4169,  2332,  4170,
    2747,  3625,  2630,   971,  2749,  2783,  3268,  1085,  2367,  2730,
    2567,  2145,  2445,   974,    41,  2446,  2435,  1087,  2576,  2577,
    2578,  2579,  2580,  2581,  2674,  2675,  2605,  3033,  3016,  2647,
    1091,  3065,  3040,  1855,  3384,  3385,  3006,  2606,  3008,  3556,
   -1335, -1335,  2500,  1581,  1189,  2501,  1093,  1582,  2687,  3185,
    3143,    45,  1886,  2678,  1119,  3066, -1265,   162,  2662,   871,
    1092,  2784,  2592,    46,  2238,  2593,  3944,  2241,  1583,  1584,
    3067,  1126,  2645,  1128,  3068,  1097,  1594,  1595,  1596,  1597,
    1598,  1599,  3034,  1585,  1109,   872,   978,   872,  1116,  2781,
    2607,   871,  3069,  2608,  1119,  2717,  2301,  4126,  2117,  1887,
    1888,  2663,  3651,  3046,  3654,  2315,  3632,  3070,  1586,   772,
    2753,  1587,  3128,  2105,  3130,  2763,  2766,  2770,  2105,  2105,
    2105,  1120,  2771,  1117,  1588,  2105,  2701,  1589,  2703,  1127,
    2896,  2897,  1451,  1884,  1283,  1453,  1141,  1455,  1142,  1457,
    2797,  1459,  1146,  2105,  2870,  1463,  2813,  1170,   872,  2105,
    3137,  1152,  3140,   612,  3587,  3588,  3589,  2883,  2818,  3497,
    3498,  2819,  3485,  3857,  2989,  2993,  3134,  2990,  2994,  3135,
    3165,  1175,  2894,  3166,  3332,  3181,  1224,  3175,  3233,  3195,
    3176,  2105,  3071,  3198,  1193,  3200,  3269,  3202,  3203,  3270,
    3072,  1494,  1495,  2870,  3337,  3339,  3208,  1260,  3279,  1590,
     978,  3280,  3291,  2781,  3361,  2105,  3365,  3362,  3388,  3366,
    2456,  2117,  3481,  1222,  2752,  3482,   691,  2902,  2903,  2326,
    3633,  2329,  2920,  3073,  2785,  2786,  2787,  3225,  2788,  2789,
    2790,  2791,  2792,  2793,  3196,  3631,  3684,  3690,  2145,  3685,
    2117,  3691,  3229,  3777,  2117,  3819,  3778,  3821,  3820,  3829,
    2105,  3896,  2145,   513,  3897,  1269,  1278,  1563,  3223,  3910,
    3945,  3956,  3911,  3946,  2145,  3963,  1279,  3968,  2332,  2783,
    3154,  2258,  3970,  4026,  4030,  3154,  1614,  4031,  1284,  1286,
    1288,  2859,  2860,  2861,  1293,  1298,  1724,  1591,  1592,  1593,
    2853,  1594,  1595,  1596,  1597,  1598,  1599,  4037,  4038,  3237,
    2145,  2819,  3467,  2863,  2774,  1300,  4039,  1310,   978,  2105,
     871,  2781,  4042,  3899,   691,  2332,  1307,  2173,  3242,  1574,
    4044,  4061,  1575,  3154,  2145,  2784,  4067,  4068,  1160,  2145,
    2145,   519,  1351,   162,  2150,   166,  2147,  2148,  2149,  1576,
    1353,  1347,  2885,  3264,   612,  4091,  1355,  1578,  2332,  2997,
    -863,  4167,  2863,  1579,  4168,   690,  3009,  4178,  1364,  -157,
    4168,  1366,  3113,  1368,  1380,  1388,  3630,   185,  3114,  2475,
    1398,  3577,  1403,  1404,  1405,  1406,  1407,  1580,  3115,  1488,
    1409,  1420,  1410,  2783,  1415,  1418,  1419,   521,  3723,  3724,
    1421,  3726,  1423,  1428,  1429,  1430,   871,  2212,  2212,  1435,
    1440,  1465,  2212,  1490,  1496,  3116,  1492,  3117,  1498,  1499,
    1505,  1506,  2211, -1436,  3043,  2211,  2211,  2211,  2211,  2211,
    2211,  2211,  2211,  2211,  2211, -1443,  2894,  2644,  1515,  1518,
    1519,  1520,  3795,    47,  1524,  1526,  1529, -1433, -1434,  2784,
    3063,  1530,  2212,  2212,  2894,  3272,  1531,  1532,  1537,  1539,
    1540,  1541, -1437,  1542, -1435,  1543,  2945,  1603,  2946,  2947,
    1550,  1551,  1553,  1554,  1555,  3614,  1556,  1618,  1557,  1558,
    1559,  1560,  1629,  2992,  2211,  2211,  1614,  1581,  1637,  3118,
    1130,  1582,  1736,  3998,  1132,  4000,  1763,  1771,  2785,  2786,
    2787,  2783,  2788,  2789,  2790,  2791,  2792,  2793,  2506,  1779,
    1777,  3014,  1583,  1584,  1778,  1781,  1574,  1782,  1783,  1575,
    1784,  1811,  1785,  2642,  2634,  1833,  1835,  1585,  1786,  1838,
     528,  1807,   529,  1836,  1837,  1859,   872,  1866,  1878,  1860,
    1177,   531,  1868,  3119,  1578,  1879,  1881,  1882,  3120,  1883,
    1579,   533,  1586,  1884,   534,  1587,  1890,  2784,  1891,  1893,
    1894,  1895,  1901,  1902,  1908,  3487,  2575,  1905,  1588,  2575,
    2575,  1589,  1178,  2575,  1580,   750,  1950,  1906,  1915,  1940,
    2507,  1916,  1922,  2575,  3121,  1207,  1929,  1930,  1306,  1941,
    1942,  3216,  3082,  3738,  1945,  1951,  1968,  3122,  1967,  1953,
    1946,  1980,  3745,  1982,  1511,  1990,  1992,  1983,  1993,  3226,
    3082,  1521,  2785,  2786,  2787,  1527,  2788,  2789,  2790,  2791,
    2792,  2793,  2010,   871,  2016,   871,   612,  1179,  2013,  2017,
    2508,   515,  2038,  3089,  3091,  2021,  2832,  2022,  3098,  2043,
    1246,  2056,  2057,  1590,   612,  2062,  2065,  2067,  2068,  2072,
    2084,  2083,  2085,  2086,  2099,  2100,  3152,  2128,  1180,  2133,
    2142,  2155,  2178,  2179,  3536,  3537,  2220,  3556,  2233,  2221,
    2239,  1575,  3141,  2244, -2126,  2635,  3123,  2251,  1582,  2303,
    2509,  2342,  2243,  2276,  2316,  3180,   871,   162,  3172,  3538,
    3581,  2323,  3817,   697,  2319,  2257,  1148,  3584,  3585,  1583,
    1584,  2320,  2324, -1277,  2274,   162,  3194,  2333,  2343,  2352,
    2366,  2368,  2334,  2870, -2126, -1277,  2346,  3590,  2369, -1277,
    2785,  2786,  2787,  2381,  2788,  2789,  2790,  2791,  2792,  2793,
    2370,  1591,  1592,  1593,  2386,  1594,  1595,  1596,  1597,  1598,
    1599,  2391,  1587,  2321,  2393,  2389,  2394,  2405,  1181,  2322,
    2399,  2402,  2422,  2425,  2441,  1588,  2211,  2408,  2436,  2443,
    2503, -1277,  2499,  2490,  2495,  2502,  2543,  2556,  2510,  2566,
    2560,  2561,  3735,  2565,  2564,  2568,  2569,  2570,  2571,  1182,
    2572, -1277,  2582,    32,  2870,   612,  2591,  1183,  3962,  2584,
    2588,  2595,  2598,  1184,  2599,  2603,  2609,  2858,  3962,  2600,
    1185,  2628,  2633,  2601,  3230,  2636,  2602,  2640,  1186,  2652,
    2604,  2646,  2655,  3795,  2659,  2660,  1187, -1277,  2677,  2693,
    2694,   691,  3402,  2695,  1188, -1277,  2679,  2697,  2691,  3286,
   -2126,   691,  2698,  2706,  2712,  2709,  2716,  2731,  2711,  2719,
    2894,  1488,  2720,  2637,  1074,  4002,  2721,  2722,  3305,  3306,
    3307,  3308,  3671,  3898,  2332,  2156,  2724,  2739,  2743,   948,
    2745,  2750,  1563,  2751,  2748,  3848,  2768,  2511,  2105,  2815,
    2834,  2842,  3312,  2852,  1189,  2512,  2849,  2872,  2513,  2878,
    2803,  2880,  3347,  -909,  2906,  2926,  3449,  2764,  2765,  3452,
    2767,  2829,  2769,  2912,  2772,  2773,  2775,  2778,  3955,  2796,
    2802,  2923,  2804,  2805,  2928,  2812,  2827,  2828,  3707,  3708,
    2877,  2908,  2918,  2929,  2937,  2933,  2934,  2944,  4123,  4043,
    2958,  2965,  1594,  1595,  1596,  1597,  1598,  1599,  2211,  2211,
    3011,  2966,  2978,  2980,  3012,  3017,  3015, -1277,  3024,  3019,
    3697,  3020,  3018,  3021,  3022,  3023,  3025,  3759,  3026,  3027,
    3028,  3029,  3031,  3030,  3032,  3039,  3037,   872,  3730,  3731,
    3041,  3706,  3991,  1938,  3047,  3053,  3996,  3997,  3054,  3055,
    3056,  3057,  3058,  3715,  3084,  3087,  3099,  3088,  3104,  1999,
    3131,  2212,  3100,  3105,  2212,  2212,  2212,  2212,  2212,  2212,
    2212,  2212,  2212,  2212,  3142,  1098,  3082,  3144,  1119,  1099,
    3146,  3153,  3397,  3398,  3399,  3400,  3738,  3860,  3158,  3995,
    3160,  3729,  3169,  3440,  2212,  3170,  3441,  3193,  3442,  3210,
    3154,  3199,  3201,  3163,  3992,  3958,  3221,  3173,  3439,  3222,
     612,  3211,  1574,  3164,  3220,  1575,  3462,  3463,  3212,  3215,
    3231,  1508,  3236,  2212,  2212,  2799,   612,  2781,  2575,  1568,
    2798,  3265,  3266,  3267,  2575,  2575,  2575,  2575,  2575,  2575,
    1578,  3281,  3293,  3273,   871,  3294,  1579,  3331,  3489,  3334,
    3357,  3302,  3354,  3803,  3375,  3804,  3805,  3340,  3350,  3318,
    3393,  3395,  2730,  3351,  3403,  3353,  3808,  3404,  4155,  3396,
    1580,  3423,  3406,  3421,  3414,  3422,  3433,  3434,   612,  3435,
    3444,  3460,  3409,  3464,  3436,  3470,  3437,  3507,  3509,  3511,
    3513,   936,   937,  3471,  3438,  3468,  3501,  3539,  3499,  3500,
    3528,  3541,  3496,  3520,  3532,  3185,  3542,  3560,  3544,  3133,
    2117,  3564,  3545,  3565,  3574,  3575,  4155,  3567,  3578,  3580,
    3586,  3506,  3591,  3594,  4155,  3595,  3603,  3596,  3597,  3598,
    3606,  3611,  3934,  3610,  3148,  3615,  3616,  1488,  2684,  3617,
    3647,  3156,  3618,  3619,  3623,  3162,  3643,  3521,  3648,  2870,
    3655,  3660,  3645,  2870,  3569,  3658,  3661,  1177,  3663,  4047,
    3174,  3664,  3672,  1606,  3868,  3975,  3675,  3679,  3681,  3686,
    1581,  3687,  3701,  3709,  1582,  3702,  3703,  3727,  3732,   772,
    3736,  3743,  3751,  3752,  3748,  3760,  3764,  3204,  3769,  1178,
    3205,  3716,  3882,  3765,  3771,  1583,  1584,  3719,  3776,  3779,
    3783,  3792,  3801,  3807,   621,   622,  3793,  3815,  3816,   628,
    1585,  3818,  3601,   638,   644,   621,  3823,   651,  3825,  3827,
     644,   644,  3834,   677,  1074,   680,  2211,  1813,  3826,  3841,
     612,  4144,  3828,  3850,  3844,  3822,  3854,  3862,  1587,  3856,
    3858,  3884,  3874,  3877,  1179,  3890,  3885,  3900,  3527,  3891,
    3907,  1588,  2211,  2211,  3909,  3919,  3920,  3922,  3924,  3938,
    1814,  3936,  3937,  3940,  3965,  3710,  3959,  3939,  3974,  3982,
    3989,   698,  4012,  1815,  4019,  1180,  4022,  3720,  4034,  4028,
    4029,  4040,  3953,  4016,  4041,  4035,  1816,  4045,  4046,  4051,
    4053,  3993,  4064,  1436,  4070,  2212,  4069,  4073,  4075,  4079,
    4084,  3342,  4109,  4101,  2685,  4104,  4071,  4106,  2863,  4112,
    4120,  4072,  2863,  4135,  4147,  4163,  4166,  4172,  1952,  2643,
    4176,  2494,  2887,  1636,  1817,  2976,  1590,  3060,  3418,  1121,
    2555,  3894,  3670,  1196,  3737,  4004,  3979,  3775,  3921,  3562,
    3309,  3310,  3311,  1488,  3923,  3757,  3680,  3933,  2931,  2718,
     872,   162,  3673,  1818,   733,   738,   738,   741,  1819,   738,
     746,  4107,   733,  3866,   677,  4003,   774,  3678,  4143,  4076,
     677,  4074,   677,  3034,  4118,  2055,   738,  4024,   677,  3563,
    2936,  3531,  2626,  3417,  4058,   612,  2987,  3534,  2627,  3533,
    2035,  4146,  2610,  3149,  4177,  4173,  3085,  3101,  4119,  3883,
      32,  2020,  4066,  4110,  2686,  3886,   627,  1488,  3704, -2039,
    1184,  1488,  1488,  3592,  1591,  1592,  1593,  1185,  1594,  1595,
    1596,  1597,  1598,  1599,  1483,  1271,   612,  3570,  3977,  4033,
    2449,   873,  3038,  1187,  4128,  2211,  4174,  3571,  2730,  3713,
    3714,  1188,  1094,  3914,  3717,  3718,  2327,  2108,  2328,  2891,
    3550,  2575,  2575,  1820,  3674,  3367,  1733,  2892,  1115, -2041,
    4055,  2351,  1760,  1759,  2904,   871,  2900,  2212,  2212,  3741,
    2350,  3742,  2345,  2905,  3746,  3747,  1764,  2917,  2870,  3725,
    3314,   185,  3967,  2870,  1102,  1767,  2870,  3368,  3653,  3285,
    2596,  1189, -2039,  3728,  2883,  2687,  3275,  3957,  4093,  4092,
    4100,  3754,  2895,  1574,  2847,  2760,  1575,  2845,  3364,  2302,
       0,   772,  1821,     0,     0,     0,  2870,     0,  1822,   612,
       0,  1823,     0,  2730,     0,  2730,  3773,     0,     0,   162,
    3766,  1578,     0,     0,  2894,     0,     0,  1579, -2039,   772,
       0,     0, -2041,     0,  3881,     0,  1824,     0,     0,     0,
   -2039,     0,  1825,     0, -2039,  3794,     0,     0,     0, -2039,
       0,  1580,     0,     0, -2039,  1826,     0, -2039,     0, -2039,
       0,     0,     0,     0,     0,  4140,  3601,  3601,  3601,  3601,
     750,  3774,     0,     0,  3503,     0,     0,     0, -2041,  1827,
       0,     0,     0,     0,     0,     0, -2039,     0,     0,     0,
   -2041,     0,     0,  3529, -2041,     0,     0,     0,     0, -2041,
       0,     0,     0,     0, -2041,     0, -2039, -2041,     0, -2041,
       0,     0,     0,     0,  2870,     0,  3540,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2863,     0,     0,
       0,     0,  2863,     0,     0,  2863, -2041,     0,     0,     0,
       0,     0, -2039,     0,     0,     0,     0,     0,     0,     0,
   -2039,  1581,     0,     0,     0,  1582, -2041,     0,     0,     0,
       0,     0,  2870,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   797,     0,  1583,  1584,     0,   677,
    3082,   733,     0,     0,   738,     0,   741,     0,   738,     0,
       0,  1585, -2041,     0,   774, -2039,     0,   850,     0,     0,
   -2041,  3859,     0,  2575,   738,     0,     0,  3895,     0,     0,
    3869,  3871,  3871,     0,   612,     0,  1586,     0,     0,  1587,
       0,     0,     0,     0,     0,   733,     0,     0,     0,     0,
     741,     0,  1588,     0,   733,     0,     0,   774,     0,   625,
       0,     0,     0,     0,     0, -2041,     0,     0,     0,     0,
       0,     0,   738,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2039,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2212,  3639,  3640,  3641,  3642,
       0,     0,     0,     0,  2212, -2039,     0, -2039, -2039,   625,
       0,     0,     0,     0,     0,     0,     0,   772,   677,     0,
       0,  2212,  2212,     0,     0, -2053,     0,  1590,   677,   961,
       0,     0, -2041,     0,     0,  3941,     0,     0,     0,     0,
   -2039,  2863,     0, -2039, -2039, -2039,     0,  1069,     0,   677,
     644,     0,     0,     0,   644, -2041,     0, -2041, -2041,     0,
       0,     0,     0,  4081,     0,     0,   677,     0,     0,     0,
     677,     0,  2870,     0,     0,     0,  1069,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   677,   871,     0,
   -2041,     0,     0, -2041, -2041, -2041,     0,     0,     0,   677,
       0,     0,  4108,     0,     0,  2730,     0,     0, -2053,     0,
       0,     0,     0,  3983,     0,  1591,  1592,  1593,     0,  1594,
    1595,  1596,  1597,  1598,  1599,     0,     0,     0,     0,     0,
       0,  3999,     0,  4001,     0,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   738,   738, -2053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2053,     0,     0,     0,
   -2053,     0,     0,     0,     0, -2053,     0,     0,     0,     0,
   -2053,     0,     0, -2053,     0, -2053,     0,     0,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     733,     0,     0,   774,  2212,     0,     0,     0,     0,     0,
       0,     0, -2053,  4175,     0,     0,   738,     0,     0,     0,
       0,     0,     0,  3871,     0,     0,     0,     0,     0,     0,
     677,     0, -2053,     0,     0,     0,   738,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     677,   677,   677,   738,     0,   733,     0,     0,     0,     0,
       0,     0,  4078,     0,     0,     0,     0,     0, -2053,  3800,
       0,     0,     0,     0,     0,     0, -2053,     0,     0,     0,
     738,   738,     0,     0,     0,  4162,     0,     0,     0,     0,
     162,  4133,   166,  4130,  4131,  4132,     0,     0,     0,     0,
       0,     0,     0,  1069,  2684,     0,     0,     0,     0,     0,
       0,  4154,  4111,     0,     0,     0,     0,     0,     0,     0,
       0, -2053,     0,  1177,     0,     0,  4161,  4133,   166,  4130,
    4131,  4132,     0,  1468,  1468,     0,     0,     0,   677,     0,
     621,     0,     0,     0,     0,  4153,     0,     0,     0,     0,
       0,     0,  4145,     0,     0,  1178,     0,  1497,     0,  4154,
     677,     0,     0,  1503,     0,   625,     0,  4154,     0,     0,
     162,  4133,   166,  4130,  4131,  4132,  1069,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0, -2053,     0,
       0,     0,     0,  4153,     0,     0,     0,     0,     0,     0,
       0,  4153,     0,     0,  1069,     0,     0,     0,     0,     0,
    1179, -2053,  -115, -2053, -2053,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,  1069,  1069,  1574,  1069,     2,  1575,     3,     4,
       0,  1180,     0,  3903,     0,     0, -2053,     0,     0, -2053,
   -2053, -2053,  1069,     5,     0,     0,     0,     0,     0,     0,
       0,     0,  1578,     0,     0,     0,  1197,     0,  1579,     0,
    2685,     0,  1198,     6,  1074,     7,     8,     0,     0,     0,
       0,     9,     0,    10,     0,     0,     0,   677,     0,     0,
    1069,     0,  1580,    11,     0,    12,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,  1199,     0,    14,     0,     0,     0,     0,  1069,
       0,     0,     0,  1069,  1069,     0,    15,     0,    16,     0,
       0,     0,    17,   677,   677,  1770,     0,     0,    18,     0,
       0,     0,     0,     0,     0,    19,     0,    20,     0,     0,
       0,   644,     0,    21,  2843,     0,     0,     0,     0,     0,
       0,  1200,     0,     0,     0,  3986,    32,    22,  1201,     0,
    1183,  1202,     0,     0,     0,     0,  1184,     0,   644,     0,
       0,     0,     0,  1185,     0,     0,     0,     0,     0,  1865,
       0,  1271, -2126,     0,     0,   677,  1582,     0,   738,  1187,
       0,     0,     0,     0,     0,     0,     0,  1188,     0,     0,
       0,     0,     0,     0,     0,     0,   774,  1583,  1584,     0,
      23,    24,     0,  1203,     0,  1574,    25,     0,  1575,     0,
       0,     0, -2126,     0,    26,     0,  1574,     0,     0,  1575,
       0,     0,     0,     0,     0,    27,     0,     0,   738,   738,
     738,   738,   677,  1578,     0,     0,  1576,  1189,     0,  1579,
    1587,  2687,     0,   644,  1578,     0,     0,     0,     0,     0,
    1579,     0,     0,  1588,     0,     0,  1963,  1204,   677,  1205,
       0,     0,    28,  1580,     0,     0,   738,   738,     0,  1206,
       0,     0,   738,    29,  1580,     0,     0,  1207,    30,     0,
      31,     0,     0,     0,     0,    32,  1208,     0,     0,     0,
      33,     0,     0,    34,     0,     0,     0,    35,     0,     0,
       0,     0,    36,    37,     0,     0,     0,     0,     0,     0,
      38,     0,     0,    39,     0,     0,     0,  1209,   738,     0,
      40,  1210,     0,     0,     0,  3299,     0,     0, -2126,     0,
       0,     0,    41,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   738,   738,   738,   738,  1211,     0,     0,    42,
       0,     0,     0,     0,  1343,     0,     0,     0,    43,     0,
       0,  1963,     0, -2126,    44,     0,     0,  1582,     0,    45,
     733,     0,     0,     0,  1581,     0,     0,   741,  1582,   733,
       0,    46,     0,     0,     0,     0,     0,   774,  1583,  1584,
       0,     0,   677,     0,     0,     0,     0,     0,     0,  1583,
    1584,   677,  1212, -2126,     0,     0,     0,   738,   738,     0,
       0,     0,   677,     0,  1585,    47,     0,     0,  -115,     0,
    1594,  1595,  1596,  1597,  1598,  1599,     0,     0,     0,     0,
       0,  1587,     0,     0,     0,     0,     0,  1468,     0,  1586,
       0,     0,  1587,     0,  1588,   733,     0,     0,     0,   677,
     677,     0,     0,     0,     0,  1588,     0,   677,  1589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     621,   621,     0,     0,  2158,     0,     0,     0,  1069,  1343,
    1069,     0,     0,     0,     0,     0,     0,  1069,     0,     0,
    1069,     0,     0,  1069,     0,     0,     0,     0,     0,     0,
       0,  1069,  1069,     0,     0,     0,     0,     0,     0,  1069,
       0,   774,  1069,  1069,  1069,  1069,     0,     0,     0, -2126,
       0,     0,  1069,  1069,     0,  1069,     0,  1069,  1069,     0,
    1590,  1069,     0,     0,     0,     0,  1197,     0,     0,     0,
       0,     0,  1198,     0,     0,     0,     0,     0,  1069,     0,
       0,     0,   738,  1069,     0,     0,     0,  1069,     0,     0,
       0,  1069,     0,  1069,  1069,  1069,  1069,  1069,  1069,  1069,
    1069,  1069,     0,  1069,     0,     0,     0,   677,  1069,     0,
    1069,     0,  1199,     0,     0,     0,   677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1624,
       0,  1594,  1595,  1596,  1597,  1598,  1599,     0,  1591,  1592,
    1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,
       0,  1200,     0,     0,  1573,  2822,     0,     0,  1201,  1574,
       0,  1202,  1575,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1574,     0,  1576,
    1575,     0,  1577,     0,     0,     0,     0,  1578,     0,     0,
    1343,     0,     0,  1579,     0,     0,     0,  1576,     0,     0,
       0,     0,     0,     0,     0,  1578,     0,     0,     0,     0,
       0,  1579,     0,  1203,     0,     0,     0,  1580,     0,     0,
     677,     0,   677,     0,  1069,     0,  1574,     0,     0,  1575,
       0,     0,     0,     0,     0,  1580,     0,  1343,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1578,     0,     0,     0,     0,     0,
    1579,  2358,     0,  2365,     0,     0,  1343,  1204,     0,  1205,
       0,     0,     0,     0,     0,     0,     0,     0,   741,  1206,
       0,     0,     0,   621,  1580,   621,     0,  1207,     0,     0,
       0,     0,     0,     0,     0,     0,  1208,     0,     0,     0,
    1069,     0,     0,     0,     0,   733,     0,   738,   738,   738,
       0,   733,   774,     0,   738,     0,   738,  1581,   738,   738,
       0,  1582,     0,     0,     0,     0,     0,  1249,     0,     0,
       0,  1210,  1343,     0,     0,  1581,     0,     0,     0,  1582,
       0,     0,  1583,  1584,     0,     0,  3300,     0,     0,     0,
       0,  1343,     0,  1865,     0,     0,  1250,  1585,     0,  2457,
    1583,  1584,     0,     0,  2466,     0,     0,     0,     0,     0,
     677,  1343,     0,     0,     0,  1585,     0,     0,     0,     0,
       0,     0,  1586,     0, -2126,  1587,  2497,  2497,  1582,     0,
       0,     0,     0,   741,     0,     0,  1343,     0,  1588,     0,
    1586,  1589,     0,  1587,     0,     0,     0,   738,     0,  1583,
    1584,     0,  1212,     0,     0,     0,  1588,     0,     0,  1589,
       0,     0,     0,     0, -2126,     0,     0,     0,     0,     0,
    2545,     0,  2547,  2549,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1574,     0,  1343,  1575,
       0,     0,  1587,     0,     0,     0,     0,     0,     0,   738,
       0,     0,     0,     0,     0,  1588,  1576,   738,   738,   738,
     738,   738,   738,  1590,  1578,     0,     0,     0,     0,     0,
    1579,     0,  1069,     0,     0,     0,     0,     0,     0,     0,
       0,  1590,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1580,     0,     0,     0,     0,  1865,
       0,     0,     0,  2497,   677,     0,     0,     0,   621,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2126,     0,     0,  2545,     0,     0,     0,     0,     0,     0,
     738,  2673,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,
    1599,     0,     0,     0,     0,   738,  2497,   738,  2497,  1591,
    1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,
       0,     0,     0,  2242,     0,     0,     0,  1069,     0,     0,
       0,     0,     0,     0,  1581,     0,     0,     0,  1582,  1468,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1583,
    1584,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,
       0,     0,     0,     0,  1585,  1574,     0,     0,  1575,     0,
       0,   733,     0,     0,     0,   733,     0,     0,     0,     0,
       0,     0,     0,   738,     0,  1576,     0,     0,     0,  1586,
    1069,  1069,  1587,  1578,     0,     0,     0,     0,     0,  1579,
       0,     0,     0,     0,     0,  1588,     0,     0,  1589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1069,  1069,     0,  1580,     0,  1069,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1069,  1069,  1069,
    1069,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1069,     0,     0,  1069,     0,  1069,  2826,  1197,     0,     0,
       0,     0,     0,  1198,     0,  1069,  1069,     0,     0,  1069,
       0,     0,     0,     0,     0,     0,     0,     0,  1574,     0,
    1590,  1575,  1069,     0,  1069,     0,   774,     0,  1069,     0,
       0,     0,     0,     0,     0,  1197,     0,     0,  1576,     0,
       0,  1198,     0,  1199,  1069,     0,  1578,     0,   677,     0,
    1197,     0,  1579,     0,     0,  2871,  1198,  1069,  1069,  1069,
       0,     0,     0,  1581,     0,     0,     0,  1582,     0,     0,
       0,     0,     0,     0,  1069,     0,  1580,     0,     0,     0,
       0,  1199,     0,     0,     0,     0,  1069,     0,  1583,  1584,
       0,  1069,  1200,     0,     0,   677,  1199,     0,  1069,  1201,
       0,     0,  1202,  1585,  2871,     0,     0,  2911,  1591,  1592,
    1593,  2365,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,
       0,     0,  3086,     0,     0,     0,     0,     0,  1586,     0,
    1200,  1587,     0,     0,     0,     0,     0,  1201,     0,     0,
    1202,  1069,     0,  2497,  1588,  1200,     0,  1589,  1468,     0,
       0,     0,  1201,  1343,  1203,  1202,     0,     0,  1343,  1343,
       0,     0,     0,     0,     0,   738,     0,   738,   738,  1343,
       0,     0,     0,     0,     0,     0,  1581,     0,     0,     0,
    1582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1203,     0,     0,     0,     0,     0,     0,     0,
       0,  1583,  1584,     0,     0,     0,     0,  1203,  1204,     0,
    1205,     0,     0,     0,     0,     0,  1585,     0,     0,  1590,
    1206,     0,     0,     0,     0,     0,     0,     0,  1207,     0,
       0,     0,     0,     0,     0,     0,     0,  1208,     0,     0,
       0,  1586,     0,     0,  1587,     0,  1204,     0,  1205,     0,
       0,     0,     0,     0,     0,     0,     0,  1588,  1206,     0,
    1589,  1204,     0,  1205,     0,     0,  1207,     0,  1274,     0,
       0,     0,  1210,  1206,     0,  1208,     0,     0,     0,     0,
       0,  1207,     0,     0,     0,     0,     0,     0,     0,     0,
    1208,     0,     0,     0,     0,     0,  1343,  1275,     0,     0,
       0,     0,     0,     0,     0,     0,  1830,  1591,  1592,  1593,
    1210,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,     0,
       0,  3284,  2497,  2497,     0,  1210,     0,     0,     0,     0,
       0,  1574,  1590,     0,  1575,  1831,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1211,  1576,     0,  1212,     0,     0,     0,     0,     0,  1578,
       0,     0,     0,     0,     0,  1579,     0,     0,     0,  1343,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,  1580,
       0,  1212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1468,   677,  1212,     0,     0,     0,
       0,     0,   677,     0,     0,     0,   677,     0,     0,     0,
    1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,
       0,   677,     0,     0,  3356,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1343,
       0,     0,     0,     0,     0,     0,     0,     0,   677,     0,
       0,   677,     0,     0,     0,     0,     0,     0,  3209,     0,
       0,     0,     0,     0,     0,     0,   733,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1581,
       0,     0,     0,  1582,     0,   677,     0,     0,     0,     0,
       0,     0,     0,   738,     0,     0,     0,     0,     0,     0,
       0,  1069,     0,     0,  1583,  1584,     0,     0,     0,     0,
    1069,     0,     0,     0,     0,     0,  1069,     0,  1069,  1585,
       0,     0,  1574,     0,  1069,  1575,     0,  1069,  1069,  1069,
    1069,  1069,  1069,  1069,  1069,  1069,  1069,     0,     0,     0,
    1069,  1069,  1576,     0,  1586,     0,     0,  1587,     0,     0,
    1578,     0,     0,  1069,     0,     0,  1579,  1069,     0,     0,
    1588,  1069,     0,  1589,     0,     0,     0,     0,     0,     0,
       0,  1069,     0,     0,  1069,     0,  1069,     0,     0,     0,
    1580,     0,     0,     0,     0,  1069,  1069,  1069,     0,     0,
       0,  1069,     0,     0,  1069,     0,     0,     0,     0,     0,
       0,   677,   677,   677,  2871,  3317,     0,     0,     0,  3317,
    3330,     0,     0,     0,  1069,     0,     0,     0,     0,     0,
    3344,     0,  1069,     0,  1069,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1069,     0,
       0,     0,     0,     0,  1069,     0,     0,     0,  2365,     0,
    1069,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3383,  1468,  1468,     0,  1963,
    1581,     0,     0,     0,  1582,     0,     0,     0,     0,     0,
       0,   738,   738,   738,   738,     0,     0,     0,     0,     0,
       0,     0,  1343,     0,     0,  1583,  1584,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1585,     0,  3416,  1591,  1592,  1593,     0,  1594,  1595,  1596,
    1597,  1598,  1599,     0,     0,     0,     0,  3377,     0,  1574,
    1343,  1343,  1575,  1343,     0,  1586,     0,     0,  1587,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1576,
       0,  1588,     0,     0,  1589,     0,     0,  1578,     0,     0,
       0,     0,     0,  1579,     0,     0,     0,     0,     0,     0,
       0,  3465,     0,     0,     0,     0,     0,     0,  1574,     0,
       0,  1575,     0,  1343,     0,  1343,     0,  1580,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1576,     0,
       0,     0,     0,     0,     0,     0,  1578,     0,     0,     0,
       0,     0,  1579,     0,   735,     0,     0,     0,     0,     0,
       0,     0,   735,   754,     0,     0,  1590,     0,   754,  1343,
       0,     0,     0,     0,     0,   677,  1580,   754,     0,     0,
       0,     0,     0,     0,     0,     0,   738,     0,  1069,     0,
    1343,     0,     0,     0,   677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1865,     0,     0,
       0,     0,     0,     0,     0,  1343,     0,   677,     0,     0,
       0,     0,     0,     0,     0,     0,  2545,  1581,     0,     0,
       0,  1582,  3557,  1343,     0,     0,  1865,     0,  3209,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1069,
    1069,     0,  1583,  1584,  1591,  1592,  1593,     0,  1594,  1595,
    1596,  1597,  1598,  1599,     0,     0,     0,  1585,  3604,     0,
       0,  2497,     0,  2497,     0,     0,  1581,     0,     0,     0,
    1582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1586,     0,     0,  1587,     0,  1343,     0,     0,
       0,  1583,  1584,     0,     0,     0,  1069,     0,  1588,     0,
    1343,  1589,     0,     0,     0,     0,  1585,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1586,  1069,     0,  1587,     0,     0,     0,     0,     0,
       0,     0,  1069,  1069,     0,     0,     0,  1588,     0,     0,
    1069,  1069,     0,     0,     0,  1069,     0,     0,     0,     0,
       0,  1069,  1069,     0,     0,  1069,     0,   677,   677,   677,
     677,     0,     0,  1590,  3317,     0,  1343,  3644,  1574,     0,
    2871,  1575,     0,     0,  2871,     0,     0,     0,     0,     0,
    3657,     0,     0,  1069,     0,  1343,     0,     0,  1069,     0,
       0,     0,     0,     0,  3667,     0,  1578,     0,     0,     0,
    1069,     0,  1579,     0,     0,  1574,   774,     0,  1575,     0,
    1343,     0,  1590,     0,  2911,     0,     0,     0,  2365,     0,
       0,     0,     0,     0,     0,  1576,  1580,   621,     0,     0,
    1069,     0,     0,  1578,     0,     0,     0,     0,     0,  1579,
       0,     0,     0,     0,     0,     0,  1343,  2497,  2497,     0,
       0,  1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,
    1599,     0,     0,  1580,  3705,  3638,     0,     0,     0,     0,
       0,   735,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   754,     0,     0,     0,   754,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   754,   738,     0,
    1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,
       0,   754,   738,     0,     0,   735,     0,     0,     0,     0,
       0,     0,     0,     0,   735,   754,  1581,     0,     0,   754,
    1582,     0,     0,     0,     0,     0,     0,     0,     0,   754,
       0,     0,     0,     0,  1468,     0,     0,   754,     0,     0,
       0,  1583,  1584,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1581,     0,     0,  1585,  1582,     0,     0,
       0,     0,  1069,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1583,  1584,
       0,     0,     0,     0,  1587,     0,     0,     0,     0,  1343,
     738,  1865,     0,  1585,     0,     0,     0,  1588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   735,     0,     0,
       0,     0,   754,     0,     0,     0,     0,     0,  1586,     0,
     677,  1587,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1588,     0,   735,  1589,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1069,     0,
       0,     0,     0,     0,     0,     0,     0,  1069,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1590,     0,  1069,  1069,     0,     0,  1069,     0,
       0,     0,     0,     0,     0,  3317,     0,     0,     0,  2871,
       0,     0,     0,     0,  2871,     0,     0,  2871,  2545,     0,
    3846,     0,  1069,  1069,     0,     0,     0,     0,     0,  1590,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1335,     0,     0,     0,  3383,   774,   738,
     738,   738,     0,     0,     0,     0,  1343,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     735,     0,     0,     0,     0,   733,   774,     0,     0,     0,
     735, -2126, -2126,     0,  1594,  1595,  1596,  1597,  1598,  1599,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1345,     0,     0,  1468,     0,     0,     0,     0,
       0,   733,     0,     0,   677,     0,     0,  1591,  1592,  1593,
       0,  1594,  1595,  1596,  1597,  1598,  1599,  2497,     0,  1865,
       0,  3824,     0,     0,     0,   735,     0,     0,     0,     0,
    3557,     0,   172,     0,     0,   677,     0,     0,     0,     0,
       0,     0,     0,     0,   738,  3383,     0,     0,     0,     0,
       0,     0,  1574,     0,   754,  1575,     0,     0,  1335,     0,
       0,     0,     0,     0,     0,     0,     0,  1069,     0,   754,
    1069,     0,  1069,   735,     0,     0,     0,     0,   173,     0,
    1578,   754,     0,     0,     0,     0,  1579,  1343,     0,  1069,
       0,   174,     0,  2871,     0,     0,  3846,     0,  1343,     0,
       0,     0,  3973,     0,     0,     0,     0,     0,   175,   754,
    1580,     0,     0,     0,   176,     0,     0,  1345,     0,   754,
       0,     0,   738,     0,     0,     0,   677,     0,     0,   177,
       0,   754,     0,     0,   754,     0,     0,     0,     0,   738,
     738,   738,   738,     0,     0,     0,   735,   178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   179,     0,
       0,     0,     0,   180,     0,     0,     0,     0,     0,   181,
       0,  1069,  3303,     0,   735,     0,     0,     0,     0,  1574,
       0,     0,  1575,     0,   182,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1343,     0,  1576,
       0,     0,   735,   735,     0,   735,     0,  1578,     0,   183,
   -2126,     0,     0,  1579,  1582,     0,     0,     0,  1343,     0,
       0,     0,   735,     0,     0,     0,  1069,     0,     0,     0,
    1343,     0,   738,     0,   774,  1583,  1584,  1580,     0,     0,
       0,  1069,     0,     0,   754,  1574,     0,     0,  1575,  1335,
   -2126,   754,   754,     0,     0,     0,     0,     0,   184,     0,
     735,  1720,     0,     0,     0,  1576,     0,     0,  1343,     0,
       0,   738,     0,  1578,   733,     0,     0,     0,  1587,  1579,
       0,     0,     0,  3383,     0,     0,   185,     0,     0,   735,
       0,  1588,     0,   735,   735,     0,  1335,  3973,     0,     0,
    1069,  1069,     0,  1580,     0,     0,     0,     0,  1345,     0,
       0,   186,     0,   733,  1720,     0,     0,   187,     0,     0,
       0,   738,     0,   188,     0,  1335,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1581,     0,     0,
       0,  1582,     0,     0,     0,     0,  1069,     0,     0,     0,
       0,   190,     0,   191,     0,  1345,  1069,   192,     0,     0,
       0,   738,  1583,  1584,     0,   193, -2126,     0,     0,     0,
     194,     0,     0,     0,     0,     0,     0,  1585,     0,     0,
       0,   195,     0,     0,  1345,     0,     0,     0,     0,     0,
       0,  1335,     0,     0,   196,     0,     0,     0,     0,     0,
       0,     0,  1586,  1581,     0,  1587,     0,  1582,     0,     0,
    1335,     0,     0,     0,  1343,  1069,     0,     0,  1588,     0,
       0,  1589,     0,     0,   733,     0,     0,     0,  1583,  1584,
    1335,   754,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1585,     0,     0,     0,     0,  1574,     0,
    1345,  1575,     0,     0,     0,  1335,     0,     0,  1594,  1595,
    1596,  1597,  1598,  1599,     0,     0,     0,     0,  1586,  1345,
       0,  1587,     0,     0,     0,     0,  1578,     0,     0,     0,
       0,     0,  1579,     0,  1588,     0,     0,  1589,     0,  1345,
       0,     0,     0,  1590,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1580,  1335,     0,  1720,
       0,     0,     0,  1343,  1345,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   754,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   754,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1590,
     735,     0,     0,     0,     0,     0,  1345,     0,  3636,   735,
       0,   754,   754,     0,     0,     0,     0,     0,     0,     0,
     754,  1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,
    1599,     0,   754,   754,     0,  3864,     0,     0,     0,  1343,
       0,     0,     0,     0,   754,     0, -2126,     0,     0,     0,
    1582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1583,  1584,     0,     0,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -2126,  1591,  1592,  1593,
    1343,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,     0,
       0,  3905,     0,     0,     0,     0,  1574,     0,   735,  1575,
     735,     0,     0,     0,  1587,     0,     0,   735,  1335,     0,
     735,     0,     0,   735,  1343,     0,  1576,  1588,  1343,  1343,
       0,   735,   735,     0,  1578,     0,     0,     0,     0,   735,
    1579,     0,   735,   735,   735,   735,     0,     0,     0,     0,
       0,     0,   735,   735,     0,   735,     0,   735,   735,     0,
       0,   735,     0,     0,  1580,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1345,   735,  1720,
       0,     0,     0,   735,     0,     0,     0,   735,     0,     0,
       0,   735,     0,   735,   735,   735,   735,   735,   735,   735,
     735,   735, -2126,   735,     0,     0,     0,     0,   735,     0,
     735,     0,     0,     0,     0,     0,  1574,     0,     0,  1575,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1576,     0,     0,     0,
       0,     0,     0,  1574,  1578,     0,  1575,     0,     0,     0,
    1579,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1576,  1581,     0,     0,     0,  1582,     0,
       0,  1578,     0,     0,  1580,     0,     0,  1579,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1583,
    1584,     0,     0,     0,  1594,  1595,  1596,  1597,  1598,  1599,
       0,  1580,     0,     0,  1585,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1586,
       0,     0,  1587,     0,   735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1588,     0,     0,  1589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1581,     0,     0,     0,  1582,   754,
       0,     0,     0,  1720,   754,     0,     0,   754,     0,     0,
       0,     0,  1335,     0,     0,     0,     0,  1335,  1335,  1583,
    1584,  1581,     0,     0,     0,  1582,     0,     0,  1335,   754,
     735,     0,     0,     0,  1585,   735,     0,     0,     0,     0,
    1590,   735,     0,     0,     0,     0,  1583,  1584,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   754,  1586,
       0,  1585,  1587,     0,     0,     0,     0,     0,     0,     0,
       0,  1345,     0,     0,     0,  1588,  1345,  1345,  1589,     0,
       0,   754,   754,     0,     0,     0,  1586,  1345,     0,  1587,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,  1720,   754,  1589,  1720,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   754,     0,     0,   754,  1591,  1592,
    1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,
       0,     0,  4080,     0,   754,     0,     0,     0,     0,     0,
    1590,   754,     0,     0,     0,  1335,     0,     0,     0,     0,
       0,     0,     0,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,   754,     0,     0,  1574,  1590,     0,  1575,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1576,     0,     0,     0,
    2335,     0,     0,     0,  1578,     0,     0,     0,     0,     0,
    1579,     0,   735,     0,  1345,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1335,     0,
       0,     0,     0,     0,  1580,     0,     0,     0,  1591,  1592,
    1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,     0,
       0,     0,  4164,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1591,  1592,  1593,     0,  1594,
    1595,  1596,  1597,  1598,  1599,     0,     0,  3352,     0,  2336,
       0,     0,     0,     0,     0,     0,     0,  1345,     0,     0,
     754,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1335,     0,
     798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   754,     0,     0,     0,     0,   735,     0,     0,
       0,     0,     0,     0,  1581,     0,     0,     0,  1582,     0,
       0,     0,     0,   799,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   754,   800,   801,     0,  1583,
    1584,     0,     0,     0,     0,   802,     0,  1345,     0,   803,
       0,     0,     0,     0,  1585,     0,     0,   754,     0,     0,
       0,   735,     0,     0,     0,   735,   804,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1586,
     735,   735,  1587,     0,     0,     0,     0,   805,     0,     0,
       0,     0,     0,     0,     0,  1588,     0,     0,  1589,     0,
       0,     0,     0,     0,     0,   806,     0,     0,     0,     0,
     735,   735,     0,     0,     0,   735,   807,     0,     0,     0,
       0,   808,     0,     0,     0,     0,     0,   735,   735,   735,
     735,     0,     0,     0,     0,  1720,     0,     0,     0,     0,
     735,  1720,   809,   735,     0,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,   735,     0,     0,   735,
       0,     0,     0,     0,     0,     0,     0,   810,     0,     0,
    1590,     0,   735,     0,   735,     0,     0,     0,   735,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   735,     0,   735,   735,   735,
       0,     0,     0,     0,     0,     0,   811,     0,     0,  2337,
       0,   754,     0,     0,   735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   735,     0,     0,     0,
       0,   735,     0,     0,   185,     0,     0,     0,   735,     0,
       0,  1335,     0,     0,   735,     0,     0,     0,  1591,  1592,
    1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,     0,   812,
     754,     0,     0,   813,     0,   814,     0,     0,     0,     0,
       0,   815,     0,     0,   816,   754,   754,     0,     0,  1335,
    1335,   735,  1335,   542,     0,     0,     0,     0,     0,   582,
       0,     0,     0,     0,     0,     0,     0,   754,   630,   817,
    1345,   818,     0,   509,     0,   819,     0,     0,     0,     0,
       0,     0,     0,   820,     0,   510,   689,     0,   821,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1335,     0,  1335,     0,   511,     0,  1345,  1345,
       0,  1345,   822,     0,     0,     0,     0,     0,     0,   512,
       0,     0,     0,     0,     0,     0,     0,     0,   513,     0,
       0,     0,  -682,     0,     0,     0,     0,     0,  1720,  1720,
    1720,     0,     0,     0,     0,     0,     0,     0,  1335,   514,
       0,     0,     0,     0,     0,   515,     0,   754,     0,     0,
       0,  1345,     0,  1345,   754,     0,     0,     0,     0,  1335,
     516,     0,     0,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   517,     0,
       0,     0,     0,     0,  1335,     0,     0,     0,     0,   518,
       0,     0,     0,     0,     0,     0,   519,  1345,     0,     0,
     520,     0,  1335,     0,     0,     0,     0,     0,   745,     0,
       0,     0,   754,     0,     0,  -863,     0,   776,  1345,   778,
       0,   780,     0,   782,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1720,     0,     0,  1345,     0,     0,     0,     0,     0,     0,
       0,     0,   521,     0,     0,     0,     0,     0,     0,     0,
    1720,  1345,     0,     0,     0,     0,  1335,     0,     0,     0,
       0,     0,     0,     0,   754,     0,   754,     0,     0,  1335,
       0,     0,     0,     0,     0,     0,   754,     0,   754,   522,
    1335,     0,   523,     0,  1574,     0,     0,  1575,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1576,     0,     0,     0,     0,     0,
       0,     0,  1578,     0,     0,  1345,     0,     0,  1579,     0,
       0,     0,     0,     0,     0,     0,     0,   754,  1345,     0,
       0,     0,   524,     0,     0,     0,     0,     0,   525,  1345,
       0,     0,  1580,     0,  -360,  1335,     0,   526,     0,     0,
       0,     0,     0,     0,   754,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1335,     0,   735,     0,     0,   754,
       0,     0,  -360,     0,   527,   528,     0,   529,   530,     0,
       0,     0,     0,     0,   754,     0,   531,   754,     0,  1335,
       0,   532,   755,     0,     0,     0,   533,   755,     0,   534,
       0,   735,   535,     0,  1345,     0,   755,     0,     0,     0,
     735,     0,     0,     0,     0,  -360,   735,     0,   735,     0,
       0,  2798,     0,  1345,   735,  1335,  2799,   735,   735,   735,
     735,   735,   735,   735,   735,   735,   735,     0,     0,     0,
     735,   735,  1581,     0,     0,     0,  1582,     0,  1345,     0,
       0,     0,     0,   735,     0,     0,     0,   735,     0,  1720,
       0,   735,     0,     0,     0,     0,     0,  1583,  1584,     0,
       0,   735,     0,     0,   735,     0,   735,     0,     0,     0,
       0,     0,  1585,     0,  1345,   735,   735,   735,     0,     0,
       0,   735,     0,     0,   735,     0,     0,     0,     0,     0,
    1574,     0,     0,  1575,   735,  1344,     0,  1586,     0,     0,
    1587,     0,     0,     0,   735,     0,     0,     0,     0,     0,
    1576,     0,   735,  1588,   735,     0,  1589,     0,  1578,     0,
     829,     0,     0,     0,  1579,     0,     0,   836,     0,     0,
       0,     0,     0,     0,     0,     0,   851,   852,   735,     0,
       0,   854,     0,     0,   735,     0,     0,     0,  1580,     0,
     735,   868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   876,   735,     0,     0,  1335,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   896,     0,
       0,   898,     0,   900,     0,   903,     0,     0,  1590,     0,
     754,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1574,     0,     0,  1575,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1344,     0,  1720,     0,     0,  1576,  1720,  1345,  1720,     0,
       0,     0,     0,  1578,     0,     0,     0,     0,     0,  1579,
       0,     0,   958,     0,   959,     0,     0,     0,  1581,     0,
       0,     0,  1582,     0,   754,     0,     0,   754,     0,     0,
       0,     0,     0,  1580,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1583,  1584,     0,  1591,  1592,  1593,     0,
    1594,  1595,  1596,  1597,  1598,  1599,     0,     0,  1585,     0,
       0,     0,     0,     0,     0,   754,   689,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1586,  1337,  1335,  1587,     0,     0,     0,
       0,   755,     0,     0,     0,   755,     0,     0,     0,  1588,
       0,     0,  1589,     0,     0,     0,   755,     0,     0,     0,
       0,  4138,     0,     0,     0,     0,     0,     0,   735,  1335,
     755,  3276,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1581,   755,     0,     0,  1582,   755,     0,
     754,   754,     0,     0,  1345,     0,     0,     0,   755,     0,
       0,     0,     0,     0,     0,     0,   755,     0,  1583,  1584,
       0,     0,     0,     0,     0,     0,     0,  1277,     0,     0,
       0,     0,     0,  1585,  1590,     0,     0,     0,  1345,   735,
     735,  1344,  1289,     0,     0,     0,     0,  3277,     0,     0,
       0,  1574,     0,  1297,  1575,     0,     0,     0,  1586,     0,
    1299,  1587,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,  1576,  1349,     0,  1588,     0,     0,  1589,     0,  1578,
     754,     0,     0,     0,     0,  1579,  1335,     0,  1858,     0,
       0,   755,     0,     0,  4139,     0,   735,  1335,     0,     0,
       0,     0,     0,     0,  1391,     0,     0,     0,     0,  1580,
       0,     0,     0,     0,     0,     0,     0,  1344,     0,     0,
       0,     0,  1591,  1592,  1593,     0,  1594,  1595,  1596,  1597,
    1598,  1599,   735,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   735,   735,     0,  1345,     0,     0,     0,  1590,
     735,   735,     0,     0,     0,   735,  1345,     0,     0,     0,
       0,   735,   735,     0,     0,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     735,     0,     0,  1344,   735,     0,     0,     0,     0,     0,
       0,     0,     0,   735,     0,     0,  1335,     0,   735,     0,
       0,     0,  1344,     0,     0,     0,     0,     0,     0,  1581,
     735,     0,     0,  1582,     0,     0,     0,  1335,     0,     0,
       0,     0,  1344,     0,     0,     0,     0,     0,     0,  1335,
       0,     0,     0,     0,  1583,  1584,     0,  1591,  1592,  1593,
     735,  1594,  1595,  1596,  1597,  1598,  1599,  1344,     0,  1585,
       0,     0,     0,     0,     0,  1345,     0,     0,     0,     0,
    1337,     0,     0,     0,     0,     0,     0,  1335,     0,     0,
       0,     0,     0,     0,  1586,     0,  1345,  1587,     0,     0,
       0,     0,     0,   754,     0,     0,     0,     0,  1345,     0,
    1588,     0,     0,  1589,     0,   754,     0,     0,     0,  1344,
       0,     0,     0,     0,     0,     0,     0,  1337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   755,     0,     0,  1345,  1574,     0,     0,
    1575,     0,     0,     0,     0,     0,  1337,     0,   755,     0,
       0,     0,     0,     0,  1720,     0,   754,  1576,     0,     0,
     755,     0,     0,     0,     0,  1578,   689,  1735,     0,     0,
       0,  1579,     0,     0,     0,  1590,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   755,     0,
       0,     0,   735,     0,     0,  1580,     0,     0,   755,     0,
    3234,     0,     0,     0,  1720,     0,     0,     0,     0,     0,
     755,     0,  1337,   755,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1335,     0,  1829,     0,     0,     0,     0,
       0,  1337,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1345,     0,     0,
       0,  1337,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1591,  1592,  1593,   754,  1594,  1595,  1596,
    1597,  1598,  1599,     0,     0,     0,  1337,     0,   735,  2811,
    1344,     0,  1345,     0,     0,     0,     0,   735,     0,     0,
       0,     0,     0,     0,     0,  1581,     0,     0,     0,  1582,
       0,     0,     0,     0,   735,   735,     0,     0,   735,     0,
       0,     0,     0,  2314,     0,     0,     0,     0,     0,   735,
    1583,  1584,  1335,   755,   735,     0,     0,   735,  1337,     0,
     755,   755,   735,   735,     0,  1585,     0,     0,     0,     0,
    1721,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   754,     0,   754,     0,     0,     0,   735,     0,     0,
    1586,     0,     0,  1587,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1588,     0,     0,  1589,
       0,  1345,     0,     0,     0,   735,     0,     0,     0,     0,
       0,  1574,     0,  1721,  1575,     0,     0,     0,     0,     0,
       0,     0,     0,  1574,     0,  2015,  1575,     0,  1335,     0,
       0,  1576,     0,     0,  2762,     0,     0,     0,  2037,  1578,
       0,   735,     0,  1576,     0,  1579,  2806,     0,     0,  1335,
       0,  1578,     0,     0,     0,     0,     0,  1579,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1580,
       0,  1590,     0,     0,     0,     0,  2078,     0,     0,  1335,
       0,  1580,     0,     0,     0,   735,     0,  1345,     0,  2091,
       0,  2093,     0,  2094,     0,     0,     0,     0,  2095,     0,
       0,     0,     0,     0,     0,     0,     0,   735,  1345,     0,
     735,     0,   735,  1335,     0,     0,     0,  1335,  1335,  1337,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   735,
     755,     0,     0,   735,     0,     0,     0,     0,  1345,     0,
       0,  1735,     0,     0,  1735,     0,  1735,     0,     0,  1735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1591,
    1592,  1593,     0,  1594,  1595,  1596,  1597,  1598,  1599,  1581,
       0,     0,  1345,  1582,  2444,     0,  1345,  1345,     0,  1858,
    2451,  1581,     0,     0,     0,  1582,     0,     0,     0,   754,
    1344,     0,     0,     0,  1583,  1584,     0,     0,     0,     0,
       0,     0,     0,  1720,     0,     0,  1583,  1584,  1721,  1585,
       0,   735,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1585,     0,     0,     0,   755,     0,     0,     0,     0,
     553,     0,     0,     0,  1586,     0,     0,  1587,  1345,     0,
       0,   755,   554,     0,     0,     0,  1586,     0,     0,  1587,
    1588,     0,     0,  1589,     0,     0,     0,     0,     0,     0,
       0,     0,  1588,   555,     0,  1589,   735,     0,     0,     0,
     755,   755,     0,     0,     0,     0,   556,     0,     0,   755,
       0,   735,     0,     0,     0,     0,     0,     0,     0,   557,
       0,   755,   755,     0,   756,     0,     0,     0,     0,   756,
       0,     0,     0,   755,     0,     0,   558,     0,   756,     0,
       0,     0,     0,     0,   735,     0,     0,  1344,     0,     0,
       0,     0,     0,   735,     0,  1590,     0,   559,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1590,     0,     0,
     735,   735,     0,   754,     0,   560,     0,     0,     0,     0,
       0,     0,     0,   735,     0,     0,   561,     0,     0,     0,
       0,   562,     0,     0,     0,     0,     0,   563,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   564,     0,     0,     0,   735,     0,     0,     0,
    1858,     0,     0,  1337,     0,     0,   735,     0,  1337,  1337,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,  1720,  1591,  1592,  1593,     0,  1594,  1595,  1596,
    1597,  1598,  1599,     0,     0,  1591,  1592,  1593,     0,  1594,
    1595,  1596,  1597,  1598,  1599,     0,     0,     0,  1721,     0,
       0,     0,     0,  1574,     0,     0,  1575,     0,  2372,  2373,
       0,     0,     0,  2376,  2377,   735,   565,  2380,     0,     0,
    1720,     0,     0,  1576,   735,     0,   566,  2390,  1720,     0,
    1344,  1578,     0,     0,  2398,     0,     0,  1579,     0,     0,
    2403,  2404,     0,     0,   185,     0,     0,     0,     0,     0,
       0,  2418,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,  1580,     0,     0,     0,     0,     0,  2440,     0,   567,
       0,     0,  2442,   568,     0,   569,     0,     0,     0,     0,
       0,   570,     0,     0,   571,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1337,     0,  2458,  2459,
    2462,  2464,     0,     0,     0,  2471,  2474,     0,     0,   572,
       0,   573,     0,  2485,     0,   574,  2489,     0,     0,     0,
    2493,     0,     0,   575,     0,     0,     0,     0,   576,     0,
       0,     0,     0,     0,     0,     0,  2516,     0,     0,   577,
       0,     0,     0,     0,     0,     0,  2519,     0,  2521,     0,
       0,     0,   578,     0,     0,     0,  2524,  2525,  2526,     0,
    2528,  1581,     0,     0,     0,  1582,     0,     0,     0,  1337,
       0,     0,     0,  2551,  2552,  2553,     0,     0,     0,     0,
       0,     0,     0,  2558,  2559,     0,  1583,  1584,     0,     0,
    2314,  2314,  2314,   756,     0,     0,     0,   756,   755,     0,
       0,  1585,  1721,   755,     0,     0,   755,     0,   756,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   756,     0,     0,     0,  1586,     0,   755,  1587,
       0,     0,     0,     0,     0,     0,   756,     0,     0,     0,
     756,     0,  1588,  2621,     0,  1589,     0,     0,     0,  1337,
     756,     0,     0,     0,     0,     0,     0,   755,   756,  2776,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     755,   755,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1344,     0,     0,     0,     0,     0,     0,
       0,  1574,  1721,   755,  1575,  1721,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1590,     0,     0,
       0,  1576,     0,   755,  2817,     0,   755,     0,     0,  1578,
       0,  1858,  2451,   756,  2451,  1579,     0,     0,     0,     0,
       0,     0,     0,   755,     0,     0,     0,     0,     0,     0,
     755,     0,     0,     0,  1735,     0,     0,     0,     0,  1580,
       0,     0,     0,   755,     0,     0,     0,     0,     0,     0,
       0,     0,   755,     0,     0,     0,     0,     0,     0,     0,
       0,  2741,     0,     0,  1344,     0,  1344,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1591,  1592,  1593,     0,  1594,
    1595,  1596,  1597,  1598,  1599,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1344,  1056,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,     0,     0,     0,     0,  1581,
    1112,     0,     0,  1582,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2451,     0,     0,     0,
       0,     0,     0,     0,  1583,  1584,     0,     0,     0,   755,
       0,     0,     0,     0,  2451,     0,     0,     0,     0,  1585,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1337,     0,     0,     0,     0,     0,     0,     0,
       0,   755,     0,     0,  1586,     0,     0,  1587,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1588,     0,     0,  1589,     0,     0,     0,     0,     0,     0,
    1337,  1337,     0,  1337,   755,     0,     0,     0,  1344,     0,
       0,  1574,  2890,     0,  1575,   756,     0,     0,     0,     0,
       0,  2451,     0,     0,     0,     0,   755,     0,     0,     0,
     756,  1576,  1344,     0,  3283,     0,     0,     0,     0,  1578,
       0,     0,   756,     0,     0,  1579,     0,     0,     0,  2921,
    2922,     0,     0,  1337,     0,  1337,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1590,  1735,     0,     0,  1580,
     756,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   756,     0,     0,   756,     0,  1344,     0,  1337,
       0,     0,     0,     0,  1721,  2953,  2955,     0,     0,  2955,
    1721,     0,     0,  2962,  2963,  2964,  1344,     0,     0,     0,
    1337,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,  1337,     0,  2982,  2983,  2984,
    2985,     0,     0,  1591,  1592,  1593,     0,  1594,  1595,  1596,
    1597,  1598,  1599,  1337,     0,     0,     0,     0,     0,  1581,
       0,     0,     0,  1582,     0,     0,     0,  1344,     0,     0,
       0,     0,     0,  3010,     0,     0,     0,     0,     0,     0,
     755,     0,     0,     0,  1583,  1584,     0,     0,     0,     0,
       0,  1574,     0,     0,  1575,   756,     0,     0,     0,  1585,
    1513,     0,   756,   756,     0,     0,     0,  2314,     0,     0,
       0,  1576,  1722,     0,     0,     0,     0,  1337,     0,  1578,
       0,     0,     0,     0,  1586,  1579,  3042,  1587,  1536,   755,
    1337,  3044,     0,     0,     0,     0,     0,     0,     0,     0,
    1588,  1337,     0,  1589,   755,   755,     0,     0,     0,  1580,
       0,     0,     0,     0,     0,     0,  1561,  1562,     0,  1564,
       0,     0,     0,     0,     0,  1722,   755,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1604,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3129,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3136,     0,     0,  1337,     0,     0,     0,
       0,     0,     0,     0,  1639,  1590,     0,     0,     0,     0,
    2451,     0,     0,     0,     0,  1337,     0,     0,     0,  3155,
       0,  3157,     0,     0,     0,     0,     0,  1721,  1721,  1721,
       0,     0,     0,  1742,     0,     0,     0,  1752,  1755,  1581,
    1337,     0,  1197,  1582,     0,     0,   755,     0,  1198,     0,
       0,     0,     0,   755,     0,     0,     0,     0,  3197,     0,
       0,     0,     0,   755,  1583,  1584,     0,     0,     0,     0,
       0,  3206,   756,  1231,     0,     0,  1337,     0,     0,  1585,
       0,     0,  1735,     0,     0,     0,     0,     0,  1199,     0,
       0,     0,     0,  1591,  1592,  1593,     0,  1594,  1595,  1596,
    1597,  1598,  1599,     0,  1586,     0,     0,  1587,     0,     0,
       0,   755,     0,     0,     0,     0,     0,     0,     0,  1232,
    1588,     0,     0,  1589,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1200,     0,  1721,
       0,     0,     0,     0,  1201,     0,     0,  1202,     0,     0,
    1722,     0,     0,     0,     0,     0,     0,  1344,     0,  1721,
       0,     0,     0,     0,     0,     0,     0,   756,     0,     0,
       0,     0,     0,   755,     0,   755,     0,     0,     0,     0,
       0,     0,     0,   756,     0,   755,     0,   755,     0,     0,
       0,  1858,     0,     0,     0,  1590,  1233,     0,     0,  1203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   756,   756,     0,     0,     0,     0,     0,     0,
       0,   756,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,     0,   756,   756,     0,   755,     0,     0,     0,
       0,  1234,     0,  1235,     0,   756,     0,     0,     0,     0,
       0,     0,  1338,  1236,     0,  1205,     0,     0,     0,     0,
       0,     0,     0,   755,     0,  1206,     0,     0,     0,     0,
       0,     0,     0,  1207,     0,     0,     0,     0,   755,     0,
       0,  1237,  1208,  1591,  1592,  1593,     0,  1594,  1595,  1596,
    1597,  1598,  1599,   755,     0,     0,   755,     0,  1344,     0,
       0,     0,     0,     0,  3394,     0,     0,     0,     0,  1344,
       0,     0,     0,  1238,     0,     0,     0,  1210,  1239,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3415,     0,
       0,     0,  1240,     0,     0,     0,  2314,     0,     0,     0,
       0,  2314,  1241,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2314,     0,     0,     0,     0,  1721,     0,
       0,     0,     0,     0,     0,     0,  1337,  1338,  3443,     0,
    1722,     0,     0,  3450,  3451,     0,  3453,  3454,  3455,  3456,
    3457,  3458,  3459,     0,     0,     0,     0,     0,  1212,     0,
       0,  3466,     0,     0,     0,     0,     0,     0,  1344,     0,
    1337,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2182,     0,     0,     0,     0,     0,     0,     0,  1344,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,  2204,     0,     0,  2206,     0,     0,  2217,
       0,     0,     0,     0,     0,     0,  2224,  2229,     0,     0,
       0,     0,  2235,     0,     0,  2240,     0,     0,     0,     0,
    3515,  3517,  3519,     0,     0,  3522,     0,  1340,     0,  1344,
       0,     0,  2249,     0,     0,     0,     0,  2256,     0,     0,
       0,  2268,     0,     0,     0,  2275,     0,  2277,  2278,  2279,
    2280,  2281,  2282,  2283,  2284,  2285,     0,  2286,     0,   755,
       0,     0,  1056,     0,  2311,     0,     0,  1337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1337,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1721,     0,     0,     0,  1721,     0,  1721,     0,     0,
       0,     0,     0,  2955,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1338,     0,
    1735,  1735,  1735,   755,     0,     0,   755,     0,     0,     0,
     756,     0,     0,     0,  1722,   756,     0,     0,   756,     0,
    3798,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,   755,  1338,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,     0,  1337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1112,   756,
       0,     0,     0,     0,  1338,     0,     0,     0,  1337,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1337,     0,   756,   756,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1722,   756,     0,  1722,     0,   755,
     755,     0,     0,     0,     0,     0,  1341,     0,  1337,     0,
       0,     0,     0,     0,     0,   756,     0,     0,   756,     0,
    1338,     0,     0,     0,  2401,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2451,   756,     0,     0,     0,  1338,
       0,     0,   756,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   756,     0,     0,     0,  1338,
       0,     0,     0,     0,   756,     0,     0,     0,     0,     0,
       0,     0,     0,  3700,     0,     0,     0,     0,     0,   755,
       0,     0,     0,     0,  1338,     0,     0,     0,     0,     0,
       0,     0,  3711,  3712,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,  3721,  3722,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,  1735,     0,  1735,     0,     0,
    2451,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,  1338,     0,     0,     0,
       0,  1344,     0,     0,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,  1337,     0,     0,     0,     0,     0,
       0,  1601,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1344,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,   756,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1344,  2594,     0,     0,  1344,
    1344,  3768,     0,   756,     0,     0,     0,  1601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3788,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1340,   756,     0,     0,     0,
       0,     0,     0,  1337,     0,     0,  3806,     0,     0,     0,
       0,     0,     0,     0,  1340,     0,     0,     0,   756,     0,
       0,  3798,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   755,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   755,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,     0,  1340,
       0,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,  2715,  1341,     0,     0,     0,     0,  1342,  1735,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1337,
       0,     0,     0,  1721,     0,   755,  1722,     0,     0,     0,
       0,     0,  1722,     0,     0,     0,     0,     0,     0,     0,
    1337,  1340,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1337,     0,     0,  1721,     0,  2758,     0,     0,  1341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1337,     0,     0,     0,  1337,  1337,
       0,     0,   756,     0,  3912,     0,     0,     0,     0,     0,
       0,  2229,     0,  2229,  2229,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  2820,   755,     0,  2823,     0,  2825,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,     0,
       0,  2955,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   756,     0,  1341,     0,     0,  2846,     0,  2848,     0,
       0,     0,  2851,     0,     0,     0,   756,   756,     0,     0,
       0,     0,     0,  1341,  1735,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1735,     0,     0,     0,   756,     0,
       0,  2311,  2311,  2311,     0,     0,     0,     0,  1341,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,  2888,     0,
     755,     0,   755,  1601,     0,     0,     0,     0,     0,     0,
    1742,     0,     0,     0,     0,  2899,     0,     0,     0,     0,
       0,  1735,  1755,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1341,  1338,     0,     0,     0,     0,  1338,  1338,     0,  1722,
    1722,  1722,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,  2930,     0,     0,   756,     0,
       0,     0,     0,     0,     0,   756,     0,     0,  1601,     0,
    2955,     0,     0,     0,     0,   756,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1735,     0,     0,     0,     0,
       0,  1601,     0,  1342,     0,     0,  2213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1601,  1601,     0,  1601,
       0,     0,     0,   756,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4077,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1722,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,  1722,     0,     0,  1338,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   756,     0,   756,     0,     0,
       0,     0,     0,     0,  1601,     0,     0,   756,     0,   756,
       0,  1341,     0,     0,     0,     0,     0,     0,   755,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1721,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,   756,     0,
       0,     0,     0,     0,  1342,     0,  1340,     0,     0,     0,
       0,  1340,  1340,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,  1342,   756,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,     0,     0,  1601,     0,  1342,
       0,     0,     0,     0,     0,   756,     0,  1601,   756,     0,
    1601,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   755,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1722,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3235,     0,     0,     0,     0,
       0,  1721,     0,     0,  3238,     0,     0,     0,     0,     0,
    3239,     0,  3240,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3258,  3259,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,  1341,     0,     0,     0,  1721,
    1341,  1341,     0,     0,     0,  2235,     0,  1721,     0,     0,
       0,  1341,     0,     0,     0,  3287,     0,     0,  3290,     0,
    3292,     0,     0,     0,     0,     0,     0,     0,     0,  3296,
       0,     0,     0,     0,     0,  3301,     0,     0,  3304,     0,
       0,   756,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3333,     0,
       0,     0,     0,     0,     0,     0,  3345,     0,  2311,     0,
       0,     0,  1340,  1722,     0,     0,     0,  1722,     0,  1722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3359,     0,     0,     0,     0,     0,  1056,     0,
       0,     0,     0,     0,  1112,   756,     0,     0,   756,     0,
    1338,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
       0,     0,     0,     0,     0,     0,   756,     0,  1338,  1338,
       0,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1338,     0,  1338,     0,     0,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   756,   756,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,  1601,     0,  2213,  2213,  2794,     0,     0,  2213,     0,
       0,  1341,  1601,  1338,     0,     0,     0,     0,     0,  1601,
       0,   756,     0,     0,  1601,     0,     0,     0,     0,     0,
    1601,  1338,     0,     0,     0,  1601,  1342,     0,     0,     0,
       0,  1342,  1342,     0,  1601,     0,     0,     0,  2213,  2213,
       0,  1601,  1342,     0,     0,  1340,     0,     0,     0,     0,
       0,     0,     0,  1601,     0,     0,     0,     0,     0,     0,
    1601,     0,  1601,  1601,  1601,  1601,  1601,  1601,  1601,  1601,
    1601,  1601,     0,  3572,  3573,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,  1340,  1338,  1340,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1601,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1338,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3602,     0,     0,     0,     0,     0,  1340,     0,  1340,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,  1338,     0,  3620,  3622,     0,     0,
       0,     0,  1340,     0,     0,     0,  1601,     0,     0,  3629,
       0,     0,     0,  1338,     0,  3634,  3635,     0,     0,  3637,
       0,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   756,     0,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,   756,  2311,  1340,     0,
       0,     0,  2311,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,  2311,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  1338,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1341,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3683,  1722,     0,   756,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,  1341,     0,  1341,     0,     0,     0,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,  1340,     0,  1722,     0,     0,     0,     0,
       0,     0,     0,     0,  1340,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,  1341,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,     0,     0,     0,     0,     0,   756,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,  1341,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,  3755,     0,  1340,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,     0,     0,     0,  1341,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,     0,     0,
       0,     0,   756,     0,   756,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1601,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,     0,  3832,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,  1601,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1341,  1338,     0,     0,  3849,     0,     0,
       0,     0,     0,     0,  2794,  2794,     0,  2213,     0,     0,
    2213,  2213,  2213,  2213,  2213,  2213,  2213,  2213,  2213,  2213,
    2794,     0,     0,     0,     0,  1342,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1601,     0,     0,  1601,     0,
    1601,     0,     0,     0,     0,  2794,  2794,     0,  1341,     0,
       0,     0,     0,  1342,  1342,     0,  1342,     0,     0,  2213,
    2213,  1601,  1340,  1601,     0,     0,  1601,  1341,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1601,     0,     0,  1342,     0,  1342,     0,
       0,     0,     0,     0,  1601,     0,     0,     0,     0,     0,
     756,     0,     0,     0,     0,  1338,     0,     0,  1341,     0,
       0,     0,     0,     0,  1722,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,  2235,  1601,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3964,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1340,
       0,     0,     0,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1338,     0,     0,     0,     0,
       0,     0,     0,  1340,     0,  4021,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1338,     0,
       0,     0,     0,     0,   756,     0,     0,     0,     0,     0,
    1342,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1342,     0,  1338,     0,     0,     0,
       0,     0,     0,     0,     0,  4060,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1722,     0,     0,     0,     0,     0,     0,
    1340,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  1342,
       0,     0,     0,     0,  4097,  4097,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1342,     0,
       0,  1722,     0,     0,     0,     0,     0,     0,     0,  1722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
    4097,     0,     0,     0,     0,     0,     0,     0,  1341,     0,
    4142,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
    1601,     0,  1338,  1601,  1601,  1601,     0,     0,  2794,     0,
    1340,     0,  1341,  2794,  2794,  2794,  2794,  2794,  2794,  2794,
    2794,  2794,  2794,  1601,  1601,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,  4097,
       0,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,     0,  1601,  2213,  2213,  1601,     0,  1601,     0,     0,
       0,  1601,  2794,  2794,     0,     0,  1601,     0,     0,  1601,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1340,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1601,     0,
       0,  1338,     0,     0,     0,     0,     0,     0,     0,     0,
    1601,     0,     0,     0,     0,     0,     0,     0,     0,  1341,
       0,     0,     0,     0,  1601,     0,     0,     0,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1340,     0,  1341,
       0,     0,     0,     0,     0,     0,     0,     0,  1338,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1338,     0,     0,     0,  1338,  1338,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2794,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1342,
    1341,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,  1601,  1601,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1601,     0,     0,
       0,  2213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1601,     0,  1601,     0,     0,
       0,     0,  2794,  2794,  1601,     0,     0,  2213,  2213,  1601,
    1601,     0,  1601,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1340,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,  1341,     0,  1601,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1340,     0,     0,
       0,  1340,  1340,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1601,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,     0,     0,
    1342,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,  2794,
    2213,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2794,  2794,  1601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1601,     0,     0,     0,     0,     0,
       0,  1342,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1341,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1341,     0,     0,  2794,
    1341,  1341,     0,     0,     0,     0,     0,     0,     0,  1601,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1342,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1601,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1601,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1601,     0,     0,     0,  1342,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1601,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1342,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1342,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   709,   975,   548,   976,   977,   978,   595,
     979,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,  2305,   209,   210,   211,     0,  1342,     0,     0,
     980,  1342,  1342,   212,   213,     0,   214,   215,   710,   216,
     217,   218,   219,   981,   711,   982,   983,     0,   223,   224,
     225,   226,   227,   984,   985,   228,   229,   986,   987,   232,
       0,   233,   234,   235,   236,   988,     0,   238,     0,   239,
     240,   241,   242,   712,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   713,   251,   252,   989,   990,   991,
     992,   993,   994,   995,   253,   254,   255,   256,   257,   258,
     996,   997,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,  2306,     0,   271,   272,   998,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   999,   286,   287,   288,  1000,  1001,
     290,     0,   291,  1002,   293,     0,   294,     0,   295,   715,
       0,   716,   296,   297,   298,     0,   299,  1003,     0,   301,
       0,   302,   303,   304,   305,   306,   717,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,   718,
     317,   318,   319,   320,   321,  1004,  1005,     0,  1006,     0,
     325,   719,   720,   326,   721,   327,   328,   329,   330,   331,
     332,   333,     0,  1007,   722,   335,   723,     0,   336,   337,
     338,  1008,  1009,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1010,   724,  1011,   353,   354,
     355,  1012,   356,   357,   725,   358,  1013,  1014,   360,  1015,
     362,   363,   364,     0,   365,     0,     0,  1016,   367,   368,
       0,     0,   369,   726,   727,   728,  1017,   371,   372,   373,
     374,   375,   376,   377,     0,   378,  1018,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1019,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   729,
     409,   410,  1020,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,  1021,   425,   426,
     427,   428,   730,   429,  1022,     0,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,  1023,     0,   442,   443,
       0,   444,   445,   446,   447,   448,   449,     0,  1024,  1025,
       0,     0,   452,  1026,   454,  1027,  1028,   456,   457,   458,
     459,   460,   461,     0,  1029,   462,   463,   464,   465,   466,
    1030,     0,   467,   468,   469,   470,   471,   472,  1031,  2307,
     474,   731,   475,   476,   477,     0,     0,   478,     0,     0,
     479,   480,   481,   482,   483,   484,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,   493,   494,   495,     0,     0,     0,
       0,     0,     0,     0,  1040,  1041,  2308,     0,     0,     0,
       0,     0,     0,  1043,  2309,   709,   975,   548,   976,   977,
     978,   595,   979,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   980,     0,     0,   212,   213,     0,   214,   215,
     710,   216,   217,   218,   219,   981,   711,   982,   983,     0,
     223,   224,   225,   226,   227,   984,   985,   228,   229,   986,
     987,   232,     0,   233,   234,   235,   236,   988,     0,   238,
       0,   239,   240,   241,   242,   712,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   713,   251,   252,   989,
     990,   991,   992,   993,   994,   995,   253,   254,   255,   256,
     257,   258,   996,   997,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   998,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   999,   286,   287,   288,
    1000,  1001,   290,     0,   291,  1002,   293,     0,   294,     0,
     295,   715,     0,   716,   296,   297,   298,     0,   299,  1003,
       0,   301,     0,   302,   303,   304,   305,   306,   717,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   718,   317,   318,   319,   320,   321,  1004,  1005,     0,
    1006,     0,   325,   719,   720,   326,   721,   327,   328,   329,
     330,   331,   332,   333,     0,  1007,   722,   335,   723,     0,
     336,   337,   338,  1008,  1009,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1010,   724,  1011,
     353,   354,   355,  1012,   356,   357,   725,   358,  1013,  1014,
     360,  1015,   362,   363,   364,     0,   365,     0,     0,  1016,
     367,   368,     0,     0,   369,   726,   727,   728,  1017,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1018,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1019,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   729,   409,   410,  1020,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1021,
     425,   426,   427,   428,   730,   429,  1022,     0,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,  1023,     0,
     442,   443,     0,   444,   445,   446,   447,   448,   449,     0,
    1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,   456,
     457,   458,   459,   460,   461,     0,  1029,   462,   463,   464,
     465,   466,  1030,     0,   467,   468,   469,   470,   471,   472,
    1031,     0,   474,   731,   475,   476,   477,     0,     0,   478,
       0,     0,   479,   480,   481,   482,   483,   484,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,     0,
       0,     0,     0,     0,     0,     0,  1040,  1041,   199,     0,
       0,     0,     0,     0,     0,  1043,  2215,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,  3315,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0, -1367,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0, -1367,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316, -1367,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326, -1367,
     327,   328,   329,   330,   331,   332,   333,     0,   334, -1367,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351, -1367,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408, -1367,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,     0,     0,     0,     0,     0,     0,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1119,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,   234,   235,
     236,   237,     0,   238,     0,   239,   240,   241,   242,     0,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
       0,   251,   252,     0,     0,     0,     0,     0,     0,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,     0,   291,   292,
     293,     0,   294,     0,   295,     0,     0,     0,   296,   297,
     298,     0,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
       0,   327,   328,   329,   330,   331,   332,   333,     0,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,     0,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,     0,   442,   443,     0,   444,   445,   446,
     447,   448,   449,     0,   450,   451,     0,     0,   452,   453,
     454,   455,     0,   456,   457,   458,   459,   460,   461,     0,
       0,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,     0,   474,     0,   475,   476,
     477,     0,     0,   478,     0,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,     0,     0,     0,     0,     0,     0,
    1311,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2629,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,     0,
    1312,   711,  1313,  1314,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,  1315,  1316,   232,     0,   233,   234,
     235,   236,     0,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,  1317,  1318,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   998,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,     0,   286,   287,   288,     0,     0,   290,     0,   291,
    1319,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,     0,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,  1846,   310,   311,
     312,   313,   314,   315,     0,   316,   718,  1847,   318,   319,
     320,   321,  1320,  1321,     0,  1322,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
       0,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,  1323,   724,  1324,   353,   354,     0,     0,   356,
     357,   725,   358,     0,     0,   360,  1325,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,  1848,
     726,   727,   728,     0,   371,   372,   373,   374,   375,   376,
     377,     0,   378,     0,   380,     0,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1326,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,     0,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,  1849,   427,   428,   730,
     429,  1328,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,     0,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,  1329,  1330,     0,     0,   452,
       0,   454,     0,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,     0,  1331,  1850,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,     0,  1311,     0,     0,     0,     0,     0,     0,
       0,   493,   494,   495,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
       0,  1851,     0,   212,   213,     0,   214,   215,   710,   216,
     217,   218,     0,  1312,   711,  1313,  1314,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,  1315,  1316,   232,
       0,   233,   234,   235,   236,     0,     0,   238,     0,   239,
     240,   241,   242,   712,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   713,   251,   252,     0,     0,     0,
     714,     0,     0,     0,   253,   254,   255,   256,   257,   258,
    1317,  1318,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   998,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,     0,   286,   287,   288,     0,     0,
     290,     0,   291,  1319,   293,     0,   294,     0,   295,   715,
       0,   716,   296,   297,   298,     0,   299,     0,     0,   301,
       0,   302,   303,   304,   305,   306,   717,   307,   308,   309,
    1846,   310,   311,   312,   313,   314,   315,     0,   316,   718,
    1847,   318,   319,   320,   321,  1320,  1321,     0,  1322,     0,
     325,   719,   720,   326,   721,   327,   328,   329,   330,   331,
     332,   333,     0,     0,   722,   335,   723,     0,   336,   337,
     338,     0,     0,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1323,   724,  1324,   353,   354,
       0,     0,   356,   357,   725,   358,     0,     0,   360,  1325,
     362,   363,   364,     0,   365,     0,     0,   366,   367,   368,
       0,     0,  1848,   726,   727,   728,     0,   371,   372,   373,
     374,   375,   376,   377,     0,   378,     0,   380,     0,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1326,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   729,
     409,   410,     0,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,     0,   425,  1849,
     427,   428,   730,   429,  1328,     0,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,     0,     0,   442,   443,
       0,   444,   445,   446,   447,   448,   449,     0,  1329,  1330,
       0,     0,   452,     0,   454,     0,     0,   456,   457,   458,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
       0,     0,   467,   468,   469,   470,   471,     0,  1331,  1850,
     474,   731,   475,   476,   477,     0,     0,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   709,   975,   548,   976,
     977,   978,   595,   979,   493,   494,   495,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   980,  2680,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   981,   711,   982,   983,
    2225,   223,   224,   225,   226,   227,   984,   985,   228,   229,
     986,   987,   232,     0,   233,   234,   235,   236,   988,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
     989,   990,   991,   992,   993,   994,   995,   253,   254,   255,
     256,   257,   258,   996,   997,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   998,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   999,   286,   287,
     288,  1000,  1001,   290,     0,   291,  1002,   293,     0,   294,
       0,   295,   715,  2226,   716,   296,   297,   298,     0,   299,
    1003,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,  1004,  1005,
       0,  1006,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,  2227,  1007,   722,   335,   723,
       0,   336,   337,   338,  1008,  1009,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1010,   724,
    1011,   353,   354,   355,  1012,   356,   357,   725,   358,  1013,
    1014,   360,  1015,   362,   363,   364,     0,   365,     0,     0,
    1016,   367,   368,     0,     0,   369,   726,   727,   728,  1017,
     371,   372,   373,   374,   375,   376,   377,     0,   378,  1018,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1019,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,  1020,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
    1021,   425,   426,   427,   428,   730,   429,  1022,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,  1023,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,  1024,  1025,     0,  2228,   452,  1026,   454,  1027,  1028,
     456,   457,   458,   459,   460,   461,     0,  1029,   462,   463,
     464,   465,   466,  1030,     0,   467,   468,   469,   470,   471,
     472,  1031,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,
       0,     0,     0,     0,     0,     0,     0,  1040,  1041,     0,
       0,     0,     0,     0,     0,     0,  1043,   709,   975,   548,
     976,   977,   978,   595,   979,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   980,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   981,   711,   982,
     983,     0,   223,   224,   225,   226,   227,   984,   985,   228,
     229,   986,   987,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   996,   997,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   998,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   999,   286,
     287,   288,  1000,  1001,   290,     0,   291,  1002,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,  1004,
    1005,     0,  1006,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
     723,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1010,
     724,  1011,   353,   354,   355,  1012,   356,   357,   725,   358,
    1013,  1014,   360,  1015,   362,   363,   364,     0,   365,     0,
       0,  1016,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1019,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,  1020,   412,   413,   414,
     415,   416,   417,   418,   419,    37,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,   730,   429,  1022,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,    41,   444,   445,   446,   447,   448,
     449,     0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,
    1028,   456,   457,   458,   459,   460,   461,     0,  1029,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   915,  1031,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,    46,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,     0,  1040,  1041,
       0,     0,     0,     0,     0,     0,     0,  1043,   709,   975,
     548,   976,   977,   978,   595,   979,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   980,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,   219,   981,   711,
     982,   983,     0,   223,   224,   225,   226,   227,   984,   985,
     228,   229,   986,   987,   232,     0,   233,   234,   235,   236,
     988,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,   989,   990,   991,   992,   993,   994,   995,   253,
     254,   255,   256,   257,   258,   996,   997,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   998,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   999,
     286,   287,   288,  1000,  1001,   290,     0,   291,  1002,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,  1003,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,   317,   318,   319,   320,   321,
    1004,  1005,     0,  1006,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,  1007,   722,
     335,   723,     0,   336,   337,   338,  1008,  1009,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
    1010,   724,  1011,   353,   354,   355,  1012,   356,   357,   725,
     358,  1013,  1014,   360,  1015,   362,   363,   364,     0,   365,
       0,     0,  1016,   367,   368,     0,     0,   369,   726,   727,
     728,  1017,   371,   372,   373,   374,   375,   376,   377,     0,
     378,  1018,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1019,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,  1020,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,  1021,   425,   426,   427,   428,   730,   429,  1022,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,  1023,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,  1024,  1025,     0,     0,   452,  1026,   454,
    1027,  1028,   456,   457,   458,   459,   460,   461,     0,  1029,
     462,   463,   464,   465,   466,  1030,     0,   467,   468,   469,
     470,   471,   472,  1031,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,
     494,   495,     0,     0,     0,     0,     0,     0,     0,  1040,
    1041,     0,     0,     0,     0,     0,  1508,  2174,  1043,   709,
     975,   548,   976,   977,   978,   595,   979,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   980,     0,     0,   212,
     213,     0,   214,   215,   710,   216,   217,   218,   219,   981,
     711,   982,   983,     0,   223,   224,   225,   226,   227,   984,
     985,   228,   229,   986,   987,   232,     0,   233,   234,   235,
     236,   988,     0,   238,     0,   239,   240,   241,   242,   712,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     713,   251,   252,   989,   990,   991,   992,   993,   994,   995,
     253,   254,   255,   256,   257,   258,   996,   997,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   998,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     999,   286,   287,   288,  1000,  1001,   290,     0,   291,  1002,
     293,     0,   294,     0,   295,   715,     0,   716,   296,   297,
     298,     0,   299,  1003,     0,   301,     0,   302,   303,   304,
     305,   306,   717,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,   718,   317,   318,   319,   320,
     321,  1004,  1005,     0,  1006,     0,   325,   719,   720,   326,
     721,   327,   328,   329,   330,   331,   332,   333,     0,  1007,
     722,   335,   723,     0,   336,   337,   338,  1008,  1009,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1010,   724,  1011,   353,   354,   355,  1012,   356,   357,
     725,   358,  1013,  1014,   360,  1015,   362,   363,   364,     0,
     365,     0,     0,  1016,   367,   368,     0,     0,   369,   726,
     727,   728,  1017,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1018,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1019,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   729,   409,   410,  1020,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1021,   425,   426,   427,   428,   730,   429,
    1022,     0,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,  1023,     0,   442,   443,     0,   444,   445,   446,
     447,   448,   449,     0,  1024,  1025,     0,     0,   452,  1026,
     454,  1027,  1028,   456,   457,   458,   459,   460,   461,     0,
    1029,   462,   463,   464,   465,   466,  1030,     0,   467,   468,
     469,   470,   471,   472,  1031,     0,   474,   731,   475,   476,
     477,     0,     0,   478,     0,     0,   479,   480,   481,   482,
     483,   484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
     493,   494,   495,     0,     0,     0,     0,     0,     0,     0,
    1040,  1041,  1042,     0,     0,     0,     0,     0,     0,  1043,
     709,   975,   548,   976,   977,   978,   595,   979,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   980,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     981,   711,   982,   983,     0,   223,   224,   225,   226,   227,
     984,   985,   228,   229,   986,   987,   232,     0,   233,   234,
     235,   236,   988,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,   989,   990,   991,   992,   993,   994,
     995,   253,   254,   255,   256,   257,   258,   996,   997,   261,
    1111,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   998,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   999,   286,   287,   288,  1000,  1001,   290,     0,   291,
    1002,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,  1003,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,  1004,  1005,     0,  1006,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
    1007,   722,   335,   723,     0,   336,   337,   338,  1008,  1009,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,  1010,   724,  1011,   353,   354,   355,  1012,   356,
     357,   725,   358,  1013,  1014,   360,  1015,   362,   363,   364,
       0,   365,     0,     0,  1016,   367,   368,     0,     0,   369,
     726,   727,   728,  1017,   371,   372,   373,   374,   375,   376,
     377,     0,   378,  1018,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1019,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,  1020,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,  1021,   425,   426,   427,   428,   730,
     429,  1022,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,  1023,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,  1024,  1025,     0,     0,   452,
    1026,   454,  1027,  1028,   456,   457,   458,   459,   460,   461,
       0,  1029,   462,   463,   464,   465,   466,  1030,     0,   467,
     468,   469,   470,   471,   472,  1031,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,   493,   494,   495,     0,     0,     0,     0,     0,     0,
       0,  1040,  1041,     0,     0,     0,     0,     0,     0,     0,
    1043,   709,   975,   548,   976,   977,   978,   595,   979,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
    1750,   209,   210,   211,     0,     0,     0,     0,   980,     0,
       0,   212,   213,     0,   214,   215,   710,   216,   217,   218,
     219,   981,   711,   982,   983,     0,   223,   224,   225,   226,
     227,   984,   985,   228,   229,   986,   987,   232,     0,   233,
     234,   235,   236,   988,     0,   238,     0,   239,   240,   241,
     242,   712,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   713,   251,   252,   989,   990,   991,   992,   993,
     994,   995,   253,   254,   255,   256,   257,   258,   996,   997,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   998,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   999,   286,   287,   288,  1000,  1001,   290,     0,
     291,  1002,   293,     0,   294,     0,   295,   715,     0,   716,
     296,   297,   298,     0,   299,  1003,     0,   301,     0,   302,
     303,   304,   305,   306,   717,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   718,   317,   318,
     319,   320,   321,  1004,  1005,     0,  1006,     0,   325,   719,
     720,   326,   721,   327,   328,   329,   330,   331,   332,   333,
       0,  1007,   722,   335,   723,     0,   336,   337,   338,  1008,
    1009,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1010,   724,  1011,   353,   354,   355,  1012,
     356,   357,   725,   358,  1013,  1014,   360,  1015,   362,   363,
     364,     0,   365,     0,     0,  1016,   367,   368,     0,     0,
     369,   726,   727,   728,  1017,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1018,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1019,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   729,   409,   410,
    1020,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1021,   425,   426,   427,   428,
     730,   429,  1022,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,  1023,     0,   442,   443,     0,   444,
     445,   446,   447,   448,   449,     0,  1024,  1025,     0,     0,
     452,  1026,   454,  1027,  1028,   456,   457,   458,   459,   460,
     461,     0,  1029,   462,   463,   464,   465,   466,  1030,     0,
     467,   468,   469,   470,   471,   472,  1031,     0,   474,   731,
     475,   476,   477,     0,     0,   478,     0,     0,   479,   480,
     481,   482,   483,   484,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,   493,   494,   495,     0,     0,     0,     0,     0,
       0,     0,  1040,  1041,     0,     0,     0,     0,     0,     0,
       0,  1043,   709,   975,   548,   976,   977,   978,   595,   979,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,   980,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,   219,   981,   711,   982,   983,     0,   223,   224,   225,
     226,   227,   984,   985,   228,   229,   986,   987,   232,     0,
     233,   234,   235,   236,   988,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,   989,   990,   991,   992,
     993,   994,   995,   253,   254,   255,   256,   257,   258,   996,
     997,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   998,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   999,   286,   287,   288,  1000,  1001,   290,
       0,   291,  1002,   293,     0,   294,     0,   295,   715,  2226,
     716,   296,   297,   298,     0,   299,  1003,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,   317,
     318,   319,   320,   321,  1004,  1005,     0,  1006,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,  1007,   722,   335,   723,     0,   336,   337,   338,
    1008,  1009,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1010,   724,  1011,   353,   354,   355,
    1012,   356,   357,   725,   358,  1013,  1014,   360,  1015,   362,
     363,   364,     0,   365,     0,     0,  1016,   367,   368,     0,
       0,   369,   726,   727,   728,  1017,   371,   372,   373,   374,
     375,   376,   377,     0,   378,  1018,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1019,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,  1020,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,  1021,   425,   426,   427,
     428,   730,   429,  1022,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,  1023,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,  1024,  1025,     0,
       0,   452,  1026,   454,  1027,  1028,   456,   457,   458,   459,
     460,   461,     0,  1029,   462,   463,   464,   465,   466,  1030,
       0,   467,   468,   469,   470,   471,   472,  1031,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,   493,   494,   495,     0,     0,     0,     0,
       0,     0,     0,  1040,  1041,     0,     0,     0,     0,     0,
       0,     0,  1043,   709,   975,   548,   976,   977,   978,   595,
     979,     0,     0,     0,   200,   201,   202,   203,   204,   205,
     206,   207,     0,   209,   210,   211,     0,     0,     0,     0,
     980,     0,     0,   212,   213,     0,   214,   215,   710,   216,
     217,   218,   219,   981,   711,   982,   983,     0,   223,   224,
     225,   226,   227,   984,   985,   228,   229,   986,   987,   232,
       0,   233,   234,   235,   236,   988,     0,   238,     0,   239,
     240,   241,   242,   712,   243,   244,     0,   245,   246,   247,
     248,   249,   250,     0,   713,   251,   252,   989,   990,   991,
     992,   993,   994,   995,   253,   254,   255,   256,   257,   258,
     996,   997,   261,     0,   262,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,     0,   271,   272,   998,
     274,   275,     0,   276,   277,   278,     0,   279,   280,     0,
     281,   282,   283,   284,   999,   286,   287,   288,  1000,  1001,
     290,     0,   291,  1002,   293,     0,   294,     0,   295,   715,
       0,   716,   296,   297,   298,     0,   299,  1003,     0,   301,
       0,   302,   303,   304,   305,   306,   717,   307,   308,   309,
       0,   310,   311,   312,   313,   314,   315,     0,   316,   718,
     317,   318,   319,   320,   321,  1004,  1005,     0,  1006,     0,
     325,   719,   720,   326,   721,   327,   328,   329,   330,   331,
     332,   333,     0,  1007,   722,   335,   723,     0,   336,   337,
     338,  1008,  1009,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,  1010,   724,  1011,   353,   354,
     355,  1012,   356,   357,   725,   358,  1013,  1014,   360,  1015,
     362,   363,   364,     0,   365,     0,     0,  1016,   367,   368,
       0,     0,   369,   726,   727,   728,  1017,   371,   372,   373,
     374,   375,   376,   377,     0,   378,  1018,   380,   381,   382,
     383,   384,     0,   385,   386,   387,   388,   389,   390,   391,
    1019,   393,   394,   395,   396,     0,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     0,   407,   408,   729,
     409,   410,  1020,   412,   413,   414,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   424,  1021,   425,   426,
     427,   428,   730,   429,  1022,     0,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,  1023,     0,   442,   443,
       0,   444,   445,   446,   447,   448,   449,     0,  1024,  1025,
       0,     0,   452,  1026,   454,  1027,  1028,   456,   457,   458,
     459,   460,   461,     0,  1029,   462,   463,   464,   465,   466,
    1030,     0,   467,   468,   469,   470,   471,   472,  1031,  3348,
     474,   731,   475,   476,   477,     0,     0,   478,     0,     0,
     479,   480,   481,   482,   483,   484,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,   493,   494,   495,     0,     0,     0,
       0,     0,     0,     0,  1040,  1041,     0,     0,     0,     0,
       0,     0,     0,  1043,   709,   975,   548,   976,   977,   978,
     595,   979,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,   980,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,   219,   981,   711,   982,   983,     0,   223,
     224,   225,   226,   227,   984,   985,   228,   229,   986,   987,
     232,     0,   233,   234,   235,   236,   988,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,   989,   990,
     991,   992,   993,   994,   995,   253,   254,   255,   256,   257,
     258,   996,   997,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     998,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   999,   286,   287,   288,  1000,
    1001,   290,     0,   291,  1002,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,  1003,     0,
     301,     0,   302,   303,   304,   305,   306,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,   317,   318,   319,   320,   321,  1004,  1005,     0,  1006,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,  1007,   722,   335,   723,     0,   336,
     337,   338,  1008,  1009,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,  1010,   724,  1011,   353,
     354,   355,  1012,   356,   357,   725,   358,  1013,  1014,   360,
    1015,   362,   363,   364,     0,   365,     0,     0,  1016,   367,
     368,     0,     0,   369,   726,   727,   728,  1017,   371,   372,
     373,   374,   375,   376,   377,     0,   378,  1018,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1019,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,  1020,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,  1021,   425,
     426,   427,   428,   730,   429,  1022,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,  1023,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,  1024,
    1025,     0,     0,   452,  1026,   454,  1027,  1028,   456,   457,
     458,   459,   460,   461,     0,  1029,   462,   463,   464,   465,
     466,  1030,     0,   467,   468,   469,   470,   471,   472,  1031,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,   493,   494,   495,     0,     0,
       0,     0,     0,     0,     0,  1040,  1041,     0,     0,     0,
       0,     0,     0,     0,  1043,   709,   975,   548,   976,   977,
     978,   595,   979,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,   980,     0,     0,   212,   213,     0,   214,   215,
     710,   216,   217,   218,   219,   981,   711,   982,   983,     0,
     223,   224,   225,   226,   227,   984,   985,   228,   229,   986,
     987,   232,     0,   233,   234,   235,   236,   988,     0,   238,
       0,   239,   240,   241,   242,   712,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   713,   251,  3358,   989,
     990,   991,   992,   993,   994,   995,   253,   254,   255,   256,
     257,   258,   996,   997,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   998,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   999,   286,   287,   288,
    1000,  1001,   290,     0,   291,  1002,   293,     0,   294,     0,
     295,   715,     0,   716,   296,   297,   298,     0,   299,  1003,
       0,   301,     0,   302,   303,   304,   305,   306,   717,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   718,   317,   318,   319,   320,   321,  1004,  1005,     0,
    1006,     0,   325,   719,   720,   326,   721,   327,   328,   329,
     330,   331,   332,   333,     0,  1007,   722,   335,   723,     0,
     336,   337,   338,  1008,  1009,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1010,   724,  1011,
     353,   354,   355,  1012,   356,   357,   725,   358,  1013,  1014,
     360,  1015,   362,   363,   364,     0,   365,     0,     0,  1016,
     367,   368,     0,     0,   369,   726,   727,   728,  1017,   371,
     372,   373,   374,   375,   376,   377,     0,   378,  1018,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1019,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   729,   409,   410,  1020,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,  1021,
     425,   426,   427,   428,   730,   429,  1022,     0,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,  1023,     0,
     442,   443,     0,   444,   445,   446,   447,   448,   449,     0,
    1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,   456,
     457,   458,   459,   460,   461,     0,  1029,   462,   463,   464,
     465,   466,  1030,     0,   467,   468,   469,   470,   471,   472,
    1031,     0,   474,   731,   475,   476,   477,     0,     0,   478,
       0,     0,   479,   480,   481,   482,   483,   484,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,     0,
       0,     0,     0,     0,     0,     0,  1040,  1041,     0,     0,
       0,     0,     0,     0,     0,  1043,   709,   975,   548,   976,
     977,   978,   595,   979,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   980,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   981,   711,   982,   983,
       0,   223,   224,   225,   226,   227,   984,   985,   228,   229,
     986,   987,   232,     0,   233,   234,   235,   236,   988,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
     989,   990,   991,   992,   993,   994,   995,   253,   254,   255,
     256,   257,   258,   996,   997,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   998,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   999,   286,   287,
     288,  1000,  1001,   290,     0,   291,  1002,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
    1003,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,  1004,  1005,
       0,  1006,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,  1007,   722,   335,   723,
       0,   336,   337,   338,  1008,  1009,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1010,   724,
    1011,   353,   354,   355,  1012,   356,   357,   725,   358,  1013,
    1014,   360,  1015,   362,   363,   364,     0,   365,     0,     0,
    1016,   367,   368,     0,     0,   369,   726,   727,   728,  1017,
     371,   372,   373,   374,   375,   376,   377,     0,   378,  1018,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1019,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,  1020,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
    1021,   425,   426,   427,   428,   730,   429,  1022,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,  1023,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,
     456,   457,   458,   459,   460,   461,     0,  1029,   462,   463,
     464,   465,   466,  1030,     0,   467,   468,   469,   470,   471,
     472,  1031,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,  3612,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,
       0,     0,     0,     0,     0,     0,     0,  1040,  1041,     0,
       0,     0,     0,     0,     0,     0,  1043,   709,   975,   548,
     976,   977,   978,   595,   979,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   980,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   981,   711,   982,
     983,     0,   223,   224,   225,   226,   227,   984,   985,   228,
     229,   986,   987,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   996,   997,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   998,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   999,   286,
     287,   288,  1000,  1001,   290,     0,   291,  1002,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,  1004,
    1005,     0,  1006,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
     723,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1010,
     724,  1011,   353,  3621,   355,  1012,   356,   357,   725,   358,
    1013,  1014,   360,  1015,   362,   363,   364,     0,   365,     0,
       0,  1016,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1019,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,  1020,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,   730,   429,  1022,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,
    1028,   456,   457,   458,   459,   460,   461,     0,  1029,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   472,  1031,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,     0,  1040,  1041,
       0,     0,     0,     0,     0,     0,     0,  1043,   709,   975,
     548,   976,   977,   978,   595,   979,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,   980,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,  4094,   981,   711,
     982,   983,     0,   223,   224,   225,   226,   227,   984,   985,
     228,   229,   986,   987,   232,     0,   233,   234,   235,   236,
     988,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,  4095,   989,   990,   991,   992,   993,   994,   995,   253,
     254,   255,   256,   257,   258,   996,   997,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   998,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   999,
     286,   287,   288,  1000,  1001,   290,     0,   291,  1002,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,  1003,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,   317,   318,   319,   320,   321,
    1004,  1005,     0,  1006,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,  1007,   722,
     335,   723,     0,   336,   337,   338,  1008,  1009,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
    1010,   724,  1011,   353,   354,   355,  1012,   356,   357,   725,
     358,  1013,  1014,   360,  1015,   362,   363,   364,     0,   365,
       0,     0,  1016,   367,   368,     0,     0,   369,   726,   727,
     728,  1017,   371,   372,   373,   374,   375,   376,   377,     0,
     378,  1018,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1019,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,  1020,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,  1021,   425,   426,   427,   428,   730,   429,  1022,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,  1023,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,  1024,  1025,     0,     0,   452,  1026,   454,
    1027,  1028,   456,   457,   458,  4096,   460,   461,     0,  1029,
     462,   463,   464,   465,   466,  1030,     0,   467,   468,   469,
     470,   471,   472,  1031,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,
     494,   495,     0,     0,     0,     0,     0,     0,     0,  1040,
    1041,     0,     0,     0,     0,     0,     0,     0,  1043,   709,
     975,   548,   976,   977,   978,   595,   979,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,   980,     0,     0,   212,
     213,     0,   214,   215,   710,   216,   217,   218,   219,   981,
     711,   982,   983,     0,   223,   224,   225,   226,   227,   984,
     985,   228,   229,   986,   987,   232,     0,   233,   234,   235,
     236,   988,     0,   238,     0,   239,   240,   241,   242,   712,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
     713,   251,  4095,   989,   990,   991,   992,   993,   994,   995,
     253,   254,   255,   256,   257,   258,   996,   997,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   998,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     999,   286,   287,   288,  1000,  1001,   290,     0,   291,  1002,
     293,     0,   294,     0,   295,   715,     0,   716,   296,   297,
     298,     0,   299,  1003,     0,   301,     0,   302,   303,   304,
     305,   306,   717,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,   718,   317,   318,   319,   320,
     321,  1004,  1005,     0,  1006,     0,   325,   719,   720,   326,
     721,   327,   328,   329,   330,   331,   332,   333,     0,  1007,
     722,   335,   723,     0,   336,   337,   338,  1008,  1009,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,  1010,   724,  1011,   353,   354,   355,  1012,   356,   357,
     725,   358,  1013,  1014,   360,  1015,   362,   363,   364,     0,
     365,     0,     0,  1016,   367,   368,     0,     0,   369,   726,
     727,   728,  1017,   371,   372,   373,   374,   375,   376,   377,
       0,   378,  1018,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,  1019,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,   729,   409,   410,  1020,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,  1021,   425,   426,   427,   428,   730,   429,
    1022,     0,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,  1023,     0,   442,   443,     0,   444,   445,   446,
     447,   448,   449,     0,  1024,  1025,     0,     0,   452,  1026,
     454,  1027,  1028,   456,   457,   458,  4096,   460,   461,     0,
    1029,   462,   463,   464,   465,   466,  1030,     0,   467,   468,
     469,   470,   471,   472,  1031,     0,   474,   731,   475,   476,
     477,     0,     0,   478,     0,     0,   479,   480,   481,   482,
     483,   484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
     493,   494,   495,     0,     0,     0,     0,     0,     0,     0,
    1040,  1041,     0,     0,     0,     0,     0,     0,     0,  1043,
     709,   975,   548,   976,   977,   978,   595,   979,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,   980,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     981,   711,   982,   983,     0,   223,   224,   225,   226,   227,
     984,   985,   228,   229,   986,   987,   232,     0,   233,   234,
     235,   236,   988,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,   989,   990,   991,   992,   993,   994,
     995,   253,   254,   255,   256,   257,   258,   996,   997,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   998,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   999,   286,   287,   288,  1000,  1001,   290,     0,   291,
    1002,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,  1003,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,  1004,  1005,     0,  1006,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
    1007,   722,   335,   723,     0,   336,   337,   338,  1008,  1009,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,  1010,   724,  1011,   353,   354,   355,     0,   356,
     357,   725,   358,  1013,  1014,   360,  1015,   362,   363,   364,
       0,   365,     0,     0,  1016,   367,   368,     0,     0,   369,
     726,   727,   728,  1017,   371,   372,   373,   374,   375,   376,
     377,     0,   378,  1018,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,  1019,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,  1020,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,  1021,   425,   426,   427,   428,   730,
     429,  1022,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,  1023,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,  1024,  1025,     0,     0,   452,
    1026,   454,  1027,  1028,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,  1030,     0,   467,
     468,   469,   470,   471,   472,  1031,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,   493,   494,   495,     0,     0,     0,     0,     0,     0,
       0,  2208,  2209,     0,     0,     0,     0,     0,     0,     0,
    1043,   709,   975,   548,   976,   977,   978,   595,   979,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,   980,     0,
       0,   212,   213,     0,   214,   215,   710,   216,   217,   218,
   -2126,   981,   711,   982,   983,     0,   223,   224,   225,   226,
     227,   984,   985,   228,   229,   986,   987,   232,     0,   233,
     234,   235,   236,   988,     0,   238,     0,   239,   240,   241,
     242,   712,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   713,   251,  4095,   989,   990,   991,   992,   993,
     994,   995,   253,   254,   255,   256,   257,   258,   996,   997,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   998,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   999,   286,   287,   288,  1000,  1001,   290,     0,
     291,  1002,   293,     0,   294,     0,   295,   715,     0,   716,
     296,   297,   298,     0,   299,  1003,     0,   301,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   718,   317,   318,
     319,   320,   321,  1004,  1005,     0,  1006,     0,   325,   719,
     720,   326,   721,   327,   328,   329,   330,   331,   332,   333,
       0,  1007,   722,   335,     0,     0,   336,   337,   338,  1008,
    1009,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1010,   724,  1011,   353,   354,   355,     0,
     356,   357,   725,   358,  1013,  1014,   360,  1015,   362,   363,
     364,     0,   365,     0,     0,  1016,   367,   368,     0,     0,
     369,   726,   727,   728,  1017,   371,   372,   373,   374,   375,
     376,   377,     0,   378,  1018,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1019,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   729,   409,   410,
    1020,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,  1021,   425,   426,   427,   428,
       0,   429,  1022,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,  1023,     0,   442,   443,     0,   444,
     445,   446,   447,   448,   449,     0,  1024,  1025,     0,     0,
     452,  1026,   454,  1027,  1028,   456,   457,   458,  4096,   460,
     461,     0,  1029,   462,   463,   464,   465,   466,  1030,     0,
     467,   468,   469,   470,   471,   472,  1031,     0,   474,   731,
     475,   476,   477,     0,     0,   478,     0,     0,   479,   480,
     481,   482,   483,   484,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,   493,   494,   495,     0,     0,     0,     0,     0,
       0,     0,  1040,  1041,     0,     0,   709,   975,   548,   976,
     977,  1043,   595,   979,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   980,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   981,   711,   982,   983,
       0,   223,   224,   225,   226,   227,   984,   985,   228,   229,
     986,   987,   232,     0,   233,   234,   235,   236,   988,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
     989,   990,   991,   992,   993,   994,   995,   253,   254,   255,
     256,   257,   258,   996,   997,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   998,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   999,   286,   287,
     288,  1000,  1001,   290,     0,   291,  1002,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
    1003,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,  1004,  1005,
       0,  1006,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,  1007,   722,   335,   723,
       0,   336,   337,   338,  1008,  1009,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1010,   724,
    1011,   353,   354,   355,     0,   356,   357,   725,   358,  1013,
    1014,   360,  1015,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,  1017,
     371,   372,   373,   374,   375,   376,   377,     0,   378,  1018,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1019,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,  1020,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
    1021,   425,   426,   427,   428,   730,   429,  1022,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,  1023,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,  1030,     0,   467,   468,   469,   470,   471,
     472,  1031,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,
       0,     0,     0,     0,     0,     0,   709,   975,   548,   976,
     977,     0,   595,   979,     0,     0,  1043,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   980,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   981,   711,   982,   983,
       0,  3271,   224,   225,   226,   227,   984,   985,   228,   229,
     986,   987,   232,     0,   233,   234,   235,   236,   988,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
     989,   990,   991,   992,   993,   994,   995,   253,   254,   255,
     256,   257,   258,   996,   997,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   998,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   999,   286,   287,
     288,  1000,  1001,   290,     0,   291,  1002,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
    1003,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,  1004,  1005,
       0,  1006,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,  1007,   722,   335,   723,
       0,   336,   337,   338,  1008,  1009,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1010,   724,
    1011,   353,   354,   355,     0,   356,   357,   725,   358,  1013,
    1014,   360,  1015,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,  1017,
     371,   372,   373,   374,   375,   376,   377,     0,   378,  1018,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1019,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,  1020,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
    1021,   425,   426,   427,   428,   730,   429,  1022,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,  1023,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,  1030,     0,   467,   468,   469,   470,   471,
     472,  1031,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,
       0,     0,     0,     0,     0,     0,   709,   975,   548,   976,
     977,   978,   595,   979,     0,     0,  1043,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,   980,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,     0,   981,   711,   982,   983,
       0,   223,   224,   225,   226,   227,   984,   985,   228,   229,
     986,   987,   232,     0,   233,   234,   235,   236,   988,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
     989,   990,   991,   992,   993,   994,   995,   253,   254,   255,
     256,   257,   258,   996,   997,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   998,   274,   275,     0,   276,   277,   278,     0,
     279,     0,     0,   281,   282,   283,   284,   999,   286,   287,
     288,  1000,  1001,   290,     0,   291,  1002,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
    1003,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,  1004,  1005,
       0,  1006,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,  1007,   722,   335,     0,
       0,   336,   337,   338,  1008,  1009,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,  1010,   724,
    1011,   353,   354,   355,     0,   356,   357,   725,   358,  1013,
    1014,   360,  1015,   362,   363,   364,     0,   365,     0,     0,
    1016,   367,   368,     0,     0,   369,   726,   727,   728,  1017,
     371,   372,   373,   374,   375,   376,   377,     0,   378,  1018,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,  1019,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,  1020,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
    1021,   425,   426,   427,   428,     0,   429,  1022,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,  1023,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,  1028,
     456,   457,   458,   459,   460,   461,     0,  1029,   462,   463,
     464,   465,   466,  1030,     0,   467,   468,   469,   470,   471,
     472,  1031,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,   495,
       0,     0,     0,     0,     0,     0,     0,  1040,  1041,     0,
       0,     0,     0,     0,     0,     0,  1043,   709,   975,   548,
     976,   977,   978,   595,   979,     0,     0,     0,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,   980,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,     0,   981,   711,   982,
     983,     0,   223,   224,   225,   226,   227,   984,   985,   228,
     229,   986,   987,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   996,   997,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   998,   274,   275,     0,   276,   277,   278,
       0,   279,     0,     0,   281,   282,   283,   284,   999,   286,
     287,   288,  1000,  1001,   290,     0,   291,  1002,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,  1004,
    1005,     0,  1006,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
       0,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1010,
     724,  1011,   353,   354,   355,     0,   356,   357,   725,   358,
    1013,  1014,   360,  1015,   362,   363,   364,     0,   365,     0,
       0,  1016,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,  1019,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,  1020,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,     0,   429,  1022,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,  1024,  1025,     0,     0,   452,  1026,   454,  1027,
    1028,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   472,  1031,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   709,  2208,  2209,
       0,     0,     0,     0,     0,     0,     0,  1043,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,   985,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,  1000,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
     723,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,  1014,   360,   361,   362,   363,   364,     0,   365,     0,
     674,   366,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    37,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,    41,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,  1026,   454,  1027,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   915,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,    46,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2862,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,   985,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,  1000,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
     723,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,  1014,   360,   361,   362,   363,   364,     0,   365,     0,
     674,   366,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,  1026,   454,  1027,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2862,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,   985,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   988,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,   989,   990,   991,   992,   993,   994,   995,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,  1000,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,  1003,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,  1007,   722,   335,
     723,     0,   336,   337,   338,  1008,  1009,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,  1014,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,   726,   727,   728,
    1017,   371,   372,   373,   374,   375,   376,   377,     0,   378,
    1018,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,  1021,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
    1023,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,  1026,   454,  1027,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,  1030,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   751,  1216,   548,
       0,     0,     0,   595,     0,     0,     0,  3378,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,     0,     0,     0,   714,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,  1443,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   722,   335,
     723,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,  1444,
       0,   366,   367,   368,     0,     0,   369,   726,   727,   728,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
    1445,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   751,   607,  1217,
    3483,     0,     0,     0,     0,     0,     0,  3484,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       3,     4,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,     0,     0,     0,   714,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   722,   335,
     723,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,   726,   727,   728,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    37,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,    41,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   915,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,    46,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   709,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    47,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,   219,   220,   711,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,     0,     0,     0,   714,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,   334,   722,   335,
     723,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     724,   352,   353,   354,   355,     0,   356,   357,   725,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,   726,   727,   728,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,   730,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3880,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    37,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,    41,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   915,   473,     0,   474,     0,   475,   476,   477,     0,
       0,   478,     0,    46,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    47,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,     0,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1095,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,     0,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2359,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,     0,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3342,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,     0,   216,   217,   218,   219,   220,     0,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,   232,     0,   233,   234,   235,   236,   237,
       0,   238,     0,   239,   240,   241,   242,     0,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,     0,   251,
     252,     0,     0,     0,     0,     0,     0,     0,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,     0,   291,   292,   293,     0,
     294,     0,   295,     0,     0,     0,   296,   297,   298,     0,
     299,   300,     0,   301,     0,   302,   303,   304,   305,   306,
       0,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,     0,   317,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,     0,   327,
     328,   329,   330,   331,   332,   333,     0,   334,     0,   335,
       0,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
       0,   352,   353,   354,   355,     0,   356,   357,     0,   358,
       0,   359,   360,   361,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,   369,     0,     0,     0,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,     0,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,   426,   427,   428,     0,   429,   430,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,   450,   451,     0,     0,   452,   453,   454,   455,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,     0,   474,     0,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,     0,     0,     0,     0,     0,     0,  1311,  1216,   548,
       0,     0,   759,   595,     0,     0,     0,  3656,   200,   201,
     202,   203,   204,   205,   206,   207,  1641,   209,   210,   211,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,   212,   213,  1649,
     214,   215,   710,   216,   217,   218,     0,  1312,   711,  1313,
    1314,  1650,   223,   224,   225,   226,   227,  1651,  1652,   228,
     229,  1315,  1316,   232,  1653,   233,   234,   235,   236,     0,
    1654,   238,  1655,   239,   240,   241,   242,   712,   243,   244,
    1656,   245,   246,   247,   248,   249,   250,  1657,   713,   251,
     252,  1658,  1659,  1660,   714,  1661,  1662,  1663,   253,   254,
     255,   256,   257,   258,  1317,  1318,   261,  1664,   262,  1665,
     263,   264,   265,   266,   267,  1666,   268,   269,   270,  1667,
    1668,   271,   272,   998,   274,   275,  1669,   276,   277,   278,
    1670,   279,   280,  1671,   281,   282,   283,   284,     0,   286,
     287,   288,     0,  1672,   290,  1673,   291,  1319,   293,  1674,
     294,  1675,   295,   715,  1676,   716,   296,   297,   298,  1677,
     299,     0,  1678,   301,  1679,   302,   303,   304,   305,   306,
     717,   307,   308,   309,  1680,   310,   311,   312,   313,   314,
     315,  1681,   316,   718,     0,   318,   319,   320,   321,  1320,
    1321,  1682,  1322,  1683,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,  1684,     0,   722,   335,
     723,  1685,   336,   337,   338,  1686,  1687,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,  1323,
     724,  1324,   353,   354,     0,  1688,   356,   357,   725,   358,
    1689,     0,   360,  1325,   362,   363,   364,  1690,   365,  1691,
    1692,  3075,   367,   368,  1693,  1694,     0,   726,   727,   728,
       0,   371,   372,   373,   374,   375,   376,   377,  1695,   378,
       0,   380,     0,   382,   383,   384,  1696,   385,   386,   387,
     388,   389,   390,   391,  1326,   393,   394,   395,   396,  1697,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
    1698,   407,   408,   729,   409,   410,     0,   412,   413,   414,
     415,   416,   417,   418,   419,  1699,   420,   421,   422,   423,
     424,  1700,   425,  1849,   427,   428,   730,   429,  1328,  1701,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
       0,  1702,   442,   443,  1703,   444,   445,   446,   447,   448,
     449,  1704,  1329,  1330,  1705,  1706,   452,     0,   454,     0,
    1707,   456,   457,   458,   459,   460,   461,  1708,  1709,   462,
     463,   464,   465,   466,  1710,  1711,   467,   468,   469,   470,
     471,     0,  1331,  1712,   474,   731,   475,   476,   477,  1713,
    1714,   478,  1715,  1716,   479,   480,   481,   482,   483,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   493,   494,
     495,     0,     0,     0,   762,   763,   764,     0,  3076,  3077,
     767,   768,   769,   770,   199,     0,     0,     0,     0,   759,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   760,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   761,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,     0,     0,
       0,   762,   763,   764,     0,   765,   766,   767,   768,   769,
     770,   199,     0,     0,     0,     0,   759,     0,     0,     0,
       0,     0,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,     0,   216,   217,   218,
     219,   220,     0,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,   232,     0,   233,
     844,   235,   236,   237,     0,   238,     0,   239,   240,   241,
     242,     0,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,     0,   251,   252,     0,     0,     0,     0,     0,
       0,     0,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   845,     0,
     291,   292,   293,     0,   294,     0,   295,     0,     0,     0,
     296,   297,   298,     0,   299,   300,     0,   301,     0,   302,
     303,   304,   305,   306,     0,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,     0,   317,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,     0,   327,   328,   329,   330,   331,   332,   333,
       0,   334,     0,   335,     0,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,     0,   352,   353,   354,   355,     0,
     356,   357,     0,   358,     0,   359,   360,   361,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
     369,     0,     0,     0,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,   426,   427,   428,
       0,   429,   430,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,     0,   442,   443,     0,   444,
     445,   446,   447,   448,   449,     0,   450,   451,     0,     0,
     452,   453,   454,   455,     0,   456,   457,   458,   459,   460,
     461,     0,     0,   462,   463,   464,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,   473,     0,   474,     0,
     475,   476,   477,     0,     0,   478,     0,     0,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,     0,     0,     0,   762,   763,
     764,     0,   765,   766,   767,   768,   769,   770,   199,     0,
       0,     0,     0,   759,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   888,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   889,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     890,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,     0,     0,     0,   762,   763,   764,     0,   765,
     766,   767,   768,   769,   770,   199,     0,     0,     0,     0,
     759,     0,     0,     0,     0,     0,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
       0,   216,   217,   218,   219,   220,     0,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   232,     0,   233,  1294,   235,   236,   237,     0,   238,
       0,   239,   240,   241,   242,     0,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,     0,   251,   252,     0,
       0,     0,     0,     0,     0,     0,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,  1295,     0,   291,   292,   293,     0,   294,     0,
     295,     0,     0,     0,   296,   297,   298,     0,   299,   300,
       0,   301,     0,   302,   303,   304,   305,   306,     0,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,     0,   317,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,     0,   327,   328,   329,
     330,   331,   332,   333,     0,   334,     0,   335,     0,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,   352,
     353,   354,   355,     0,   356,   357,     0,   358,     0,   359,
     360,   361,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,   369,     0,     0,     0,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,     0,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,   426,   427,   428,     0,   429,   430,     0,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,     0,
     442,   443,     0,   444,   445,   446,   447,   448,   449,     0,
     450,   451,     0,     0,   452,   453,   454,   455,     0,   456,
     457,   458,   459,   460,   461,     0,     0,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,     0,   474,     0,   475,   476,   477,     0,     0,   478,
       0,     0,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,     0,
       0,     0,   762,   763,   764,     0,   765,   766,   767,   768,
     769,   770,   199,     0,     0,     0,     0,   759,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,     0,     0,     0,   762,
     763,   764,     0,   765,   766,   767,   768,   769,   770,   199,
       0,     0,     0,     0,   759,     0,     0,     0,     0,     0,
     200,   201,   202,   203,   204,   205,   206,   207,     0,   209,
     210,   211,     0,     0,     0,     0,     0,     0,     0,   212,
     213,     0,   214,   215,     0,   216,   217,   218,   219,   220,
       0,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   232,     0,   233,  2415,   235,
     236,   237,     0,   238,     0,   239,   240,   241,   242,     0,
     243,   244,     0,   245,   246,   247,   248,   249,   250,     0,
       0,   251,   252,     0,     0,     0,     0,     0,     0,     0,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,     0,   279,   280,     0,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,  2416,     0,   291,   292,
     293,     0,   294,     0,   295,     0,     0,     0,   296,   297,
     298,     0,   299,   300,     0,   301,     0,   302,   303,   304,
     305,   306,     0,   307,   308,   309,     0,   310,   311,   312,
     313,   314,   315,     0,   316,     0,   317,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
       0,   327,   328,   329,   330,   331,   332,   333,     0,   334,
       0,   335,     0,     0,   336,   337,   338,     0,     0,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,     0,   352,   353,   354,   355,     0,   356,   357,
       0,   358,     0,   359,   360,   361,   362,   363,   364,     0,
     365,     0,     0,   366,   367,   368,     0,     0,   369,     0,
       0,     0,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,     0,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,     0,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     0,   407,   408,     0,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,   424,     0,   425,   426,   427,   428,     0,   429,
     430,     0,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,     0,   442,   443,     0,   444,   445,   446,
     447,   448,   449,     0,   450,   451,     0,     0,   452,   453,
     454,   455,     0,   456,   457,   458,   459,   460,   461,     0,
       0,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,     0,   474,     0,   475,   476,
     477,     0,     0,   478,     0,     0,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,     0,     0,     0,   762,   763,   764,     0,
     765,   766,   767,   768,   769,   770,   199,     0,     0,     0,
       0,   759,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
    3867,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
       0,     0,  1640,   762,   763,   764,     0,   765,   766,   767,
     768,   769,   770,   200,   201,   202,   203,   204,   205,   206,
     207,  1641,   209,   210,   211,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,   212,   213,  1649,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,  1650,   223,   224,   225,
     226,   227,  1651,  1652,   228,   229,   230,   231,   232,  1653,
     233,   234,   235,   236,   237,  1654,   238,  1655,   239,   240,
     241,   242,   712,   243,   244,  1656,   245,   246,   247,   248,
     249,   250,  1657,   713,   251,   252,  1658,  1659,  1660,   714,
    1661,  1662,  1663,   253,   254,   255,   256,   257,   258,   259,
     260,   261,  1664,   262,  1665,   263,   264,   265,   266,   267,
    1666,   268,   269,   270,  1667,  1668,   271,   272,   273,   274,
     275,  1669,   276,   277,   278,  1670,   279,   280,  1671,   281,
     282,   283,   284,   285,   286,   287,   288,   289,  1672,   290,
    1673,   291,   292,   293,  1674,   294,  1675,   295,   715,  1676,
     716,   296,   297,   298,  1677,   299,   300,  1678,   301,  1679,
     302,   303,   304,   305,   306,   717,   307,   308,   309,  1680,
     310,   311,   312,   313,   314,   315,  1681,   316,   718,   317,
     318,   319,   320,   321,   322,   323,  1682,   324,  1683,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,  1684,   334,   722,   335,   723,  1685,   336,   337,   338,
    1686,  1687,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
    1688,   356,   357,   725,   358,  1689,   359,   360,   361,   362,
     363,   364,  1690,   365,  1691,  1692,   366,   367,   368,  1693,
    1694,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,  1695,   378,   379,   380,   381,   382,   383,
     384,  1696,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,  1697,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,  1698,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
    1699,   420,   421,   422,   423,   424,  1700,   425,   426,   427,
     428,   730,   429,   430,  1701,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1702,   442,   443,  1703,
     444,   445,   446,   447,   448,   449,  1704,   450,   451,  1705,
    1706,   452,   453,   454,   455,  1707,   456,   457,   458,   459,
     460,   461,  1708,  1709,   462,   463,   464,   465,   466,  1710,
    1711,   467,   468,   469,   470,   471,   472,   473,  1712,   474,
     731,   475,   476,   477,  1713,  1714,   478,  1715,  1716,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,  1717,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,   679,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,  1311,     0,     0,     0,     0,     0,
       0,     0,     0,  3744,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,     0,  1312,   711,  1313,  1314,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,  1315,  1316,
     232,     0,   233,   234,   235,   236,     0,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,     0,     0,
       0,   714,     0,     0,     0,   253,   254,   255,   256,   257,
     258,  1317,  1318,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     998,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,     0,   286,   287,   288,     0,
       0,   290,     0,   291,  1319,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,     0,     0,
     301,     0,   302,   303,   304,   305,   306,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,     0,   318,   319,   320,   321,  1320,  1321,     0,  1322,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,     0,   722,   335,   723,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,  1323,   724,  1324,   353,
     354,     0,     0,   356,   357,   725,   358,     0,     0,   360,
    1325,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,     0,   726,   727,   728,     0,   371,   372,
     373,   374,   375,   376,   377,     0,   378,     0,   380,     0,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1326,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,     0,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
    1327,   427,   428,   730,   429,  1328,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,     0,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,  1329,
    1330,     0,     0,   452,     0,   454,     0,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,     0,  1331,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,     0,     0,  1986,     0,
       0,     0,     0,     0,     0,   493,   494,   495,     0,   200,
     201,   202,   203,   204,   205,   206,   207,  1772,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,     0,  1312,   711,
    1313,  1314,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,  1315,  1316,   232,     0,   233,   234,   235,   236,
       0,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,     0,     0,     0,   714,     0,     0,     0,   253,
     254,   255,   256,   257,   258,  1317,  1318,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   998,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,     0,
     286,   287,   288,     0,     0,   290,     0,   291,  1319,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,     0,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,     0,   318,   319,   320,   321,
    1320,  1321,     0,  1322,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,     0,   722,
     335,   723,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
    1323,   724,  1324,   353,   354,     0,     0,   356,   357,   725,
     358,     0,     0,   360,  1325,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,     0,   726,   727,
     728,     0,   371,   372,   373,   374,   375,   376,   377,     0,
     378,     0,   380,     0,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1326,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,     0,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,  1327,   427,   428,   730,   429,  1328,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,     0,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,  1329,  1330,     0,     0,   452,     0,   454,
       0,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,     0,  1331,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
       0,     0,   751,  1216,   548,     0,     0,     0,   595,   493,
     494,   495,     0,   200,   201,   202,   203,   204,   205,   206,
     207,  1772,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,  1630,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,  1443,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
       0,   356,   357,   725,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,  1444,     0,   366,   367,   368,     0,
       0,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   730,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,  1445,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   751,  1216,   548,     0,
       0,     0,   595,   607,  1217,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   220,   711,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
       0,     0,     0,   714,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  1635,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,  1443,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   722,   335,   723,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   724,
     352,   353,   354,   355,     0,   356,   357,   725,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,  1444,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   730,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,  1445,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     751,  1216,   548,     0,     0,     0,   595,   607,  1217,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     220,   711,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,  1443,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   724,   352,   353,   354,   355,     0,   356,
     357,   725,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,  1444,     0,   366,   367,   368,     0,     0,   369,
     726,   727,   728,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   730,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,  1445,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
     595,   607,  1217,     0,     0,   200,   596,   202,   203,   204,
     205,   206,   207,   597,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     598,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   599,   292,   293,     0,   294,     0,   600,
       0,   601,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,   602,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     603,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   604,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   605,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   606,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,  1640,  4150,
     548,     0,     0,     0,   595,   607,   608,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,  1641,   209,   210,
     211,  1642,  1643,  1644,  1645,  1646,  1647,  1648,   212,   213,
    1649,   214,   215,   710,   216,   217,   218,   219,   220,   711,
     221,   222,  1650,   223,   224,   225,   226,   227,  1651,  1652,
     228,   229,   230,   231,   232,  1653,   233,   234,   235,   236,
     237,  1654,   238,  1655,   239,   240,   241,   242,   712,   243,
     244,  1656,   245,   246,   247,   248,   249,   250,  1657,   713,
     251,   252,  1658,  1659,  1660,   714,  1661,  1662,  1663,   253,
     254,   255,   256,   257,   258,   259,   260,   261,  1664,   262,
    1665,   263,   264,   265,   266,   267,  1666,   268,   269,   270,
    1667,  1668,   271,   272,   273,   274,   275,  1669,   276,   277,
     278,  1670,   279,   280,  1671,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1672,   290,  1673,   291,   292,   293,
    1674,   294,  1675,   295,   715,  1676,   716,   296,   297,   298,
    1677,   299,   300,  1678,   301,  1679,   302,   303,   304,   305,
     306,   717,   307,   308,   309,  1680,   310,   311,   312,   313,
     314,   315,  1681,   316,   718,   317,   318,   319,   320,   321,
     322,   323,  1682,   324,  1683,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,  1684,   334,   722,
     335,   723,  1685,   336,   337,   338,  1686,  1687,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   724,   352,   353,   354,   355,  1688,   356,   357,   725,
     358,  1689,   359,   360,   361,   362,   363,   364,  1690,   365,
    1691,  1692,   366,   367,   368,  1693,  1694,   369,   726,   727,
     728,   370,   371,   372,   373,   374,   375,   376,   377,  1695,
     378,   379,   380,   381,   382,   383,   384,  1696,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
    1697,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,  1698,   407,   408,   729,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,  1699,   420,   421,   422,
     423,   424,  1700,   425,   426,   427,   428,   730,   429,   430,
    1701,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,  1702,   442,   443,  1703,   444,   445,   446,   447,
     448,   449,  1704,   450,   451,  1705,  1706,   452,   453,   454,
     455,  1707,   456,   457,   458,   459,   460,   461,  1708,  1709,
     462,   463,   464,   465,   466,  1710,  1711,   467,   468,   469,
     470,   471,   472,   473,  1712,   474,   731,   475,   476,   477,
    1713,  1714,   478,  1715,  1716,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,  1640,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,  1641,   209,   210,   211,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,   212,   213,  1649,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,  1650,   223,   224,   225,
     226,   227,  1651,  1652,   228,   229,   230,   231,   232,  1653,
     233,   234,   235,   236,   237,  1654,   238,  1655,   239,   240,
     241,   242,   712,   243,   244,  1656,   245,   246,   247,   248,
     249,   250,  1657,   713,   251,   252,  1658,  1659,  1660,   714,
    1661,  1662,  1663,   253,   254,   255,   256,   257,   258,   259,
     260,   261,  1664,   262,  1665,   263,   264,   265,   266,   267,
    1666,   268,   269,   270,  1667,  1668,   271,   272,   273,   274,
     275,  1669,   276,   277,   278,  1670,   279,   280,  1671,   281,
     282,   283,   284,   285,   286,   287,   288,   289,  1672,   290,
    1673,   291,   292,   293,  1674,   294,  1675,   295,   715,  1676,
     716,   296,   297,   298,  1677,   299,   300,  1678,   301,  1679,
     302,   303,   304,   305,   306,   717,   307,   308,   309,  1680,
     310,   311,   312,   313,   314,   315,  1681,   316,   718,   317,
     318,   319,   320,   321,   322,   323,  1682,   324,  1683,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,  1684,   334,   722,   335,   723,  1685,   336,   337,   338,
    1686,  1687,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
    1688,   356,   357,   725,   358,  1689,   359,   360,   361,   362,
     363,   364,  1690,   365,  1691,  1692,   366,   367,   368,  1693,
    1694,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,  1695,   378,   379,   380,   381,   382,   383,
     384,  1696,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,  1697,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,  1698,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
    1699,   420,   421,   422,   423,   424,  1700,   425,   426,   427,
     428,   730,   429,   430,  1701,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,  1702,   442,   443,  1703,
     444,   445,   446,   447,   448,   449,  1704,   450,   451,  1705,
    1706,   452,   453,   454,   455,  1707,   456,   457,   458,   459,
     460,   461,  1708,  1709,   462,   463,   464,   465,   466,  1710,
    1711,   467,   468,   469,   470,   471,   472,   473,  1712,   474,
     731,   475,   476,   477,  1713,  1714,   478,  1715,  1716,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,  1640,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,  2476,   205,   206,   207,  1641,   209,   210,   211,  1642,
    1643,  1644,  1645,  1646,  1647,  1648,   212,   213,  1649,   214,
     215,   710,   216,   217,   218,   219,   220,   711,   221,   222,
    1650,   223,   224,   225,   226,   227,  1651,  1652,   228,   229,
     230,   231,   232,  1653,   233,   234,   235,   236,   237,  1654,
     238,  1655,   239,   240,   241,   242,   712,   243,   244,  1656,
     245,   246,   247,   248,   249,   250,  1657,   713,   251,   252,
    1658,  1659,  1660,   714,  1661,  1662,  1663,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  1664,   262,  1665,   263,
     264,   265,   266,   267,  1666,   268,   269,   270,  1667,  1668,
     271,   272,   273,  2477,   275,  1669,   276,   277,   278,  1670,
     279,   280,  1671,   281,   282,   283,   284,   285,   286,   287,
     288,   289,  1672,   290,  1673,   291,   292,   293,  1674,   294,
    1675,   295,   715,  1676,   716,   296,   297,   298,  1677,   299,
     300,  1678,   301,  1679,   302,   303,   304,   305,   306,   717,
     307,   308,   309,  1680,   310,   311,   312,   313,   314,   315,
    1681,   316,   718,   317,   318,   319,   320,   321,   322,   323,
    1682,   324,  1683,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,  1684,   334,   722,   335,   723,
    1685,   336,   337,   338,  1686,  1687,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   724,
     352,   353,   354,   355,  1688,   356,   357,   725,   358,  1689,
     359,   360,   361,   362,   363,   364,  1690,   365,  1691,  1692,
     366,   367,   368,  1693,  1694,   369,   726,   727,   728,   370,
     371,   372,   373,   374,   375,   376,   377,  1695,   378,   379,
     380,   381,   382,   383,   384,  1696,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,  1697,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,  1698,
     407,   408,   729,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,  1699,   420,   421,   422,   423,   424,
    1700,  2478,   426,   427,   428,   730,   429,   430,  1701,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
    1702,   442,   443,  1703,   444,   445,   446,   447,   448,   449,
    1704,   450,   451,  1705,  1706,   452,   453,   454,   455,  1707,
     456,   457,   458,   459,   460,   461,  1708,  1709,   462,   463,
     464,   465,   466,  1710,  1711,   467,   468,   469,   470,   471,
     472,   473,  1712,   474,   731,   475,   476,   477,  1713,  1714,
     478,  1715,  1716,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     751,     0,   548,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     220,   711,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,  1443,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   724,   352,   353,   354,   355,     0,   356,
     357,   725,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,  1444,     0,   366,   367,   368,     0,     0,   369,
     726,   727,   728,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   730,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,  1445,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   751,     0,   548,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,   219,   220,   711,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,     0,     0,
       0,   714,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,  1616,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   722,   335,   723,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   724,   352,   353,
     354,   355,     0,   356,   357,   725,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,   726,   727,   728,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   730,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   751,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,   219,   220,   711,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,     0,     0,     0,   714,     0,     0,  1947,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   722,
     335,   723,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   724,   352,   353,   354,   355,     0,   356,   357,   725,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,   726,   727,
     728,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   730,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,  1948,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   751,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     3,     4,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
       0,   356,   357,   725,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   730,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   751,     0,   548,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   220,   711,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
       0,     0,     0,   714,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   722,   335,   723,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   724,
     352,   353,   354,   355,     0,   356,   357,   725,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   730,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     751,     0,   548,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     220,   711,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,  1433,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   724,   352,   353,   354,   355,     0,   356,
     357,   725,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
     726,   727,   728,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   730,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   751,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,   219,   220,   711,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,     0,     0,
       0,   714,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,   300,  2727,
     301,     0,   302,   303,   304,   305,   306,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   722,   335,   723,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   724,   352,   353,
     354,   355,     0,   356,   357,   725,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,   726,   727,   728,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   730,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   709,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,   219,   220,   711,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,     0,     0,     0,   714,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   722,
     335,   723,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   724,   352,   353,   354,   355,     0,   356,   357,   725,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,   726,   727,
     728,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   730,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   751,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
       0,   356,   357,   725,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   730,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   751,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   220,   711,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
       0,     0,     0,   714,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   722,   335,   723,
       0,   336,   337,   338,     0,     0,   339,   340,   784,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   724,
     352,   353,   354,   355,     0,   356,   357,   725,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   730,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     751,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     220,   711,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   856,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   724,   352,   353,   354,   355,     0,   356,
     357,   725,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
     726,   727,   728,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   730,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   709,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,   219,   220,   711,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,     0,     0,
       0,   714,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   874,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,   334,   722,   335,   723,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   724,   352,   353,
     354,   355,     0,   356,   357,   725,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,   726,   727,   728,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,   730,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   709,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,   219,   220,   711,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,     0,     0,     0,   714,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     883,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,   334,   722,
     335,   723,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   724,   352,   353,   354,   355,     0,   356,   357,   725,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,   726,   727,
     728,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,   730,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   751,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,   219,   220,   711,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   885,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,   334,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   724,   352,   353,   354,   355,
       0,   356,   357,   725,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,   726,   727,   728,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,   730,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   751,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,   710,   216,   217,   218,   219,   220,   711,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,   712,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,   713,   251,   252,
       0,     0,     0,   714,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,   715,     0,   716,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   893,   717,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,   718,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,   719,   720,   326,   721,   327,   328,
     329,   330,   331,   332,   333,     0,   334,   722,   335,   723,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   724,
     352,   353,   354,   355,     0,   356,   357,   725,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,   726,   727,   728,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,   729,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,   730,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,   731,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     751,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,   710,   216,   217,   218,   219,
     220,   711,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
     712,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,   713,   251,   252,     0,     0,     0,   714,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,   715,     0,   716,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   904,   717,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,   718,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,   719,   720,
     326,   721,   327,   328,   329,   330,   331,   332,   333,     0,
     334,   722,   335,   723,     0,   336,   337,   338,     0,     0,
     339,   340,   905,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   724,   352,   353,   354,   355,     0,   356,
     357,   725,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
     726,   727,   728,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,   729,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,   730,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,   731,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,  1796,   233,   234,   235,   236,   237,     0,   238,  1861,
     239,   240,   241,   242,     0,   243,   244,  1797,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,  1862,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,  1799,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,  1800,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,  1801,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,  1796,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,  1797,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,  1862,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,  1799,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,  2664,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,  1800,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,  1801,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   645,   206,
     207,   614,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,   615,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,   646,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   616,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     617,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,   614,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,   615,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,  2387,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   616,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   617,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,  1796,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,  1797,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,  1862,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,  1799,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,  1800,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,  1801,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,   614,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,   615,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   616,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   617,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,  1470,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,  1471,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,  1472,   295,     0,     0,     0,  1473,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,  1474,  1475,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,  1476,   416,   417,   418,   419,     0,  1477,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,  1478,   444,  1479,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,   615,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   616,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     617,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     3,
       4,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,  2460,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,  2461,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,  2472,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,  2473,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,   540,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   541,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,   639,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   640,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   641,   451,     0,     0,   642,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,   668,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   669,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   670,   451,     0,     0,   671,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,   674,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,   867,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,  1071,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,  1082,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   656,   229,
     230,   231,  1083,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   659,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   660,   410,   411,   412,   413,   414,   661,
     416,   417,   418,   419,     0,   420,   421,   422,   423,  1075,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   663,   451,     0,     0,   664,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   665,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,  2294,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,  2295,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,  2296,   444,   445,
    2297,   447,  2298,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,  2299,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,   548,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,  3315,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
    3328,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  3514,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
    3516,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,  3518,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,  3870,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   306,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   629,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   637,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   656,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   657,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   658,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   659,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   660,   410,   411,   412,   413,   414,   661,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   662,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   663,
     451,     0,     0,   664,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   665,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   686,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   835,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   879,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   895,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   897,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     899,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   902,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,   908,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   656,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   659,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   660,   410,   411,
     412,   413,   414,   661,   416,   417,   418,   419,     0,   420,
     421,   422,   423,  1075,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   663,   451,     0,     0,   664,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   665,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,  1356,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
    1383,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,  1411,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   450,   451,     0,
       0,   452,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,  1413,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,   306,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,  1502,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,  1769,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,   306,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,     0,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     656,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   659,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   660,   410,   411,   412,   413,
     414,   661,   416,   417,   418,   419,     0,   420,   421,   422,
     423,  1075,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,  1787,   446,   447,
     448,   449,     0,   663,   451,     0,     0,   664,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   665,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,     0,   216,   217,
     218,   219,   220,     0,   221,   222,     0,   223,   224,   225,
     226,   227,     0,     0,   656,   229,   230,   231,   232,     0,
     233,   234,   235,   236,   237,     0,   238,     0,   239,   240,
     241,   242,     0,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,     0,   251,   252,     0,     0,     0,     0,
       0,     0,     0,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
       0,   291,   292,   293,     0,   294,     0,   295,     0,     0,
       0,   296,   297,   298,     0,   299,   300,     0,   301,     0,
     302,   303,   304,   305,   306,     0,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,     0,   317,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,     0,   327,   328,   329,   330,   331,   332,
     333,     0,   334,     0,   335,     0,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   659,   351,     0,   352,   353,   354,   355,
       0,   356,   357,     0,   358,     0,   359,   360,   361,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,   369,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,     0,   660,
     410,   411,   412,   413,   414,  1842,   416,   417,   418,   419,
       0,   420,   421,   422,   423,  1075,     0,   425,   426,   427,
     428,     0,   429,   430,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,   663,   451,     0,
       0,   664,   453,   454,   455,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,     0,   474,
       0,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   665,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   199,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   200,   201,   202,
     203,   204,   205,   206,   207,     0,   209,   210,   211,     0,
       0,     0,     0,     0,     0,     0,   212,   213,     0,   214,
     215,     0,   216,   217,   218,   219,   220,     0,   221,   222,
       0,   223,   224,   225,   226,   227,     0,     0,   228,   229,
     230,   231,   232,     0,   233,   234,   235,   236,   237,     0,
     238,     0,   239,   240,   241,   242,     0,   243,   244,     0,
     245,   246,   247,   248,   249,   250,     0,     0,   251,   252,
       0,     0,     0,     0,     0,     0,     0,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,     0,   263,
     264,   265,   266,   267,     0,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,     0,
     279,   280,     0,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,     0,   291,   292,   293,     0,   294,
       0,   295,     0,     0,     0,   296,   297,   298,     0,   299,
     300,     0,   301,     0,   302,   303,   304,   305,  2077,     0,
     307,   308,   309,     0,   310,   311,   312,   313,   314,   315,
       0,   316,     0,   317,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,     0,   327,   328,
     329,   330,   331,   332,   333,     0,   334,     0,   335,     0,
       0,   336,   337,   338,     0,     0,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,     0,
     352,   353,   354,   355,     0,   356,   357,     0,   358,     0,
     359,   360,   361,   362,   363,   364,     0,   365,     0,     0,
     366,   367,   368,     0,     0,   369,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,     0,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,     0,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,     0,
     407,   408,     0,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     0,   420,   421,   422,   423,   424,
       0,   425,   426,   427,   428,     0,   429,   430,     0,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
       0,   442,   443,     0,   444,   445,   446,   447,   448,   449,
       0,   450,   451,     0,     0,   452,   453,   454,   455,     0,
     456,   457,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,     0,   474,     0,   475,   476,   477,     0,     0,
     478,     0,     0,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     199,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   200,   201,   202,   203,   204,   205,   206,   207,     0,
     209,   210,   211,     0,     0,     0,     0,     0,     0,     0,
     212,   213,     0,   214,   215,     0,   216,   217,   218,   219,
     220,     0,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,   232,     0,   233,   234,
     235,   236,   237,     0,   238,     0,   239,   240,   241,   242,
       0,   243,   244,     0,   245,   246,   247,   248,   249,   250,
       0,     0,   251,   252,     0,     0,     0,     0,     0,     0,
       0,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,     0,   279,   280,     0,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,     0,   291,
     292,   293,     0,   294,     0,   295,     0,     0,     0,   296,
     297,   298,     0,   299,   300,     0,   301,     0,   302,   303,
     304,   305,  2463,     0,   307,   308,   309,     0,   310,   311,
     312,   313,   314,   315,     0,   316,     0,   317,   318,   319,
     320,   321,   322,   323,     0,   324,     0,   325,     0,     0,
     326,     0,   327,   328,   329,   330,   331,   332,   333,     0,
     334,     0,   335,     0,     0,   336,   337,   338,     0,     0,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,     0,   352,   353,   354,   355,     0,   356,
     357,     0,   358,     0,   359,   360,   361,   362,   363,   364,
       0,   365,     0,     0,   366,   367,   368,     0,     0,   369,
       0,     0,     0,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,     0,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,     0,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,     0,   407,   408,     0,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   428,     0,
     429,   430,     0,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,     0,   442,   443,     0,   444,   445,
     446,   447,   448,   449,     0,   450,   451,     0,     0,   452,
     453,   454,   455,     0,   456,   457,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,     0,   474,     0,   475,
     476,   477,     0,     0,   478,     0,     0,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   199,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,     0,
     216,   217,   218,   219,   220,     0,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
     232,     0,   233,   234,   235,   236,   237,     0,   238,     0,
     239,   240,   241,   242,     0,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,     0,   251,   252,     0,     0,
       0,     0,     0,     0,     0,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,     0,   291,   292,   293,     0,   294,     0,   295,
       0,     0,     0,   296,   297,   298,     0,   299,   300,     0,
     301,     0,   302,   303,   304,   305,  2465,     0,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
       0,   317,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,     0,   327,   328,   329,   330,
     331,   332,   333,     0,   334,     0,   335,     0,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,     0,   352,   353,
     354,   355,     0,   356,   357,     0,   358,     0,   359,   360,
     361,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,   369,     0,     0,     0,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
       0,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
     426,   427,   428,     0,   429,   430,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,   450,
     451,     0,     0,   452,   453,   454,   455,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
       0,   474,     0,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   199,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
    2548,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,  1311,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,     0,  1312,   711,  1313,  1314,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,  1315,  1316,   232,     0,
     233,   234,   235,   236,     0,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,  1317,
    1318,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   998,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,     0,   286,   287,   288,     0,     0,   290,
       0,   291,  1319,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,     0,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,  1846,
     310,   311,   312,   313,   314,   315,     0,   316,   718,  1847,
     318,   319,   320,   321,  1320,  1321,     0,  1322,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,     0,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1323,   724,  1324,   353,   354,     0,
       0,   356,   357,   725,   358,     0,     0,   360,  1325,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,  1848,   726,   727,   728,     0,   371,   372,   373,   374,
     375,   376,   377,     0,   378,     0,   380,     0,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1326,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,     0,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,  1849,   427,
     428,   730,   429,  1328,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,     0,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,  1329,  1330,     0,
       0,   452,     0,   454,     0,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,     0,  1331,  1850,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,     0,  1311,     0,     0,     0,     0,
       0,     0,     0,   493,   494,   495,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     710,   216,   217,   218,     0,  1312,   711,  1313,  1314,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,  1315,
    1316,   232,     0,   233,   234,   235,   236,     0,     0,   238,
       0,   239,   240,   241,   242,   712,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   713,   251,   252,     0,
       0,     0,   714,     0,     0,     0,   253,   254,   255,   256,
     257,   258,  1317,  1318,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   998,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,     0,   286,   287,   288,
       0,     0,   290,     0,   291,  1319,   293,     0,   294,     0,
     295,   715,     0,   716,   296,   297,   298,     0,   299,     0,
       0,   301,     0,   302,   303,   304,   305,   306,   717,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   718,     0,   318,   319,   320,   321,  1320,  1321,     0,
    1322,     0,   325,   719,   720,   326,   721,   327,   328,   329,
     330,   331,   332,   333,     0,     0,   722,   335,   723,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1323,   724,  1324,
     353,   354,     0,     0,   356,   357,   725,   358,  1838,     0,
     360,  1325,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,     0,   726,   727,   728,     0,   371,
     372,   373,   374,   375,   376,   377,     0,   378,     0,   380,
       0,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1326,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   729,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,  1849,   427,   428,   730,   429,  1328,     0,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,     0,     0,
     442,   443,  3182,   444,   445,   446,   447,   448,   449,     0,
    1329,  1330,     0,     0,   452,     0,   454,     0,     0,   456,
     457,   458,   459,   460,   461,     0,     0,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,     0,
    1331,     0,   474,   731,   475,   476,   477,     0,     0,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   199,     0,
       0,     0,     0,     0,     0,     0,   493,   494,   495,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,     0,   216,   217,   218,   219,   220,     0,
     221,   222,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,   230,   231,   232,     0,   233,   234,   235,   236,
     237,     0,   238,     0,   239,   240,   241,   242,     0,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     251,   252,     0,     0,     0,     0,     0,     0,     0,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,     0,   291,   292,   293,
       0,   294,     0,   295,     0,     0,     0,   296,   297,   298,
       0,   299,   300,     0,   301,     0,   302,   303,   304,   305,
     306,     0,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,     0,   317,   318,   319,   320,   321,
     322,   323,     0,   324,     0,   325,     0,     0,   326,     0,
     327,   328,   329,   330,   331,   332,   333,     0,   334,     0,
     335,     0,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,     0,   352,   353,   354,   355,     0,   356,   357,     0,
     358,     0,   359,   360,   361,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,   369,     0,     0,
       0,   370,   371,   372,   373,   374,     0,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,     0,   385,   386,
     387,   388,   389,     0,   391,   392,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,     0,   409,   410,   411,     0,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   428,     0,   429,   430,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,   450,   451,     0,     0,   452,   453,   454,
     455,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,     0,   474,     0,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,  1311,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   201,   202,   203,   204,   205,   206,
     207,     0,   209,   210,   211,     0,     0,     0,     0,     0,
       0,     0,   212,   213,     0,   214,   215,   710,   216,   217,
     218,     0,  1312,   711,  1313,  1314,     0,   223,   224,   225,
     226,   227,     0,     0,   228,   229,  1315,  1316,   232,     0,
     233,   234,   235,   236,     0,     0,   238,     0,   239,   240,
     241,   242,   712,   243,   244,     0,   245,   246,   247,   248,
     249,   250,     0,   713,   251,   252,     0,     0,     0,   714,
       0,     0,     0,   253,   254,   255,   256,   257,   258,  1317,
    1318,   261,     0,   262,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,     0,   271,   272,   998,   274,
     275,     0,   276,   277,   278,     0,   279,   280,     0,   281,
     282,   283,   284,     0,   286,   287,   288,     0,     0,   290,
       0,   291,  1319,   293,     0,   294,     0,   295,   715,     0,
     716,   296,   297,   298,     0,   299,     0,     0,   301,     0,
     302,   303,   304,   305,   306,   717,   307,   308,   309,     0,
     310,   311,   312,   313,   314,   315,     0,   316,   718,     0,
     318,   319,   320,   321,  1320,  1321,     0,  1322,     0,   325,
     719,   720,   326,   721,   327,   328,   329,   330,   331,   332,
     333,     0,     0,   722,   335,   723,     0,   336,   337,   338,
       0,     0,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,  1323,   724,  1324,   353,   354,  1896,
       0,   356,   357,   725,   358,     0,     0,   360,  1325,   362,
     363,   364,     0,   365,     0,     0,   366,   367,   368,     0,
       0,     0,   726,   727,   728,     0,   371,   372,   373,   374,
     375,   376,   377,     0,   378,     0,   380,     0,   382,   383,
     384,     0,   385,   386,   387,   388,   389,   390,   391,  1326,
     393,   394,   395,   396,     0,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,     0,   407,   408,   729,   409,
     410,     0,   412,   413,   414,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,   424,     0,   425,  1327,   427,
     428,   730,   429,  1328,     0,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,     0,     0,   442,   443,     0,
     444,   445,   446,   447,   448,   449,     0,  1329,  1330,     0,
       0,   452,     0,   454,     0,     0,   456,   457,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,     0,  1331,     0,   474,
     731,   475,   476,   477,     0,     0,   478,     0,     0,   479,
     480,   481,   482,   483,     0,  1311,     0,     0,     0,     0,
       0,     0,     0,   493,   494,   495,   200,   201,   202,   203,
     204,   205,   206,   207,     0,   209,   210,   211,     0,     0,
       0,     0,     0,     0,     0,   212,   213,     0,   214,   215,
     710,   216,   217,   218,     0,  1312,   711,  1313,  1314,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,  1315,
    1316,   232,     0,   233,   234,   235,   236,     0,     0,   238,
       0,   239,   240,   241,   242,   712,   243,   244,     0,   245,
     246,   247,   248,   249,   250,     0,   713,   251,   252,     0,
       0,     0,   714,     0,     0,     0,   253,   254,   255,   256,
     257,   258,  1317,  1318,   261,     0,   262,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,     0,   271,
     272,   998,   274,   275,     0,   276,   277,   278,     0,   279,
     280,     0,   281,   282,   283,   284,     0,   286,   287,   288,
       0,     0,   290,     0,   291,  1319,   293,     0,   294,     0,
     295,   715,     0,   716,   296,   297,   298,     0,   299,     0,
       0,   301,     0,   302,   303,   304,   305,   306,   717,   307,
     308,   309,     0,   310,   311,   312,   313,   314,   315,     0,
     316,   718,     0,   318,   319,   320,   321,  1320,  1321,     0,
    1322,     0,   325,   719,   720,   326,   721,   327,   328,   329,
     330,   331,   332,   333,     0,     0,   722,   335,   723,     0,
     336,   337,   338,     0,     0,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,  1323,   724,  1324,
     353,   354,  3007,     0,   356,   357,   725,   358,     0,     0,
     360,  1325,   362,   363,   364,     0,   365,     0,     0,   366,
     367,   368,     0,     0,     0,   726,   727,   728,     0,   371,
     372,   373,   374,   375,   376,   377,     0,   378,     0,   380,
       0,   382,   383,   384,     0,   385,   386,   387,   388,   389,
     390,   391,  1326,   393,   394,   395,   396,     0,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     0,   407,
     408,   729,   409,   410,     0,   412,   413,   414,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,   424,     0,
     425,  1327,   427,   428,   730,   429,  1328,     0,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,     0,     0,
     442,   443,     0,   444,   445,   446,   447,   448,   449,     0,
    1329,  1330,     0,     0,   452,     0,   454,     0,     0,   456,
     457,   458,   459,   460,   461,     0,     0,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,     0,
    1331,     0,   474,   731,   475,   476,   477,     0,     0,   478,
       0,     0,   479,   480,   481,   482,   483,     0,  1311,     0,
       0,     0,     0,     0,     0,     0,   493,   494,   495,   200,
     201,   202,   203,   204,   205,   206,   207,     0,   209,   210,
     211,     0,     0,     0,     0,     0,     0,     0,   212,   213,
       0,   214,   215,   710,   216,   217,   218,     0,  1312,   711,
    1313,  1314,     0,   223,   224,   225,   226,   227,     0,     0,
     228,   229,  1315,  1316,   232,     0,   233,   234,   235,   236,
       0,     0,   238,     0,   239,   240,   241,   242,   712,   243,
     244,     0,   245,   246,   247,   248,   249,   250,     0,   713,
     251,   252,     0,     0,     0,   714,     0,     0,     0,   253,
     254,   255,   256,   257,   258,  1317,  1318,   261,     0,   262,
       0,   263,   264,   265,   266,   267,     0,   268,   269,   270,
       0,     0,   271,   272,   998,   274,   275,     0,   276,   277,
     278,     0,   279,   280,     0,   281,   282,   283,   284,     0,
     286,   287,   288,     0,     0,   290,     0,   291,  1319,   293,
       0,   294,     0,   295,   715,     0,   716,   296,   297,   298,
       0,   299,     0,     0,   301,     0,   302,   303,   304,   305,
     306,   717,   307,   308,   309,     0,   310,   311,   312,   313,
     314,   315,     0,   316,   718,     0,   318,   319,   320,   321,
    1320,  1321,     0,  1322,     0,   325,   719,   720,   326,   721,
     327,   328,   329,   330,   331,   332,   333,     0,     0,   722,
     335,   723,     0,   336,   337,   338,     0,     0,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
    1323,   724,  1324,   353,   354,     0,     0,   356,   357,   725,
     358,     0,     0,   360,  1325,   362,   363,   364,     0,   365,
       0,     0,   366,   367,   368,     0,     0,     0,   726,   727,
     728,     0,   371,   372,   373,   374,   375,   376,   377,     0,
     378,     0,   380,     0,   382,   383,   384,     0,   385,   386,
     387,   388,   389,   390,   391,  1326,   393,   394,   395,   396,
       0,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,     0,   407,   408,   729,   409,   410,     0,   412,   413,
     414,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,   424,     0,   425,  1327,   427,   428,   730,   429,  1328,
       0,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,     0,     0,   442,   443,     0,   444,   445,   446,   447,
     448,   449,     0,  1329,  1330,     0,     0,   452,     0,   454,
       0,     0,   456,   457,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,     0,  1331,     0,   474,   731,   475,   476,   477,
       0,     0,   478,     0,     0,   479,   480,   481,   482,   483,
       0,  1311,     0,     0,     0,     0,     0,     0,     0,   493,
     494,   495,   200,   201,   202,   203,   204,   205,   206,   207,
       0,   209,   210,   211,     0,     0,     0,     0,     0,     0,
       0,   212,   213,     0,   214,   215,   710,   216,   217,   218,
       0,  1312,   711,  1313,  1314,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,  1315,  1316,   232,     0,   233,
     234,   235,   236,     0,     0,   238,     0,   239,   240,   241,
     242,   712,   243,   244,     0,   245,   246,   247,   248,   249,
     250,     0,   713,   251,   252,     0,     0,     0,   714,     0,
       0,     0,   253,   254,   255,   256,   257,   258,  1317,  1318,
     261,     0,   262,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,     0,   271,   272,   998,   274,   275,
       0,   276,   277,   278,     0,   279,   280,     0,   281,   282,
     283,   284,     0,   286,   287,   288,     0,     0,   290,     0,
     291,  1319,   293,     0,   294,     0,   295,   715,     0,   716,
     296,   297,   298,     0,   299,     0,     0,   301,     0,   302,
     303,   304,   305,   306,   717,   307,   308,   309,     0,   310,
     311,   312,   313,   314,   315,     0,   316,   718,     0,   318,
     319,   320,   321,  1320,  1321,     0,  1322,     0,   325,   719,
     720,   326,   721,   327,   328,   329,   330,   331,   332,   333,
       0,     0,   722,   335,   723,     0,   336,   337,   338,     0,
       0,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,  1323,   724,  1324,   353,   354,     0,     0,
     356,   357,   725,   358,     0,     0,   360,  1325,   362,   363,
     364,     0,   365,     0,     0,   366,   367,   368,     0,     0,
       0,   726,   727,   728,     0,   371,   372,   373,   374,   375,
     376,   377,     0,   378,     0,   380,     0,   382,   383,   384,
       0,   385,   386,   387,   388,   389,   390,   391,  1326,   393,
     394,   395,   396,     0,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     0,   407,   408,   729,   409,   410,
       0,   412,   413,   414,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   424,     0,   425,  1849,   427,   428,
     730,   429,  1328,     0,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,     0,     0,   442,   443,     0,   444,
     445,   446,   447,   448,   449,     0,  1329,  1330,     0,     0,
     452,     0,   454,     0,     0,   456,   457,   458,   459,   460,
     461,     0,     0,   462,   463,   464,   465,   466,     0,     0,
     467,   468,   469,   470,   471,     0,  1331,     0,   474,   731,
     475,   476,   477,     0,     0,   478,     0,     0,   479,   480,
     481,   482,   483,     0,  1311,     0,     0,     0,     0,     0,
       0,     0,   493,   494,   495,   200,   201,   202,   203,   204,
     205,   206,   207,     0,   209,   210,   211,     0,     0,     0,
       0,     0,     0,     0,   212,   213,     0,   214,   215,   710,
     216,   217,   218,     0,  1312,   711,  1313,  1314,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,  1315,  1316,
     232,     0,   233,   234,   235,   236,     0,     0,   238,     0,
     239,   240,   241,   242,   712,   243,   244,     0,   245,   246,
     247,   248,   249,   250,     0,   713,   251,   252,     0,     0,
       0,   714,     0,     0,     0,   253,   254,   255,   256,   257,
     258,  1317,  1318,   261,     0,   262,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,     0,   271,   272,
     998,   274,   275,     0,   276,   277,   278,     0,   279,   280,
       0,   281,   282,   283,   284,     0,   286,   287,   288,     0,
       0,   290,     0,   291,  1319,   293,     0,   294,     0,   295,
     715,     0,   716,   296,   297,   298,     0,   299,     0,     0,
     301,     0,   302,   303,   304,   305,   306,   717,   307,   308,
     309,     0,   310,   311,   312,   313,   314,   315,     0,   316,
     718,     0,   318,   319,   320,   321,  1320,  1321,     0,  1322,
       0,   325,   719,   720,   326,   721,   327,   328,   329,   330,
     331,   332,   333,     0,     0,   722,   335,   723,     0,   336,
     337,   338,     0,     0,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,  1323,   724,  1324,   353,
     354,     0,     0,   356,   357,   725,   358,     0,     0,   360,
    1325,   362,   363,   364,     0,   365,     0,     0,   366,   367,
     368,     0,     0,     0,   726,   727,   728,     0,   371,   372,
     373,   374,   375,   376,   377,     0,   378,     0,   380,     0,
     382,   383,   384,     0,   385,   386,   387,   388,   389,   390,
     391,  1326,   393,   394,   395,   396,     0,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,     0,   407,   408,
     729,   409,   410,     0,   412,   413,   414,   415,   416,   417,
     418,   419,     0,   420,   421,   422,   423,   424,     0,   425,
       0,   427,   428,   730,   429,  1328,     0,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,     0,     0,   442,
     443,     0,   444,   445,   446,   447,   448,   449,     0,  1329,
    1330,     0,     0,   452,     0,   454,     0,     0,   456,   457,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,     0,  1331,
       0,   474,   731,   475,   476,   477,     0,     0,   478,     0,
       0,   479,   480,   481,   482,   483,     0,  1311,     0,     0,
       0,     0,     0,     0,     0,   493,   494,   495,   200,   201,
     202,   203,   204,   205,   206,   207,     0,   209,   210,   211,
       0,     0,     0,     0,     0,     0,     0,   212,   213,     0,
     214,   215,   710,   216,   217,   218,     0,     0,   711,     0,
       0,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,     0,     0,   232,     0,   233,   234,   235,   236,     0,
       0,   238,     0,   239,   240,   241,   242,   712,   243,   244,
       0,   245,   246,   247,   248,   249,   250,     0,   713,   251,
     252,     0,     0,     0,   714,     0,     0,     0,   253,   254,
     255,   256,   257,   258,     0,     0,   261,     0,   262,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
       0,   279,   280,     0,   281,   282,   283,   284,     0,   286,
     287,   288,     0,     0,   290,     0,   291,     0,   293,     0,
     294,     0,   295,   715,     0,   716,   296,   297,   298,     0,
     299,     0,     0,   301,     0,   302,   303,   304,   305,   306,
     717,   307,   308,   309,     0,   310,   311,   312,   313,   314,
     315,     0,   316,   718,     0,   318,   319,   320,   321,     0,
       0,     0,     0,     0,   325,   719,   720,   326,   721,   327,
     328,   329,   330,   331,   332,   333,     0,     0,   722,   335,
     723,     0,   336,   337,   338,     0,     0,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,     0,
     724,     0,   353,   354,     0,     0,   356,   357,   725,   358,
       0,     0,   360,     0,   362,   363,   364,     0,   365,     0,
       0,   366,   367,   368,     0,     0,     0,   726,   727,   728,
       0,   371,   372,   373,   374,   375,   376,   377,     0,   378,
       0,   380,     0,   382,   383,   384,     0,   385,   386,   387,
     388,   389,   390,   391,     0,   393,   394,   395,   396,     0,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       0,   407,   408,   729,   409,   410,     0,   412,   413,   414,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     424,     0,   425,     0,   427,   428,   730,   429,     0,     0,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
       0,     0,   442,   443,     0,   444,   445,   446,   447,   448,
     449,     0,     0,     0,     0,     0,   452,     0,   454,     0,
       0,   456,   457,   458,   459,   460,   461,     0,     0,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,     0,     0,     0,   474,   731,   475,   476,   477,     0,
       0,   478,     0,     0,   479,   480,   481,   482,   483,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   493,   494,
     495
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    47,    16,   891,   164,
     522,    11,   549,   172,    33,    24,   657,   884,   919,   184,
      20,   180,    20,   703,   616,   617,    42,   955,    21,   621,
     708,  1435,   846,    26,  1210,   181,   733,  1473,   778,   549,
     186,   855,   942,   793,  1165,  1327,    21,    47,   585,   195,
    1193,    26,   968,   565,  1895,  1101,     7,  1099,   775,    12,
     664,  1117,   828,    14,  1197,  1572,   996,   997,   785,  1284,
    1025,  2155,  2456,  1344,   514,    22,  1197,  2309,  1254,  1255,
    2688,  1982,  2429,   567,  2303,  1015,    33,  1380,  1365,  1365,
      17,    20,  1365,   577,  1193,    41,  1508,  1365,  2895,  1365,
    1365,  1938,  1148,  2476,  1732,  2478,   911,  1122,  2135,   875,
    1152,  2591,  2359,  2936,  2609,  2929,   833,   584,   558,   836,
     151,  2305,  2306,   660,   841,  1854,  1855,   166,  1243,  2609,
    3183,   848,   166,  2352,  2307,  3136,  2242,  3161,  1431,     0,
     857,     0,  2867,  2868,     0,     0,     0,  3383,  2907,   749,
     660,   700,  2862,  1201,  3155,  1152,  2800,   700,   986,   987,
     740,     5,     5,     0,  3558,     0,   166,    38,     0,     0,
       9,    31,    44,  3123,  1389,     0,    18,    83,    58,     3,
    2021,  3800,   103,  1011,     0,    25,     5,  2613,  2614,  2615,
    2616,  2617,  2618,     9,  2208,  2209,   102,     5,     5,  2213,
      68,  1249,    22,    37,     5,   785,    22,    11,    22,     5,
     127,     0,    13,  3689,    58,    29,   173,   174,     5,    18,
     177,   178,   156,     5,     5,    24,    13,   133,   150,  3780,
      68,    13,   145,    98,   826,    37,     5,   194,  1043,  2253,
    2254,   150,     5,  2084,   190,  2086,     0,     5,     5,    11,
     758,    75,    83,     5,    22,     9,   150,     5,    51,  2365,
      35,    29,    58,  3086,     5,   110,   150,    96,    22,    96,
       5,   189,     5,   241,    36,   150,    79,     5,   120,     9,
       4,  2431,  3656,   150,  3658,     9,    51,   777,   244,   779,
     153,   153,   258,    76,    83,   103,   786,    64,   163,   811,
     274,   125,    34,   103,    66,  1347,   246,    83,    26,    27,
    3751,   105,   103,   150,   229,   150,     9,   318,   150,   141,
     103,   120,   152,   289,   155,   150,    51,   107,   218,   107,
      72,     5,     4,   170,   150,   170,  1086,     9,   170,   151,
    4094,   304,   150,   152,    11,   170,   271,  1044,     5,    11,
     509,   175,   318,   218,   170,   105,   221,   522,     5,   302,
      66,   302,     9,  3706,   350,   352,   155,   830,   389,    36,
     907,   180,  1069,   251,   520,  1330,   421,    11,   524,   155,
     425,   898,   919,  1819,  3935,   207,  3729,  1317,  1318,   535,
    3784,   354,   909,    11,   553,  1325,   150,   907,    35,    66,
     565,   105,    36,   562,   391,   311,   427,    22,   892,  4163,
     190,   919,   190,  1296,    29,  1471,   170,   247,  1474,   309,
    1476,   243,   306,  1479,   425,  1292,    30,   352,   369,   103,
     308,   149,    66,   151,   340,   972,   236,   169,  3388,   263,
     231,   427,   236,   193,   309,   265,   103,   108,   231,   423,
     313,   313,   292,   393,   921,   423,   103,   423,  3899,   258,
     375,  1507,   972,   947,   304,   296,   391,   423,     8,   197,
    3844,   377,   122,   957,   170,   350,  2626,   244,   341,   341,
     423,   231,   350,   389,   236,   969,   315,  1315,  1316,   410,
     289,   294,   955,   427,  1308,   504,  1324,  2923,   382,   103,
    2995,   423,   295,   236,  3980,  4124,   423,   296,  1248,   427,
     423,   325,   350,   340,   354,  2995,   350,   423,   427,   318,
    1566,  1287,  1239,   343,  1241,   345,   371,   369,    16,   279,
     295,  4082,  1282,   427,  4085,  1577,   380,  3561,   362,   404,
     549,   550,   350,   423,   585,  1082,   370,   390,   703,   373,
    2391,   423,  1089,  1090,  3377,   512,   587,   325,   389,   516,
     427,   380,   337,   423,  1610,  1465,   409,  1849,   331,   332,
     295,  4122,  1082,   191,   376,   532,   503,  1085,  3528,   423,
     423,  1089,  1090,   422,   584,   585,   584,  1858,  1305,   426,
    1139,   426,  1192,   424,   426,   426,  1139,  3241,   414,   415,
     389,   426,   410,   596,   423,   598,    11,   600,  3318,  3368,
     426,   423,  3322,   606,   421,   419,   423,   425,   425,   361,
     629,   596,   423,   598,   427,   600,  3576,   423,  3864,  4023,
     583,   606,   607,   608,   427,   424,   423,   426,    18,   798,
     649,   423,   423,  2862,   132,  2877,   811,   656,  1228,   808,
     659,   660,   661,   692,   423,   390,   585,   419,   692,   610,
     414,   415,   427,   381,  2565,   423,   423,  2568,  2569,   373,
    1178,  2572,   426,   182,   409,   423,  1184,   427,  3104,   188,
     626,  2582,   423,  1146,   414,   415,  1176,   196,   423,  4083,
     414,   415,   692,   423,   694,   694,   694,   694,   694,   694,
     337,  1506,   427,  1508,   863,  1533,  1534,   247,   369,  2882,
     325,  1854,  1224,  1518,  2933,   421,  1521,   389,  2447,   425,
    2449,   414,   415,  1231,  1529,  1530,  1234,  1235,  1861,  2570,
    2571,   427,   678,     8,  3684,   385,    11,  1542,  1543,  1781,
     120,  3691,   414,   415,   145,    98,   241,   108,  1553,   416,
     417,   418,   419,   682,   416,   417,   418,   419,    96,  1222,
     152,   707,  1132,     5,   150,   103,     5,  3768,  2782,   159,
     241,  2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,  2793,
    2794,   103,  1830,   758,  1781,  1293,   191,   658,   108,   141,
    3793,   662,    23,    96,  1386,     5,   414,   415,   416,   417,
     418,   419,   748,   760,   761,  2911,   410,     3,    51,     5,
     163,  2318,   289,   343,   302,   345,    96,   421,   827,   423,
     424,   425,   183,   427,    18,  1288,  3872,  3873,    96,   158,
    2844,  2845,   320,   694,   371,   694,  1477,  1478,   694,   694,
     694,   318,  1884,   132,  1307,   159,  3193,    74,   258,    96,
       3,     4,     5,    51,   251,   207,     9,   381,    18,   152,
      18,   350,  2591,   183,    24,   218,  1563,   824,   221,   229,
     410,   411,   412,   108,   414,   415,   416,   417,   418,   419,
    2609,    74,  1399,   142,  2017,   112,   423,   844,   845,  1352,
     291,  1408,  3945,   231,    96,   170,   132,  3921,   907,  1416,
    1417,   108,    98,  1415,   861,  1442,   159,   191,   318,   289,
     919,  3912,   304,   120,   410,   229,   191,  1434,  3643,   112,
      60,   921,  2065,   921,   245,  1409,   120,   144,   423,   425,
    3753,   888,   889,   159,  1418,   249,    76,  3647,   427,   866,
    2055,  1404,  3652,   952,   919,  3655,  1430,    97,   183,   229,
     103,   300,   423,   184,   247,   133,   309,  2686,    26,    27,
     120,   245,   120,   972,   350,  1405,   358,   163,  3576,   228,
      22,   300,   247,   924,  1441,   926,   229,   928,    22,   930,
     980,   932,   933,   934,     8,   375,   229,    11,   939,   311,
     130,   311,   330,   502,   236,   333,   357,   236,   507,   999,
    4024,    60,  1043,   229,    28,   258,  4052,   147,   369,   414,
     415,   416,   417,   418,   419,    83,    74,   103,   340,   120,
     389,   370,   218,   173,   410,   221,    70,  1539,  4031,  1029,
     427,   320,   259,    77,   102,   188,  1045,   340,     8,   425,
     333,    11,    42,  1043,   254,   405,  1055,   129,  3862,   369,
     267,   404,   295,  3876,   112,   377,  1065,   210,   427,  1224,
     104,   375,   269,   115,   258,   133,   259,   389,  2124,    74,
     423,   130,   340,  1082,  2004,   318,  1085,    18,    74,  1110,
    1089,  1090,  4032,    24,   320,   423,  1125,  1126,   147,  1128,
      22,  1125,  1126,   340,  1128,   289,   105,   295,   258,  3318,
     258,   423,  3116,  3322,   245,   187,   151,   112,  3340,     5,
    1085,   106,  1575,   309,  1089,  1090,   112,   344,  3350,  3366,
    1934,   154,   375,  1269,   318,  1125,  1126,   636,  1128,   289,
     174,  3841,   272,   311,   369,   410,   411,   412,   340,   414,
     415,   416,   417,   418,   419,   231,  3047,  3331,   657,   375,
     170,   344,  3053,  3054,  3055,  3056,  3057,  3058,   318,  3532,
     318,    20,   340,  3336,  3987,   674,   166,   191,   177,   251,
     170,  1541,   167,  2444,    52,  3348,    32,   210,   302,   120,
    2451,    40,    60,   115,    84,  1555,   695,  3984,  3985,   339,
     340,  2233,   293,   340,   371,  1141,  3223,  2239,   115,   377,
     117,   259,   304,  1178,  2087,   329,   206,   249,   404,  1184,
    1727,   389,  2079,   272,  3709,   260,   258,   318,  1364,   257,
     306,   191,   231,   247,   364,  2039,  2040,  2041,  2042,  3709,
      49,  4054,   251,   115,  1380,   117,   106,  1246,     5,  1398,
      11,    95,  1217,   311,   371,   423,   423,  1174,  1407,  1206,
    1415,   151,   354,   105,   259,   111,  1231,   139,   106,  1234,
    1235,   414,   415,   259,  1410,    36,  2995,  3692,     8,   289,
     291,    11,   340,   293,  3288,  3289,    95,   247,   323,   179,
     421,   363,   251,   271,   425,  1431,   344,    11,  2724,   333,
    2918,   115,   258,   117,   194,    66,   423,   167,   318,  1256,
    1257,  1258,  1259,  2446,   204,   364,  4103,  2073,  1820,   377,
     343,  2326,   345,   381,  1473,   139,   163,  3154,  1293,   167,
    4143,   389,   322,   289,   241,   184,   226,   293,   196,   838,
    2386,    75,   210,  3758,   367,   320,   103,  1294,  1295,   344,
     382,   193,    66,  1300,  2756,   245,  1786,  2446,   344,   858,
     859,   860,   318,   172,   236,   423,   311,  1366,  3199,   241,
    3201,   352,    95,   217,   352,   219,  2643,  2643,   389,   389,
    2643,   218,   145,  2178,  1539,  2643,  1860,  2643,  2643,   231,
     124,  1903,   155,   423,   369,   340,   410,   411,   412,  1346,
     414,   415,   416,   417,   418,   419,    60,   170,   217,   299,
     219,  1909,  1865,   391,   293,   424,   427,   231,   427,  1917,
     229,  1919,   236,  1370,  1371,  1372,  1373,   241,     0,  2712,
     191,  2226,   377,   389,  4032,   131,    44,   279,  3647,   318,
    1952,  3663,  3664,  3652,   389,   151,  3655,   946,   257,   103,
    3865,  1441,   175,  1441,   414,   415,   416,   417,   418,   419,
    3875,   191,  2257,   311,  3801,   424,   200,   201,   427,   968,
     141,  1901,   309,   179,   145,   171,  3685,   154,   423,   213,
     258,   371,    11,    50,   356,   294,    94,    68,   194,  1436,
    1499,   105,   340,   365,   217,    76,   219,  2292,   204,   258,
    1490,  1490,  1490,  1490,  1490,  1490,  2396,    36,  2674,   389,
    1451,   289,  1453,    78,  1455,    82,  1457,   247,  1459,   328,
    3594,   141,  1463,  1442,   258,   145,   115,  1526,   117,   377,
     289,   145,  2452,   210,   293,   298,   207,    66,   150,  1992,
     318,  2068,   356,   342,  2417,   426,    32,   427,  3911,  1485,
    3924,   365,   117,    39,  1519,  1520,  2588,   279,   170,   318,
     427,  1498,  1527,   177,  3395,  3396,  1531,  1532,  2068,   304,
     137,  2078,   243,  2100,   182,   423,  2608,   231,   258,  3470,
    3471,  1546,   236,  1548,  3793,  2092,  2093,   207,  1505,  2096,
     389,   390,  1582,   299,   145,  2102,  1095,   278,   320,   231,
    2100,   168,  3606,  3100,  1569,  3679,  1571,  3681,   342,   289,
     344,   289,   274,  3950,   165,   293,   240,   231,   272,   354,
     312,   229,   303,   243,   423,  1624,   279,    21,  3632,  3633,
    2128,   285,  3841,  1580,  3856,  2777,   258,   290,   318,    38,
     318,  1777,   231,  1142,   312,   277,  1782,   369,   340,  1785,
    2157,  2407,   241,   414,   415,   416,   417,   418,   419,  2801,
      59,   314,   191,   192,  1813,  1820,   343,   289,   345,   308,
    1819,  1807,   340,   306,    68,    20,  2722,   145,   289,   390,
       8,   411,   412,    11,   414,   415,   416,   417,   418,   419,
     367,   383,  2145,   197,  2955,    40,   318,   165,   409,   307,
    1836,    31,  2432,  1363,  1203,   234,   383,   318,    36,   342,
     364,   389,  2343,   306,    42,   383,   258,   129,    57,    58,
      50,  1381,  2316,  1859,   118,   343,   293,   345,   295,   141,
     297,   390,  2937,   145,    84,   350,   303,   258,    66,   258,
    1541,   390,   424,   310,   306,   427,  1882,   289,   423,   342,
     409,   318,    82,   147,  1555,   354,   389,   390,   152,   326,
     409,  1260,  2652,  1746,   423,   291,  1902,   334,   289,  1905,
     289,   421,  2274,   423,   423,   187,   318,   308,  1768,  1768,
     342,  1746,  1791,   173,  1793,  2817,  1922,  1286,  2824,  3286,
     423,    80,  2319,  1929,   233,   207,   389,   390,  3066,   165,
    3068,   151,  1603,  3071,   198,  3073,  1942,   137,  2974,  2975,
    1729,  3815,   421,    48,   423,  1951,   425,   384,   598,   599,
     600,  2319,  4031,   603,   604,   605,   308,   389,   390,   179,
     423,   243,     8,   613,   343,    11,   345,  2743,   168,   251,
     197,  3732,   170,  1842,   194,     5,     4,   423,  2208,  2209,
      10,     9,    28,  2213,   204,   389,   390,   245,    18,  2804,
    2805,   423,   250,   191,   192,     9,   418,   197,  1815,  1816,
    1817,   423,   311,   425,    34,  1822,   226,  1824,  2405,  1826,
    1827,   275,   423,  2919,   425,   414,   415,   416,   417,   418,
     419,  2398,  2749,  2253,  2254,     8,   423,   422,    11,   422,
      48,   340,   427,   245,   427,  2405,   234,   245,   250,  2383,
    2384,   423,   306,   425,  2621,    28,   232,   233,   312,   247,
     418,  1420,   427,    36,  2842,   423,    21,   425,   423,    42,
    1429,    26,    38,  2225,  3765,  2227,  2228,   406,   377,   424,
    1939,  1440,   427,   248,  1909,   424,   340,   193,   427,   299,
     389,   363,  1917,    66,  1919,  2408,   145,  2464,   424,  2466,
     425,   427,  2994,   293,  2996,   359,   248,   297,  1915,  3595,
    3596,  3597,  3598,   303,   343,  1974,   345,  4051,  1477,  1478,
     310,   302,   303,  1982,   423,   424,   245,   426,   318,   383,
    3709,  2747,  2600,  2601,  2602,   311,   326,  2133,   424,   424,
      44,   427,   427,   424,   334,   424,   427,   424,   427,   426,
    2159,  3283,  3135,   350,  2163,   191,  2811,   406,   424,  2155,
    1967,   427,   424,   245,   340,   427,   306,   248,  1975,  1976,
    1977,  1978,  1979,  1980,   389,   390,  2001,  2544,  2512,  2038,
      38,    85,  2549,  3176,  2934,  2935,  2499,  2967,  2501,  3160,
     302,   303,   424,   166,   384,   427,   193,   170,   388,   389,
    2642,   377,   342,  2062,   424,   109,   426,  2057,  2057,  2068,
     406,   247,   424,   389,  1557,   427,  3795,  1560,   191,   192,
     124,   697,  2025,   699,   128,   416,   414,   415,   416,   417,
     418,   419,  2545,   206,   149,  2622,     8,  2624,   427,    11,
     424,  2100,   146,   427,   424,   424,  1605,   423,   427,   389,
     390,  2058,  3323,  2566,  3325,  1614,    28,   161,   231,  2274,
     424,   234,  2622,   427,  2624,   424,   424,   424,   427,   427,
     427,   424,   424,   423,   247,   427,  2083,   250,  2085,    48,
     407,   408,   922,   423,  2884,   925,   150,   927,   189,   929,
     424,   931,   423,   427,  2303,   935,   424,   318,  2685,   427,
    2634,   425,  2636,  2128,  3210,  3211,  3212,  2312,   424,   389,
     390,   427,  3063,  3670,   424,   424,   424,   427,   427,   427,
     424,   392,  2337,   427,  2871,  2685,   425,   424,   424,  2696,
     427,   427,   236,  2700,   423,  2702,   424,  2704,  2705,   427,
     244,   959,   960,  2352,  2874,  2875,  2713,   245,   424,   322,
       8,   427,   424,    11,   424,   427,   424,   427,   424,   427,
    2673,   427,   424,   423,  2171,   427,  2257,  2344,  2345,  1728,
      28,  1730,  2368,   277,   410,   411,   412,  2744,   414,   415,
     416,   417,   418,   419,  2697,   424,   424,   424,   427,   427,
     427,   424,  2750,   424,   427,   424,   427,   424,   427,   424,
     427,   424,   427,    76,   427,   145,   205,  2257,  2742,   424,
     424,   424,   427,   427,   427,   424,   105,   424,   427,   191,
     427,  2271,   424,   424,   424,   427,   427,   427,   371,   245,
     423,  2297,  2298,  2299,   240,   308,  3332,   410,   411,   412,
    2290,   414,   415,   416,   417,   418,   419,   424,   424,  2762,
     427,   427,  3042,  2303,   427,   197,   424,    60,     8,   427,
    2319,    11,   424,  3749,  2355,   427,   423,  3363,  2781,     8,
     424,   424,    11,   427,   427,   247,   424,   424,   389,   427,
     427,   154,    31,  2333,  2333,  2333,  2333,  2333,  2333,    28,
     231,   423,  2317,  2806,  2319,   424,   392,    36,   427,  2495,
     173,   424,  2352,    42,   427,  2355,  2502,   424,    38,    38,
     427,   359,    60,   258,   145,    73,  3294,   275,    66,  1878,
     134,  3185,   134,   423,   134,   392,   134,    66,    76,  2842,
     134,   245,   427,   191,   134,   134,   134,   210,  3444,  3445,
     134,  3447,   134,   134,   245,   134,  2405,  2208,  2209,   134,
     340,   423,  2213,    31,   205,   103,   146,   105,   145,   145,
     245,   423,  2782,     5,  2560,  2785,  2786,  2787,  2788,  2789,
    2790,  2791,  2792,  2793,  2794,     5,  2591,   250,   423,   423,
     423,   423,  3575,   423,   268,   423,   423,     5,     5,   247,
    3482,   423,  2253,  2254,  2609,  2815,   423,   423,   423,   423,
     423,   423,     5,   423,     5,   423,  2413,   255,  2415,  2416,
     423,   423,   423,   423,   423,  3270,   423,    31,   423,   423,
     423,   423,    86,  2482,  2844,  2845,   427,   166,   205,   177,
     145,   170,    31,  3887,   243,  3889,   145,   318,   410,   411,
     412,   191,   414,   415,   416,   417,   418,   419,     3,   306,
     350,  2510,   191,   192,   350,   425,     8,   350,   350,    11,
     306,   306,   350,  2022,    19,   245,   310,   206,   350,   236,
     343,   350,   345,   350,   350,   350,  3063,    68,   175,   370,
      50,   354,   245,   231,    36,   241,   423,   350,   236,   350,
      42,   364,   231,   423,   367,   234,    76,   247,   427,   258,
     371,   371,    97,   350,    48,  3063,  2565,   350,   247,  2568,
    2569,   250,    82,  2572,    66,  2724,  2712,   350,    48,    37,
      75,   350,   350,  2582,   272,   249,   350,   350,  2587,    37,
     350,  2727,  2591,  3484,   306,   350,   392,   285,   245,   350,
     427,   245,  3492,   191,   380,   423,    31,   389,    30,  2745,
    2609,   423,   410,   411,   412,   423,   414,   415,   416,   417,
     418,   419,    20,  2622,   231,  2624,  2591,   137,   134,   423,
     125,   103,   213,  2598,  2599,   371,   128,   383,  2603,   241,
     382,   231,    31,   322,  2609,   145,   423,    31,   197,   307,
     371,   134,   134,   371,   134,   134,  2655,   240,   168,   350,
     235,   150,   423,   385,  3138,  3139,   348,  3778,   223,   406,
     223,    11,  2637,   318,   166,   170,   364,   348,   170,   150,
     175,   246,   427,   350,   352,  2684,  2685,  2677,  2677,  3142,
    3197,   164,  3610,   187,   427,   423,  3383,  3204,  3205,   191,
     192,   424,   164,   129,   423,  2695,  2695,   423,   241,   371,
     424,   350,   427,  2862,   206,   141,   427,  3215,   350,   145,
     410,   411,   412,    75,   414,   415,   416,   417,   418,   419,
     306,   410,   411,   412,   306,   414,   415,   416,   417,   418,
     419,   371,   234,   422,   195,   423,   195,   350,   258,   428,
     236,   236,   308,   197,   245,   247,  3116,   423,   236,   252,
     306,   187,   427,   244,   350,   350,   289,   315,   263,    31,
     350,   350,  3479,   191,   279,   191,   191,   371,   371,   289,
     191,   207,   191,   293,  2933,  2750,   410,   297,  3834,   244,
     423,    30,   421,   303,   421,   423,   410,  2296,  3844,   350,
     310,   134,   315,   350,  2751,   300,   350,   145,   318,   241,
     350,   147,   423,  3946,   315,   134,   326,   243,    31,   162,
     162,  2852,  2958,   145,   334,   251,   245,    31,   245,  2828,
     322,  2862,   134,   245,   145,   245,   423,    19,   315,   170,
    2995,  3294,   170,   338,  2343,  3891,   170,   392,  2854,  2855,
    2856,  2857,  3354,  3743,   427,   156,   427,   220,   245,   427,
      48,   240,  2852,   197,   340,  3660,   150,   362,   427,   262,
     150,   423,  2862,   423,   384,   370,   350,   386,   373,   254,
     406,    13,  2881,    13,   386,   245,  3022,   424,   424,  3025,
     424,   406,   424,   296,   424,   424,   424,   424,  3816,   424,
     424,   207,   424,   424,   248,   424,   424,   424,  3415,  3416,
     424,   377,   410,   245,   173,   423,   423,   392,  4084,  3965,
     350,   181,   414,   415,   416,   417,   418,   419,  3288,  3289,
     207,   236,   134,   134,   263,   368,   263,   363,   306,   215,
    3393,   215,   350,   215,   350,   350,   350,  3529,   350,   306,
     350,   306,   306,   350,   350,   134,   318,  3484,  3465,  3466,
     350,  3414,  3880,    37,   191,   191,  3884,  3885,   191,   191,
     191,   191,   191,  3426,     3,   421,   221,   424,   207,   309,
     249,  2782,   424,   410,  2785,  2786,  2787,  2788,  2789,  2790,
    2791,  2792,  2793,  2794,   359,   421,  2995,   291,   424,   425,
      96,   424,  2949,  2950,  2951,  2952,  3897,  3675,   389,  3882,
     423,  3464,   244,  3012,  2815,   245,  3015,   159,  3017,   306,
     427,   371,   371,   424,  3881,  3820,   132,   350,  3011,   132,
    2995,   306,     8,   427,   248,    11,  3035,  3036,   306,   427,
     191,   421,   126,  2844,  2845,   150,  3011,    11,  3047,    58,
     145,   424,   424,   424,  3053,  3054,  3055,  3056,  3057,  3058,
      36,   382,   150,   424,  3063,   423,    42,   423,  3067,   158,
     246,   424,   423,  3580,   145,  3582,  3583,   424,   424,   427,
      31,   371,  3218,   424,   350,   424,  3593,   181,  4120,   371,
      66,   306,   359,   350,   359,   350,   350,   350,  3063,   306,
     145,    66,    96,   359,   424,   191,   424,  3106,  3107,  3108,
    3109,  3076,  3077,   191,   424,   424,   424,    31,   422,   422,
     195,   392,  3087,   423,   423,   389,   145,   176,   424,  2628,
     427,    71,   427,   342,   427,   423,  4168,   389,   350,   424,
     315,  3106,   155,   150,  4176,   191,   424,   191,   191,   191,
     150,   424,  3783,   423,  2653,   284,    48,  3610,    31,   387,
     194,  2660,   387,   424,   427,  2664,   424,  3114,   253,  3318,
     194,    48,   423,  3322,  3173,   423,   160,    50,   424,  3974,
    2679,   424,   241,   427,  3686,  3855,   410,   350,   150,   389,
     166,    66,   359,   410,   170,   236,   236,   134,   191,  3354,
     110,   236,   152,   150,   422,   371,   315,  2706,   121,    82,
    2709,   427,  3714,   371,   385,   191,   192,   427,    96,   389,
     423,   150,   178,   248,    22,    23,   423,   150,   423,    27,
     206,   423,  3231,    31,    32,    33,   284,    35,   376,   424,
      38,    39,   423,    41,  2743,    43,  3606,    21,   327,   194,
    3215,  4108,   424,   388,   423,  3615,   261,   245,   234,   424,
     424,   423,   285,   424,   137,   389,   423,    31,   236,   145,
     216,   247,  3632,  3633,   173,   423,   133,   424,   249,    60,
      54,   303,   303,    60,   423,  3421,    48,   248,    48,   423,
     371,   251,   245,    67,   140,   168,   276,  3433,   116,   248,
     248,   284,  3809,   342,   376,   375,    80,   427,    31,   150,
     386,   145,   282,   427,   121,  3116,   389,   245,   245,    31,
     389,   423,    48,   424,   197,   423,   108,   424,  3318,   302,
     423,   369,  3322,   302,    17,    28,   133,   276,  1272,  2024,
     423,  1891,  2319,  1090,   118,  2457,   322,  2587,  2994,   694,
    1946,  3735,  3351,   752,  3482,  3897,  3863,  3549,  3774,  3164,
    2859,  2860,  2861,  3816,  3778,  3522,  3375,  3782,  2390,  2117,
    3897,  3361,  3361,   147,   172,   173,   174,   175,   152,   177,
     178,  4058,   180,  3685,   182,  3892,   184,  3370,  4107,  4015,
     188,  4014,   190,  3846,  4072,  1382,   194,  3922,   196,  3166,
    2394,  3127,  2015,  2990,  3986,  3370,  2477,  3135,  2015,  3133,
    1367,  4112,  2010,  2654,  4176,  4168,  2593,  2608,  4079,  3716,
     293,  1359,  3995,  4066,   297,  3719,    26,  3880,  3411,     0,
     303,  3884,  3885,  3218,   410,   411,   412,   310,   414,   415,
     416,   417,   418,   419,   948,   318,  3411,  3174,  3861,  3946,
    1855,   550,  2547,   326,  4090,  3815,  4170,  3176,  3594,  3424,
    3425,   334,   673,  3766,  3429,  3430,  1729,  1442,  1730,  2333,
    3157,  3470,  3471,   247,  3362,  2916,  1116,  2334,   686,     0,
    3982,  1766,  1135,  1134,  2346,  3484,  2340,  3288,  3289,  3488,
    1765,  3490,  1749,  2352,  3493,  3494,  1137,  2360,  3647,  3446,
    2862,   275,  3842,  3652,   678,  1141,  3655,  2917,  3324,  2827,
    1991,   384,    83,  3460,  3659,   388,  2819,  3818,  4046,  4045,
    4049,  3504,  2337,     8,  2271,  2180,    11,  2269,  2912,  1606,
      -1,  3686,   306,    -1,    -1,    -1,  3685,    -1,   312,  3504,
      -1,   315,    -1,  3679,    -1,  3681,  3545,    -1,    -1,  3539,
    3539,    36,    -1,    -1,  3709,    -1,    -1,    42,   129,  3714,
      -1,    -1,    83,    -1,  3713,    -1,   340,    -1,    -1,    -1,
     141,    -1,   346,    -1,   145,  3574,    -1,    -1,    -1,   150,
      -1,    66,    -1,    -1,   155,   359,    -1,   158,    -1,   160,
      -1,    -1,    -1,    -1,    -1,  4102,  3595,  3596,  3597,  3598,
    3749,  3548,    -1,    -1,  3103,    -1,    -1,    -1,   129,   383,
      -1,    -1,    -1,    -1,    -1,    -1,   187,    -1,    -1,    -1,
     141,    -1,    -1,  3122,   145,    -1,    -1,    -1,    -1,   150,
      -1,    -1,    -1,    -1,   155,    -1,   207,   158,    -1,   160,
      -1,    -1,    -1,    -1,  3793,    -1,  3145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3647,    -1,    -1,
      -1,    -1,  3652,    -1,    -1,  3655,   187,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,   166,    -1,    -1,    -1,   170,   207,    -1,    -1,    -1,
      -1,    -1,  3841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   502,    -1,   191,   192,    -1,   507,
    3709,   509,    -1,    -1,   512,    -1,   514,    -1,   516,    -1,
      -1,   206,   243,    -1,   522,   296,    -1,   525,    -1,    -1,
     251,  3672,    -1,  3732,   532,    -1,    -1,  3736,    -1,    -1,
    3687,  3688,  3689,    -1,  3709,    -1,   231,    -1,    -1,   234,
      -1,    -1,    -1,    -1,    -1,   553,    -1,    -1,    -1,    -1,
     558,    -1,   247,    -1,   562,    -1,    -1,   565,    -1,   340,
      -1,    -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,
      -1,    -1,   580,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   363,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3606,  3305,  3306,  3307,  3308,
      -1,    -1,    -1,    -1,  3615,   386,    -1,   388,   389,   340,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3982,   626,    -1,
      -1,  3632,  3633,    -1,    -1,     0,    -1,   322,   636,   637,
      -1,    -1,   363,    -1,    -1,  3792,    -1,    -1,    -1,    -1,
     421,  3841,    -1,   424,   425,   426,    -1,   655,    -1,   657,
     658,    -1,    -1,    -1,   662,   386,    -1,   388,   389,    -1,
      -1,    -1,    -1,  4022,    -1,    -1,   674,    -1,    -1,    -1,
     678,    -1,  4031,    -1,    -1,    -1,   684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   695,  3897,    -1,
     421,    -1,    -1,   424,   425,   426,    -1,    -1,    -1,   707,
      -1,    -1,  4061,    -1,    -1,  4051,    -1,    -1,    83,    -1,
      -1,    -1,    -1,  3870,    -1,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,  3888,    -1,  3890,    -1,    -1,    -1,    -1,    -1,    -1,
     748,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   760,   761,   129,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,
     145,    -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,
     155,    -1,    -1,   158,    -1,   160,    -1,    -1,    -1,    -1,
     798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     808,    -1,    -1,   811,  3815,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   187,  4172,    -1,    -1,   824,    -1,    -1,    -1,
      -1,    -1,    -1,  3980,    -1,    -1,    -1,    -1,    -1,    -1,
     838,    -1,   207,    -1,    -1,    -1,   844,   845,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     858,   859,   860,   861,    -1,   863,    -1,    -1,    -1,    -1,
      -1,    -1,  4019,    -1,    -1,    -1,    -1,    -1,   243,  3578,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
     888,   889,    -1,    -1,    -1,  4126,    -1,    -1,    -1,    -1,
    4090,  4090,  4090,  4090,  4090,  4090,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   911,    31,    -1,    -1,    -1,    -1,    -1,
      -1,  4120,  4069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   296,    -1,    50,    -1,    -1,  4126,  4126,  4126,  4126,
    4126,  4126,    -1,   941,   942,    -1,    -1,    -1,   946,    -1,
     948,    -1,    -1,    -1,    -1,  4120,    -1,    -1,    -1,    -1,
      -1,    -1,  4109,    -1,    -1,    82,    -1,   965,    -1,  4168,
     968,    -1,    -1,   971,    -1,   340,    -1,  4176,    -1,    -1,
    4170,  4170,  4170,  4170,  4170,  4170,   984,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,
      -1,    -1,    -1,  4168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4176,    -1,    -1,  1012,    -1,    -1,    -1,    -1,    -1,
     137,   386,     0,   388,   389,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    -1,  1040,  1041,     8,  1043,    24,    11,    26,    27,
      -1,   168,    -1,  3752,    -1,    -1,   421,    -1,    -1,   424,
     425,   426,  1060,    41,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    -1,    18,    -1,    42,    -1,
     197,    -1,    24,    61,  3783,    63,    64,    -1,    -1,    -1,
      -1,    69,    -1,    71,    -1,    -1,    -1,  1095,    -1,    -1,
    1098,    -1,    66,    81,    -1,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    99,    64,    -1,   102,    -1,    -1,    -1,    -1,  1127,
      -1,    -1,    -1,  1131,  1132,    -1,   114,    -1,   116,    -1,
      -1,    -1,   120,  1141,  1142,  1143,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,   135,    -1,    -1,
      -1,  1159,    -1,   141,   128,    -1,    -1,    -1,    -1,    -1,
      -1,   113,    -1,    -1,    -1,  3874,   293,   155,   120,    -1,
     297,   123,    -1,    -1,    -1,    -1,   303,    -1,  1186,    -1,
      -1,    -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,  1197,
      -1,   318,   166,    -1,    -1,  1203,   170,    -1,  1206,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1224,   191,   192,    -1,
     208,   209,    -1,   175,    -1,     8,   214,    -1,    11,    -1,
      -1,    -1,   206,    -1,   222,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,  1256,  1257,
    1258,  1259,  1260,    36,    -1,    -1,    28,   384,    -1,    42,
     234,   388,    -1,  1271,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,   247,    -1,    -1,  1284,   229,  1286,   231,
      -1,    -1,   270,    66,    -1,    -1,  1294,  1295,    -1,   241,
      -1,    -1,  1300,   281,    66,    -1,    -1,   249,   286,    -1,
     288,    -1,    -1,    -1,    -1,   293,   258,    -1,    -1,    -1,
     298,    -1,    -1,   301,    -1,    -1,    -1,   305,    -1,    -1,
      -1,    -1,   310,   311,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    -1,    -1,   321,    -1,    -1,    -1,   289,  1346,    -1,
     328,   293,    -1,    -1,    -1,   128,    -1,    -1,   322,    -1,
      -1,    -1,   340,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1370,  1371,  1372,  1373,   318,    -1,    -1,   357,
      -1,    -1,    -1,    -1,   830,    -1,    -1,    -1,   366,    -1,
      -1,  1389,    -1,   166,   372,    -1,    -1,   170,    -1,   377,
    1398,    -1,    -1,    -1,   166,    -1,    -1,  1405,   170,  1407,
      -1,   389,    -1,    -1,    -1,    -1,    -1,  1415,   191,   192,
      -1,    -1,  1420,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,  1429,   374,   206,    -1,    -1,    -1,  1435,  1436,    -1,
      -1,    -1,  1440,    -1,   206,   423,    -1,    -1,   426,    -1,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,  1465,    -1,   231,
      -1,    -1,   234,    -1,   247,  1473,    -1,    -1,    -1,  1477,
    1478,    -1,    -1,    -1,    -1,   247,    -1,  1485,   250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1498,  1499,    -1,    -1,  1502,    -1,    -1,    -1,  1506,   955,
    1508,    -1,    -1,    -1,    -1,    -1,    -1,  1515,    -1,    -1,
    1518,    -1,    -1,  1521,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1529,  1530,    -1,    -1,    -1,    -1,    -1,    -1,  1537,
      -1,  1539,  1540,  1541,  1542,  1543,    -1,    -1,    -1,   322,
      -1,    -1,  1550,  1551,    -1,  1553,    -1,  1555,  1556,    -1,
     322,  1559,    -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,  1576,    -1,
      -1,    -1,  1580,  1581,    -1,    -1,    -1,  1585,    -1,    -1,
      -1,  1589,    -1,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,    -1,  1601,    -1,    -1,    -1,  1605,  1606,    -1,
    1608,    -1,    64,    -1,    -1,    -1,  1614,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1085,
      -1,   414,   415,   416,   417,   418,   419,    -1,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,   113,    -1,    -1,     3,   427,    -1,    -1,   120,     8,
      -1,   123,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    28,
      11,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
    1146,    -1,    -1,    42,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    42,    -1,   175,    -1,    -1,    -1,    66,    -1,    -1,
    1728,    -1,  1730,    -1,  1732,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    66,    -1,  1193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      42,  1769,    -1,  1771,    -1,    -1,  1222,   229,    -1,   231,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1786,   241,
      -1,    -1,    -1,  1791,    66,  1793,    -1,   249,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,    -1,
    1808,    -1,    -1,    -1,    -1,  1813,    -1,  1815,  1816,  1817,
      -1,  1819,  1820,    -1,  1822,    -1,  1824,   166,  1826,  1827,
      -1,   170,    -1,    -1,    -1,    -1,    -1,   289,    -1,    -1,
      -1,   293,  1288,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,   191,   192,    -1,    -1,   128,    -1,    -1,    -1,
      -1,  1307,    -1,  1861,    -1,    -1,   318,   206,    -1,  1867,
     191,   192,    -1,    -1,  1872,    -1,    -1,    -1,    -1,    -1,
    1878,  1327,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,   166,   234,  1894,  1895,   170,    -1,
      -1,    -1,    -1,  1901,    -1,    -1,  1352,    -1,   247,    -1,
     231,   250,    -1,   234,    -1,    -1,    -1,  1915,    -1,   191,
     192,    -1,   374,    -1,    -1,    -1,   247,    -1,    -1,   250,
      -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,
    1938,    -1,  1940,  1941,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,  1404,    11,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,  1967,
      -1,    -1,    -1,    -1,    -1,   247,    28,  1975,  1976,  1977,
    1978,  1979,  1980,   322,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,  1990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,  2017,
      -1,    -1,    -1,  2021,  2022,    -1,    -1,    -1,  2026,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     322,    -1,    -1,  2051,    -1,    -1,    -1,    -1,    -1,    -1,
    2058,  2059,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,    -1,    -1,    -1,    -1,  2083,  2084,  2085,  2086,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,    -1,
      -1,    -1,    -1,   424,    -1,    -1,    -1,  2105,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,  2117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,    -1,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,   206,     8,    -1,    -1,    11,    -1,
      -1,  2159,    -1,    -1,    -1,  2163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2171,    -1,    28,    -1,    -1,    -1,   231,
    2178,  2179,   234,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2208,  2209,    -1,    66,    -1,  2213,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2225,  2226,  2227,
    2228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2238,    -1,    -1,  2241,    -1,  2243,  2244,    18,    -1,    -1,
      -1,    -1,    -1,    24,    -1,  2253,  2254,    -1,    -1,  2257,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
     322,    11,  2270,    -1,  2272,    -1,  2274,    -1,  2276,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    -1,    28,    -1,
      -1,    24,    -1,    64,  2292,    -1,    36,    -1,  2296,    -1,
      18,    -1,    42,    -1,    -1,  2303,    24,  2305,  2306,  2307,
      -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,  2322,    -1,    66,    -1,    -1,    -1,
      -1,    64,    -1,    -1,    -1,    -1,  2334,    -1,   191,   192,
      -1,  2339,   113,    -1,    -1,  2343,    64,    -1,  2346,   120,
      -1,    -1,   123,   206,  2352,    -1,    -1,  2355,   410,   411,
     412,  2359,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,   231,    -1,
     113,   234,    -1,    -1,    -1,    -1,    -1,   120,    -1,    -1,
     123,  2389,    -1,  2391,   247,   113,    -1,   250,  2396,    -1,
      -1,    -1,   120,  1849,   175,   123,    -1,    -1,  1854,  1855,
      -1,    -1,    -1,    -1,    -1,  2413,    -1,  2415,  2416,  1865,
      -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,   175,   229,    -1,
     231,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,   322,
     241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   249,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,    -1,    -1,
      -1,   231,    -1,    -1,   234,    -1,   229,    -1,   231,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,   241,    -1,
     250,   229,    -1,   231,    -1,    -1,   249,    -1,   289,    -1,
      -1,    -1,   293,   241,    -1,   258,    -1,    -1,    -1,    -1,
      -1,   249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     258,    -1,    -1,    -1,    -1,    -1,  1992,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   289,   410,   411,   412,
     293,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,   424,  2570,  2571,    -1,   293,    -1,    -1,    -1,    -1,
      -1,     8,   322,    -1,    11,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    28,    -1,   374,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    -1,  2065,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2628,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2652,  2653,   374,    -1,    -1,    -1,
      -1,    -1,  2660,    -1,    -1,    -1,  2664,    -1,    -1,    -1,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
      -1,  2679,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2145,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2706,    -1,
      -1,  2709,    -1,    -1,    -1,    -1,    -1,    -1,  2716,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2724,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,  2743,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2751,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2759,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
    2768,    -1,    -1,    -1,    -1,    -1,  2774,    -1,  2776,   206,
      -1,    -1,     8,    -1,  2782,    11,    -1,  2785,  2786,  2787,
    2788,  2789,  2790,  2791,  2792,  2793,  2794,    -1,    -1,    -1,
    2798,  2799,    28,    -1,   231,    -1,    -1,   234,    -1,    -1,
      36,    -1,    -1,  2811,    -1,    -1,    42,  2815,    -1,    -1,
     247,  2819,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2829,    -1,    -1,  2832,    -1,  2834,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    -1,  2843,  2844,  2845,    -1,    -1,
      -1,  2849,    -1,    -1,  2852,    -1,    -1,    -1,    -1,    -1,
      -1,  2859,  2860,  2861,  2862,  2863,    -1,    -1,    -1,  2867,
    2868,    -1,    -1,    -1,  2872,    -1,    -1,    -1,    -1,    -1,
    2878,    -1,  2880,    -1,  2882,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2906,    -1,
      -1,    -1,    -1,    -1,  2912,    -1,    -1,    -1,  2916,    -1,
    2918,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2933,  2934,  2935,    -1,  2937,
     166,    -1,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,
      -1,  2949,  2950,  2951,  2952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2408,    -1,    -1,   191,   192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     206,    -1,  2980,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,   424,    -1,     8,
    2446,  2447,    11,  2449,    -1,   231,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,   247,    -1,    -1,   250,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3039,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,  2499,    -1,  2501,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,    -1,   172,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   180,   181,    -1,    -1,   322,    -1,   186,  2545,
      -1,    -1,    -1,    -1,    -1,  3103,    66,   195,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3114,    -1,  3116,    -1,
    2566,    -1,    -1,    -1,  3122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2591,    -1,  3145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3154,   166,    -1,    -1,
      -1,   170,  3160,  2609,    -1,    -1,  3164,    -1,  3166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3177,
    3178,    -1,   191,   192,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,   206,   424,    -1,
      -1,  3199,    -1,  3201,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   231,    -1,    -1,   234,    -1,  2673,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,  3234,    -1,   247,    -1,
    2686,   250,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,
      -1,  2697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   231,  3270,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3280,  3281,    -1,    -1,    -1,   247,    -1,    -1,
    3288,  3289,    -1,    -1,    -1,  3293,    -1,    -1,    -1,    -1,
      -1,  3299,  3300,    -1,    -1,  3303,    -1,  3305,  3306,  3307,
    3308,    -1,    -1,   322,  3312,    -1,  2762,  3315,     8,    -1,
    3318,    11,    -1,    -1,  3322,    -1,    -1,    -1,    -1,    -1,
    3328,    -1,    -1,  3331,    -1,  2781,    -1,    -1,  3336,    -1,
      -1,    -1,    -1,    -1,  3342,    -1,    36,    -1,    -1,    -1,
    3348,    -1,    42,    -1,    -1,     8,  3354,    -1,    11,    -1,
    2806,    -1,   322,    -1,  3362,    -1,    -1,    -1,  3366,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    66,  3375,    -1,    -1,
    3378,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    -1,    -1,    -1,    -1,  2842,  3395,  3396,    -1,
      -1,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,    -1,    -1,    66,  3412,   424,    -1,    -1,    -1,    -1,
      -1,   509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   520,    -1,    -1,    -1,   524,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   535,  3446,    -1,
     410,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
      -1,   549,  3460,    -1,    -1,   553,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   562,   563,   166,    -1,    -1,   567,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   577,
      -1,    -1,    -1,    -1,  3492,    -1,    -1,   585,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,    -1,    -1,   206,   170,    -1,    -1,
      -1,    -1,  3520,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,  2995,
    3548,  3549,    -1,   206,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   655,    -1,    -1,
      -1,    -1,   660,    -1,    -1,    -1,    -1,    -1,   231,    -1,
    3578,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   247,    -1,   684,   250,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3606,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3615,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   322,    -1,  3632,  3633,    -1,    -1,  3636,    -1,
      -1,    -1,    -1,    -1,    -1,  3643,    -1,    -1,    -1,  3647,
      -1,    -1,    -1,    -1,  3652,    -1,    -1,  3655,  3656,    -1,
    3658,    -1,  3660,  3661,    -1,    -1,    -1,    -1,    -1,   322,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   830,    -1,    -1,    -1,  3685,  3686,  3687,
    3688,  3689,    -1,    -1,    -1,    -1,  3142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     798,    -1,    -1,    -1,    -1,  3713,  3714,    -1,    -1,    -1,
     808,   411,   412,    -1,   414,   415,   416,   417,   418,   419,
    3176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   830,    -1,    -1,  3743,    -1,    -1,    -1,    -1,
      -1,  3749,    -1,    -1,  3752,    -1,    -1,   410,   411,   412,
      -1,   414,   415,   416,   417,   418,   419,  3765,    -1,  3767,
      -1,   424,    -1,    -1,    -1,   863,    -1,    -1,    -1,    -1,
    3778,    -1,    21,    -1,    -1,  3783,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3792,  3793,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,   892,    11,    -1,    -1,   955,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3815,    -1,   907,
    3818,    -1,  3820,   911,    -1,    -1,    -1,    -1,    67,    -1,
      36,   919,    -1,    -1,    -1,    -1,    42,  3283,    -1,  3837,
      -1,    80,    -1,  3841,    -1,    -1,  3844,    -1,  3294,    -1,
      -1,    -1,  3850,    -1,    -1,    -1,    -1,    -1,    97,   947,
      66,    -1,    -1,    -1,   103,    -1,    -1,   955,    -1,   957,
      -1,    -1,  3870,    -1,    -1,    -1,  3874,    -1,    -1,   118,
      -1,   969,    -1,    -1,   972,    -1,    -1,    -1,    -1,  3887,
    3888,  3889,  3890,    -1,    -1,    -1,   984,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,    -1,
      -1,    -1,    -1,   152,    -1,    -1,    -1,    -1,    -1,   158,
      -1,  3919,   128,    -1,  1012,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3393,    -1,    28,
      -1,    -1,  1040,  1041,    -1,  1043,    -1,    36,    -1,   198,
     166,    -1,    -1,    42,   170,    -1,    -1,    -1,  3414,    -1,
      -1,    -1,  1060,    -1,    -1,    -1,  3974,    -1,    -1,    -1,
    3426,    -1,  3980,    -1,  3982,   191,   192,    66,    -1,    -1,
      -1,  3989,    -1,    -1,  1082,     8,    -1,    -1,    11,  1146,
     206,  1089,  1090,    -1,    -1,    -1,    -1,    -1,   247,    -1,
    1098,  1099,    -1,    -1,    -1,    28,    -1,    -1,  3464,    -1,
      -1,  4019,    -1,    36,  4022,    -1,    -1,    -1,   234,    42,
      -1,    -1,    -1,  4031,    -1,    -1,   275,    -1,    -1,  1127,
      -1,   247,    -1,  1131,  1132,    -1,  1193,  4045,    -1,    -1,
    4048,  4049,    -1,    66,    -1,    -1,    -1,    -1,  1146,    -1,
      -1,   300,    -1,  4061,  1152,    -1,    -1,   306,    -1,    -1,
      -1,  4069,    -1,   312,    -1,  1222,   315,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,    -1,  4094,    -1,    -1,    -1,
      -1,   340,    -1,   342,    -1,  1193,  4104,   346,    -1,    -1,
      -1,  4109,   191,   192,    -1,   354,   322,    -1,    -1,    -1,
     359,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,   370,    -1,    -1,  1222,    -1,    -1,    -1,    -1,    -1,
      -1,  1288,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   231,   166,    -1,   234,    -1,   170,    -1,    -1,
    1307,    -1,    -1,    -1,  3610,  4163,    -1,    -1,   247,    -1,
      -1,   250,    -1,    -1,  4172,    -1,    -1,    -1,   191,   192,
    1327,  1269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,     8,    -1,
    1288,    11,    -1,    -1,    -1,  1352,    -1,    -1,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,   231,  1307,
      -1,   234,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    42,    -1,   247,    -1,    -1,   250,    -1,  1327,
      -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,  1404,    -1,  1347,
      -1,    -1,    -1,  3709,  1352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1364,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,
    1398,    -1,    -1,    -1,    -1,    -1,  1404,    -1,   128,  1407,
      -1,  1409,  1410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1418,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,    -1,  1430,  1431,    -1,   424,    -1,    -1,    -1,  3795,
      -1,    -1,    -1,    -1,  1442,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,  1473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,   410,   411,   412,
    3846,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,   424,    -1,    -1,    -1,    -1,     8,    -1,  1506,    11,
    1508,    -1,    -1,    -1,   234,    -1,    -1,  1515,  1575,    -1,
    1518,    -1,    -1,  1521,  3880,    -1,    28,   247,  3884,  3885,
      -1,  1529,  1530,    -1,    36,    -1,    -1,    -1,    -1,  1537,
      42,    -1,  1540,  1541,  1542,  1543,    -1,    -1,    -1,    -1,
      -1,    -1,  1550,  1551,    -1,  1553,    -1,  1555,  1556,    -1,
      -1,  1559,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1575,  1576,  1577,
      -1,    -1,    -1,  1581,    -1,    -1,    -1,  1585,    -1,    -1,
      -1,  1589,    -1,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,   322,  1601,    -1,    -1,    -1,    -1,  1606,    -1,
    1608,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    36,    -1,    11,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,   166,    -1,    -1,    -1,   170,    -1,
      -1,    36,    -1,    -1,    66,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,    -1,    -1,    -1,   414,   415,   416,   417,   418,   419,
      -1,    66,    -1,    -1,   206,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,
      -1,    -1,   234,    -1,  1732,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,  1777,
      -1,    -1,    -1,  1781,  1782,    -1,    -1,  1785,    -1,    -1,
      -1,    -1,  1849,    -1,    -1,    -1,    -1,  1854,  1855,   191,
     192,   166,    -1,    -1,    -1,   170,    -1,    -1,  1865,  1807,
    1808,    -1,    -1,    -1,   206,  1813,    -1,    -1,    -1,    -1,
     322,  1819,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1836,   231,
      -1,   206,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1849,    -1,    -1,    -1,   247,  1854,  1855,   250,    -1,
      -1,  1859,  1860,    -1,    -1,    -1,   231,  1865,    -1,   234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   247,  1881,  1882,   250,  1884,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1902,    -1,    -1,  1905,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,   424,    -1,  1922,    -1,    -1,    -1,    -1,    -1,
     322,  1929,    -1,    -1,    -1,  1992,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1951,    -1,    -1,     8,   322,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      32,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      42,    -1,  1990,    -1,  1992,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2065,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,    -1,    -1,   422,    -1,   111,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2065,    -1,    -1,
    2068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2145,    -1,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2100,    -1,    -1,    -1,    -1,  2105,    -1,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2133,    67,    68,    -1,   191,
     192,    -1,    -1,    -1,    -1,    76,    -1,  2145,    -1,    80,
      -1,    -1,    -1,    -1,   206,    -1,    -1,  2155,    -1,    -1,
      -1,  2159,    -1,    -1,    -1,  2163,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,
    2178,  2179,   234,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,   250,    -1,
      -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,    -1,
    2208,  2209,    -1,    -1,    -1,  2213,   147,    -1,    -1,    -1,
      -1,   152,    -1,    -1,    -1,    -1,    -1,  2225,  2226,  2227,
    2228,    -1,    -1,    -1,    -1,  2233,    -1,    -1,    -1,    -1,
    2238,  2239,   173,  2241,    -1,  2243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2253,  2254,    -1,    -1,  2257,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,    -1,    -1,
     322,    -1,  2270,    -1,  2272,    -1,    -1,    -1,  2276,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2292,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2303,    -1,  2305,  2306,  2307,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,   371,
      -1,  2319,    -1,    -1,  2322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2334,    -1,    -1,    -1,
      -1,  2339,    -1,    -1,   275,    -1,    -1,    -1,  2346,    -1,
      -1,  2408,    -1,    -1,  2352,    -1,    -1,    -1,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,    -1,   300,
    2368,    -1,    -1,   304,    -1,   306,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,   315,  2383,  2384,    -1,    -1,  2446,
    2447,  2389,  2449,    13,    -1,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2405,    28,   340,
    2408,   342,    -1,    21,    -1,   346,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    33,    46,    -1,   359,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2499,    -1,  2501,    -1,    54,    -1,  2446,  2447,
      -1,  2449,   383,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,  2476,  2477,
    2478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2545,    97,
      -1,    -1,    -1,    -1,    -1,   103,    -1,  2495,    -1,    -1,
      -1,  2499,    -1,  2501,  2502,    -1,    -1,    -1,    -1,  2566,
     118,    -1,    -1,    -1,  2512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,    -1,    -1,  2591,    -1,    -1,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,    -1,   154,  2545,    -1,    -1,
     158,    -1,  2609,    -1,    -1,    -1,    -1,    -1,   178,    -1,
      -1,    -1,  2560,    -1,    -1,   173,    -1,   187,  2566,   189,
      -1,   191,    -1,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2588,    -1,    -1,  2591,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2608,  2609,    -1,    -1,    -1,    -1,  2673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2622,    -1,  2624,    -1,    -1,  2686,
      -1,    -1,    -1,    -1,    -1,    -1,  2634,    -1,  2636,   247,
    2697,    -1,   250,    -1,     8,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    36,    -1,    -1,  2673,    -1,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2685,  2686,    -1,
      -1,    -1,   300,    -1,    -1,    -1,    -1,    -1,   306,  2697,
      -1,    -1,    66,    -1,   312,  2762,    -1,   315,    -1,    -1,
      -1,    -1,    -1,    -1,  2712,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2781,    -1,  2724,    -1,    -1,  2727,
      -1,    -1,   340,    -1,   342,   343,    -1,   345,   346,    -1,
      -1,    -1,    -1,    -1,  2742,    -1,   354,  2745,    -1,  2806,
      -1,   359,   181,    -1,    -1,    -1,   364,   186,    -1,   367,
      -1,  2759,   370,    -1,  2762,    -1,   195,    -1,    -1,    -1,
    2768,    -1,    -1,    -1,    -1,   383,  2774,    -1,  2776,    -1,
      -1,   145,    -1,  2781,  2782,  2842,   150,  2785,  2786,  2787,
    2788,  2789,  2790,  2791,  2792,  2793,  2794,    -1,    -1,    -1,
    2798,  2799,   166,    -1,    -1,    -1,   170,    -1,  2806,    -1,
      -1,    -1,    -1,  2811,    -1,    -1,    -1,  2815,    -1,  2817,
      -1,  2819,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
      -1,  2829,    -1,    -1,  2832,    -1,  2834,    -1,    -1,    -1,
      -1,    -1,   206,    -1,  2842,  2843,  2844,  2845,    -1,    -1,
      -1,  2849,    -1,    -1,  2852,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    11,  2862,   830,    -1,   231,    -1,    -1,
     234,    -1,    -1,    -1,  2872,    -1,    -1,    -1,    -1,    -1,
      28,    -1,  2880,   247,  2882,    -1,   250,    -1,    36,    -1,
     510,    -1,    -1,    -1,    42,    -1,    -1,   517,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   526,   527,  2906,    -1,
      -1,   531,    -1,    -1,  2912,    -1,    -1,    -1,    66,    -1,
    2918,   541,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   554,  2933,    -1,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   568,    -1,
      -1,   571,    -1,   573,    -1,   575,    -1,    -1,   322,    -1,
    2958,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     955,    -1,  2990,    -1,    -1,    28,  2994,  2995,  2996,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    42,
      -1,    -1,   632,    -1,   634,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,    -1,  3022,    -1,    -1,  3025,    -1,    -1,
      -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,    -1,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    -1,    -1,  3063,   686,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   231,   830,  3142,   234,    -1,    -1,    -1,
      -1,   520,    -1,    -1,    -1,   524,    -1,    -1,    -1,   247,
      -1,    -1,   250,    -1,    -1,    -1,   535,    -1,    -1,    -1,
      -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,  3116,  3176,
     549,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   166,   563,    -1,    -1,   170,   567,    -1,
    3138,  3139,    -1,    -1,  3142,    -1,    -1,    -1,   577,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   585,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   787,    -1,    -1,
      -1,    -1,    -1,   206,   322,    -1,    -1,    -1,  3176,  3177,
    3178,  1146,   802,    -1,    -1,    -1,    -1,   335,    -1,    -1,
      -1,     8,    -1,   813,    11,    -1,    -1,    -1,   231,    -1,
     820,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   955,
      -1,    28,   832,    -1,   247,    -1,    -1,   250,    -1,    36,
    3218,    -1,    -1,    -1,    -1,    42,  3283,    -1,  1193,    -1,
      -1,   660,    -1,    -1,   267,    -1,  3234,  3294,    -1,    -1,
      -1,    -1,    -1,    -1,   864,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1222,    -1,    -1,
      -1,    -1,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,  3270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3280,  3281,    -1,  3283,    -1,    -1,    -1,   322,
    3288,  3289,    -1,    -1,    -1,  3293,  3294,    -1,    -1,    -1,
      -1,  3299,  3300,    -1,    -1,  3303,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3318,    -1,    -1,  1288,  3322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3331,    -1,    -1,  3393,    -1,  3336,    -1,
      -1,    -1,  1307,    -1,    -1,    -1,    -1,    -1,    -1,   166,
    3348,    -1,    -1,   170,    -1,    -1,    -1,  3414,    -1,    -1,
      -1,    -1,  1327,    -1,    -1,    -1,    -1,    -1,    -1,  3426,
      -1,    -1,    -1,    -1,   191,   192,    -1,   410,   411,   412,
    3378,   414,   415,   416,   417,   418,   419,  1352,    -1,   206,
      -1,    -1,    -1,    -1,    -1,  3393,    -1,    -1,    -1,    -1,
    1146,    -1,    -1,    -1,    -1,    -1,    -1,  3464,    -1,    -1,
      -1,    -1,    -1,    -1,   231,    -1,  3414,   234,    -1,    -1,
      -1,    -1,    -1,  3421,    -1,    -1,    -1,    -1,  3426,    -1,
     247,    -1,    -1,   250,    -1,  3433,    -1,    -1,    -1,  1404,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   892,    -1,    -1,  3464,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,  1222,    -1,   907,    -1,
      -1,    -1,    -1,    -1,  3482,    -1,  3484,    28,    -1,    -1,
     919,    -1,    -1,    -1,    -1,    36,  1116,  1117,    -1,    -1,
      -1,    42,    -1,    -1,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   947,    -1,
      -1,    -1,  3520,    -1,    -1,    66,    -1,    -1,   957,    -1,
     347,    -1,    -1,    -1,  3532,    -1,    -1,    -1,    -1,    -1,
     969,    -1,  1288,   972,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3610,    -1,  1175,    -1,    -1,    -1,    -1,
      -1,  1307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3575,    -1,    -1,
      -1,  1327,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   410,   411,   412,  3594,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,  1352,    -1,  3606,   150,
    1575,    -1,  3610,    -1,    -1,    -1,    -1,  3615,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,  3632,  3633,    -1,    -1,  3636,    -1,
      -1,    -1,    -1,  1608,    -1,    -1,    -1,    -1,    -1,  3647,
     191,   192,  3709,  1082,  3652,    -1,    -1,  3655,  1404,    -1,
    1089,  1090,  3660,  3661,    -1,   206,    -1,    -1,    -1,    -1,
    1099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3679,    -1,  3681,    -1,    -1,    -1,  3685,    -1,    -1,
     231,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,   250,
      -1,  3709,    -1,    -1,    -1,  3713,    -1,    -1,    -1,    -1,
      -1,     8,    -1,  1152,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,  1355,    11,    -1,  3795,    -1,
      -1,    28,    -1,    -1,    31,    -1,    -1,    -1,  1368,    36,
      -1,  3749,    -1,    28,    -1,    42,    31,    -1,    -1,  3816,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      -1,   322,    -1,    -1,    -1,    -1,  1406,    -1,    -1,  3846,
      -1,    66,    -1,    -1,    -1,  3793,    -1,  3795,    -1,  1419,
      -1,  1421,    -1,  1423,    -1,    -1,    -1,    -1,  1428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3815,  3816,    -1,
    3818,    -1,  3820,  3880,    -1,    -1,    -1,  3884,  3885,  1575,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3837,
    1269,    -1,    -1,  3841,    -1,    -1,    -1,    -1,  3846,    -1,
      -1,  1471,    -1,    -1,  1474,    -1,  1476,    -1,    -1,  1479,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,   166,
      -1,    -1,  3880,   170,  1849,    -1,  3884,  3885,    -1,  1854,
    1855,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,  3897,
    1865,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3911,    -1,    -1,   191,   192,  1347,   206,
      -1,  3919,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   206,    -1,    -1,    -1,  1364,    -1,    -1,    -1,    -1,
      21,    -1,    -1,    -1,   231,    -1,    -1,   234,  3946,    -1,
      -1,  1380,    33,    -1,    -1,    -1,   231,    -1,    -1,   234,
     247,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   247,    54,    -1,   250,  3974,    -1,    -1,    -1,
    1409,  1410,    -1,    -1,    -1,    -1,    67,    -1,    -1,  1418,
      -1,  3989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,  1430,  1431,    -1,   181,    -1,    -1,    -1,    -1,   186,
      -1,    -1,    -1,  1442,    -1,    -1,    97,    -1,   195,    -1,
      -1,    -1,    -1,    -1,  4022,    -1,    -1,  1992,    -1,    -1,
      -1,    -1,    -1,  4031,    -1,   322,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
    4048,  4049,    -1,  4051,    -1,   136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4061,    -1,    -1,   147,    -1,    -1,    -1,
      -1,   152,    -1,    -1,    -1,    -1,    -1,   158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   173,    -1,    -1,    -1,  4094,    -1,    -1,    -1,
    2065,    -1,    -1,  1849,    -1,    -1,  4104,    -1,  1854,  1855,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1865,
      -1,    -1,  4120,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,    -1,    -1,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,  1577,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,  1778,  1779,
      -1,    -1,    -1,  1783,  1784,  4163,   247,  1787,    -1,    -1,
    4168,    -1,    -1,    28,  4172,    -1,   257,  1797,  4176,    -1,
    2145,    36,    -1,    -1,  1804,    -1,    -1,    42,    -1,    -1,
    1810,  1811,    -1,    -1,   275,    -1,    -1,    -1,    -1,    -1,
      -1,  1821,    -1,  1823,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    -1,    -1,    -1,    -1,    -1,  1837,    -1,   300,
      -1,    -1,  1842,   304,    -1,   306,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1992,    -1,  1868,  1869,
    1870,  1871,    -1,    -1,    -1,  1875,  1876,    -1,    -1,   340,
      -1,   342,    -1,  1883,    -1,   346,  1886,    -1,    -1,    -1,
    1890,    -1,    -1,   354,    -1,    -1,    -1,    -1,   359,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1906,    -1,    -1,   370,
      -1,    -1,    -1,    -1,    -1,    -1,  1916,    -1,  1918,    -1,
      -1,    -1,   383,    -1,    -1,    -1,  1926,  1927,  1928,    -1,
    1930,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,  2065,
      -1,    -1,    -1,  1943,  1944,  1945,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1953,  1954,    -1,   191,   192,    -1,    -1,
    2305,  2306,  2307,   520,    -1,    -1,    -1,   524,  1777,    -1,
      -1,   206,  1781,  1782,    -1,    -1,  1785,    -1,   535,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   549,    -1,    -1,    -1,   231,    -1,  1807,   234,
      -1,    -1,    -1,    -1,    -1,    -1,   563,    -1,    -1,    -1,
     567,    -1,   247,  2013,    -1,   250,    -1,    -1,    -1,  2145,
     577,    -1,    -1,    -1,    -1,    -1,    -1,  1836,   585,   264,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1859,  1860,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,  1881,  1882,    11,  1884,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,    -1,
      -1,    28,    -1,  1902,    31,    -1,  1905,    -1,    -1,    36,
      -1,  2446,  2447,   660,  2449,    42,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1922,    -1,    -1,    -1,    -1,    -1,    -1,
    1929,    -1,    -1,    -1,  2124,    -1,    -1,    -1,    -1,    66,
      -1,    -1,    -1,  1942,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1951,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2151,    -1,    -1,  2499,    -1,  2501,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2545,   655,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
     684,    -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2591,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,  2068,
      -1,    -1,    -1,    -1,  2609,    -1,    -1,    -1,    -1,   206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2100,    -1,    -1,   231,    -1,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
    2446,  2447,    -1,  2449,  2133,    -1,    -1,    -1,  2673,    -1,
      -1,     8,  2332,    -1,    11,   892,    -1,    -1,    -1,    -1,
      -1,  2686,    -1,    -1,    -1,    -1,  2155,    -1,    -1,    -1,
     907,    28,  2697,    -1,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,   919,    -1,    -1,    42,    -1,    -1,    -1,  2369,
    2370,    -1,    -1,  2499,    -1,  2501,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   322,  2386,    -1,    -1,    66,
     947,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     957,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   969,    -1,    -1,   972,    -1,  2762,    -1,  2545,
      -1,    -1,    -1,    -1,  2233,  2425,  2426,    -1,    -1,  2429,
    2239,    -1,    -1,  2433,  2434,  2435,  2781,    -1,    -1,    -1,
    2566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2806,    -1,    -1,    -1,  2591,    -1,  2467,  2468,  2469,
    2470,    -1,    -1,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,  2609,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,    -1,  2842,    -1,    -1,
      -1,    -1,    -1,  2503,    -1,    -1,    -1,    -1,    -1,    -1,
    2319,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,  1082,    -1,    -1,    -1,   206,
     984,    -1,  1089,  1090,    -1,    -1,    -1,  2882,    -1,    -1,
      -1,    28,  1099,    -1,    -1,    -1,    -1,  2673,    -1,    36,
      -1,    -1,    -1,    -1,   231,    42,  2556,   234,  1012,  2368,
    2686,  2561,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,  2697,    -1,   250,  2383,  2384,    -1,    -1,    -1,    66,
      -1,    -1,    -1,    -1,    -1,    -1,  1040,  1041,    -1,  1043,
      -1,    -1,    -1,    -1,    -1,  1152,  2405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1060,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2623,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2633,    -1,    -1,  2762,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1098,   322,    -1,    -1,    -1,    -1,
    2995,    -1,    -1,    -1,    -1,  2781,    -1,    -1,    -1,  2659,
      -1,  2661,    -1,    -1,    -1,    -1,    -1,  2476,  2477,  2478,
      -1,    -1,    -1,  1127,    -1,    -1,    -1,  1131,  1132,   166,
    2806,    -1,    18,   170,    -1,    -1,  2495,    -1,    24,    -1,
      -1,    -1,    -1,  2502,    -1,    -1,    -1,    -1,  2698,    -1,
      -1,    -1,    -1,  2512,   191,   192,    -1,    -1,    -1,    -1,
      -1,  2711,  1269,    49,    -1,    -1,  2842,    -1,    -1,   206,
      -1,    -1,  2722,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      -1,    -1,    -1,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,    -1,   231,    -1,    -1,   234,    -1,    -1,
      -1,  2560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
     247,    -1,    -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,  2588,
      -1,    -1,    -1,    -1,   120,    -1,    -1,   123,    -1,    -1,
    1347,    -1,    -1,    -1,    -1,    -1,    -1,  3142,    -1,  2608,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1364,    -1,    -1,
      -1,    -1,    -1,  2622,    -1,  2624,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1380,    -1,  2634,    -1,  2636,    -1,    -1,
      -1,  3176,    -1,    -1,    -1,   322,   172,    -1,    -1,   175,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1409,  1410,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2995,
      -1,    -1,    -1,  1430,  1431,    -1,  2685,    -1,    -1,    -1,
      -1,   217,    -1,   219,    -1,  1442,    -1,    -1,    -1,    -1,
      -1,    -1,   830,   229,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2712,    -1,   241,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   249,    -1,    -1,    -1,    -1,  2727,    -1,
      -1,   257,   258,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,  2742,    -1,    -1,  2745,    -1,  3283,    -1,
      -1,    -1,    -1,    -1,  2944,    -1,    -1,    -1,    -1,  3294,
      -1,    -1,    -1,   289,    -1,    -1,    -1,   293,   294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2978,    -1,
      -1,    -1,   318,    -1,    -1,    -1,  3331,    -1,    -1,    -1,
      -1,  3336,   328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3348,    -1,    -1,    -1,    -1,  2817,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3142,   955,  3018,    -1,
    1577,    -1,    -1,  3023,  3024,    -1,  3026,  3027,  3028,  3029,
    3030,  3031,  3032,    -1,    -1,    -1,    -1,    -1,   374,    -1,
      -1,  3041,    -1,    -1,    -1,    -1,    -1,    -1,  3393,    -1,
    3176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3414,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3426,    -1,  1537,    -1,    -1,  1540,    -1,    -1,  1543,
      -1,    -1,    -1,    -1,    -1,    -1,  1550,  1551,    -1,    -1,
      -1,    -1,  1556,    -1,    -1,  1559,    -1,    -1,    -1,    -1,
    3110,  3111,  3112,    -1,    -1,  3115,    -1,   830,    -1,  3464,
      -1,    -1,  1576,    -1,    -1,    -1,    -1,  1581,    -1,    -1,
      -1,  1585,    -1,    -1,    -1,  1589,    -1,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,    -1,  1601,    -1,  2958,
      -1,    -1,  1606,    -1,  1608,    -1,    -1,  3283,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3294,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2990,    -1,    -1,    -1,  2994,    -1,  2996,    -1,    -1,
      -1,    -1,    -1,  3193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1146,    -1,
    3210,  3211,  3212,  3022,    -1,    -1,  3025,    -1,    -1,    -1,
    1777,    -1,    -1,    -1,  1781,  1782,    -1,    -1,  1785,    -1,
    3575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   955,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1807,    -1,    -1,    -1,  3063,  1193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3610,    -1,  3393,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1732,  1836,
      -1,    -1,    -1,    -1,  1222,    -1,    -1,    -1,  3414,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3426,    -1,  1859,  1860,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1881,  1882,    -1,  1884,    -1,  3138,
    3139,    -1,    -1,    -1,    -1,    -1,   830,    -1,  3464,    -1,
      -1,    -1,    -1,    -1,    -1,  1902,    -1,    -1,  1905,    -1,
    1288,    -1,    -1,    -1,  1808,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3709,  1922,    -1,    -1,    -1,  1307,
      -1,    -1,  1929,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1942,    -1,    -1,    -1,  1327,
      -1,    -1,    -1,    -1,  1951,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3403,    -1,    -1,    -1,    -1,    -1,  3218,
      -1,    -1,    -1,    -1,  1352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3422,  3423,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1146,  3434,  3435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3444,  3445,    -1,  3447,    -1,    -1,
    3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   955,    -1,    -1,    -1,    -1,  1404,    -1,    -1,    -1,
      -1,  3816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1193,    -1,    -1,    -1,  3610,    -1,    -1,    -1,    -1,    -1,
      -1,  1056,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1222,
      -1,  2068,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3880,  1990,    -1,    -1,  3884,
    3885,  3541,    -1,  2100,    -1,    -1,    -1,  1112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3565,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1288,  2133,    -1,    -1,    -1,
      -1,    -1,    -1,  3709,    -1,    -1,  3586,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1307,    -1,    -1,    -1,  2155,    -1,
      -1,  3946,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3421,    -1,  1327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3433,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1575,    -1,  1352,
      -1,    -1,    -1,    -1,    -1,  3645,    -1,    -1,    -1,    -1,
      -1,  2105,  1146,    -1,    -1,    -1,    -1,   830,  3658,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3795,
      -1,    -1,    -1,  3482,    -1,  3484,  2233,    -1,    -1,    -1,
      -1,    -1,  2239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3816,  1404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3846,    -1,    -1,  3532,    -1,  2179,    -1,    -1,  1222,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3880,    -1,    -1,    -1,  3884,  3885,
      -1,    -1,  2319,    -1,  3764,    -1,    -1,    -1,    -1,    -1,
      -1,  2225,    -1,  2227,  2228,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   955,    -1,  2238,  3594,    -1,  2241,    -1,  2243,
      -1,    -1,    -1,    -1,  1288,    -1,    -1,    -1,    -1,    -1,
      -1,  3801,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2368,    -1,  1307,    -1,    -1,  2270,    -1,  2272,    -1,
      -1,    -1,  2276,    -1,    -1,    -1,  2383,  2384,    -1,    -1,
      -1,    -1,    -1,  1327,  3834,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3844,    -1,    -1,    -1,  2405,    -1,
      -1,  2305,  2306,  2307,    -1,    -1,    -1,    -1,  1352,    -1,
      -1,    -1,  1575,    -1,    -1,    -1,    -1,    -1,  2322,    -1,
    3679,    -1,  3681,  1438,    -1,    -1,    -1,    -1,    -1,    -1,
    2334,    -1,    -1,    -1,    -1,  2339,    -1,    -1,    -1,    -1,
      -1,  3891,  2346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1404,  1849,    -1,    -1,    -1,    -1,  1854,  1855,    -1,  2476,
    2477,  2478,    -1,    -1,    -1,    -1,    -1,  1865,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2389,    -1,    -1,  2495,    -1,
      -1,    -1,    -1,    -1,    -1,  2502,    -1,    -1,  1513,    -1,
    3950,    -1,    -1,    -1,    -1,  2512,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3965,    -1,    -1,    -1,    -1,
      -1,  1536,    -1,  1146,    -1,    -1,  1541,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1561,  1562,    -1,  1564,
      -1,    -1,    -1,  2560,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4016,    -1,    -1,    -1,
    1193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1604,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1222,
      -1,  2608,    -1,    -1,  1992,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2622,    -1,  2624,    -1,    -1,
      -1,    -1,    -1,    -1,  1639,    -1,    -1,  2634,    -1,  2636,
      -1,  1575,    -1,    -1,    -1,    -1,    -1,    -1,  3897,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2065,  2685,    -1,
      -1,    -1,    -1,    -1,  1307,    -1,  1849,    -1,    -1,    -1,
      -1,  1854,  1855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1865,    -1,  1327,  2712,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2727,    -1,    -1,    -1,    -1,    -1,    -1,  1742,    -1,  1352,
      -1,    -1,    -1,    -1,    -1,  2742,    -1,  1752,  2745,    -1,
    1755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4051,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2817,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1992,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2759,    -1,    -1,    -1,    -1,
      -1,  4120,    -1,    -1,  2768,    -1,    -1,    -1,    -1,    -1,
    2774,    -1,  2776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2798,  2799,    -1,    -1,    -1,    -1,
      -1,    -1,  2065,    -1,    -1,  1849,    -1,    -1,    -1,  4168,
    1854,  1855,    -1,    -1,    -1,  2819,    -1,  4176,    -1,    -1,
      -1,  1865,    -1,    -1,    -1,  2829,    -1,    -1,  2832,    -1,
    2834,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2843,
      -1,    -1,    -1,    -1,    -1,  2849,    -1,    -1,  2852,    -1,
      -1,  2958,  1575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2872,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2880,    -1,  2882,    -1,
      -1,    -1,  2145,  2990,    -1,    -1,    -1,  2994,    -1,  2996,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2906,    -1,    -1,    -1,    -1,    -1,  2912,    -1,
      -1,    -1,    -1,    -1,  2918,  3022,    -1,    -1,  3025,    -1,
    2408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1992,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3063,    -1,  2446,  2447,
      -1,  2449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2499,    -1,  2501,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3138,  3139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2545,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2182,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2566,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2204,
      -1,  2206,    -1,  2208,  2209,  2210,    -1,    -1,  2213,    -1,
      -1,  2145,  2217,  2591,    -1,    -1,    -1,    -1,    -1,  2224,
      -1,  3218,    -1,    -1,  2229,    -1,    -1,    -1,    -1,    -1,
    2235,  2609,    -1,    -1,    -1,  2240,  1849,    -1,    -1,    -1,
      -1,  1854,  1855,    -1,  2249,    -1,    -1,    -1,  2253,  2254,
      -1,  2256,  1865,    -1,    -1,  2408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2268,    -1,    -1,    -1,    -1,    -1,    -1,
    2275,    -1,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,
    2285,  2286,    -1,  3177,  3178,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2446,  2447,  2673,  2449,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,  2686,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2697,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3234,    -1,    -1,    -1,    -1,    -1,  2499,    -1,  2501,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1992,
      -1,    -1,    -1,    -1,  2762,    -1,  3280,  3281,    -1,    -1,
      -1,    -1,  2545,    -1,    -1,    -1,  2401,    -1,    -1,  3293,
      -1,    -1,    -1,  2781,    -1,  3299,  3300,    -1,    -1,  3303,
      -1,    -1,    -1,  2566,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3421,    -1,    -1,    -1,  2806,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3433,  3331,  2591,    -1,
      -1,    -1,  3336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2065,    -1,  3348,    -1,  2609,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2842,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2408,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3378,  3482,    -1,  3484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2446,  2447,    -1,  2449,    -1,    -1,    -1,    -1,
    2673,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2145,  2686,    -1,  3532,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2697,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2499,    -1,  2501,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2594,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3594,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2762,
      -1,  2545,    -1,    -1,    -1,    -1,    -1,  2995,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3520,    -1,  2781,    -1,
      -1,    -1,  2566,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2806,    -1,    -1,    -1,  2591,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2609,    -1,    -1,    -1,    -1,
      -1,    -1,  3679,    -1,  3681,    -1,    -1,    -1,    -1,  2842,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2715,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2673,
      -1,    -1,  3636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2686,  2758,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2697,  3142,    -1,    -1,  3661,    -1,    -1,
      -1,    -1,    -1,    -1,  2779,  2780,    -1,  2782,    -1,    -1,
    2785,  2786,  2787,  2788,  2789,  2790,  2791,  2792,  2793,  2794,
    2795,    -1,    -1,    -1,    -1,  2408,    -1,    -1,  3176,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2820,    -1,    -1,  2823,    -1,
    2825,    -1,    -1,    -1,    -1,  2830,  2831,    -1,  2762,    -1,
      -1,    -1,    -1,  2446,  2447,    -1,  2449,    -1,    -1,  2844,
    2845,  2846,  2995,  2848,    -1,    -1,  2851,  2781,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2888,    -1,    -1,  2499,    -1,  2501,    -1,
      -1,    -1,    -1,    -1,  2899,    -1,    -1,    -1,    -1,    -1,
    3897,    -1,    -1,    -1,    -1,  3283,    -1,    -1,  2842,    -1,
      -1,    -1,    -1,    -1,  3911,    -1,  3294,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3818,  2930,    -1,    -1,    -1,    -1,
      -1,    -1,  2545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3837,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2566,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2591,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3142,
      -1,    -1,    -1,    -1,    -1,    -1,  2609,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3393,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3176,    -1,  3919,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3414,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3426,    -1,
      -1,    -1,    -1,    -1,  4051,    -1,    -1,    -1,    -1,    -1,
    2673,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2686,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2697,    -1,  3464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3989,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3116,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4120,    -1,    -1,    -1,    -1,    -1,    -1,
    3283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2762,
      -1,    -1,    -1,    -1,  4048,  4049,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2781,    -1,
      -1,  4168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2806,    -1,    -1,    -1,    -1,    -1,    -1,
    4094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3142,    -1,
    4104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2842,
    3235,    -1,  3610,  3238,  3239,  3240,    -1,    -1,  3243,    -1,
    3393,    -1,  3176,  3248,  3249,  3250,  3251,  3252,  3253,  3254,
    3255,  3256,  3257,  3258,  3259,    -1,    -1,    -1,    -1,    -1,
      -1,  3414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4163,
      -1,    -1,    -1,  3426,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3287,  3288,  3289,  3290,    -1,  3292,    -1,    -1,
      -1,  3296,  3297,  3298,    -1,    -1,  3301,    -1,    -1,  3304,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3333,    -1,
      -1,  3709,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3283,
      -1,    -1,    -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,
    3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3795,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3816,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3610,    -1,  3393,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3846,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3426,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3880,    -1,    -1,    -1,  3884,  3885,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3523,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3142,
    3464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3709,    -1,    -1,    -1,
      -1,    -1,    -1,  3176,    -1,    -1,    -1,  3572,  3573,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,  3606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3620,    -1,  3622,    -1,    -1,
      -1,    -1,  3627,  3628,  3629,    -1,    -1,  3632,  3633,  3634,
    3635,    -1,  3637,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3816,    -1,    -1,    -1,    -1,    -1,    -1,
    3283,    -1,    -1,    -1,    -1,    -1,  3610,    -1,  3683,    -1,
      -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3846,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3880,    -1,    -1,
      -1,  3884,  3885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3709,    -1,    -1,    -1,    -1,
    3393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3414,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3814,
    3815,    -1,    -1,  3426,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3830,  3831,  3832,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3849,    -1,    -1,    -1,    -1,    -1,
      -1,  3464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3880,    -1,    -1,  3954,
    3884,  3885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3964,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4021,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4097,    -1,    -1,    -1,  3709,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4142,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3816,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3846,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,  3880,    -1,    -1,
      30,  3884,  3885,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,   115,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,    -1,   244,    -1,    -1,   247,   248,   249,
      -1,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    -1,   265,   266,   267,   268,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,    -1,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,    -1,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   414,   415,   416,    -1,    -1,    -1,
      -1,    -1,    -1,   423,   424,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,    -1,   244,    -1,    -1,   247,
     248,   249,    -1,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,    -1,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,    -1,   387,
      -1,    -1,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   414,   415,     3,    -1,
      -1,    -1,    -1,    -1,    -1,   423,   424,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,   233,
      -1,   235,    -1,   237,   238,   239,   240,   241,   242,    -1,
     244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,   268,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,    -1,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,    -1,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,    -1,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,    -1,   382,   383,
     384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     424,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    -1,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,    -1,   135,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
      -1,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,    -1,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,    -1,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,    -1,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,    -1,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
      -1,   354,    -1,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   404,   405,   406,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,   424,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    -1,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,
      90,    -1,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,    -1,   135,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   204,   205,   206,    -1,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,    -1,    -1,   247,   248,   249,
      -1,    -1,   252,   253,   254,   255,    -1,   257,   258,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,    -1,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,    -1,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,    -1,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,    -1,   352,    -1,   354,    -1,    -1,   357,   358,   359,
     360,   361,   362,    -1,    -1,   365,   366,   367,   368,   369,
      -1,    -1,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,
     390,   391,   392,   393,   394,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,   404,   405,   406,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,   424,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,
     415,    -1,    -1,    -1,    -1,    -1,   421,   422,   423,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,    -1,
     244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,   268,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,    -1,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,    -1,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     414,   415,   416,    -1,    -1,    -1,    -1,    -1,    -1,   423,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    -1,   265,   266,   267,   268,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,    -1,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,    -1,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   423,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,    -1,   364,   365,   366,   367,   368,   369,   370,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   414,   415,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   423,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    62,    63,    64,    65,    -1,    67,    -1,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      80,    81,    82,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,   114,    -1,    -1,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,    -1,   127,   128,    -1,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,    -1,   244,    -1,    -1,   247,   248,   249,
      -1,    -1,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,    -1,   265,   266,   267,   268,   269,
     270,   271,    -1,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,    -1,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,    -1,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,    -1,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,    -1,   364,   365,   366,   367,   368,   369,
     370,    -1,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   414,   415,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   423,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   414,   415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   423,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,   204,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,    -1,   244,    -1,    -1,   247,
     248,   249,    -1,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,    -1,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,    -1,   364,   365,   366,   367,
     368,   369,   370,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,   381,   382,   383,   384,    -1,    -1,   387,
      -1,    -1,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   414,   415,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   423,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,
     415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,    -1,
     244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,   268,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,    -1,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,    -1,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,    -1,
     364,   365,   366,   367,   368,   369,   370,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,   381,   382,   383,
     384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   414,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,   204,   205,    -1,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,    -1,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,    -1,   265,   266,   267,   268,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,    -1,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,    -1,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,    -1,   364,   365,   366,   367,   368,   369,   370,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,   381,
     382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   414,   415,    -1,    -1,     3,     4,     5,     6,
       7,   423,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,     9,    10,    -1,    -1,   423,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,   423,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,    -1,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,    -1,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,   364,   365,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   414,   415,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   423,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,    -1,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
      -1,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,   414,   415,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
     246,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,   370,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,    -1,     9,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,   245,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,   414,   415,
     416,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,    -1,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,   233,    -1,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,    -1,   382,   383,   384,    -1,
      -1,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,   233,    -1,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,    -1,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,   233,    -1,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,    -1,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,   233,    -1,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,    -1,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,   201,    -1,   203,    -1,   205,
      -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,    -1,   232,   233,    -1,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,
     256,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
     266,   267,   268,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,    -1,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,    -1,   323,   324,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,    -1,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,   377,   378,    -1,   380,    -1,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    -1,    -1,    -1,   423,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,    -1,   135,
     136,   137,    -1,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,    -1,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,   267,    -1,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,    -1,   354,    -1,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   405,
     406,    -1,    -1,    -1,   410,   411,   412,    -1,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,    -1,    -1,
      -1,   410,   411,   412,    -1,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    -1,    39,    40,    41,
      42,    43,    -1,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,   201,
      -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,    -1,
     232,   233,    -1,   235,    -1,   237,   238,   239,   240,   241,
     242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,
     252,    -1,    -1,    -1,   256,   257,   258,   259,   260,   261,
     262,   263,    -1,   265,   266,   267,   268,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,    -1,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
      -1,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,    -1,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,    -1,
     352,   353,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,
     372,   373,   374,   375,   376,   377,   378,    -1,   380,    -1,
     382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,    -1,    -1,    -1,   410,   411,
     412,    -1,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,    -1,    -1,    -1,   410,   411,   412,    -1,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      -1,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    -1,    85,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,    -1,   232,   233,    -1,   235,    -1,   237,
     238,   239,   240,   241,   242,    -1,   244,    -1,    -1,   247,
     248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,    -1,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,    -1,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,    -1,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,    -1,   352,   353,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,    -1,    -1,   372,   373,   374,   375,   376,   377,
     378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,
      -1,    -1,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,    -1,
      -1,    -1,   410,   411,   412,    -1,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,    -1,    -1,    -1,   410,
     411,   412,    -1,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,    -1,
     104,    -1,   106,   107,   108,   109,   110,    -1,   112,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,    -1,   127,   128,    -1,   130,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,   201,    -1,   203,
      -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,    -1,   232,   233,
      -1,   235,    -1,   237,   238,   239,   240,   241,   242,    -1,
     244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,
      -1,    -1,   256,   257,   258,   259,   260,   261,   262,   263,
      -1,   265,   266,   267,   268,   269,   270,   271,    -1,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,    -1,   297,   298,    -1,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,    -1,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,    -1,   323,
     324,    -1,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,    -1,   338,   339,    -1,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,    -1,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,    -1,
      -1,   365,   366,   367,   368,   369,    -1,    -1,   372,   373,
     374,   375,   376,   377,   378,    -1,   380,    -1,   382,   383,
     384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,    -1,    -1,    -1,   410,   411,   412,    -1,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
      -1,    -1,     3,   410,   411,   412,    -1,   414,   415,   416,
     417,   418,   419,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   416,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,    -1,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,    -1,   354,    -1,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,    -1,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,   416,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,    -1,
     135,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,    -1,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,    -1,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,    -1,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,    -1,   354,
      -1,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,    -1,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,    -1,     3,     4,     5,    -1,    -1,    -1,     9,   404,
     405,   406,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,   416,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,   245,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,     4,     5,    -1,
      -1,    -1,     9,   414,   415,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,   245,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,     4,     5,    -1,    -1,    -1,     9,   414,   415,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
       9,   414,   415,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,   150,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,     4,
       5,    -1,    -1,    -1,     9,   414,   415,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,   245,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,   370,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    -1,   232,   233,   234,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,    -1,   232,   233,   234,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    84,    85,    86,
      -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,   204,   205,   206,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,   233,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,   381,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,   204,   205,   206,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,    -1,   232,
     233,   234,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,   381,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    67,    68,
      69,    70,    71,    72,    -1,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,   147,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,   364,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,   364,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,   147,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,   364,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    26,
      27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,   370,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,   370,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,   246,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,   371,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,    -1,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    -1,    85,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
     201,    -1,   203,    -1,   205,    -1,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
      -1,   232,   233,    -1,   235,    -1,   237,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,    -1,    -1,    -1,   256,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,   266,   267,   268,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,    -1,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,    -1,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,   377,   378,    -1,   380,
      -1,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    -1,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    -1,    55,    56,
      57,    58,    59,    -1,    61,    62,    63,    64,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    74,    75,    -1,
      77,    78,    79,    80,    81,    82,    -1,    -1,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,   104,    -1,   106,
     107,   108,   109,   110,    -1,   112,   113,   114,    -1,    -1,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,    -1,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,   136,
     137,   138,    -1,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,    -1,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,
     197,   198,   199,   200,   201,    -1,   203,    -1,   205,    -1,
      -1,   208,   209,   210,    -1,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,    -1,
     227,   228,   229,   230,    -1,   232,   233,    -1,   235,    -1,
     237,   238,   239,   240,   241,   242,    -1,   244,    -1,    -1,
     247,   248,   249,    -1,    -1,   252,    -1,    -1,    -1,   256,
     257,   258,   259,   260,   261,   262,   263,    -1,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    -1,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,    -1,
     297,   298,    -1,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,    -1,   323,   324,    -1,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
      -1,   338,   339,    -1,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,    -1,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,    -1,    -1,   365,   366,
     367,   368,   369,    -1,    -1,   372,   373,   374,   375,   376,
     377,   378,    -1,   380,    -1,   382,   383,   384,    -1,    -1,
     387,    -1,    -1,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    -1,    55,    56,    57,    58,    59,    -1,    61,    62,
      63,    64,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,   104,    -1,   106,   107,   108,   109,   110,    -1,   112,
     113,   114,    -1,    -1,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,    -1,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,   201,    -1,
     203,    -1,   205,    -1,    -1,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,    -1,   232,
     233,    -1,   235,    -1,   237,   238,   239,   240,   241,   242,
      -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,   252,
      -1,    -1,    -1,   256,   257,   258,   259,   260,   261,   262,
     263,    -1,   265,   266,   267,   268,   269,   270,   271,    -1,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,    -1,   297,   298,    -1,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,    -1,
     323,   324,    -1,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,    -1,   338,   339,    -1,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,    -1,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
      -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,   372,
     373,   374,   375,   376,   377,   378,    -1,   380,    -1,   382,
     383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    -1,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    -1,    85,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,   136,   137,   138,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
      -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,    -1,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
      -1,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   203,    -1,   205,    -1,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,    -1,   227,   228,
     229,   230,    -1,   232,   233,    -1,   235,    -1,   237,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,   252,    -1,    -1,    -1,   256,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,   266,   267,   268,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
      -1,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,    -1,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,   377,   378,
      -1,   380,    -1,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,    -1,   135,   136,   137,    -1,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,    -1,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
      -1,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,   252,   253,   254,   255,    -1,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,    -1,   354,    -1,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,    -1,   135,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,   204,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,    -1,    -1,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,    -1,    -1,   247,
     248,   249,    -1,    -1,    -1,   253,   254,   255,    -1,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,    -1,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,    -1,   352,    -1,   354,    -1,    -1,   357,
     358,   359,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,    -1,    -1,   372,   373,   374,   375,   376,    -1,
     378,    -1,   380,   381,   382,   383,   384,    -1,    -1,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    -1,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,   201,    -1,   203,    -1,
     205,    -1,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,    -1,   232,   233,    -1,
     235,    -1,   237,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,   252,    -1,    -1,
      -1,   256,   257,   258,   259,   260,    -1,   262,   263,    -1,
     265,   266,   267,   268,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,    -1,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,   377,   378,    -1,   380,    -1,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    -1,
      61,    62,    63,    64,    -1,    -1,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    80,
      81,    82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,    -1,   127,   128,    -1,   130,
     131,   132,   133,    -1,   135,   136,   137,    -1,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,    -1,    -1,   204,   205,   206,    -1,   208,   209,   210,
      -1,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
      -1,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,   242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,
      -1,    -1,   253,   254,   255,    -1,   257,   258,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,    -1,   269,   270,
     271,    -1,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,    -1,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,    -1,   297,   298,   299,   300,
     301,    -1,   303,   304,   305,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,    -1,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,    -1,    -1,   338,   339,    -1,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
      -1,   352,    -1,   354,    -1,    -1,   357,   358,   359,   360,
     361,   362,    -1,    -1,   365,   366,   367,   368,   369,    -1,
      -1,   372,   373,   374,   375,   376,    -1,   378,    -1,   380,
     381,   382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,
     391,   392,   393,   394,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   404,   405,   406,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    -1,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,    71,    72,    73,    74,    75,    -1,    77,
      78,    79,    80,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    -1,   104,    -1,   106,   107,
     108,   109,   110,    -1,   112,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,    -1,   127,
     128,    -1,   130,   131,   132,   133,    -1,   135,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,    -1,    -1,   204,   205,   206,    -1,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,    -1,   232,   233,   234,   235,    -1,    -1,
     238,   239,   240,   241,   242,    -1,   244,    -1,    -1,   247,
     248,   249,    -1,    -1,    -1,   253,   254,   255,    -1,   257,
     258,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
      -1,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,    -1,   297,
     298,   299,   300,   301,    -1,   303,   304,   305,   306,   307,
     308,   309,   310,    -1,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,    -1,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,    -1,    -1,
     338,   339,    -1,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,    -1,   352,    -1,   354,    -1,    -1,   357,
     358,   359,   360,   361,   362,    -1,    -1,   365,   366,   367,
     368,   369,    -1,    -1,   372,   373,   374,   375,   376,    -1,
     378,    -1,   380,   381,   382,   383,   384,    -1,    -1,   387,
      -1,    -1,   390,   391,   392,   393,   394,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   404,   405,   406,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      55,    56,    57,    58,    59,    -1,    61,    62,    63,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    -1,    84,
      85,    86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,   104,
      -1,   106,   107,   108,   109,   110,    -1,   112,   113,   114,
      -1,    -1,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,    -1,   127,   128,    -1,   130,   131,   132,   133,    -1,
     135,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,    -1,    -1,   204,
     205,   206,    -1,   208,   209,   210,    -1,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,    -1,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,   242,    -1,   244,
      -1,    -1,   247,   248,   249,    -1,    -1,    -1,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,    -1,   269,   270,   271,    -1,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,   299,   300,   301,    -1,   303,   304,
     305,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,    -1,   338,   339,    -1,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,    -1,   352,    -1,   354,
      -1,    -1,   357,   358,   359,   360,   361,   362,    -1,    -1,
     365,   366,   367,   368,   369,    -1,    -1,   372,   373,   374,
     375,   376,    -1,   378,    -1,   380,   381,   382,   383,   384,
      -1,    -1,   387,    -1,    -1,   390,   391,   392,   393,   394,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,
     405,   406,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    -1,    55,    56,    57,    58,    59,    -1,    61,
      62,    63,    64,    -1,    -1,    67,    -1,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,    90,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,   104,    -1,   106,   107,   108,   109,   110,    -1,
     112,   113,   114,    -1,    -1,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,    -1,   127,   128,    -1,   130,   131,
     132,   133,    -1,   135,   136,   137,    -1,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
      -1,    -1,   204,   205,   206,    -1,   208,   209,   210,    -1,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,    -1,
     232,   233,   234,   235,    -1,    -1,   238,   239,   240,   241,
     242,    -1,   244,    -1,    -1,   247,   248,   249,    -1,    -1,
      -1,   253,   254,   255,    -1,   257,   258,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,    -1,   269,   270,   271,
      -1,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,    -1,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,    -1,   297,   298,   299,   300,   301,
      -1,   303,   304,   305,   306,   307,   308,   309,   310,    -1,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,    -1,   338,   339,    -1,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,    -1,
     352,    -1,   354,    -1,    -1,   357,   358,   359,   360,   361,
     362,    -1,    -1,   365,   366,   367,   368,   369,    -1,    -1,
     372,   373,   374,   375,   376,    -1,   378,    -1,   380,   381,
     382,   383,   384,    -1,    -1,   387,    -1,    -1,   390,   391,
     392,   393,   394,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   404,   405,   406,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    -1,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    -1,    -1,    67,    -1,
      69,    70,    71,    72,    73,    74,    75,    -1,    77,    78,
      79,    80,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,    -1,   112,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,    -1,   127,   128,
      -1,   130,   131,   132,   133,    -1,   135,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,    -1,    -1,   204,   205,   206,    -1,   208,
     209,   210,    -1,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,    -1,    -1,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,   242,    -1,   244,    -1,    -1,   247,   248,
     249,    -1,    -1,    -1,   253,   254,   255,    -1,   257,   258,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,    -1,
     269,   270,   271,    -1,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,    -1,   297,   298,
     299,   300,   301,    -1,   303,   304,   305,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,    -1,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,    -1,   352,    -1,   354,    -1,    -1,   357,   358,
     359,   360,   361,   362,    -1,    -1,   365,   366,   367,   368,
     369,    -1,    -1,   372,   373,   374,   375,   376,    -1,   378,
      -1,   380,   381,   382,   383,   384,    -1,    -1,   387,    -1,
      -1,   390,   391,   392,   393,   394,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   404,   405,   406,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    -1,    -1,    44,    -1,
      -1,    -1,    48,    49,    50,    51,    52,    -1,    -1,    55,
      56,    -1,    -1,    59,    -1,    61,    62,    63,    64,    -1,
      -1,    67,    -1,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    80,    81,    82,    -1,    84,    85,
      86,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    95,
      96,    97,    98,    99,    -1,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,   110,    -1,   112,   113,   114,    -1,
      -1,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
      -1,   127,   128,    -1,   130,   131,   132,   133,    -1,   135,
     136,   137,    -1,    -1,   140,    -1,   142,    -1,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,    -1,   181,   182,   183,   184,    -1,
      -1,    -1,    -1,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,    -1,    -1,   204,   205,
     206,    -1,   208,   209,   210,    -1,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,    -1,
     226,    -1,   228,   229,    -1,    -1,   232,   233,   234,   235,
      -1,    -1,   238,    -1,   240,   241,   242,    -1,   244,    -1,
      -1,   247,   248,   249,    -1,    -1,    -1,   253,   254,   255,
      -1,   257,   258,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,    -1,   269,   270,   271,    -1,   273,   274,   275,
     276,   277,   278,   279,    -1,   281,   282,   283,   284,    -1,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
      -1,   297,   298,   299,   300,   301,    -1,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,    -1,    -1,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,    -1,   338,   339,    -1,   341,   342,   343,   344,   345,
     346,    -1,    -1,    -1,    -1,    -1,   352,    -1,   354,    -1,
      -1,   357,   358,   359,   360,   361,   362,    -1,    -1,   365,
     366,   367,   368,   369,    -1,    -1,   372,   373,   374,   375,
     376,    -1,    -1,    -1,   380,   381,   382,   383,   384,    -1,
      -1,   387,    -1,    -1,   390,   391,   392,   393,   394,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   404,   405,
     406
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    41,    61,    63,    64,    69,
      71,    81,    83,    99,   102,   114,   116,   120,   126,   133,
     135,   141,   155,   208,   209,   214,   222,   233,   270,   281,
     286,   288,   293,   298,   301,   305,   310,   311,   318,   321,
     328,   340,   357,   366,   372,   377,   389,   423,   430,   431,
     432,   433,   439,   440,   442,   443,   444,   445,   446,   447,
     448,   450,   451,   455,   465,   467,   468,   471,   472,   473,
     484,   487,   488,   503,   539,   545,   546,   553,   559,   561,
     563,   564,   567,   570,   571,   575,   576,   585,   589,   590,
     591,   595,   596,   598,   599,   600,   613,   614,   615,   616,
     627,   628,   635,   636,   639,   640,   641,   642,   643,   648,
     650,   653,   657,   661,   662,   672,   673,   676,   681,   692,
     711,   714,   715,   716,   719,   722,   724,   726,   729,   732,
     733,   734,   741,   742,   744,   745,   746,   751,   753,   754,
     758,   759,   762,   763,   764,   766,   767,   768,   769,   771,
     774,   775,   780,   786,   789,   791,   792,   797,   799,   803,
     810,   814,   815,   816,   817,   818,   819,   822,   849,   352,
     391,   747,    21,    67,    80,    97,   103,   118,   136,   147,
     152,   158,   173,   198,   247,   275,   300,   306,   312,   315,
     340,   342,   346,   354,   359,   370,   383,   560,   747,     3,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    33,    34,    36,    37,    39,    40,    41,    42,
      43,    45,    46,    48,    49,    50,    51,    52,    55,    56,
      57,    58,    59,    61,    62,    63,    64,    65,    67,    69,
      70,    71,    72,    74,    75,    77,    78,    79,    80,    81,
      82,    85,    86,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   104,   106,   107,   108,   109,   110,   112,   113,
     114,   117,   118,   119,   120,   121,   123,   124,   125,   127,
     128,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     140,   142,   143,   144,   146,   148,   152,   153,   154,   156,
     157,   159,   161,   162,   163,   164,   165,   167,   168,   169,
     171,   172,   173,   174,   175,   176,   178,   180,   181,   182,
     183,   184,   185,   186,   188,   190,   193,   195,   196,   197,
     198,   199,   200,   201,   203,   205,   208,   209,   210,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   227,   228,   229,   230,   232,   233,   235,   237,
     238,   239,   240,   241,   242,   244,   247,   248,   249,   252,
     256,   257,   258,   259,   260,   261,   262,   263,   265,   266,
     267,   268,   269,   270,   271,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   297,   298,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     312,   313,   314,   315,   316,   318,   319,   320,   321,   323,
     324,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   338,   339,   341,   342,   343,   344,   345,   346,
     348,   349,   352,   353,   354,   355,   357,   358,   359,   360,
     361,   362,   365,   366,   367,   368,   369,   372,   373,   374,
     375,   376,   377,   378,   380,   382,   383,   384,   387,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   811,   954,   967,   971,
     972,   381,   776,   245,   271,   747,    44,   494,   815,    21,
      33,    54,    67,    76,    97,   103,   118,   136,   147,   154,
     158,   210,   247,   250,   300,   306,   315,   342,   343,   345,
     346,   354,   359,   364,   367,   370,   504,   631,   682,   693,
      22,   270,   954,   811,    22,   265,   343,   345,     5,   197,
     720,   721,   963,    21,    33,    54,    67,    80,    97,   118,
     136,   147,   152,   158,   173,   247,   257,   300,   304,   306,
     312,   315,   340,   342,   346,   354,   359,   370,   383,   560,
     644,   747,   954,    83,   381,   423,   539,   775,   781,   789,
     792,   797,   803,   810,   814,     9,    15,    22,    39,   142,
     148,   150,   170,   199,   228,   273,   287,   414,   415,   658,
     659,   811,   962,   966,    22,    83,   285,   311,   663,   664,
     665,   967,   967,   959,   963,   340,   825,   658,   967,   352,
     954,   257,    97,   173,   339,   340,   727,   305,   967,    22,
     316,   348,   352,   457,   967,    19,   155,   663,   664,   271,
     747,   967,   196,    22,   115,   827,    55,    77,   210,   224,
     300,   306,   316,   348,   352,   394,   456,   457,    22,   316,
     348,   352,   457,   352,   246,   858,   952,   967,   825,   416,
     967,   151,   423,   777,   423,   948,   283,   820,   821,   954,
     815,   816,   819,     0,   426,   776,   129,   187,   251,   363,
     828,   829,   815,   817,   818,   108,   183,   369,   427,     3,
      38,    44,    73,    84,    90,   149,   151,   166,   179,   191,
     192,   194,   204,   206,   226,   234,   253,   254,   255,   299,
     322,   381,   960,   967,   968,   971,   973,   646,   967,   646,
     955,   967,   274,   646,   646,   954,   967,    96,   340,   671,
     960,     3,   964,   969,   971,   972,   973,   952,   240,     8,
      62,   140,   410,   411,   412,   414,   415,   416,   417,   418,
     419,   718,   915,   916,   967,   964,   954,   952,   954,   858,
     954,   308,   954,   646,   215,   964,   952,   197,   105,   193,
     231,   279,   748,   749,   750,   952,   958,   967,    21,    54,
      67,    68,    76,    80,    97,   118,   136,   147,   152,   173,
     198,   247,   300,   304,   306,   312,   315,   340,   342,   346,
     354,   359,   383,   560,   651,   963,   952,   350,   960,   954,
     423,   646,   354,   955,   646,   165,   954,    96,   340,   343,
     345,   964,   343,   345,    62,   140,   718,   291,   964,   452,
     967,   954,   954,   308,   954,   646,   215,   964,   312,   340,
     383,    80,   173,   152,   304,   358,   554,    22,   954,   812,
     464,   963,   969,   721,   165,   960,   954,   165,   725,   165,
     955,    96,   340,   165,   960,   165,   964,   965,    62,   140,
     165,   718,    48,   165,   965,   165,   954,   165,   954,   165,
     954,   308,   165,   954,   165,   215,   965,   197,   165,   645,
     646,   423,   790,   504,   781,   377,   775,   782,   783,   784,
     969,   776,   966,   659,   660,    22,   660,   966,   660,    22,
     660,   966,   660,   660,   660,   966,   962,   962,   811,   660,
     274,   423,   423,   522,   522,   522,   245,   350,   427,   522,
     858,   859,   427,   743,   963,   423,   787,    48,   954,   954,
     952,   967,    38,   406,   193,   425,   248,   248,   245,   150,
     963,   350,   145,   654,   245,     4,     6,     7,     8,    10,
      30,    43,    45,    46,    53,    54,    57,    58,    65,    87,
      88,    89,    90,    91,    92,    93,   100,   101,   119,   134,
     138,   139,   143,   157,   185,   186,   188,   203,   211,   212,
     225,   227,   231,   236,   237,   239,   247,   256,   266,   280,
     302,   317,   324,   336,   348,   349,   353,   355,   356,   364,
     370,   378,   396,   397,   398,   399,   400,   401,   402,   403,
     414,   415,   416,   423,   815,   870,   873,   876,   877,   878,
     880,   881,   882,   883,   886,   887,   891,   893,   894,   913,
     917,   936,   941,   949,   950,   960,   961,   962,   963,   967,
     963,    22,   469,   951,   952,   316,   456,   103,   463,   963,
     464,   963,    38,    59,   456,   406,   749,   248,   150,   350,
     410,    38,   406,   193,   750,   423,   952,   416,   421,   425,
     942,   943,   859,   149,   151,   381,   772,   773,   775,   149,
     778,   103,   891,   946,   947,   820,   427,   423,   779,   424,
     424,   432,   952,    22,   115,   826,   826,    48,   826,   141,
     145,   207,   243,   832,   834,   835,   844,   846,   847,   828,
     829,   150,   189,   858,   860,   948,   423,   621,   943,   258,
     289,   318,   425,   647,   258,   289,   318,   258,   289,   318,
     389,   434,   465,   466,   677,    18,   120,   258,   318,   476,
     318,    18,   120,   369,   449,   392,   858,    50,    82,   137,
     168,   258,   289,   297,   303,   310,   318,   326,   334,   384,
     466,   705,   712,   423,   694,   289,   449,    18,    24,    64,
     113,   120,   123,   175,   229,   231,   241,   249,   258,   289,
     293,   318,   374,   474,   475,   579,     4,   415,   551,   966,
     646,   646,   423,   717,   425,   170,   289,   434,   441,   258,
     289,    49,    95,   172,   217,   219,   229,   257,   289,   294,
     318,   328,   474,   548,   549,   258,   382,   579,   587,   289,
     318,   474,   258,   289,   293,   318,    74,   112,   259,   344,
     245,    18,    24,   120,   258,   289,   318,   485,   486,   145,
     289,   318,   434,   466,   289,   318,   474,   954,   205,   105,
     246,   393,   427,   748,   371,   770,   245,   960,   423,   954,
      96,   340,   960,   240,    62,   140,   718,   954,   308,   954,
     197,   646,   522,   331,   332,   490,   963,   423,   621,   622,
      60,     3,    43,    45,    46,    57,    58,   100,   101,   143,
     185,   186,   188,   225,   227,   239,   280,   319,   324,   348,
     349,   378,   867,   869,   871,   873,   875,   877,   878,   879,
     881,   882,   886,   887,   968,   971,   150,   423,   617,   954,
     434,    31,   765,   231,   434,   392,   165,   952,   434,   646,
     646,   617,   504,   434,    38,   453,   359,   586,   258,   562,
      74,   112,   259,   344,    20,    40,   184,   601,    31,   617,
     145,   434,   952,   165,   540,   952,   952,   646,    73,   683,
     960,   954,   560,    44,    94,   182,   229,   307,   134,   621,
      51,   295,   477,   134,   423,   134,   392,   134,   694,   134,
     427,   165,   646,   165,   646,   134,   717,   965,   134,   134,
     245,   134,   477,   134,    74,   112,   259,   344,   134,   245,
     134,   145,   165,   165,   464,   134,   427,   477,   891,   920,
     340,   424,   427,   139,   245,   356,   461,   464,   551,   785,
     781,   660,   811,   660,   811,   660,   811,   660,   811,   660,
     811,   811,   811,   660,   811,   423,   523,   524,   967,   523,
      22,    97,   147,   152,   197,   198,   306,   312,   340,   342,
     666,   951,   965,   665,   170,   427,   800,   963,   867,   923,
      31,   965,   146,   728,   728,   728,   205,   967,   145,   145,
     666,   965,   305,   967,   464,   245,   423,   944,   421,   815,
     924,   380,   884,   891,   940,   423,   884,   884,   423,   423,
     423,   423,   872,   872,   268,   815,   423,   423,   874,   423,
     423,   423,   423,    57,    58,   884,   891,   423,   872,   423,
     423,   423,   423,   423,   390,   409,   423,   888,   423,   888,
     423,   423,   815,   423,   423,   423,   423,   423,   423,   423,
     423,   891,   891,   815,   891,   920,   943,   963,    58,   423,
     885,   423,   963,     3,     8,    11,    28,    31,    36,    42,
      66,   166,   170,   191,   192,   206,   231,   234,   247,   250,
     322,   410,   411,   412,   414,   415,   416,   417,   418,   419,
     915,   917,   919,   255,   891,   189,   427,   823,   423,   963,
     943,   106,   167,   470,   427,    59,   103,   464,    31,     3,
     103,   210,   462,   551,   887,   963,    78,   117,   900,    86,
     103,   458,   459,   461,   551,   103,   458,   205,   952,   891,
       3,    22,    26,    27,    28,    29,    30,    31,    32,    35,
      47,    53,    54,    60,    66,    68,    76,    83,    87,    88,
      89,    91,    92,    93,   103,   105,   111,   115,   116,   122,
     126,   129,   139,   141,   145,   147,   150,   155,   158,   160,
     170,   177,   187,   189,   202,   207,   211,   212,   231,   236,
     243,   245,   246,   250,   251,   264,   272,   285,   296,   311,
     317,   325,   337,   340,   347,   350,   351,   356,   363,   364,
     370,   371,   379,   385,   386,   388,   389,   416,   957,   970,
     971,   972,   973,   974,   942,    79,   294,   649,   424,   427,
     776,   424,   427,   821,   953,   954,    31,   779,   817,   817,
     830,   831,   891,   817,   142,   228,   841,   279,   320,   369,
      22,   836,   891,   837,   839,   891,   893,   844,   845,   835,
     834,   832,   833,   145,   847,   832,   844,   860,   952,    31,
     967,   318,   416,   923,   258,   289,   318,   350,   350,   306,
     957,   425,   350,   350,   306,   350,   350,   342,   456,   760,
     145,   155,   170,   298,   678,   679,    60,    76,   130,   147,
     272,   364,   520,   521,    76,   103,   231,   350,   103,   231,
     306,   306,   568,    21,    54,    67,    80,   118,   147,   152,
     247,   306,   312,   315,   340,   346,   359,   383,   560,   954,
     289,   318,   474,   245,   551,   310,   350,   350,   236,   551,
     107,   190,   306,   295,   705,   713,   170,   180,   252,   319,
     379,   424,   695,   698,   699,   700,   702,   867,   968,   350,
     370,    68,   130,   511,   520,   967,    68,   730,   245,   304,
     354,    76,   730,    25,   292,   304,   354,   952,   175,   241,
     646,   423,   350,   350,   423,   480,   342,   389,   390,   480,
      76,   427,     4,   258,   371,   371,   230,   867,   258,   318,
     718,    97,   350,   436,   466,   350,   350,   551,    48,   550,
     551,   551,    95,   217,   219,    48,   350,   434,   306,   434,
     229,   549,   350,   236,   963,   579,   350,   730,   306,   350,
     350,   480,   480,   646,   646,   646,   646,   952,    37,   376,
      37,    37,   350,    37,   350,   306,   427,    93,   370,   597,
     964,   350,   436,   350,   306,   258,   289,   279,   290,   314,
     460,   748,   958,   967,   952,   621,   867,   245,   392,   694,
     551,   646,   646,   717,   191,   245,    74,   112,   259,   344,
     245,   646,   191,   389,   495,   434,     3,   623,   624,   617,
     423,   869,    31,    30,   868,    98,   163,   218,   221,   309,
     404,   423,   889,   890,   647,   872,   646,   618,   619,   970,
      20,   755,   867,   134,   565,   954,   231,   423,   592,   435,
     631,   371,   383,   435,   964,    83,   155,   454,   503,   545,
     600,   661,   681,   751,   963,   587,   588,   954,   213,   646,
     646,   646,   646,   241,   108,   183,   357,   369,   602,   603,
     127,   423,   597,   435,   547,   548,   231,    31,   241,   423,
     541,   522,   145,   684,   958,   423,   696,    31,   197,   389,
     390,   813,   307,   960,   477,   867,   955,   165,   954,   960,
     477,   965,   964,   134,   371,   134,   371,   718,   477,   477,
     965,   954,   952,   954,   954,   954,   952,   965,   597,   134,
     134,   477,   645,   646,   424,   427,   952,   781,   783,   811,
     811,   811,   811,   811,   811,   523,   424,   427,   424,   153,
     313,   341,   953,    96,   315,   670,   671,   953,   240,   953,
     951,   951,   953,   350,   389,   674,    16,   132,   302,   320,
     801,   858,   235,   802,   424,   427,   788,   792,   797,   803,
     814,   350,   664,   663,   664,   150,   156,   675,   967,    21,
      68,   118,   147,   152,   198,   306,   312,   340,   359,   383,
     560,   655,   920,   942,   422,   920,   924,   925,   423,   385,
     937,   938,   891,   920,   962,   962,   920,     3,    98,   163,
     218,   221,   309,   404,   926,   927,   963,   962,   920,   920,
     962,   962,   884,   884,   891,   718,   891,   928,   414,   415,
     892,   893,   913,   917,   930,   424,   920,   891,   920,   931,
     348,   406,   962,   962,   891,    47,   150,   202,   351,   891,
     920,   934,   920,   223,   893,   891,   898,   899,   900,   223,
     891,   900,   424,   427,   318,   962,   962,   889,   867,   891,
     970,   348,    35,   337,   945,   646,   891,   423,   815,   935,
     115,   117,   139,   231,   236,   241,   356,   365,   891,    42,
     166,   170,   206,   322,   423,   891,   350,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,    22,    29,   325,
     914,   302,   423,   913,   154,   210,   340,   343,   345,   367,
     824,   952,   950,   150,   850,    22,   115,   379,   416,   424,
     700,   891,   921,   922,   968,   952,   352,   423,   963,   427,
     424,   422,   428,   164,   164,   477,   952,   773,   774,   952,
     946,   424,   427,   423,   427,    32,   111,   371,   690,   423,
     838,   966,   246,   241,   848,   848,   427,   302,   303,   840,
     845,   833,   371,   798,   103,   423,   793,   814,   967,   423,
     804,   805,   806,   807,   808,   967,   424,   424,   350,   350,
     306,   964,   954,   954,   957,   964,   954,   954,   964,   955,
     954,    75,   761,   300,   370,   663,   306,   155,   663,   423,
     954,   371,   685,   195,   195,   371,   423,   538,   954,   236,
     964,   891,   236,   954,   954,   350,   569,   960,   423,   646,
     646,   646,    96,   340,   671,    62,   140,   718,   954,   646,
     954,   646,   308,   646,   646,   197,   159,   229,   258,   375,
     572,   573,   574,   350,   730,   306,   236,   107,   190,   964,
     954,   245,   954,   252,   968,   424,   427,   700,   702,   699,
     702,   968,   647,   964,   965,   511,   867,   967,   954,   954,
      22,   370,   954,   165,   954,   165,   967,   304,   354,   304,
     354,   954,    22,   370,   954,   952,    18,   120,   318,   580,
     581,   582,   583,   970,   964,   954,   482,   483,   970,   954,
     244,    64,   244,   954,   475,   350,   956,   967,   956,   427,
     424,   427,   350,   306,   955,   964,     3,    75,   125,   175,
     263,   362,   370,   373,   437,   964,   954,   551,   646,   954,
     551,   954,   551,   964,   954,   954,   954,   964,   954,    18,
      24,   120,   258,   289,   318,   258,   289,   318,   617,   289,
     318,   289,   318,   289,   866,   967,   963,   967,   165,   967,
     964,   954,   954,   954,    18,   486,   315,   964,   954,   954,
     350,   350,    72,   361,   279,   191,    31,   646,   191,   191,
     371,   371,   191,   236,   652,   963,   646,   646,   646,   646,
     646,   646,   191,   652,   244,   150,   350,   489,   423,   491,
     492,   410,   424,   427,   891,    30,   868,   867,   421,   421,
     350,   350,   350,   423,   350,   962,   872,   424,   427,   410,
     602,    75,   124,   200,   201,   213,   258,   342,   344,   756,
     513,   954,   150,   306,   382,   566,   573,   574,   134,   424,
     511,   593,   594,   315,    19,   170,   300,   338,   437,   438,
     145,   956,   952,   453,   250,   504,   147,   963,   617,   617,
     617,   617,   241,   245,   250,   423,   864,   865,   866,   315,
     134,   133,   814,   646,   206,   505,   507,   509,   511,   517,
     520,   542,   543,   967,   389,   390,   534,    31,   963,   245,
     424,   697,   698,   703,    31,   197,   297,   388,   704,   705,
     706,   245,   464,   162,   162,   145,   621,    31,   134,   477,
     694,   646,   956,   646,   956,   717,   245,   477,   477,   245,
     477,   315,   145,   464,   477,   891,   423,   424,   524,   170,
     170,   170,   392,   953,   427,   551,   552,   158,   667,   668,
     964,    19,   675,   132,   320,   132,   320,   302,   369,   220,
     867,   954,   150,   245,   667,    48,   477,   960,   340,   960,
     240,   197,   646,   424,   422,   422,   427,   920,   891,   122,
     938,   939,    31,   424,   424,   424,   424,   424,   150,   424,
     424,   424,   424,   424,   427,   424,   264,   929,   424,   892,
     892,    11,   170,   191,   247,   410,   411,   412,   414,   415,
     416,   417,   418,   419,   917,   892,   424,   424,   145,   150,
     932,   933,   424,   406,   424,   424,    31,   934,   920,   934,
     934,   150,   424,   424,   970,   262,   902,    31,   424,   427,
     891,   970,   427,   891,   944,   891,   967,   424,   424,   406,
     892,   892,   128,   920,   150,   115,   117,   139,   236,   241,
     356,   365,   423,   128,   337,   945,   891,   935,   891,   350,
     718,   891,   423,   815,   343,   345,   343,   345,   952,   825,
     825,   825,   423,   815,   851,   852,   853,   858,   861,   894,
     960,   967,   386,   862,   921,   921,   922,   424,   254,   906,
      13,   424,   427,   829,   749,   962,   889,   459,   891,   779,
     954,   788,   831,   247,   915,   918,   407,   408,   691,   891,
     840,   951,   802,   802,   837,   851,   386,   863,   377,   794,
     795,   967,   296,   796,   808,   809,   427,   850,   410,   944,
     964,   954,   954,   207,   965,   965,   245,   953,   248,   245,
     891,   521,   956,   423,   423,   423,   538,   173,   523,   611,
     477,   464,   621,   867,   392,   646,   646,   646,   717,    74,
     112,   259,   344,   954,   555,   954,   159,   375,   350,   555,
     572,   579,   954,   954,   954,   181,   236,   647,   698,   702,
     702,   418,   513,   120,   293,   318,   476,   731,   134,   477,
     134,   477,   954,   954,   954,   954,   582,   583,   582,   424,
     427,   584,   963,   424,   427,   410,   425,   964,   258,   289,
     318,    18,   120,   258,   289,   318,   867,   230,   867,   964,
     954,   207,   263,   236,   963,   263,   965,   368,   350,   215,
     215,   215,   350,   350,   306,   350,   350,   306,   350,   306,
     350,   306,   350,   477,   867,    20,    40,   318,   731,   134,
     477,   350,   954,   964,   954,   652,   867,   191,   652,   652,
     956,   956,   652,   191,   191,   191,   191,   191,   191,   652,
     490,   498,   499,   970,    44,    85,   109,   124,   128,   146,
     161,   236,   244,   277,   493,   247,   414,   415,   551,   620,
     702,   918,   963,   974,     3,   624,   424,   421,   424,   962,
     422,   962,   163,   218,   890,   218,   890,   890,   962,   221,
     424,   619,   620,   245,   207,   410,   757,   757,   757,   757,
     757,   757,   757,    60,    66,    76,   103,   105,   177,   231,
     236,   272,   285,   364,   514,   515,   516,   434,   464,   954,
     464,   249,   577,   952,   424,   427,   954,   965,   158,   300,
     965,   962,   359,   522,   291,   340,    96,   523,   952,   603,
     625,   626,   963,   424,   427,   954,   952,   954,   389,   544,
     423,   506,   952,   424,   427,   424,   427,   244,   480,   244,
     245,   535,   814,   350,   952,   424,   427,   103,   410,   707,
     963,   464,   340,   701,   702,   389,   706,   708,   108,   183,
     311,   369,   739,   159,   814,   477,   867,   954,   477,   371,
     477,   371,   477,   477,   952,   952,   954,   597,   477,   967,
     306,   306,   306,   953,   671,   427,   964,   389,   427,   669,
     248,   132,   132,   965,   666,   477,   964,   621,   694,   551,
     646,   191,   924,   424,   347,   891,   126,   867,   891,   891,
     891,   932,   867,   892,   115,   117,   231,   241,   892,   892,
     892,   892,   892,   892,   892,   892,   892,   892,   891,   891,
     933,   932,   888,   888,   867,   424,   424,   424,   920,   424,
     427,    48,   893,   424,   970,   899,   269,   335,   901,   424,
     427,   382,   895,    31,   424,   885,   963,   891,    28,    28,
     891,   424,   891,   150,   423,   923,   891,   892,   892,   128,
     128,   891,   424,   128,   891,   825,   825,   825,   825,   952,
     952,   952,   815,   852,   853,    31,   854,   967,   427,    84,
     151,   179,   194,   204,   226,   299,   855,   854,    31,   854,
     967,   423,   943,   891,   158,   842,   427,   828,   829,   828,
     424,   906,   423,   907,   967,   891,   906,   963,   379,   922,
     424,   424,   422,   424,   423,   691,   424,   246,    86,   891,
     796,   424,   427,   944,   949,   424,   427,   805,   863,   946,
     757,   153,   313,   341,   680,   145,   680,   424,   423,   526,
     527,   687,   894,   967,   523,   523,   611,   958,   424,   105,
     177,   231,   612,    31,   954,   371,   371,   646,   646,   646,
     646,   647,   964,   350,   181,   418,   359,   231,   480,    96,
     231,   330,   333,   480,   359,   954,   967,   581,   483,   620,
     970,   350,   350,   306,   152,   247,   333,   629,   630,   152,
     247,   637,   638,   350,   350,   306,   424,   424,   424,   966,
     963,   963,   963,   954,   145,   145,   291,   145,   165,   964,
     954,   954,   964,   954,   954,   954,   954,   954,   954,   954,
      66,   478,   963,   963,   359,   967,   954,   579,   424,   652,
     191,   191,   652,   652,   652,   652,   652,   652,   371,   496,
     497,   424,   427,   416,   423,   461,   500,   551,   765,   963,
     765,   231,   277,   765,   765,   611,   962,   389,   390,   422,
     422,   424,   889,   952,   757,   103,   962,   963,   103,   963,
     103,   963,   103,   963,   103,   954,   103,   954,   103,   954,
     423,   646,   954,   892,   106,   167,   105,   236,   195,   952,
     708,   565,   423,   592,   594,   577,   965,   965,   867,    31,
     952,   392,   145,   604,   424,   427,   866,   577,   241,   423,
     790,    96,   229,   508,   510,   512,   520,   967,   534,   518,
     176,   533,   509,   543,    71,   342,   536,   389,   752,   963,
     685,   703,   891,   891,   427,   423,   704,   617,   350,   555,
     424,   477,   956,   956,   477,   477,   315,   953,   953,   953,
     551,   155,   668,   675,   150,   191,   191,   191,   191,   236,
     656,   963,   891,   424,   424,   933,   150,   115,   117,   241,
     423,   424,   395,   897,   920,   284,    48,   387,   387,   424,
     891,   229,   891,   427,   896,   869,   889,   892,   892,   891,
     923,   424,    28,    28,   891,   891,   128,   891,   424,   952,
     952,   952,   952,   424,   967,   423,   852,   194,   253,   856,
     852,   856,   194,   855,   856,   194,   423,   967,   423,   921,
      48,   160,   843,   424,   424,   906,   908,   967,   922,   906,
     963,   718,   241,   814,   795,   410,   808,   796,   966,   350,
     663,   150,   611,   891,   424,   427,   389,    66,   688,   688,
     424,   424,   708,   106,   167,   105,   373,   867,   956,   956,
     954,   359,   236,   236,   966,   967,   867,   477,   477,   410,
     964,   954,   954,   962,   962,   867,   427,   962,   962,   427,
     964,   954,   954,   953,   953,   646,   953,   134,   646,   867,
     477,   477,   191,   652,   652,   434,   110,   499,   461,   501,
     502,   963,   963,   236,   416,   523,   963,   963,   422,   152,
     180,   152,   150,   610,   966,   891,   231,   515,   708,   522,
     371,   537,   578,   582,   315,   371,   814,   423,   954,   121,
     605,   385,   607,   963,   646,   505,    96,   424,   427,   389,
     535,   131,   171,   423,   534,   108,   120,   269,   954,    52,
      60,   210,   150,   423,   963,   700,   709,   710,   968,   708,
     952,   178,   556,   477,   477,   477,   954,   248,   477,   667,
     656,   656,   656,   656,   892,   150,   423,   923,   423,   424,
     427,   424,   893,   284,   424,   376,   327,   424,   424,   424,
     892,   892,   891,   854,   423,   953,   852,   245,   371,   857,
     852,   194,   852,   865,   423,   865,   967,   424,   920,   891,
     388,   903,   906,   906,   261,   909,   424,   889,   424,   811,
     948,   667,   245,   667,   424,   708,   527,   247,   718,   646,
     371,   646,   689,   689,   285,   708,   537,   424,   478,   620,
     423,   960,   718,   630,   423,   423,   638,   389,   291,   389,
     389,   145,   478,   652,   491,   963,   424,   427,   523,   671,
      31,   723,   723,   952,   611,   424,   537,   216,   525,   173,
     424,   427,   954,   956,   752,   577,   302,   329,   606,   423,
     133,   506,   424,   510,   249,   536,    22,    70,    77,   104,
     174,   333,   519,   519,   951,   535,   303,   303,    60,   248,
      60,   646,   686,   687,   702,   424,   427,   862,   555,   229,
     375,   557,   558,   477,   892,   923,   424,   898,   920,    48,
     229,   405,   953,   424,   891,   423,   852,   857,   424,   865,
     424,   904,   905,   967,    48,   828,   906,   669,   680,   477,
     688,   537,   423,   646,   690,   690,   952,   537,   611,   371,
     479,   923,   694,   145,   633,   717,   923,   923,   645,   646,
     645,   646,   953,   477,   502,   723,    34,   169,   145,   151,
     260,   323,   245,   529,   530,   531,   342,   582,   577,   140,
     632,   891,   276,   534,   533,   513,   424,   536,   248,   248,
     424,   427,   704,   709,   116,   375,   555,   424,   424,   424,
     284,   376,   424,   953,   424,   427,    31,   920,   278,   303,
     910,   150,   689,   386,   528,   718,   691,   691,   522,   611,
     891,   424,   251,   308,   282,   634,   633,   424,   424,   389,
     121,   108,   369,   245,   531,   245,   530,   954,   646,    31,
     424,   960,   535,   534,   389,   481,   687,   708,    23,   184,
     740,   424,   905,   907,    42,    86,   360,   891,   911,   912,
     911,   424,   667,   690,   423,   611,   424,   525,   960,    48,
     634,   646,   302,    51,   229,   295,   318,   532,   532,   629,
     423,   536,   535,   480,   536,   232,   423,   735,   737,   742,
     792,   797,   803,   814,   912,   302,   144,   267,   144,   267,
     477,   691,   891,   529,   694,   646,   607,    17,   103,   236,
       4,   608,   609,   962,   963,   970,   536,   862,   736,   737,
     738,   815,   816,    28,   424,   611,   133,   424,   427,   424,
     426,   912,   276,   609,   738,   960,   423,   608,   424
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   429,   430,   431,   431,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   433,   434,   434,   435,
     435,   436,   436,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   438,   438,   438,   439,   440,
     441,   441,   442,   443,   444,   445,   445,   446,   446,   447,
     448,   449,   449,   450,   450,   451,   451,   452,   452,   453,
     453,   454,   454,   454,   454,   454,   454,   455,   455,   455,
     456,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   456,   456,   456,   456,   457,   457,   458,   458,   459,
     459,   460,   460,   460,   460,   461,   461,   461,   461,   462,
     462,   462,   462,   462,   462,   462,   463,   463,   463,   464,
     464,   465,   465,   465,   465,   465,   466,   466,   467,   467,
     467,   467,   467,   468,   469,   469,   470,   470,   471,   472,
     472,   472,   472,   473,   473,   473,   473,   474,   474,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     476,   476,   477,   477,   477,   478,   478,   479,   479,   480,
     481,   481,   482,   482,   483,   483,   483,   483,   484,   485,
     485,   486,   486,   486,   486,   487,   487,   488,   488,   489,
     489,   490,   490,   490,   491,   491,   492,   492,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     494,   494,   495,   495,   496,   496,   497,   497,   498,   498,
     499,   500,   500,   500,   500,   500,   501,   501,   502,   503,
     503,   503,   503,   504,   504,   504,   504,   504,   504,   504,
     504,   505,   505,   506,   506,   507,   507,   508,   508,   509,
     509,   509,   510,   510,   511,   512,   513,   513,   514,   514,
     514,   514,   515,   515,   515,   515,   515,   515,   515,   516,
     516,   516,   516,   517,   518,   518,   518,   519,   519,   519,
     519,   519,   519,   520,   520,   521,   521,   521,   521,   521,
     521,   521,   522,   522,   523,   523,   524,   525,   525,   525,
     525,   526,   526,   527,   527,   528,   528,   529,   529,   529,
     529,   529,   530,   531,   532,   532,   532,   532,   532,   533,
     533,   534,   534,   534,   534,   535,   535,   535,   535,   536,
     536,   537,   537,   538,   539,   540,   541,   541,   542,   542,
     543,   544,   544,   544,   545,   546,   547,   547,   548,   548,
     549,   549,   549,   549,   549,   549,   549,   549,   549,   549,
     549,   549,   550,   550,   551,   551,   551,   552,   552,   553,
     553,   554,   554,   555,   555,   556,   556,   557,   557,   558,
     558,   559,   559,   560,   560,   561,   562,   562,   563,   563,
     564,   564,   565,   565,   566,   566,   566,   567,   568,   568,
     569,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   571,   572,   572,   572,   572,   573,   573,
     574,   574,   575,   575,   576,   576,   577,   577,   578,   578,
     579,   580,   580,   581,   581,   581,   581,   582,   583,   584,
     585,   586,   586,   587,   587,   588,   588,   589,   589,   590,
     590,   590,   591,   591,   592,   592,   593,   593,   594,   595,
     596,   597,   597,   597,   598,   598,   599,   600,   600,   601,
     601,   601,   602,   602,   603,   603,   603,   603,   603,   604,
     604,   605,   605,   606,   606,   607,   607,   608,   608,   608,
     609,   609,   609,   609,   610,   610,   611,   611,   612,   612,
     612,   612,   612,   613,   613,   614,   615,   616,   616,   616,
     616,   616,   616,   616,   616,   616,   616,   616,   616,   616,
     617,   618,   618,   619,   619,   620,   620,   620,   620,   620,
     621,   621,   622,   623,   623,   624,   625,   625,   626,   626,
     627,   627,   627,   628,   629,   629,   630,   630,   630,   630,
     630,   631,   631,   632,   632,   633,   633,   633,   634,   634,
     635,   636,   636,   637,   637,   638,   638,   639,   639,   640,
     640,   641,   642,   643,   643,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     645,   645,   646,   646,   647,   647,   648,   649,   649,   649,
     650,   650,   650,   650,   650,   650,   650,   650,   650,   650,
     650,   650,   650,   650,   650,   650,   650,   651,   651,   651,
     651,   651,   651,   651,   651,   651,   651,   651,   651,   651,
     651,   651,   651,   651,   652,   652,   653,   653,   653,   653,
     653,   654,   654,   655,   655,   655,   655,   655,   655,   655,
     655,   656,   656,   657,   657,   658,   658,   658,   658,   658,
     658,   658,   658,   658,   658,   658,   658,   658,   658,   658,
     658,   659,   659,   660,   660,   661,   662,   662,   663,   663,
     663,   663,   663,   664,   664,   665,   665,   665,   665,   666,
     666,   666,   666,   666,   666,   666,   666,   666,   666,   666,
     666,   666,   666,   667,   667,   668,   668,   669,   669,   670,
     670,   671,   672,   673,   673,   674,   674,   675,   675,   676,
     677,   677,   678,   678,   678,   679,   679,   679,   680,   680,
     680,   681,   682,   682,   683,   683,   684,   684,   685,   685,
     686,   686,   687,   687,   687,   688,   688,   689,   689,   689,
     690,   690,   690,   691,   691,   691,   692,   692,   692,   693,
     693,   694,   694,   695,   695,   696,   696,   697,   697,   698,
     698,   698,   698,   698,   699,   699,   699,   699,   699,   700,
     701,   702,   702,   702,   703,   703,   703,   704,   704,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   706,   706,   706,   706,   707,   707,   708,   708,
     709,   710,   710,   711,   712,   712,   713,   713,   714,   714,
     715,   715,   716,   716,   717,   717,   717,   717,   718,   718,
     719,   720,   720,   721,   721,   722,   722,   722,   723,   723,
     723,   724,   725,   725,   726,   726,   726,   727,   727,   728,
     728,   729,   729,   729,   729,   729,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   729,   729,   729,   729,
     729,   729,   729,   729,   729,   729,   729,   729,   729,   729,
     730,   730,   731,   731,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   733,   733,   733,   733,   733,   733,   733,   733,
     733,   733,   733,   733,   733,   733,   733,   733,   733,   733,
     734,   735,   735,   735,   736,   736,   737,   737,   737,   737,
     737,   738,   738,   739,   739,   739,   739,   740,   740,   740,
     741,   741,   742,   743,   743,   744,   745,   745,   746,   746,
     746,   746,   746,   746,   746,   746,   746,   746,   746,   746,
     746,   746,   747,   747,   747,   748,   748,   748,   748,   748,
     749,   749,   749,   750,   750,   751,   751,   752,   752,   752,
     752,   753,   754,   755,   755,   756,   756,   756,   756,   756,
     756,   756,   756,   756,   756,   756,   756,   756,   756,   756,
     756,   757,   757,   758,   758,   759,   760,   760,   761,   762,
     762,   763,   764,   764,   764,   764,   764,   765,   765,   766,
     767,   767,   767,   767,   767,   767,   768,   769,   769,   769,
     770,   770,   771,   771,   771,   771,   771,   772,   772,   773,
     773,   773,   773,   774,   774,   775,   775,   776,   776,   777,
     777,   778,   778,   779,   779,   780,   780,   780,   780,   781,
     781,   781,   781,   781,   781,   781,   782,   782,   783,   784,
     784,   785,   785,   785,   786,   787,   787,   788,   788,   788,
     788,   789,   789,   790,   790,   791,   791,   791,   791,   792,
     793,   793,   793,   794,   794,   795,   796,   796,   797,   798,
     798,   799,   800,   800,   801,   801,   801,   801,   801,   801,
     801,   801,   802,   802,   803,   804,   804,   805,   805,   806,
     807,   808,   809,   809,   810,   811,   812,   812,   812,   812,
     812,   813,   813,   813,   814,   814,   815,   815,   816,   816,
     816,   816,   816,   816,   816,   816,   817,   817,   818,   818,
     818,   818,   818,   818,   819,   819,   820,   820,   821,   822,
     822,   823,   823,   824,   824,   824,   824,   824,   824,   824,
     824,   824,   825,   825,   826,   826,   826,   827,   827,   827,
     827,   828,   828,   829,   830,   830,   831,   831,   832,   832,
     832,   832,   833,   833,   834,   834,   834,   835,   835,   836,
     836,   837,   838,   838,   838,   839,   840,   840,   841,   841,
     842,   842,   843,   843,   844,   844,   845,   845,   846,   846,
     847,   847,   848,   848,   849,   849,   850,   850,   851,   851,
     852,   852,   852,   852,   852,   852,   852,   852,   852,   852,
     852,   853,   853,   853,   853,   853,   853,   854,   854,   854,
     854,   855,   855,   855,   855,   856,   856,   857,   857,   858,
     858,   858,   858,   859,   859,   860,   860,   860,   861,   862,
     862,   863,   863,   863,   864,   864,   865,   865,   866,   867,
     867,   867,   867,   867,   867,   868,   868,   868,   869,   869,
     869,   869,   869,   869,   869,   870,   870,   870,   870,   871,
     871,   872,   872,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   873,   873,   874,   874,   875,   875,   876,   876,
     877,   878,   879,   879,   880,   880,   881,   882,   883,   883,
     883,   883,   883,   883,   884,   884,   885,   885,   886,   886,
     886,   886,   887,   888,   888,   888,   889,   889,   889,   889,
     889,   889,   889,   889,   889,   889,   889,   889,   889,   889,
     890,   890,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   891,   891,   891,   891,   891,   891,   891,   891,   891,
     891,   892,   892,   892,   892,   892,   892,   892,   892,   892,
     892,   892,   892,   892,   892,   892,   892,   892,   892,   892,
     892,   892,   892,   893,   893,   893,   893,   893,   893,   893,
     893,   893,   893,   893,   893,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   894,   894,   894,   894,   894,   894,
     894,   894,   894,   894,   895,   895,   896,   896,   896,   896,
     897,   898,   898,   899,   899,   900,   900,   901,   901,   901,
     902,   902,   902,   902,   903,   903,   904,   904,   905,   906,
     906,   906,   907,   908,   908,   909,   909,   910,   910,   910,
     911,   911,   912,   912,   912,   912,   912,   913,   913,   913,
     914,   914,   914,   915,   915,   916,   916,   916,   916,   916,
     916,   916,   916,   916,   917,   917,   918,   918,   919,   919,
     919,   919,   919,   919,   920,   920,   921,   921,   922,   922,
     923,   923,   924,   924,   924,   925,   925,   926,   926,   927,
     927,   927,   927,   927,   927,   927,   927,   928,   928,   929,
     930,   930,   931,   931,   931,   931,   931,   931,   932,   933,
     934,   934,   934,   935,   935,   936,   937,   937,   938,   939,
     939,   940,   940,   941,   941,   942,   942,   942,   942,   943,
     943,   944,   944,   945,   945,   946,   946,   947,   947,   948,
     949,   949,   950,   950,   950,   950,   951,   951,   952,   952,
     953,   953,   954,   955,   956,   957,   958,   959,   960,   960,
     961,   961,   961,   961,   961,   961,   961,   961,   961,   961,
     961,   961,   961,   962,   963,   964,   965,   965,   966,   966,
     966,   967,   967,   967,   968,   968,   968,   969,   969,   969,
     969,   970,   970,   970,   970,   970,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   971,   971,   971,   971,   971,   971,
     971,   971,   971,   971,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   972,   972,   972,   972,   972,   972,   972,   972,   972,
     972,   973,   973,   973,   973,   973,   973,   973,   973,   973,
     973,   973,   973,   973,   973,   973,   973,   973,   973,   973,
     973,   973,   973,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974,   974,
     974,   974,   974,   974,   974,   974,   974,   974,   974
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     1,     0,     2,
       0,     2,     0,     2,     2,     3,     3,     1,     3,     3,
       2,     1,     1,     2,     2,     2,     3,     3,     5,     5,
       0,     3,     5,     5,     4,     3,     5,     3,     5,     5,
       6,     1,     1,     3,     5,     6,     4,     1,     0,     2,
       0,     1,     1,     1,     1,     1,     1,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     5,     2,     2,
       2,     2,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     6,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     3,     4,     3,     2,     2,     1,     2,     3,
       4,     3,     2,     4,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     4,     4,     4,     4,     1,     3,     2,
       3,     4,     6,     6,     6,     5,     5,     6,     6,     4,
       8,     2,     3,     6,     4,     3,     3,     3,     3,     3,
       4,     4,     3,     3,     3,     3,     3,     3,     4,     4,
       3,     2,     3,     2,     2,     3,     3,     2,     2,     1,
       3,     2,     1,     1,     0,     2,     0,     2,     0,     3,
       2,     0,     1,     3,     3,     1,     5,     3,     4,     1,
       3,     4,     6,     4,     8,     2,     2,    10,     6,     1,
       1,     1,     1,     1,     1,     3,     2,     0,     1,     1,
       3,     3,     1,     1,     3,     3,     3,     3,     4,     2,
       1,     0,     2,     0,     3,     0,     1,     0,     1,     3,
       2,     1,     1,     1,     3,     0,     1,     3,     1,    11,
      14,    10,    13,     1,     1,     2,     2,     2,     2,     1,
       0,     1,     0,     3,     0,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     3,     4,     2,     0,     3,     1,
       1,     2,     2,     1,     3,     4,     4,     2,     5,     1,
       2,     2,     2,     3,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     7,     3,     8,     4,
       9,    11,     3,     0,     1,     3,     1,     2,     2,     2,
       0,     1,     3,     3,     6,     4,     0,     1,     1,     2,
       2,     0,     3,     3,     2,     1,     1,     2,     2,     4,
       0,     2,     2,     2,     0,     3,     4,     4,     0,     2,
       0,     4,     0,     3,     7,     5,     3,     0,     1,     3,
       1,     2,     3,     0,     5,     4,     1,     0,     1,     2,
       2,     1,     2,     3,     2,     2,     2,     2,     3,     3,
       1,     3,     1,     0,     1,     2,     1,     1,     3,     6,
      10,     1,     0,     1,     2,     2,     0,     2,     2,     1,
       0,     5,     7,     1,     0,     6,     2,     0,     3,     5,
       5,     8,     2,     0,     2,     2,     2,     5,     2,     0,
       2,     7,    10,     6,     6,     6,     6,     7,     7,     9,
       9,     6,     6,     8,     8,     8,     8,     6,     6,     7,
       8,     6,     6,     7,     2,     2,     2,     2,     1,     2,
       1,     0,     6,     8,     7,     6,     4,     0,     1,     3,
       4,     1,     3,     1,     2,     2,     2,     2,     1,     1,
      10,     2,     0,     2,     2,     1,     0,     4,     6,     5,
       4,     4,     8,    11,     3,     2,     1,     3,     1,     5,
       8,     1,     1,     1,     7,     9,     8,    15,    20,     1,
       1,     2,     1,     3,     1,     1,     1,     3,     1,     3,
       0,     1,     0,     1,     1,     4,     0,     1,     3,     0,
       1,     1,     1,     1,     2,     0,     0,     2,     2,     1,
       2,     2,     2,     6,     8,     8,     4,     5,     4,     4,
       4,     3,     7,     8,     6,     6,     6,     6,     4,     5,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     0,     1,     3,
       6,     8,     8,    13,     1,     3,     5,     6,     4,     7,
       2,     1,     0,     2,     0,     2,     4,     0,     1,     0,
       6,     8,     8,     1,     3,     5,     5,     7,     9,     7,
       9,     5,     6,     6,     4,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     3,     1,     2,     2,     3,     5,     2,     2,     0,
       6,     7,     7,     7,     8,     8,     6,     8,     9,     9,
       7,    10,     7,     8,     8,     8,     8,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     3,     1,     1,     8,     9,     9,     9,
       9,     2,     0,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     2,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     4,     4,     3,     4,
       4,     1,     1,     1,     0,     7,     7,    10,     1,     1,
       2,     4,     5,     1,     3,     2,     2,     2,     2,     1,
       2,     2,     4,     3,     2,     2,     2,     3,     2,     2,
       5,     5,     5,     1,     3,     1,     2,     3,     0,     1,
       3,     2,     6,     6,     9,     3,     0,     3,     0,     5,
       2,     0,     3,     3,     3,     7,     7,    10,     1,     1,
       1,    14,     1,     0,     1,     0,     1,     0,     2,     0,
       1,     3,     5,     5,     7,     2,     0,     1,     2,     0,
       1,     1,     0,     1,     1,     0,     9,    12,     7,     2,
       0,     3,     2,     1,     3,     3,     2,     1,     3,     3,
       3,     2,     2,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     4,     5,     1,     3,     3,     1,     2,     4,
       5,     1,     1,     1,     1,     3,     3,     2,     2,     2,
       2,     1,     2,     2,     1,     1,     1,     3,     2,     0,
       2,     1,     3,     5,     1,     2,     1,     0,     5,     7,
       5,     7,     5,     7,     3,     5,     5,     5,     1,     3,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,     4,     4,     4,     1,     1,     1,
       0,     7,     6,     6,     6,     6,     6,     7,     9,     9,
       6,     6,     6,     6,     6,     7,     8,     9,     8,     6,
       6,     6,     5,     5,     8,     8,     8,     8,     6,     9,
       1,     0,     2,     0,     7,     6,     6,     6,     6,     6,
       7,     9,     9,     6,     8,     8,     8,     8,     6,     6,
       7,     6,     7,     6,     6,     6,     6,     6,     7,     7,
       7,     9,     9,     6,     6,     6,     8,     8,     8,     6,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       6,     8,     3,     2,     0,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     3,     2,     5,     4,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     8,    10,     3,     4,     4,
       0,     2,     5,     2,     0,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     1,     0,     5,     6,     4,     2,     0,     4,     3,
       5,     6,     4,     6,     6,     5,     7,     1,     0,     6,
      11,    11,    11,    13,     9,    11,    10,     4,     2,     5,
       2,     0,     4,     5,     5,     4,     6,     1,     3,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     0,     1,
       0,     1,     0,     3,     0,     2,     4,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     2,     1,
       1,     1,     1,     0,     5,     3,     0,     1,     1,     1,
       1,     3,     8,     3,     0,     2,     3,     2,     3,     6,
       1,     4,     2,     1,     3,     2,     2,     0,     7,     2,
       0,     5,     3,     0,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     8,     1,     3,     1,     1,     3,
       5,     2,     1,     3,     7,     1,     0,     3,     2,     2,
       2,     0,     2,     2,     1,     1,     3,     3,     1,     2,
       4,     4,     2,     3,     5,     5,     1,     1,     9,     1,
       2,     4,     4,     4,     2,     3,     1,     3,     6,     1,
       0,     2,     0,     3,     3,     4,     4,     4,     4,     3,
       2,     1,     1,     0,     1,     1,     0,     1,     5,     1,
       0,     1,     0,     3,     1,     3,     4,     3,     2,     2,
       1,     1,     1,     0,     2,     4,     5,     2,     3,     1,
       1,     1,     1,     3,     0,     1,     1,     1,     1,     1,
       3,     0,     2,     0,     1,     3,     1,     0,     1,     2,
       4,     4,     2,     0,     2,     3,     2,     0,     1,     3,
       1,     2,     1,     2,     5,     6,     5,     1,     2,     1,
       4,     3,     4,     5,     4,     5,     4,     5,     2,     4,
       1,     2,     2,     2,     1,     1,     0,     4,     2,     1,
       2,     2,     4,     1,     3,     1,     2,     3,     1,     2,
       0,     2,     4,     0,     1,     0,     1,     3,     3,     2,
       3,     5,     6,     2,     3,     3,     4,     0,     1,     1,
       1,     1,     1,     2,     5,     1,     1,     1,     1,     2,
       3,     3,     0,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     1,     3,     0,     1,     1,     1,     1,
       5,     2,     1,     1,     1,     1,     5,     2,     2,     2,
       1,     3,     3,     2,     1,     0,     3,     0,     5,     2,
       5,     2,     1,     2,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     4,     1,     3,     3,     5,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     6,     7,     3,     4,     4,     6,     2,     3,
       4,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     4,     5,     6,     8,     6,
       7,     7,     5,     1,     1,     4,     1,     4,     1,     4,
       1,     4,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     5,     4,     6,
       5,     7,     7,     7,     2,     3,     3,     3,     4,     0,
       4,     1,     3,     3,     1,     1,     1,     2,     2,     0,
       2,     4,     4,     6,     2,     0,     1,     3,     3,     2,
       2,     0,     6,     1,     0,     3,     0,     2,     2,     0,
       1,     4,     2,     2,     2,     2,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     4,     1,     4,
       1,     2,     1,     2,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     3,     2,     1,     3,     3,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     2,
       3,     0,     3,     3,     2,     2,     1,     0,     2,     2,
       3,     2,     1,     1,     3,     5,     1,     2,     4,     2,
       0,     1,     0,     1,     2,     2,     2,     3,     5,     1,
       2,     0,     2,     1,     0,     1,     1,     1,     3,     3,
       1,     3,     3,     2,     1,     1,     1,     3,     1,     2,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     2,     5,     2,     3,     6,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 655 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 18167 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 662 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 18178 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 669 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1((yyvsp[0].node));
					else
						(yyval.list) = NIL;
				}
#line 18189 "gram.c" /* yacc.c:1646  */
    break;

  case 115:
#line 789 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 18195 "gram.c" /* yacc.c:1646  */
    break;

  case 116:
#line 800 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18207 "gram.c" /* yacc.c:1646  */
    break;

  case 117:
#line 810 "gram.y" /* yacc.c:1646  */
    {}
#line 18213 "gram.c" /* yacc.c:1646  */
    break;

  case 118:
#line 811 "gram.y" /* yacc.c:1646  */
    {}
#line 18219 "gram.c" /* yacc.c:1646  */
    break;

  case 119:
#line 820 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 18225 "gram.c" /* yacc.c:1646  */
    break;

  case 120:
#line 821 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 18231 "gram.c" /* yacc.c:1646  */
    break;

  case 121:
#line 825 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 18237 "gram.c" /* yacc.c:1646  */
    break;

  case 122:
#line 826 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 18243 "gram.c" /* yacc.c:1646  */
    break;

  case 123:
#line 831 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 18252 "gram.c" /* yacc.c:1646  */
    break;

  case 124:
#line 836 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
#line 18260 "gram.c" /* yacc.c:1646  */
    break;

  case 125:
#line 840 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 18269 "gram.c" /* yacc.c:1646  */
    break;

  case 126:
#line 845 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[0].str)));
				}
#line 18278 "gram.c" /* yacc.c:1646  */
    break;

  case 127:
#line 850 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
#line 18286 "gram.c" /* yacc.c:1646  */
    break;

  case 128:
#line 854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 18294 "gram.c" /* yacc.c:1646  */
    break;

  case 129:
#line 858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)));
				}
#line 18302 "gram.c" /* yacc.c:1646  */
    break;

  case 130:
#line 863 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 18310 "gram.c" /* yacc.c:1646  */
    break;

  case 131:
#line 867 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[0].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 18365 "gram.c" /* yacc.c:1646  */
    break;

  case 132:
#line 920 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 18371 "gram.c" /* yacc.c:1646  */
    break;

  case 133:
#line 923 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 18379 "gram.c" /* yacc.c:1646  */
    break;

  case 134:
#line 927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list));
				}
#line 18387 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 931 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list));
				}
#line 18395 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 935 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 18403 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 939 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list));
				}
#line 18411 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 953 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18423 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 971 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 18435 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 981 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 18441 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 982 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 18447 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 987 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].str);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 18459 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1005 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 18471 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1017 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-1].str);
					n->database = NULL;
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 18483 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1038 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18494 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1045 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18505 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1064 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18516 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1071 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 18527 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1088 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18539 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1106 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 18552 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1116 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 18558 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1117 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 18564 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1130 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18575 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1137 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18586 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1154 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[-3].str) != NULL)
						n->schemaname = (yyvsp[-3].str);
					else
						n->schemaname = (yyvsp[-1].str);
					n->authid = (yyvsp[-1].str);
					n->schemaElts = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18602 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1166 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 18615 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1177 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 18621 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1178 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 18627 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 18633 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1183 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 18639 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1211 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 18649 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1217 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 18659 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1223 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 18669 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1232 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 18681 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1240 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 18693 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1248 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 18704 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1255 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 18715 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1262 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 18726 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1270 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 18741 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1281 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 18753 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1289 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 18765 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1297 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 18777 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1305 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 18789 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1313 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 18804 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1324 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 18816 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1332 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 18828 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1340 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 18839 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1347 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 18851 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1356 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 18857 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1358 "gram.y" /* yacc.c:1646  */
    {
					(yyval.str) = palloc(strlen((yyvsp[-2].str)) + strlen((yyvsp[0].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
				}
#line 18866 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1364 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 18872 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1365 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 18878 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1369 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 18884 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1371 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 18890 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1374 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 18896 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 18902 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 18908 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1377 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 18914 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1381 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 18920 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1382 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 18926 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1383 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 18932 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1389 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 18938 "gram.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1402 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 18946 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1406 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 18954 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1410 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 18973 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1425 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 19000 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1447 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 19006 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1448 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19012 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1449 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19018 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1453 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19024 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1454 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19030 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1455 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 19036 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1459 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19042 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1460 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 19048 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1465 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 19059 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1472 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 19070 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1479 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 19081 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1486 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 19092 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1493 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				}
#line 19102 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1502 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 19108 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1503 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 19114 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1509 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 19124 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1515 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 19134 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1521 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 19144 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1527 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 19154 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1533 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 19164 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1543 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred    = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 19175 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1552 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19181 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 19187 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1557 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 19193 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1558 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 19199 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1567 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 19208 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1582 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 19218 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1588 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 19228 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1594 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 19238 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1600 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 19248 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1618 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				}
#line 19260 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1626 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				}
#line 19272 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1634 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				}
#line 19284 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1642 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				}
#line 19296 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1652 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 19302 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1653 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 19308 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1659 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 19319 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1667 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 19330 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1675 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 19342 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1684 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 19353 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1692 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 19364 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1700 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 19376 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1709 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19388 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1718 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19400 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1727 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 19412 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1736 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 19425 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1746 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 19438 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1759 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 19455 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1773 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 19466 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1781 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19477 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1789 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 19490 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1799 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 19503 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1809 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
#line 19513 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1816 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 19523 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1823 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19534 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1831 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 19545 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1839 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19556 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1847 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19567 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1855 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19578 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1863 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 19588 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1870 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 19598 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1877 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19609 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1885 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 19619 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1892 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 19629 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1899 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19640 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1907 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19651 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1915 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19662 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1923 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19673 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1931 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 19684 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1939 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 19695 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1947 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 19708 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1957 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 19718 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1964 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19729 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1972 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19740 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1980 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19751 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1988 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 19762 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1995 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 19773 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2004 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 19779 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2005 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19785 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2009 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 19791 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2010 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 19797 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2011 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 19803 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2016 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 19815 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19821 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2027 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 19827 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 19833 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 19839 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2035 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 19845 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2036 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 19851 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2040 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 19857 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 19863 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2047 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 19871 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2051 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 19879 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC);
				}
#line 19888 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2060 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC);
				}
#line 19896 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2075 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 19910 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2087 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 19916 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 19922 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2094 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 19934 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2103 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 19947 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2113 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 19960 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2123 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these three fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					(yyval.node) = (Node *)n;
				}
#line 19978 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2148 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 19988 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2154 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 19998 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2182 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-7].range);
					n->query = NULL;
					n->attlist = (yyvsp[-6].list);
					n->is_from = (yyvsp[-4].boolean);
					n->filename = (yyvsp[-3].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-8].defelt))
						n->options = lappend(n->options, (yyvsp[-8].defelt));
					if ((yyvsp[-5].defelt))
						n->options = lappend(n->options, (yyvsp[-5].defelt));
					if ((yyvsp[-2].defelt))
						n->options = lappend(n->options, (yyvsp[-2].defelt));
					if ((yyvsp[0].list))
						n->options = list_concat(n->options, (yyvsp[0].list));
					(yyval.node) = (Node *)n;
				}
#line 20023 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2203 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-4].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 20038 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2216 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 20044 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2217 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 20050 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2226 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 20056 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2227 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20062 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2228 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 20068 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 20074 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 20080 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 20086 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2238 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20092 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2243 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 20100 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2247 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 20108 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2251 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 20116 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)));
				}
#line 20124 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2259 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
#line 20132 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2263 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
#line 20140 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2267 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)));
				}
#line 20148 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)));
				}
#line 20156 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2275 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list));
				}
#line 20164 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
#line 20172 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2283 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list));
				}
#line 20180 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 20188 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
#line 20196 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2299 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 20202 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2304 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
#line 20210 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2307 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 20216 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)));
				}
#line 20224 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2315 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 20230 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2319 "gram.y" /* yacc.c:1646  */
    {}
#line 20236 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2320 "gram.y" /* yacc.c:1646  */
    {}
#line 20242 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2326 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 20250 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2330 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 20258 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2337 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 20266 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2343 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 20272 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2344 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 20278 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2345 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 20284 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2346 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 20290 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2347 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 20296 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 20304 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 20312 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2363 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 20318 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2376 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-9].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20336 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2392 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-7].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-7].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = (yyvsp[-3].list);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20354 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2407 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-8].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 20373 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2423 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-6].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-6].range);
					n->tableElts = (yyvsp[-3].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-4].list));
					n->ofTypename->location = (yylsp[-4]);
					n->constraints = NIL;
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 20392 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2446 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20398 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2447 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20404 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2448 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20410 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2449 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20416 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2450 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20422 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2451 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 20428 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2452 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 20434 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2453 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 20440 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2457 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 20446 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2458 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20452 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2462 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 20458 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20464 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 20472 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 20480 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2479 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 20488 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 20496 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2489 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20502 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20508 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2491 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20514 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2495 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20520 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2496 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20526 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2500 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20547 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2519 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20568 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2538 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 20574 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20580 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2544 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 20592 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2551 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20598 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2552 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20604 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2554 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 20621 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2585 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 20632 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2592 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 20643 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2599 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20658 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2610 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 20673 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2621 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-3]);
					n->raw_expr = (yyvsp[-1].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 20686 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2630 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
#line 20699 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2639 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 20718 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2672 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 20729 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2679 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 20740 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2686 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 20751 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2693 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 20762 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2712 "gram.y" /* yacc.c:1646  */
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 20773 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2721 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 20779 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2722 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 20785 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2723 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 20791 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2727 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 20797 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2728 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 20803 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2729 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 20809 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2730 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 20815 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2731 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 20821 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2732 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 20827 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2742 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = (Constraint *) (yyvsp[0].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 20839 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2749 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 20845 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2754 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20861 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2767 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-6]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20879 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2781 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20897 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2796 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20915 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2810 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20933 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2826 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-8]);
					n->access_method	= (yyvsp[-7].str);
					n->exclusions		= (yyvsp[-5].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 20953 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2843 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 20975 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 20981 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2864 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 20987 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2868 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 20993 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2869 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 20999 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2873 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 21007 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2879 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 21015 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2883 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 21027 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2891 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
#line 21035 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2895 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			}
#line 21043 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2901 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 21049 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2903 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 21055 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2907 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 21063 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2912 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 21071 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2918 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 21077 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2919 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 21083 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2930 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 21089 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2932 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 21095 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2934 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 21101 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2936 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 21107 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2938 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 21113 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2941 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 21119 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2944 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 21125 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2948 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 21131 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2949 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 21137 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2950 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 21143 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2951 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 21149 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2952 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 21155 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21161 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21167 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2961 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21173 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2962 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(true)); }
#line 21179 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2963 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(defWithOids(false)); }
#line 21185 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2964 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21191 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2967 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 21197 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2968 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 21203 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2969 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 21209 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2970 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 21215 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2973 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21221 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2974 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21227 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2977 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21233 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2978 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21239 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2981 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21245 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2992 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[-1].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 parser_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					n->intoClause = (yyvsp[-3].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[0].boolean))
						((SelectStmt *) (yyvsp[-1].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 21271 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
				}
#line 21284 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3028 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 21290 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3029 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21296 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3033 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 21302 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3034 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 21308 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3039 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[0].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = NULL;
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
#line 21329 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3058 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21335 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3059 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21341 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3060 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21347 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3074 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 21360 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3086 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21371 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3094 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21377 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21383 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3098 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 21389 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3099 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 21395 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3103 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value));
				}
#line 21403 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
#line 21411 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3111 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
#line 21419 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value));
				}
#line 21427 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value));
				}
#line 21435 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value));
				}
#line 21443 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
#line 21451 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3131 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
#line 21459 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3135 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list));
				}
#line 21467 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value));
				}
#line 21475 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3143 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
#line 21483 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3147 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value));
				}
#line 21491 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3152 "gram.y" /* yacc.c:1646  */
    {}
#line 21497 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3153 "gram.y" /* yacc.c:1646  */
    {}
#line 21503 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3157 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 21509 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 21518 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3163 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 21524 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3166 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 21530 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3167 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 21536 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3180 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-4].boolean);
				n->plname = (yyvsp[0].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
#line 21552 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3193 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 21567 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3206 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 21573 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3207 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 21579 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 21585 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3216 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 21591 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3220 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21597 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3221 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21603 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21609 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21615 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 21621 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21627 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3236 "gram.y" /* yacc.c:1646  */
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 21639 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3244 "gram.y" /* yacc.c:1646  */
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 21651 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3254 "gram.y" /* yacc.c:1646  */
    {}
#line 21657 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3255 "gram.y" /* yacc.c:1646  */
    {}
#line 21663 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3266 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-3].str);
					n->owner = (yyvsp[-2].str);
					n->location = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 21675 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3275 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 21681 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3276 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 21687 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3290 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 21698 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3297 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 21709 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3314 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 21721 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3322 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 21733 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3333 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 21739 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3335 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21745 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3340 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)));
				}
#line 21753 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 21761 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 21769 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3360 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 21780 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3370 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 21786 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3372 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 21792 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3377 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)));
				}
#line 21800 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3390 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21814 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3400 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-3].typnam));
					n->objargs = list_make1((yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 21828 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3410 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21841 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3419 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21854 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3428 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21867 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3437 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[0].funwithargs)->funcname;
					n->objargs = (yyvsp[0].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
#line 21881 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3447 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 21894 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3456 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21908 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3466 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 21922 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3476 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-2].list);
					n->objargs = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 21936 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3486 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 21949 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3495 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21962 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3504 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21975 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3513 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 21988 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3522 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22001 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3531 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22014 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3540 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22027 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3549 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22040 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 3558 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-4].str);
					n->action = (yyvsp[-3].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22053 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3567 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-5].str);
					n->action = (yyvsp[-4].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22066 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3576 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 22079 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 3585 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22092 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3603 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22104 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3613 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list)); }
#line 22110 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3614 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL); }
#line 22116 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 3615 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list)); }
#line 22122 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 3616 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL); }
#line 22128 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3620 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 22134 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3621 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 22140 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3625 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22146 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3626 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22152 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3637 "gram.y" /* yacc.c:1646  */
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 22164 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 3645 "gram.y" /* yacc.c:1646  */
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 22176 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 3662 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22188 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 3670 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 22200 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 3681 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22206 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 3682 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22212 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 3687 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 22220 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 3691 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 22228 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 3698 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22234 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 3703 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 22242 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 3707 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 22250 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 3714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 22258 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 3718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 22267 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 3723 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 22276 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 3728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP);
				}
#line 22284 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 3735 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 22292 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 3741 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22298 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 3746 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 22304 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 3758 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22318 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 3770 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22324 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 3771 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22330 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 3776 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22336 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 3777 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22342 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 3781 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 22348 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 3782 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 22354 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 3793 "gram.y" /* yacc.c:1646  */
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 22366 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 3801 "gram.y" /* yacc.c:1646  */
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 22378 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 3818 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 22391 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 3827 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 22403 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 3835 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22414 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 3854 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-4].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-4].range);
					n->base.tableElts = (yyvsp[-3].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22431 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 3869 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-4].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-4].range);
					n->base.tableElts = (yyvsp[-3].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22448 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 3884 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 22454 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 3885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22460 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 3890 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 22468 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 3894 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 22476 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 3900 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 22482 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 3912 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					(yyval.node) = (Node *)n;
				}
#line 22494 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 3929 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22506 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 3940 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 22512 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 3941 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "current_user"; }
#line 22518 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 3942 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (strcmp((yyvsp[0].str), "public") == 0) ? NULL : (yyvsp[0].str); }
#line 22524 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 3953 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 22536 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 3961 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[-2].str);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 22548 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 3978 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[-3].str);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 22560 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 3999 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-12].str);
					n->relation = (yyvsp[-8].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-11].ival);
					n->events = intVal(linitial((yyvsp[-10].list)));
					n->columns = (List *) lsecond((yyvsp[-10].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 22582 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4020 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 22605 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4041 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 22611 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4042 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 22617 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4043 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 22623 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4048 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 22629 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4050 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 22652 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 22658 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 22664 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 22670 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 22676 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4080 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 22682 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4085 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 22690 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4089 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
#line 22702 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4099 "gram.y" /* yacc.c:1646  */
    {}
#line 22708 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4100 "gram.y" /* yacc.c:1646  */
    {}
#line 22714 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4104 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 22720 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4105 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 22726 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4109 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 22732 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4110 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 22738 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 22744 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4115 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 22750 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4116 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 22756 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4121 "gram.y" /* yacc.c:1646  */
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[0].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
#line 22766 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4126 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 22772 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4127 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 22778 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4128 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 22784 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4132 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 22790 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4133 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 22796 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4138 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 22802 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4140 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 22830 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4166 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 22836 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4167 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 22842 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4168 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 22848 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4169 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 22854 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4170 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 22860 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4176 "gram.y" /* yacc.c:1646  */
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[-1].range);
					n->property = (yyvsp[-3].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 22874 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4186 "gram.y" /* yacc.c:1646  */
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[-1].range);
					n->property = (yyvsp[-3].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 22888 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4209 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[-5].str);
					n->args = list_make1((yyvsp[-2].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
#line 22908 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4228 "gram.y" /* yacc.c:1646  */
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
#line 22924 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4251 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22938 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4261 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22953 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4272 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22967 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4282 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 22981 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4292 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 22996 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4303 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 23009 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4312 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 23020 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4319 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23033 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4328 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23046 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4337 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23059 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4346 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23072 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4355 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 23085 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4364 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list)));
					(yyval.node) = (Node *)n;
				}
#line 23098 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4374 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23104 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 23110 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4378 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 23116 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4382 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node));
				}
#line 23124 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4386 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL);
				}
#line 23132 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4392 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 23138 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4393 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 23144 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4394 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 23150 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4395 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 23156 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4396 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 23162 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4399 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23168 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4400 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23174 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4403 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 23180 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4406 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 23186 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4407 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 23192 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4416 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node));
				}
#line 23200 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4422 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23206 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4423 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23212 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 23218 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 23224 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4440 "gram.y" /* yacc.c:1646  */
    {
				 AlterEnumStmt *n = makeNode(AlterEnumStmt);
				 n->typeName = (yyvsp[-3].list);
				 n->newVal = (yyvsp[0].str);
				 n->newValNeighbor = NULL;
				 n->newValIsAfter = true;
				 (yyval.node) = (Node *) n;
			 }
#line 23237 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4449 "gram.y" /* yacc.c:1646  */
    {
				 AlterEnumStmt *n = makeNode(AlterEnumStmt);
				 n->typeName = (yyvsp[-5].list);
				 n->newVal = (yyvsp[-2].str);
				 n->newValNeighbor = (yyvsp[0].str);
				 n->newValIsAfter = false;
				 (yyval.node) = (Node *) n;
			 }
#line 23250 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4458 "gram.y" /* yacc.c:1646  */
    {
				 AlterEnumStmt *n = makeNode(AlterEnumStmt);
				 n->typeName = (yyvsp[-5].list);
				 n->newVal = (yyvsp[-2].str);
				 n->newValNeighbor = (yyvsp[0].str);
				 n->newValIsAfter = true;
				 (yyval.node) = (Node *) n;
			 }
#line 23263 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4483 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23278 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23284 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23290 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4502 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = NIL;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 23304 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4513 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-3].list);
					n->args = (yyvsp[-2].list);
					n->number = (yyvsp[-4].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 23318 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4523 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 23331 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4532 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[-1].list);
					n->args = extractArgTypes((yyvsp[0].list));
					n->number = (yyvsp[-5].ival);
					n->class_args = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 23345 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4542 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 23356 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4550 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 23362 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4551 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23368 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4554 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23374 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4555 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23380 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4558 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23386 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4559 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 23392 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 23398 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4564 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = TRUE;
				}
#line 23416 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4577 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 23422 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4583 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23433 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4593 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23446 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4602 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 23459 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4613 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 23465 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 23471 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4619 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 23483 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4627 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 23495 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4639 "gram.y" /* yacc.c:1646  */
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[-3].list);
					n->amname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 23508 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4648 "gram.y" /* yacc.c:1646  */
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[-3].list);
					n->amname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 23521 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4660 "gram.y" /* yacc.c:1646  */
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[-3].list);
					n->amname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 23534 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 4669 "gram.y" /* yacc.c:1646  */
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[-3].list);
					n->amname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 23547 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 4690 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 23558 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 4700 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 23569 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 4718 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 23582 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 4727 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 23595 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 4738 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 23601 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 4739 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 23607 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 4740 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 23613 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 4741 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 23619 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 4742 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 23625 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 4743 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 23631 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 4744 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 23637 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 4745 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 23643 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 4746 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 23649 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 4747 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 23655 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 4748 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 23661 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 4749 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 23667 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 4750 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 23673 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 4751 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 23679 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 4752 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 23685 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 4756 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 23691 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 4757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 23697 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 4760 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 23703 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 4761 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 23709 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 4765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 23715 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 4767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 23721 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 4780 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 23733 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 4790 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 23739 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 4791 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 23745 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 4792 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 23751 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 4819 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23764 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 4828 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23777 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 4837 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23790 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 4846 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23803 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 4855 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23816 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 4864 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23829 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 4873 "gram.y" /* yacc.c:1646  */
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[-2].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23843 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 4883 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23856 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 4892 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23869 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 4901 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[-4].list);
					n->objargs = list_make1(makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23882 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 4910 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23895 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 4919 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[-5].typnam));
					n->objargs = list_make1((yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23908 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 4928 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23921 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 4937 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23933 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 4945 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23945 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 4953 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23957 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 4961 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 23969 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 4971 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 23975 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 4972 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 23981 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 4973 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 23987 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 4974 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 23993 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 4975 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 23999 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 4976 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 24005 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 4977 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DOMAIN; }
#line 24011 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 4978 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 24017 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 4979 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 24023 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 4980 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 24029 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 4981 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 24035 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 4982 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 24041 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 4983 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 24047 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 4984 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 24053 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 4985 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 24059 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 4986 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 24065 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 4987 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 24071 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 4991 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24077 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 4992 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24083 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5008 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24097 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5019 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[-3].list);
					n->objargs = (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24111 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5030 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[-3].list);
					n->objargs = extractArgTypes((yyvsp[-2].list));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24125 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5041 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[-2].value));
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24139 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5052 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[-2].list);
					n->objargs = NIL;
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 24153 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5063 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24159 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5064 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24165 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5068 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLUMN; }
#line 24171 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5069 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 24177 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5070 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 24183 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5071 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 24189 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5072 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 24195 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 5073 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 24201 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 5074 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TYPE; }
#line 24207 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5075 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 24213 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5078 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24219 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5079 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24225 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5090 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 24235 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5096 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 24245 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5104 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24257 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5112 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24269 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5120 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24281 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5128 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24293 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5136 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24305 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5144 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 24317 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5152 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 24329 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5160 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 24341 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5168 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 24353 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5176 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 24365 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5184 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24377 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5192 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 24389 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5200 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 24401 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5208 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 24413 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5216 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 24425 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5224 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 24437 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5233 "gram.y" /* yacc.c:1646  */
    {}
#line 24443 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5234 "gram.y" /* yacc.c:1646  */
    {}
#line 24449 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5237 "gram.y" /* yacc.c:1646  */
    {}
#line 24455 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5238 "gram.y" /* yacc.c:1646  */
    {}
#line 24461 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5250 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 24477 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5266 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 24494 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5280 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ((yyvsp[-3].privtarget))->targtype;
					n->objtype = ((yyvsp[-3].privtarget))->objtype;
					n->objects = ((yyvsp[-3].privtarget))->objs;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 24511 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 24517 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24523 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24529 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5311 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 24540 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5318 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 24551 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5326 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 24557 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5327 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 24563 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5331 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 24574 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5338 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 24585 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5345 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 24596 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5352 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 24607 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5366 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24619 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5374 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24631 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5382 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24643 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5390 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24655 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5398 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24667 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5406 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24679 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5414 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24691 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5422 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24703 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5430 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24715 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5438 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24727 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5446 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24739 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5454 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24751 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5462 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24763 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5470 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 24775 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5481 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 24781 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5482 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 24787 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5486 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24801 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5496 "gram.y" /* yacc.c:1646  */
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[0].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 24815 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5509 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24821 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5510 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24827 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].funwithargs)); }
#line 24833 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].funwithargs)); }
#line 24839 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5521 "gram.y" /* yacc.c:1646  */
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[-1].list);
					n->funcargs = extractArgTypes((yyvsp[0].list));
					(yyval.funwithargs) = n;
				}
#line 24850 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5537 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].str);
					(yyval.node) = (Node*)n;
				}
#line 24864 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5550 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 24878 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5560 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 24892 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5571 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 24898 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5572 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 24904 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5575 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 24910 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5576 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 24916 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5587 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 24927 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 5596 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 24933 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 5597 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 24939 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 5602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list));
				}
#line 24947 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 5606 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 24955 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 5610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list));
				}
#line 24963 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 5622 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 24979 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 5635 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 24996 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 5649 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 25013 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 5664 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_RELATION; }
#line 25019 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 5665 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
#line 25025 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 5666 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
#line 25031 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 5681 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-12].boolean);
					n->concurrent = (yyvsp[-10].boolean);
					n->idxname = (yyvsp[-9].str);
					n->relation = (yyvsp[-7].range);
					n->accessMethod = (yyvsp[-6].str);
					n->indexParams = (yyvsp[-4].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->indexOid = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 25050 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 5698 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25056 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 5699 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25062 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 5703 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25068 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 5704 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25074 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 5708 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25080 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 5709 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 25086 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 5713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 25092 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 5714 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 25098 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 5717 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 25104 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 5718 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 25110 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 5727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[-4].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 25125 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 5738 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-4].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 25140 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 5749 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[-5].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[-3].list);
					(yyval.ielem)->opclass = (yyvsp[-2].list);
					(yyval.ielem)->ordering = (yyvsp[-1].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
				}
#line 25155 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 5761 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25161 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 5762 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25167 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 5765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25173 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 5766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25179 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 5767 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25185 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 5770 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 25191 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 5771 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 25197 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 5772 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 25203 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 5775 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 25209 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 5776 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 25215 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 5777 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 25221 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 5795 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25236 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 5807 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25252 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 5820 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->withClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25267 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 5833 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25273 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 5834 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25279 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 5837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25285 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 5838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25291 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 5842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 25297 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 5843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 25303 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 5851 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 25309 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 5852 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25315 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 5856 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 25321 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 5858 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 25327 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 5873 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25340 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 5882 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25353 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 5891 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25366 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 5900 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25379 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 5909 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25392 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 5920 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 25398 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 5921 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 25404 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 5922 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 25410 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 5923 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 25416 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 5924 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 25422 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 5935 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 25434 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 5949 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 25440 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 5951 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 25450 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 5957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 25461 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 5967 "gram.y" /* yacc.c:1646  */
    {
				    (yyval.fun_param) = (yyvsp[0].fun_param);
			    }
#line 25469 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 5971 "gram.y" /* yacc.c:1646  */
    {
				    (yyval.fun_param) = (yyvsp[-2].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[0].node);
			    }
#line 25478 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 5976 "gram.y" /* yacc.c:1646  */
    {
				    (yyval.fun_param) = (yyvsp[-2].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[0].node);
			    }
#line 25487 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 5985 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25493 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 5986 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25499 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 5994 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
#line 25507 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 5998 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 25515 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6002 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
#line 25523 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6006 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
#line 25531 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6010 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
#line 25539 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6014 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
#line 25547 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6018 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 25555 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6022 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 25563 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
#line 25571 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6030 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
#line 25579 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value));
				}
#line 25587 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6038 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value));
				}
#line 25595 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6042 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt));
				}
#line 25604 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6050 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list));
				}
#line 25612 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6054 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 25620 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6058 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
#line 25628 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6062 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 25636 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6067 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25642 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6069 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 25650 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6075 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 25656 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 25662 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6080 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 25675 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6092 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 25683 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6096 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 25691 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6111 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[-2].funwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 25702 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6121 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25708 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25714 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6144 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[-2].list);
					n->args = extractArgTypes((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 25728 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6154 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[-2].list);
					n->args = extractArgTypes((yyvsp[-1].list));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 25742 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6167 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 25756 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6177 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 25770 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6190 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 25784 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6200 "gram.y" /* yacc.c:1646  */
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 25798 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6213 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 25810 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6221 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 25816 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6223 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 25822 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 25828 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 25834 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 25840 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6245 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 25850 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6253 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 25856 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 25862 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6259 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)));
				}
#line 25870 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6263 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)));
				}
#line 25878 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6276 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].funwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 25892 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6287 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 25906 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6298 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 25920 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6309 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 25926 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6310 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 25932 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6311 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 25938 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6316 "gram.y" /* yacc.c:1646  */
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[-4].typnam);
					n->targettype = (yyvsp[-2].typnam);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					(yyval.node) = (Node *)n;
				}
#line 25951 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6326 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 25957 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6327 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 25963 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6342 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].objtype);
					n->relation = (yyvsp[-1].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 25975 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6350 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
#line 25989 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6360 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[-1].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
#line 26003 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6372 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 26009 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6373 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 26015 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6376 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = TRUE; }
#line 26021 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6377 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = FALSE; }
#line 26027 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6388 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26040 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6397 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26052 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6405 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26064 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6413 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26076 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6421 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26089 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 6430 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26101 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 6438 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26113 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 6446 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26126 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 6455 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26139 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6464 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26151 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6472 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26164 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6481 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26177 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6490 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26190 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6499 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26203 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6508 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26216 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6517 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26230 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6527 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26244 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 6537 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26257 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 6546 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26269 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 6554 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26281 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 6562 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26293 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 6570 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 26306 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 6579 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 26319 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 6588 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26331 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 6596 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26343 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 6604 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26355 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 6612 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26367 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 6620 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26379 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 6628 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 26394 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 6640 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COLUMN; }
#line 26400 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 6641 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 26406 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 6644 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 26412 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 6645 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 26418 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 6656 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26431 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 6665 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26443 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 6673 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26455 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 6681 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26467 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 6689 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26479 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 6697 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26492 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 6706 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26505 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 6715 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26518 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 6724 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26531 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 6733 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26543 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 6741 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26555 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 6749 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26567 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 6757 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26579 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 6765 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26591 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 6773 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26603 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 6781 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26615 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 6789 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26627 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 6797 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26639 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 6813 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26652 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 6822 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26664 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 6830 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26676 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 6838 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26688 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 6846 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26700 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 6854 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[-3].funwithargs)->funcname;
					n->objarg = (yyvsp[-3].funwithargs)->funcargs;
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26713 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 6863 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26725 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 6871 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[-3].value));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26737 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 6879 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[-4].list);
					n->objarg = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26750 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 6888 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26763 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 6897 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[-5].list);
					n->addname = (yyvsp[-3].str);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26776 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 6906 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26788 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 6914 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26800 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 6922 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26812 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 6930 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26824 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 6938 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[-3].list);
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26836 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 6946 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26848 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 6954 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[-3].str)));
					n->newowner = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 26860 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 6973 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 26876 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 6987 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 26882 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 6988 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 26888 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 6989 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 26894 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 6995 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 26904 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7001 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 26914 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7017 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 26920 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7018 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 26926 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7021 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 26932 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7022 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 26938 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7023 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 26944 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7024 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 26950 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7028 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 26956 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7029 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26962 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7030 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 26968 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7036 "gram.y" /* yacc.c:1646  */
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[-1].range);
					n->property = (yyvsp[-3].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 26982 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7046 "gram.y" /* yacc.c:1646  */
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[-1].range);
					n->property = (yyvsp[-3].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 26996 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7067 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27007 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7076 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27013 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7077 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27019 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7081 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27029 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7090 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27039 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7096 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 27049 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7115 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27060 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7122 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27071 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7129 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27082 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7136 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27093 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7143 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27104 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7150 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27115 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7157 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 27127 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7165 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 27139 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7173 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 27151 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7181 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 27163 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7189 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				}
#line 27175 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7197 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27186 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7204 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27197 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7211 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27208 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7219 "gram.y" /* yacc.c:1646  */
    {}
#line 27214 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7220 "gram.y" /* yacc.c:1646  */
    {}
#line 27220 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7221 "gram.y" /* yacc.c:1646  */
    {}
#line 27226 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7226 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0]))); }
#line 27233 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7229 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[-1]))); }
#line 27240 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7232 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 27247 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7235 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[0]))); }
#line 27254 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7238 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[-1]))); }
#line 27261 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7245 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 27267 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7247 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 27273 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7249 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27279 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27285 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7269 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-4].range);
					n->view->relpersistence = (yyvsp[-6].ival);
					n->aliases = (yyvsp[-3].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 27299 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7280 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-4].range);
					n->view->relpersistence = (yyvsp[-6].ival);
					n->aliases = (yyvsp[-3].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 27313 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7293 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 27323 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7299 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 27333 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7305 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				}
#line 27343 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27349 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7321 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 27359 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7337 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27370 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 7346 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27376 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7347 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27382 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[0].str)));
				}
#line 27390 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
#line 27398 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7360 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[0].str)));
				}
#line 27406 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7364 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
#line 27414 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7368 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[0].str)));
				}
#line 27422 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7372 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
#line 27430 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)));
				}
#line 27438 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7380 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 27446 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7384 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
#line 27454 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7388 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[0].str)));
				}
#line 27462 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7392 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
#line 27470 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[0].str)));
				}
#line 27478 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7400 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
#line 27486 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 27494 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7408 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[0].str)));
				}
#line 27502 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7412 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
#line 27510 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 7421 "gram.y" /* yacc.c:1646  */
    {}
#line 27516 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7422 "gram.y" /* yacc.c:1646  */
    {}
#line 27522 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7434 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27533 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7441 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[0].str))));
					(yyval.node) = (Node *)n;
				 }
#line 27545 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7452 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27556 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7462 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27562 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27568 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7468 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)));
				}
#line 27576 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7482 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
#line 27587 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7489 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
#line 27598 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7506 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 27611 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7519 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27623 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7528 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 27634 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7536 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 27645 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7544 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 27657 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7553 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 27670 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7563 "gram.y" /* yacc.c:1646  */
    {}
#line 27676 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7564 "gram.y" /* yacc.c:1646  */
    {}
#line 27682 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7576 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27693 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7586 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 27707 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7596 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 27721 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7606 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 27735 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7616 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 27749 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7626 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 27761 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7634 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 27773 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7656 "gram.y" /* yacc.c:1646  */
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[-6].list);
			  n->for_encoding_name = (yyvsp[-4].str);
			  n->to_encoding_name = (yyvsp[-2].str);
			  n->func_name = (yyvsp[0].list);
			  n->def = (yyvsp[-8].boolean);
			  (yyval.node) = (Node *)n;
			}
#line 27787 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7678 "gram.y" /* yacc.c:1646  */
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[-1].range);
				   n->indexname = (yyvsp[0].str);
				   n->verbose = (yyvsp[-2].boolean);
				   (yyval.node) = (Node*)n;
				}
#line 27799 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7686 "gram.y" /* yacc.c:1646  */
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[0].boolean);
				   (yyval.node) = (Node*)n;
				}
#line 27811 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7695 "gram.y" /* yacc.c:1646  */
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[0].range);
				   n->indexname = (yyvsp[-2].str);
				   n->verbose = (yyvsp[-3].boolean);
				   (yyval.node) = (Node*)n;
				}
#line 27823 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 7705 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27829 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 7706 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27835 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 7719 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-1].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27853 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 7733 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->relation = (yyvsp[0].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27871 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 7747 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[0].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[-3].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[-1].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[-2].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[-2].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
#line 27887 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 7759 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-1].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
#line 27903 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 7771 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[-3].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
#line 27921 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 7787 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 27927 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 7788 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 27933 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 7792 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_ANALYZE; }
#line 27939 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 7793 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_VERBOSE; }
#line 27945 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 7794 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FREEZE; }
#line 27951 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 7795 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = VACOPT_FULL; }
#line 27957 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 7800 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[0].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
#line 27973 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 7812 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[-2].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[-1].range);
					n->va_cols = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27989 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 7826 "gram.y" /* yacc.c:1646  */
    {}
#line 27995 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 7827 "gram.y" /* yacc.c:1646  */
    {}
#line 28001 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 7831 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28007 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 7832 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28013 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 7835 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28019 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 7836 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28025 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 7839 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28031 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 7840 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28037 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 7844 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28043 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 7845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28049 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 7859 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 28060 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 7866 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 28074 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 7876 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
#line 28085 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 7883 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 28096 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 7903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 28104 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 7907 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 28112 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 7914 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node));
				}
#line 28120 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 7920 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28126 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 7921 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 28132 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 7925 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 28138 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 7926 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 28144 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 7927 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28150 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 7938 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 28162 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 7947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28168 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 7948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28174 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 7966 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				}
#line 28186 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 7975 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyvsp[-4].into)->rel->relpersistence = (yyvsp[-6].ival);
					n->into = (yyvsp[-4].into);
					if ((yyvsp[-4].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				}
#line 28204 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 7990 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28210 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 7991 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28216 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8002 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 28226 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8008 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 28236 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8014 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 28246 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8020 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 28256 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8036 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].istmt)->relation = (yyvsp[-2].range);
					(yyvsp[-1].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-1].istmt)->withClause = (yyvsp[-5].with);
					(yyval.node) = (Node *) (yyvsp[-1].istmt);
				}
#line 28267 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 28277 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8052 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 28287 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8058 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 28297 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8067 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 28303 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 28309 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8074 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 28321 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8084 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28327 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8085 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28333 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8098 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 28347 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8110 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28353 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8111 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28359 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8123 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28372 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8133 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 28378 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8134 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 28384 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8137 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 28390 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8138 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 28396 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8139 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 28402 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8140 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 28408 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8141 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 28414 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8142 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 28420 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8143 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 28426 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8144 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 28432 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8147 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28438 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8148 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28444 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8164 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 28459 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8177 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28465 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8178 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 28471 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8182 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 28477 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8183 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28483 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8188 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = (yyvsp[-2].target);
					(yyval.target)->val = (Node *) (yyvsp[0].node);
				}
#line 28492 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8196 "gram.y" /* yacc.c:1646  */
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[-3].list)) != list_length((yyvsp[0].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[-4]))));
					forboth(col_cell, (yyvsp[-3].list), val_cell, (yyvsp[0].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 28521 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 28533 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 28539 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 28545 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8246 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 28558 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8256 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28564 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8259 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28570 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8260 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 28576 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8261 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 28582 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8262 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 28588 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8263 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 28594 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8266 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28600 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8267 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 28606 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8268 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 28612 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8321 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28618 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8322 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 28624 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8336 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28630 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8338 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 28641 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8345 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 28653 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8353 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 28665 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8361 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 28677 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8369 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 28689 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8377 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										list_nth((yyvsp[0].list), 0), list_nth((yyvsp[0].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 28701 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8385 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										list_nth((yyvsp[-1].list), 0), list_nth((yyvsp[-1].list), 1),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 28713 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8395 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28719 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8396 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28725 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8426 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = (yyvsp[-2].list);
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28742 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8438 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 28748 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 8440 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 28771 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 8459 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 28779 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 8463 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 28787 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 8467 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].boolean), (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 28795 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 8482 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 28806 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 8489 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 28817 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 8498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28823 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 8499 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28829 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 8503 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-5].str);
				n->aliascolnames = (yyvsp[-4].list);
				n->ctequery = (yyvsp[-1].node);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 28842 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 8514 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 28848 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 8515 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 28854 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 8520 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				}
#line 28867 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 8529 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 28873 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 8538 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28882 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 8543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28891 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 8548 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28900 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 8553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28909 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 8558 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28918 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 8563 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 28927 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 8568 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 28936 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 8573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 28945 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 8578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 28954 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 8584 "gram.y" /* yacc.c:1646  */
    {}
#line 28960 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 8585 "gram.y" /* yacc.c:1646  */
    {}
#line 28966 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 8588 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 28972 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 8589 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28978 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 8590 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 28984 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 8597 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 28990 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 8598 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 28996 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 8599 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29002 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 8600 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29008 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 8604 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list);}
#line 29014 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 8605 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29020 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 8609 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29026 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 8613 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 29032 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 8614 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 29038 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 8618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 29051 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 8627 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 29064 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 8639 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-1].node)); }
#line 29070 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 8640 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node)); }
#line 29076 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 8641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[0].node)); }
#line 29082 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 8642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), NULL); }
#line 29088 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 8646 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29094 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 8647 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL,NULL); }
#line 29100 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 8652 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29106 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 8654 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 29119 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 8664 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 29125 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 8669 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29131 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 8672 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 29137 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 8676 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29143 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 8678 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 29152 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 8685 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29158 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 8695 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0])); }
#line 29164 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 8696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 29170 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 8697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(1, -1); }
#line 29176 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 8705 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29182 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 8709 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29188 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 8710 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29194 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 8713 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29200 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 8714 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 29206 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 8719 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29212 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 8720 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29218 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 8724 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29224 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 8725 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29230 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 8729 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29236 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 8730 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29242 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 8734 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29248 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 8735 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29254 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 8739 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29260 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 8740 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 29266 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 8745 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29278 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 8753 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 29290 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 8763 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29296 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 8764 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29302 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 8770 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 29312 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 8776 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-2].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 29322 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 8793 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29328 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 8794 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29334 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 8798 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29340 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 8799 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29346 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 8810 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].range);
				}
#line 29354 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 8814 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 29363 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 8819 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[0].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
#line 29374 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 8826 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				}
#line 29386 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 8834 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[-4].node);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29397 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 8841 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[-5].node);
					a->aliasname = (yyvsp[-3].str);
					n->alias = a;
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29411 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 8851 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[-4].node);
					a->aliasname = (yyvsp[-3].str);
					n->alias = a;
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 29425 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 8861 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[0].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[0].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[0]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = NULL;
				}
#line 29457 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 8889 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 29468 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 8896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 29476 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 8900 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 29485 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 8926 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 29493 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 8930 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 29509 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 8942 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 29526 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 8955 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
						n->usingClause = (List *) (yyvsp[0].node); /* USING clause */
					else
						n->quals = (yyvsp[0].node); /* ON clause */
					(yyval.jexpr) = n;
				}
#line 29544 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 8969 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 29559 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 8980 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 29575 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 8995 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 29585 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9001 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 29594 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9006 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 29604 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9012 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 29613 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9018 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 29619 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9019 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 29625 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9020 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 29631 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9021 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 29637 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9025 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29643 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 9026 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29649 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 9038 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 29655 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 9039 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29661 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 9045 "gram.y" /* yacc.c:1646  */
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
#line 29672 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 9052 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
#line 29683 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9059 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 29694 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9066 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
#line 29705 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 29711 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9077 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 29717 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 29725 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9095 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 29736 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9102 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 29747 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9111 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29753 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9116 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29759 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9117 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29765 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9122 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29771 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9124 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 29783 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9131 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29789 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9136 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 29795 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9137 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 29801 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9142 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 29809 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9146 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 29817 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 9152 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				}
#line 29838 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 9181 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 29847 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 9186 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = TRUE;
				}
#line 29857 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 9193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 29866 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 9198 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = TRUE;
				}
#line 29876 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 9204 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 29885 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 9209 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
#line 29895 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 9218 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 29901 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 9220 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 29907 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 9222 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 29913 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 9226 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29919 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 9227 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29925 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 9228 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29931 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 9229 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29937 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 9230 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29943 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 9232 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 29952 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 9237 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-4]))));
						(yyval.typnam)->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
				}
#line 29972 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 9266 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29978 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 9267 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29984 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 9268 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29990 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 9269 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 29996 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 9281 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30006 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 9287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 30016 "gram.c" /* yacc.c:1646  */
    break;

  case 1431:
#line 9294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30022 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 9295 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30028 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 9302 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30037 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 9307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30046 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 9312 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30055 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 9317 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30064 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 9322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30073 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 9327 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30082 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 9332 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30091 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 9337 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30101 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 9343 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30111 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 9349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30121 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 9355 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30130 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 9362 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 30155 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 9383 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 30163 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 9393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30171 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 9397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30179 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 9405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30187 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 9409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 30196 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 9417 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 30209 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 9429 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30227 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 9450 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30235 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 9454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30243 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 9460 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 30251 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 9464 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 30266 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 9477 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-4].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-4].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-4].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-4].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 30287 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 9496 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].str) != NULL) && (strcmp((yyvsp[0].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[-1].str)) + 1 + strlen((yyvsp[0].str)) + 1);
						strcpy(type, (yyvsp[-1].str));
						strcat(type, "_");
						strcat(type, (yyvsp[0].str));
						(yyvsp[-1].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[-1].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[-1].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30312 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 9519 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 30318 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 9521 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 30324 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 9523 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 30330 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 9525 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 30336 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 9527 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 30342 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 9529 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 30348 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 9533 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30354 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 9534 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30360 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 9538 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30366 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 9539 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30372 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 9547 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 30385 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 9556 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30397 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 9564 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 30410 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 9573 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 30422 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 9584 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 30431 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 9591 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 30437 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 9592 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30443 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 9593 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 30449 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 9598 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 30455 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 9600 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 30461 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 9602 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 30467 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 9604 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 30473 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 9606 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 30479 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 9608 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30485 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 9610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 30494 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 9615 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 30503 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 9620 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 30513 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 9626 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 30525 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 9634 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 30534 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 9639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 30545 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 9646 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 30555 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 9652 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30561 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 30569 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 9661 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 30578 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 9690 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30584 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 9692 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 30590 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 9694 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30602 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 9702 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[0].node), (yyvsp[-4].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 30619 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 9724 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 30625 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 9726 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 30631 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 9728 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30637 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 9730 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30643 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 9732 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30649 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 9734 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30655 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 9736 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30661 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 9738 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30667 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 9740 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30673 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 9742 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30679 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 9744 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30685 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 9747 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30691 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 9749 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 30697 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 9751 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 30703 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 9754 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30709 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 9756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30715 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 9758 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 30721 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 9761 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30727 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 9763 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 30744 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 9776 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 30750 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 9778 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 30767 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 9791 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 30773 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 9793 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 30790 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 9806 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2])); }
#line 30796 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 9808 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 30813 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 9822 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 30830 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 9835 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 30847 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 9848 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[0].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 30864 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 9861 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[0].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 30881 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 9884 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 30892 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 9891 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
#line 30903 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 9898 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 30914 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 9905 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
#line 30925 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 9912 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlaps");
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					n->args = list_concat((yyvsp[-2].list), (yyvsp[0].list));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 30952 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 9935 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 30963 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 9942 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
#line 30974 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 9949 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 30985 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 9956 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
#line 30996 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 9963 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 31007 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 9970 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
#line 31018 "gram.c" /* yacc.c:1646  */
    break;

  case 1536:
#line 9977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 31026 "gram.c" /* yacc.c:1646  */
    break;

  case 1537:
#line 9981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));

				}
#line 31038 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 9989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 31046 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 9993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 31054 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 10003 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											 (yylsp[-4]));
				}
#line 31065 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 10010 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											 (yylsp[-5]));
				}
#line 31076 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 10017 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
											(yylsp[-4])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-5].node), (yyvsp[-2].node), (yylsp[-4])),
											(yylsp[-4])),
											 (yylsp[-4]));
				}
#line 31093 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 10030 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
											(yylsp[-5])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-6].node), (yyvsp[0].node), (yylsp[-5])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-6].node), (yyvsp[-2].node), (yylsp[-5])),
											(yylsp[-5])),
											 (yylsp[-5]));
				}
#line 31110 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10043 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-2].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 31133 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10062 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[-3].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[-1]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 31158 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10083 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 31172 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 10093 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 31183 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 10100 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 31203 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 10116 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 31212 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 10121 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 31223 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10139 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31229 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10141 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 31235 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10143 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 31241 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10145 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 31247 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10147 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31253 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10149 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31259 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10151 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31265 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 10153 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31271 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 10155 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31277 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 10157 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31283 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 10159 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31289 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 10161 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31295 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 10163 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31301 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 10165 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 31307 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 10167 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 31313 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 10169 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[0].list), (yyvsp[-1].node), NULL, (yylsp[0])); }
#line 31319 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 10171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 31327 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 10175 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4])), (yylsp[-4]));
				}
#line 31336 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 10180 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[-5].node), (Node *) (yyvsp[-1].list), (yylsp[-4]));
				}
#line 31344 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 10184 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[-6].node), (Node *) (yyvsp[-1].list), (yylsp[-5]));
				}
#line 31352 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 10188 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 31361 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 10193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[-3].node)), (yylsp[-2])),
											 (yylsp[-2]));
				}
#line 31372 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 10209 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31378 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 10210 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31384 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 10212 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 31403 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 10227 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 31419 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 10239 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31425 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 10241 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31431 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 10243 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31445 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 10253 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 31472 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 10276 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31486 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 10286 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31500 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 10296 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[0].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31512 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 10304 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 31524 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 10322 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-3].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31541 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 10335 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31558 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 10348 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = list_make1((yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 31575 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 10361 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-7].list);
					n->args = lappend((yyvsp[-5].list), (yyvsp[-2].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *)n;
				}
#line 31592 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 10374 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-5].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 31609 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 10387 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 31630 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 10404 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-6].list);
					n->args = (yyvsp[-3].list);
					n->agg_order = (yyvsp[-2].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 31647 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 10417 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[-4].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[0].windef);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31674 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 10440 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[0]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				}
#line 31699 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 10461 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[0]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				}
#line 31713 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 10471 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[-3]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, -1);
				}
#line 31730 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 10484 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31751 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 10501 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[-3]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, -1);
				}
#line 31768 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 10514 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[0]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				}
#line 31782 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 10524 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[-3]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				}
#line 31799 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 10537 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[0]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				}
#line 31813 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 10547 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[-3]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.node) = makeTypeCast(n, d, -1);
				}
#line 31830 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 10560 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31847 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 10573 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31864 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 10586 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31881 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 10599 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31898 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 10612 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31915 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 10625 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31932 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 10638 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 31938 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 10640 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31955 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 10653 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31977 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 10671 "gram.y" /* yacc.c:1646  */
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31995 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 10685 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 32015 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 10701 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[-1].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[-3].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 32041 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 10723 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 32061 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 10739 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 32078 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 10752 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 10765 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[-1].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 32112 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 10778 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 32120 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 10782 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 32131 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 10789 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 32143 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 10797 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 32155 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 10805 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 32163 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 10809 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 32171 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 10813 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 32179 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 10817 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 32187 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 10821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 32195 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 10825 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("xmlexists");
					n->args = list_make2((yyvsp[-2].node), (yyvsp[-1].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 32214 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 10840 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 32222 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 10844 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 32235 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 10853 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 32243 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 10857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 32251 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 10861 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 32260 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 10866 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 32273 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 10880 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 32279 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 10882 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 32285 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 10886 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 32291 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 10888 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 32297 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 10890 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 32303 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 10892 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 32309 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 10895 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32315 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 10898 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 32321 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 10899 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 32327 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 10903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 32339 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 10911 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 32351 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 10920 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 32357 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 10921 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 32363 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 10924 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = TRUE; }
#line 32369 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 10925 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32375 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 10926 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = FALSE; }
#line 32381 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 10932 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 32389 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 10936 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 32397 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 10940 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 32405 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 10944 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-2].node);
				}
#line 32413 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 10954 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32419 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 10955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32425 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 10959 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 32431 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 10961 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 32437 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 10966 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 32447 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 10974 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 32453 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 10976 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 32470 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 10989 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 32476 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 10994 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 32494 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11019 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32500 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11020 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32506 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11023 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32512 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11024 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32518 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11036 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[-1]))));
					(yyval.windef) = n;
				}
#line 32540 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11054 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
#line 32550 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11060 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32562 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11070 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 32583 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11087 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 32624 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11132 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32636 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11140 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32648 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11148 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32660 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11156 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32672 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11164 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 32684 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11184 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32690 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11185 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32696 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 32702 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11189 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 32708 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11190 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 32714 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11191 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 32720 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11194 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32726 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11195 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32732 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11198 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 32738 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11199 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 32744 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11200 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 32750 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11201 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 32756 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11202 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 32762 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11203 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 32768 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11204 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 32774 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11205 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 32780 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11206 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 32786 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11210 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32792 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11212 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32798 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11217 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32804 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32810 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11224 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32816 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32822 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11228 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 32828 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11230 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 32834 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 32840 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11234 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 32846 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32854 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11250 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32862 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 32870 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 32878 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11267 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 32886 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11271 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 32899 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11281 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 32905 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11282 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 32911 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11286 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 32919 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11290 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 32927 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 11294 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 32935 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 11299 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32941 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 11300 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32947 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 11306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 32955 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 11309 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 11316 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32967 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 11317 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 32973 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 11318 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 32979 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 11319 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 32985 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 11320 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 32991 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 11321 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 32997 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 11322 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 33003 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 11323 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33009 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 11334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make4((yyvsp[-3].node), (yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 33017 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 11338 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 33025 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 11345 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33031 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 11351 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 33037 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 11352 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33043 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 11369 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[-1].node), (yyvsp[0].node));
				}
#line 33051 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 11373 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-2].node), (yyvsp[0].node), (yyvsp[-1].node));
				}
#line 33060 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 11378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].node));
				}
#line 33068 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 11382 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-1].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 33087 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 11397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
				}
#line 33095 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 11401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33101 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 11405 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33107 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 11408 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33113 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 11411 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 33119 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 11412 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33125 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 11413 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33131 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 11417 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 33142 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 11423 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 33148 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 11434 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 33162 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 11447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33168 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 11448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33174 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 11453 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 33186 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 11463 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33192 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 11464 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33198 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 11467 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33204 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 11468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33210 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 11472 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 33218 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 11476 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 33226 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 11483 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 33234 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 11487 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 33242 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 11491 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 33253 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 11498 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 33264 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 11507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33270 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 11508 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33276 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 11512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33282 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 11513 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33288 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 11528 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 33294 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 11530 "gram.y" /* yacc.c:1646  */
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 33304 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 11538 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33310 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 11539 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33316 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 11547 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33322 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 11558 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 33328 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 11559 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 33334 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 11563 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 33346 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 11579 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 33358 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 11587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 33370 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 11595 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 33386 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 11616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 33392 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 11617 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 33398 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 11629 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 33406 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 11633 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 33435 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 11660 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33441 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 11662 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33447 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 11666 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33453 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 11669 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33459 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 11672 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33465 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 11674 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33471 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 11676 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33477 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 11678 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33483 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 11689 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33489 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 11691 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 33498 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 11702 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 33506 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 11706 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 33514 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 11710 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 33522 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 11714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 33530 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 11718 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 33543 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 11727 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 33554 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 11734 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-4].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[-2].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
								    (errcode(ERRCODE_SYNTAX_ERROR),
								     errmsg("type modifier cannot have parameter name"),
								     parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[-2].list);
					t->location = (yylsp[-4]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 33583 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 11759 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 33591 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 11763 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 33601 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 11769 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-5].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						if (list_length((yyvsp[0].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[-5]))));
						t->typmods = lappend((yyvsp[0].list), makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[-3].ival), (yylsp[-3])));
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 33622 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 11786 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[0]));
				}
#line 33630 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 11790 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[0]));
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 11794 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 33646 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 11799 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 33652 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 11800 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33658 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 11801 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33664 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 11804 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33670 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 11806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33676 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 11809 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 33682 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 11810 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 33688 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 11811 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 33694 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 11827 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33700 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 11828 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33706 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 11829 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33712 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 11834 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33718 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 11835 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33724 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 11836 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33730 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 11841 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33736 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 11842 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33742 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 11843 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33748 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 11844 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33754 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 11850 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33760 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 11851 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33766 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 11852 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33772 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 11853 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33778 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 11854 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 33784 "gram.c" /* yacc.c:1646  */
    break;


#line 33788 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 12304 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"
